/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs
#define yylval          cf_lval
#define yychar          cf_char

/* First part of user prologue.  */
#line 50 "conf/gen_parser.m4"

#line 9 "conf/confbase.Y"
/* Headers from conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/bfd.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from conf/confbase.Y */

static void
check_u16(uint val)
{
  if (val > 0xFFFF)
    cf_error("Value %u out of range (0-65535)", val);
}

#define cf_assert(cond, ...) do { if (!(cond)) cf_error(__VA_ARGS__); } while (0)
static inline void cf_assert_symbol(const struct symbol *sym, uint class) {
  switch (class) {
    case SYM_PROTO: cf_assert(sym->class == SYM_PROTO, "Protocol name required"); break;
    case SYM_TEMPLATE: cf_assert(sym->class == SYM_TEMPLATE, "Protocol template name required"); break;
    case SYM_FUNCTION: cf_assert(sym->class == SYM_FUNCTION, "Function name required"); break;
    case SYM_FILTER: cf_assert(sym->class == SYM_FILTER, "Filter name required"); break;
    case SYM_TABLE: cf_assert(sym->class == SYM_TABLE, "Table name required"); break;
    case SYM_ATTRIBUTE: cf_assert(sym->class == SYM_ATTRIBUTE, "Custom attribute name required"); break;
    case SYM_VARIABLE: cf_assert((sym->class & ~0xff) == SYM_VARIABLE, "Variable name required"); break;
    case SYM_CONSTANT: cf_assert((sym->class & ~0xff) == SYM_CONSTANT, "Constant name required"); break;
    default: bug("This shall not happen");
  }
}

#line 9 "conf/flowspec.Y"
/* Headers from conf/flowspec.Y */

#define PARSER 1

#include "nest/bird.h"
#include "lib/flowspec.h"


/* Defines from conf/flowspec.Y */

struct flow_builder *this_flow;


#line 11 "filter/config.Y"
/* Headers from filter/config.Y */

#include "filter/f-inst.h"
#include "filter/data.h"

/* Defines from filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }

#define f_generate_complex(fi_code, da, arg) \
  f_new_inst(FI_EA_SET, f_new_inst(fi_code, f_new_inst(FI_EA_GET, da), arg), da)

/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
  case T_RD:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_val empty;

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      empty = f_const_empty_path;
      break;
    case EAF_TYPE_INT_SET:
      empty = f_const_empty_clist;
      break;
    case EAF_TYPE_EC_SET:
      empty = f_const_empty_eclist;
      break;
    case EAF_TYPE_LC_SET:
      empty = f_const_empty_lclist;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  return f_new_inst(FI_EA_SET, f_new_inst(FI_CONSTANT, empty), dyn);
}

/*
 * Remove all new lines and doubled whitespaces
 * and convert all tabulators to spaces
 * and return a copy of string
 */
char *
assert_copy_expr(const char *start, size_t len)
{
  /* XXX: Allocates maybe a little more memory than we really finally need */
  char *str = cfg_alloc(len + 1);

  char *dst = str;
  const char *src = start - 1;
  const char *end = start + len;
  while (++src < end)
  {
    if (*src == '\n')
      continue;

    /* Skip doubled whitespaces */
    if (src != start)
    {
      const char *prev = src - 1;
      if ((*src == ' ' || *src == '\t') && (*prev == ' ' || *prev == '\t'))
	continue;
    }

    if (*src == '\t')
      *dst = ' ';
    else
      *dst = *src;

    dst++;
  }
  *dst = '\0';

  return str;
}

/*
 * assert_done - create f_instruction of bt_assert
 * @expr: expression in bt_assert()
 * @start: pointer to first char of test expression
 * @end: pointer to the last char of test expression
 */
static struct f_inst *
assert_done(struct f_inst *expr, const char *start, const char *end)
{
  return f_new_inst(FI_ASSERT, expr,
    (end >= start) ?
      assert_copy_expr(start, end - start + 1)
    : "???");
}

static struct f_inst *
assert_assign(struct f_lval *lval, struct f_inst *expr, const char *start, const char *end)
{
  struct f_inst *setter, *getter, *checker;
  switch (lval->type) {
    case F_LVAL_VARIABLE:
      setter = f_new_inst(FI_VAR_SET, expr, lval->sym);
      getter = f_new_inst(FI_VAR_GET, lval->sym);
      break;
    case F_LVAL_PREFERENCE:
      setter = f_new_inst(FI_PREF_SET, expr);
      getter = f_new_inst(FI_PREF_GET);
      break;
    case F_LVAL_SA:
      setter = f_new_inst(FI_RTA_SET, expr, lval->sa);
      getter = f_new_inst(FI_RTA_GET, lval->sa);
      break;
    case F_LVAL_EA:
      setter = f_new_inst(FI_EA_SET, expr, lval->da);
      getter = f_new_inst(FI_EA_GET, lval->da);
      break;
    default:
      bug("Unknown lval type");
  }

  checker = f_new_inst(FI_EQ, expr, getter);
  setter->next = checker;
  
  return assert_done(setter, start, end);
}

#line 10 "nest/config.Y"
/* Headers from nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from nest/config.Y */

static struct proto_config *this_proto;
static struct channel_config *this_channel;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
/* static struct roa_table_config *this_roa_table; */
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;
static struct bfd_options *this_bfd_opts;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->prefix.type)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

static inline void
init_bfd_opts(struct bfd_options **opts)
{
  cf_check_bfd(1);

  if (! *opts)
    *opts = bfd_new_options();
}

static inline void
open_bfd_opts(struct bfd_options **opts)
{
  init_bfd_opts(opts);
  this_bfd_opts = *opts;
}

static inline void
close_bfd_opts(void)
{
  this_bfd_opts = NULL;
}

static void
proto_postconfig(void)
{
  CALL(this_proto->protocol->postconfig, this_proto);
  this_channel = NULL;
  this_proto = NULL;
}


#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

#line 8 "proto/bfd/config.Y"
/* Headers from proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

#line 13 "proto/babel/config.Y"
/* Headers from proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)

#line 9 "proto/bgp/config.Y"
/* Headers from proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)
#define BGP_CC ((struct bgp_channel_config *) this_channel)

#line 10 "proto/mrt/config.Y"
/* Headers from proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

#line 9 "proto/ospf/config.Y"
/* Headers from proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if (ospf_cfg_is_v2() && (ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;

      if (ospf_cfg_is_v3() && ip->autype && (pass->alg < ALG_HMAC))
	cf_error("Keyed hash algorithms are not allowed, use HMAC algorithms");
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;
  struct ospf_area_config *ac;
  struct ospf_iface_patt *ic;

  /* Define default channel */
  if (EMPTY_LIST(this_proto->channels))
  {
    uint net_type = this_proto->net_type = ospf_cfg_is_v2() ? NET_IP4 : NET_IP6;
    channel_config_new(NULL, net_label[net_type], net_type, this_proto);
  }

  /* Propagate global instance ID to interfaces */
  if (cf->instance_id_set)
  {
    WALK_LIST(ac, cf->area_list)
      WALK_LIST(ic, ac->patt_list)
	if (!ic->instance_id_set)
	{ ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }

    WALK_LIST(ic, cf->vlink_list)
      if (!ic->instance_id_set)
      { ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }
  }

  if (ospf_cfg_is_v3())
  {
    uint ipv4 = (this_proto->net_type == NET_IP4);
    uint base = (ipv4 ? 64 : 0) + (cf->af_mc ? 32 : 0);

    /* RFC 5838 - OSPFv3-AF */
    if (cf->af_ext)
    {
      /* RFC 5838 2.1 - instance IDs based on AFs */
      WALK_LIST(ac, cf->area_list)
	WALK_LIST(ic, ac->patt_list)
	{
	  if (!ic->instance_id_set)
	    ic->instance_id = base;
	  else if (ic->instance_id >= 128)
	    log(L_WARN "Instance ID %d from unassigned/private range", ic->instance_id);
	  else if ((ic->instance_id < base) || (ic->instance_id >= (base + 32)))
	    cf_error("Instance ID %d invalid for given channel type", ic->instance_id);
	}

      /* RFC 5838 2.8 - vlinks limited to IPv6 unicast */
      if ((ipv4 || cf->af_mc) && !EMPTY_LIST(cf->vlink_list))
	cf_error("Vlinks not supported in AFs other than IPv6 unicast");
    }
    else
    {
      if (ipv4 || cf->af_mc)
	cf_error("Different channel type");
    }
  }

  if (EMPTY_LIST(cf->area_list))
    cf_error("No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (proto_cf_main_channel(this_proto)->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%u", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Plaintext authentication not supported in OSPFv3");
}


#line 9 "proto/perf/config.Y"
/* Headers from proto/perf/config.Y */

#include "filter/filter.h"
#include "proto/perf/perf.h"

/* Defines from proto/perf/config.Y */

#define PERF_CFG ((struct perf_config *) this_proto)

#line 9 "proto/pipe/config.Y"
/* Headers from proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

#line 10 "proto/radv/config.Y"
/* Headers from proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


#line 12 "proto/rip/config.Y"
/* Headers from proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


#line 9 "proto/rpki/config.Y"
/* Headers from proto/rpki/config.Y */

#include "proto/rpki/rpki.h"

/* Defines from proto/rpki/config.Y */

#define RPKI_CFG ((struct rpki_config *) this_proto)
#define RPKI_TR_SSH_CFG ((struct rpki_tr_ssh_config *) RPKI_CFG->tr_config.spec)

static void
rpki_check_unused_hostname(void)
{
  if (RPKI_CFG->hostname != NULL)
    cf_error("Only one cache server per protocol allowed");
}

static void
rpki_check_unused_transport(void)
{
  if (RPKI_CFG->tr_config.spec != NULL)
    cf_error("At the most one transport per protocol allowed");
}

#line 9 "proto/static/config.Y"
/* Headers from proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_snh;
static struct f_inst *this_srt_cmds, *this_srt_last_cmd;

static struct static_route *
static_nexthop_new(void)
{
  struct static_route *nh = this_srt;

  if (this_snh)
  {
    /* Additional next hop */
    nh = cfg_allocz(sizeof(struct static_route));
    nh->net = this_srt->net;
    this_snh->mp_next = nh;
  }

  nh->dest = RTD_UNICAST;
  nh->mp_head = this_srt;
  return nh;
};

static void
static_route_finish(void)
{
  if (net_type_match(this_srt->net, NB_DEST) == !this_srt->dest)
    cf_error("Unexpected or missing nexthop/type");

  this_srt->cmds = f_linearize(this_srt_cmds);
}

#line 9 "sysdep/linux/netlink.Y"
/* Headers from sysdep/linux/netlink.Y */

#line 9 "sysdep/unix/config.Y"
/* Headers from sysdep/unix/config.Y */

#include "sysdep/unix/unix.h"
#include <stdio.h>

/* Defines from sysdep/unix/config.Y */

static struct log_config *this_log;

#line 9 "sysdep/unix/krt.Y"
/* Headers from sysdep/unix/krt.Y */

#include "sysdep/unix/krt.h"

/* Defines from sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)
#define KIF_IFACE ((struct kif_iface_config *) this_ipatt)

static void
kif_set_preferred(ip_addr ip)
{
  if (ipa_is_ip4(ip))
    KIF_IFACE->pref_v4 = ip;
  else if (!ipa_is_link_local(ip))
    KIF_IFACE->pref_v6 = ip;
  else
    KIF_IFACE->pref_ll = ip;
}

#line 50 "conf/gen_parser.m4"

#line 868 "obj/conf/cf-parse.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cf-parse.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_QUIT = 3,                       /* QUIT  */
  YYSYMBOL_EXIT = 4,                       /* EXIT  */
  YYSYMBOL_HELP = 5,                       /* HELP  */
  YYSYMBOL_END = 6,                        /* END  */
  YYSYMBOL_CLI_MARKER = 7,                 /* CLI_MARKER  */
  YYSYMBOL_INVALID_TOKEN = 8,              /* INVALID_TOKEN  */
  YYSYMBOL_ELSECOL = 9,                    /* ELSECOL  */
  YYSYMBOL_DDOT = 10,                      /* DDOT  */
  YYSYMBOL_GEQ = 11,                       /* GEQ  */
  YYSYMBOL_LEQ = 12,                       /* LEQ  */
  YYSYMBOL_NEQ = 13,                       /* NEQ  */
  YYSYMBOL_AND = 14,                       /* AND  */
  YYSYMBOL_OR = 15,                        /* OR  */
  YYSYMBOL_PO = 16,                        /* PO  */
  YYSYMBOL_PC = 17,                        /* PC  */
  YYSYMBOL_NUM = 18,                       /* NUM  */
  YYSYMBOL_ENUM = 19,                      /* ENUM  */
  YYSYMBOL_IP4 = 20,                       /* IP4  */
  YYSYMBOL_IP6 = 21,                       /* IP6  */
  YYSYMBOL_VPN_RD = 22,                    /* VPN_RD  */
  YYSYMBOL_CF_SYM_KNOWN = 23,              /* CF_SYM_KNOWN  */
  YYSYMBOL_CF_SYM_UNDEFINED = 24,          /* CF_SYM_UNDEFINED  */
  YYSYMBOL_TEXT = 25,                      /* TEXT  */
  YYSYMBOL_PREFIX_DUMMY = 26,              /* PREFIX_DUMMY  */
  YYSYMBOL_27_ = 27,                       /* '='  */
  YYSYMBOL_28_ = 28,                       /* '<'  */
  YYSYMBOL_29_ = 29,                       /* '>'  */
  YYSYMBOL_30_ = 30,                       /* '~'  */
  YYSYMBOL_NMA = 31,                       /* NMA  */
  YYSYMBOL_32_ = 32,                       /* '+'  */
  YYSYMBOL_33_ = 33,                       /* '-'  */
  YYSYMBOL_34_ = 34,                       /* '*'  */
  YYSYMBOL_35_ = 35,                       /* '/'  */
  YYSYMBOL_36_ = 36,                       /* '%'  */
  YYSYMBOL_37_ = 37,                       /* '!'  */
  YYSYMBOL_38_ = 38,                       /* '.'  */
  YYSYMBOL_DEFINE = 39,                    /* DEFINE  */
  YYSYMBOL_ON = 40,                        /* ON  */
  YYSYMBOL_OFF = 41,                       /* OFF  */
  YYSYMBOL_YES = 42,                       /* YES  */
  YYSYMBOL_NO = 43,                        /* NO  */
  YYSYMBOL_S = 44,                         /* S  */
  YYSYMBOL_MS = 45,                        /* MS  */
  YYSYMBOL_US = 46,                        /* US  */
  YYSYMBOL_PORT = 47,                      /* PORT  */
  YYSYMBOL_VPN = 48,                       /* VPN  */
  YYSYMBOL_MPLS = 49,                      /* MPLS  */
  YYSYMBOL_FROM = 50,                      /* FROM  */
  YYSYMBOL_51_ = 51,                       /* ';'  */
  YYSYMBOL_52_ = 52,                       /* '('  */
  YYSYMBOL_53_ = 53,                       /* ')'  */
  YYSYMBOL_FLOW4 = 54,                     /* FLOW4  */
  YYSYMBOL_FLOW6 = 55,                     /* FLOW6  */
  YYSYMBOL_DST = 56,                       /* DST  */
  YYSYMBOL_SRC = 57,                       /* SRC  */
  YYSYMBOL_PROTO = 58,                     /* PROTO  */
  YYSYMBOL_NEXT = 59,                      /* NEXT  */
  YYSYMBOL_HEADER = 60,                    /* HEADER  */
  YYSYMBOL_DPORT = 61,                     /* DPORT  */
  YYSYMBOL_SPORT = 62,                     /* SPORT  */
  YYSYMBOL_ICMP = 63,                      /* ICMP  */
  YYSYMBOL_TYPE = 64,                      /* TYPE  */
  YYSYMBOL_CODE = 65,                      /* CODE  */
  YYSYMBOL_TCP = 66,                       /* TCP  */
  YYSYMBOL_FLAGS = 67,                     /* FLAGS  */
  YYSYMBOL_LENGTH = 68,                    /* LENGTH  */
  YYSYMBOL_DSCP = 69,                      /* DSCP  */
  YYSYMBOL_DONT_FRAGMENT = 70,             /* DONT_FRAGMENT  */
  YYSYMBOL_IS_FRAGMENT = 71,               /* IS_FRAGMENT  */
  YYSYMBOL_FIRST_FRAGMENT = 72,            /* FIRST_FRAGMENT  */
  YYSYMBOL_LAST_FRAGMENT = 73,             /* LAST_FRAGMENT  */
  YYSYMBOL_FRAGMENT = 74,                  /* FRAGMENT  */
  YYSYMBOL_LABEL = 75,                     /* LABEL  */
  YYSYMBOL_OFFSET = 76,                    /* OFFSET  */
  YYSYMBOL_77_ = 77,                       /* ','  */
  YYSYMBOL_78_ = 78,                       /* '{'  */
  YYSYMBOL_79_ = 79,                       /* '}'  */
  YYSYMBOL_FUNCTION = 80,                  /* FUNCTION  */
  YYSYMBOL_PRINT = 81,                     /* PRINT  */
  YYSYMBOL_PRINTN = 82,                    /* PRINTN  */
  YYSYMBOL_UNSET = 83,                     /* UNSET  */
  YYSYMBOL_RETURN = 84,                    /* RETURN  */
  YYSYMBOL_ACCEPT = 85,                    /* ACCEPT  */
  YYSYMBOL_REJECT = 86,                    /* REJECT  */
  YYSYMBOL_ERROR = 87,                     /* ERROR  */
  YYSYMBOL_INT = 88,                       /* INT  */
  YYSYMBOL_BOOL = 89,                      /* BOOL  */
  YYSYMBOL_IP = 90,                        /* IP  */
  YYSYMBOL_PREFIX = 91,                    /* PREFIX  */
  YYSYMBOL_RD = 92,                        /* RD  */
  YYSYMBOL_PAIR = 93,                      /* PAIR  */
  YYSYMBOL_QUAD = 94,                      /* QUAD  */
  YYSYMBOL_EC = 95,                        /* EC  */
  YYSYMBOL_LC = 96,                        /* LC  */
  YYSYMBOL_SET = 97,                       /* SET  */
  YYSYMBOL_STRING = 98,                    /* STRING  */
  YYSYMBOL_BGPMASK = 99,                   /* BGPMASK  */
  YYSYMBOL_BGPPATH = 100,                  /* BGPPATH  */
  YYSYMBOL_CLIST = 101,                    /* CLIST  */
  YYSYMBOL_ECLIST = 102,                   /* ECLIST  */
  YYSYMBOL_LCLIST = 103,                   /* LCLIST  */
  YYSYMBOL_IF = 104,                       /* IF  */
  YYSYMBOL_THEN = 105,                     /* THEN  */
  YYSYMBOL_ELSE = 106,                     /* ELSE  */
  YYSYMBOL_CASE = 107,                     /* CASE  */
  YYSYMBOL_TRUE = 108,                     /* TRUE  */
  YYSYMBOL_FALSE = 109,                    /* FALSE  */
  YYSYMBOL_RT = 110,                       /* RT  */
  YYSYMBOL_RO = 111,                       /* RO  */
  YYSYMBOL_UNKNOWN = 112,                  /* UNKNOWN  */
  YYSYMBOL_GENERIC = 113,                  /* GENERIC  */
  YYSYMBOL_GW = 114,                       /* GW  */
  YYSYMBOL_NET = 115,                      /* NET  */
  YYSYMBOL_MASK = 116,                     /* MASK  */
  YYSYMBOL_SOURCE = 117,                   /* SOURCE  */
  YYSYMBOL_SCOPE = 118,                    /* SCOPE  */
  YYSYMBOL_DEST = 119,                     /* DEST  */
  YYSYMBOL_IFNAME = 120,                   /* IFNAME  */
  YYSYMBOL_IFINDEX = 121,                  /* IFINDEX  */
  YYSYMBOL_WEIGHT = 122,                   /* WEIGHT  */
  YYSYMBOL_PREFERENCE = 123,               /* PREFERENCE  */
  YYSYMBOL_ROA_CHECK = 124,                /* ROA_CHECK  */
  YYSYMBOL_ASN = 125,                      /* ASN  */
  YYSYMBOL_IS_V4 = 126,                    /* IS_V4  */
  YYSYMBOL_IS_V6 = 127,                    /* IS_V6  */
  YYSYMBOL_LEN = 128,                      /* LEN  */
  YYSYMBOL_MAXLEN = 129,                   /* MAXLEN  */
  YYSYMBOL_DEFINED = 130,                  /* DEFINED  */
  YYSYMBOL_ADD = 131,                      /* ADD  */
  YYSYMBOL_DELETE = 132,                   /* DELETE  */
  YYSYMBOL_CONTAINS = 133,                 /* CONTAINS  */
  YYSYMBOL_RESET = 134,                    /* RESET  */
  YYSYMBOL_PREPEND = 135,                  /* PREPEND  */
  YYSYMBOL_FIRST = 136,                    /* FIRST  */
  YYSYMBOL_LAST = 137,                     /* LAST  */
  YYSYMBOL_LAST_NONAGGREGATED = 138,       /* LAST_NONAGGREGATED  */
  YYSYMBOL_MATCH = 139,                    /* MATCH  */
  YYSYMBOL_EMPTY = 140,                    /* EMPTY  */
  YYSYMBOL_FILTER = 141,                   /* FILTER  */
  YYSYMBOL_WHERE = 142,                    /* WHERE  */
  YYSYMBOL_EVAL = 143,                     /* EVAL  */
  YYSYMBOL_ATTRIBUTE = 144,                /* ATTRIBUTE  */
  YYSYMBOL_BT_ASSERT = 145,                /* BT_ASSERT  */
  YYSYMBOL_BT_TEST_SUITE = 146,            /* BT_TEST_SUITE  */
  YYSYMBOL_BT_CHECK_ASSIGN = 147,          /* BT_CHECK_ASSIGN  */
  YYSYMBOL_BT_TEST_SAME = 148,             /* BT_TEST_SAME  */
  YYSYMBOL_FORMAT = 149,                   /* FORMAT  */
  YYSYMBOL_150_ = 150,                     /* ':'  */
  YYSYMBOL_151_ = 151,                     /* '['  */
  YYSYMBOL_152_ = 152,                     /* ']'  */
  YYSYMBOL_153_ = 153,                     /* '?'  */
  YYSYMBOL_ROUTER = 154,                   /* ROUTER  */
  YYSYMBOL_ID = 155,                       /* ID  */
  YYSYMBOL_HOSTNAME = 156,                 /* HOSTNAME  */
  YYSYMBOL_PROTOCOL = 157,                 /* PROTOCOL  */
  YYSYMBOL_TEMPLATE = 158,                 /* TEMPLATE  */
  YYSYMBOL_DISABLED = 159,                 /* DISABLED  */
  YYSYMBOL_DEBUG = 160,                    /* DEBUG  */
  YYSYMBOL_ALL = 161,                      /* ALL  */
  YYSYMBOL_DIRECT = 162,                   /* DIRECT  */
  YYSYMBOL_INTERFACE = 163,                /* INTERFACE  */
  YYSYMBOL_IMPORT = 164,                   /* IMPORT  */
  YYSYMBOL_EXPORT = 165,                   /* EXPORT  */
  YYSYMBOL_NONE = 166,                     /* NONE  */
  YYSYMBOL_VRF = 167,                      /* VRF  */
  YYSYMBOL_DEFAULT = 168,                  /* DEFAULT  */
  YYSYMBOL_TABLE = 169,                    /* TABLE  */
  YYSYMBOL_STATES = 170,                   /* STATES  */
  YYSYMBOL_ROUTES = 171,                   /* ROUTES  */
  YYSYMBOL_FILTERS = 172,                  /* FILTERS  */
  YYSYMBOL_IPV4 = 173,                     /* IPV4  */
  YYSYMBOL_IPV6 = 174,                     /* IPV6  */
  YYSYMBOL_VPN4 = 175,                     /* VPN4  */
  YYSYMBOL_VPN6 = 176,                     /* VPN6  */
  YYSYMBOL_ROA4 = 177,                     /* ROA4  */
  YYSYMBOL_ROA6 = 178,                     /* ROA6  */
  YYSYMBOL_SADR = 179,                     /* SADR  */
  YYSYMBOL_RECEIVE = 180,                  /* RECEIVE  */
  YYSYMBOL_LIMIT = 181,                    /* LIMIT  */
  YYSYMBOL_ACTION = 182,                   /* ACTION  */
  YYSYMBOL_WARN = 183,                     /* WARN  */
  YYSYMBOL_BLOCK = 184,                    /* BLOCK  */
  YYSYMBOL_RESTART = 185,                  /* RESTART  */
  YYSYMBOL_DISABLE = 186,                  /* DISABLE  */
  YYSYMBOL_KEEP = 187,                     /* KEEP  */
  YYSYMBOL_FILTERED = 188,                 /* FILTERED  */
  YYSYMBOL_RPKI = 189,                     /* RPKI  */
  YYSYMBOL_PASSWORD = 190,                 /* PASSWORD  */
  YYSYMBOL_PASSIVE = 191,                  /* PASSIVE  */
  YYSYMBOL_TO = 192,                       /* TO  */
  YYSYMBOL_EVENTS = 193,                   /* EVENTS  */
  YYSYMBOL_PACKETS = 194,                  /* PACKETS  */
  YYSYMBOL_PROTOCOLS = 195,                /* PROTOCOLS  */
  YYSYMBOL_CHANNELS = 196,                 /* CHANNELS  */
  YYSYMBOL_INTERFACES = 197,               /* INTERFACES  */
  YYSYMBOL_ALGORITHM = 198,                /* ALGORITHM  */
  YYSYMBOL_KEYED = 199,                    /* KEYED  */
  YYSYMBOL_HMAC = 200,                     /* HMAC  */
  YYSYMBOL_MD5 = 201,                      /* MD5  */
  YYSYMBOL_SHA1 = 202,                     /* SHA1  */
  YYSYMBOL_SHA256 = 203,                   /* SHA256  */
  YYSYMBOL_SHA384 = 204,                   /* SHA384  */
  YYSYMBOL_SHA512 = 205,                   /* SHA512  */
  YYSYMBOL_PRIMARY = 206,                  /* PRIMARY  */
  YYSYMBOL_STATS = 207,                    /* STATS  */
  YYSYMBOL_COUNT = 208,                    /* COUNT  */
  YYSYMBOL_BY = 209,                       /* BY  */
  YYSYMBOL_FOR = 210,                      /* FOR  */
  YYSYMBOL_COMMANDS = 211,                 /* COMMANDS  */
  YYSYMBOL_PREEXPORT = 212,                /* PREEXPORT  */
  YYSYMBOL_NOEXPORT = 213,                 /* NOEXPORT  */
  YYSYMBOL_EXPORTED = 214,                 /* EXPORTED  */
  YYSYMBOL_GENERATE = 215,                 /* GENERATE  */
  YYSYMBOL_BGP = 216,                      /* BGP  */
  YYSYMBOL_PASSWORDS = 217,                /* PASSWORDS  */
  YYSYMBOL_DESCRIPTION = 218,              /* DESCRIPTION  */
  YYSYMBOL_SORTED = 219,                   /* SORTED  */
  YYSYMBOL_RELOAD = 220,                   /* RELOAD  */
  YYSYMBOL_IN = 221,                       /* IN  */
  YYSYMBOL_OUT = 222,                      /* OUT  */
  YYSYMBOL_MRTDUMP = 223,                  /* MRTDUMP  */
  YYSYMBOL_MESSAGES = 224,                 /* MESSAGES  */
  YYSYMBOL_RESTRICT = 225,                 /* RESTRICT  */
  YYSYMBOL_MEMORY = 226,                   /* MEMORY  */
  YYSYMBOL_IGP_METRIC = 227,               /* IGP_METRIC  */
  YYSYMBOL_CLASS = 228,                    /* CLASS  */
  YYSYMBOL_TIMEFORMAT = 229,               /* TIMEFORMAT  */
  YYSYMBOL_ISO = 230,                      /* ISO  */
  YYSYMBOL_SHORT = 231,                    /* SHORT  */
  YYSYMBOL_LONG = 232,                     /* LONG  */
  YYSYMBOL_ROUTE = 233,                    /* ROUTE  */
  YYSYMBOL_BASE = 234,                     /* BASE  */
  YYSYMBOL_LOG = 235,                      /* LOG  */
  YYSYMBOL_GRACEFUL = 236,                 /* GRACEFUL  */
  YYSYMBOL_WAIT = 237,                     /* WAIT  */
  YYSYMBOL_MAX = 238,                      /* MAX  */
  YYSYMBOL_FLUSH = 239,                    /* FLUSH  */
  YYSYMBOL_AS = 240,                       /* AS  */
  YYSYMBOL_MIN = 241,                      /* MIN  */
  YYSYMBOL_IDLE = 242,                     /* IDLE  */
  YYSYMBOL_RX = 243,                       /* RX  */
  YYSYMBOL_TX = 244,                       /* TX  */
  YYSYMBOL_INTERVAL = 245,                 /* INTERVAL  */
  YYSYMBOL_MULTIPLIER = 246,               /* MULTIPLIER  */
  YYSYMBOL_CHECK = 247,                    /* CHECK  */
  YYSYMBOL_LINK = 248,                     /* LINK  */
  YYSYMBOL_IPV4_MC = 249,                  /* IPV4_MC  */
  YYSYMBOL_IPV4_MPLS = 250,                /* IPV4_MPLS  */
  YYSYMBOL_IPV6_MC = 251,                  /* IPV6_MC  */
  YYSYMBOL_IPV6_MPLS = 252,                /* IPV6_MPLS  */
  YYSYMBOL_IPV6_SADR = 253,                /* IPV6_SADR  */
  YYSYMBOL_VPN4_MC = 254,                  /* VPN4_MC  */
  YYSYMBOL_VPN4_MPLS = 255,                /* VPN4_MPLS  */
  YYSYMBOL_VPN6_MC = 256,                  /* VPN6_MC  */
  YYSYMBOL_VPN6_MPLS = 257,                /* VPN6_MPLS  */
  YYSYMBOL_PRI = 258,                      /* PRI  */
  YYSYMBOL_SEC = 259,                      /* SEC  */
  YYSYMBOL_SHOW = 260,                     /* SHOW  */
  YYSYMBOL_STATUS = 261,                   /* STATUS  */
  YYSYMBOL_SUMMARY = 262,                  /* SUMMARY  */
  YYSYMBOL_SYMBOLS = 263,                  /* SYMBOLS  */
  YYSYMBOL_DUMP = 264,                     /* DUMP  */
  YYSYMBOL_RESOURCES = 265,                /* RESOURCES  */
  YYSYMBOL_SOCKETS = 266,                  /* SOCKETS  */
  YYSYMBOL_NEIGHBORS = 267,                /* NEIGHBORS  */
  YYSYMBOL_ATTRIBUTES = 268,               /* ATTRIBUTES  */
  YYSYMBOL_ECHO = 269,                     /* ECHO  */
  YYSYMBOL_ENABLE = 270,                   /* ENABLE  */
  YYSYMBOL_BABEL = 271,                    /* BABEL  */
  YYSYMBOL_METRIC = 272,                   /* METRIC  */
  YYSYMBOL_RXCOST = 273,                   /* RXCOST  */
  YYSYMBOL_HELLO = 274,                    /* HELLO  */
  YYSYMBOL_UPDATE = 275,                   /* UPDATE  */
  YYSYMBOL_WIRED = 276,                    /* WIRED  */
  YYSYMBOL_WIRELESS = 277,                 /* WIRELESS  */
  YYSYMBOL_BUFFER = 278,                   /* BUFFER  */
  YYSYMBOL_PRIORITY = 279,                 /* PRIORITY  */
  YYSYMBOL_HOP = 280,                      /* HOP  */
  YYSYMBOL_BABEL_METRIC = 281,             /* BABEL_METRIC  */
  YYSYMBOL_ENTRIES = 282,                  /* ENTRIES  */
  YYSYMBOL_RANDOMIZE = 283,                /* RANDOMIZE  */
  YYSYMBOL_BFD = 284,                      /* BFD  */
  YYSYMBOL_MULTIHOP = 285,                 /* MULTIHOP  */
  YYSYMBOL_NEIGHBOR = 286,                 /* NEIGHBOR  */
  YYSYMBOL_DEV = 287,                      /* DEV  */
  YYSYMBOL_LOCAL = 288,                    /* LOCAL  */
  YYSYMBOL_AUTHENTICATION = 289,           /* AUTHENTICATION  */
  YYSYMBOL_SIMPLE = 290,                   /* SIMPLE  */
  YYSYMBOL_METICULOUS = 291,               /* METICULOUS  */
  YYSYMBOL_SESSIONS = 292,                 /* SESSIONS  */
  YYSYMBOL_HOLD = 293,                     /* HOLD  */
  YYSYMBOL_TIME = 294,                     /* TIME  */
  YYSYMBOL_CONNECT = 295,                  /* CONNECT  */
  YYSYMBOL_RETRY = 296,                    /* RETRY  */
  YYSYMBOL_KEEPALIVE = 297,                /* KEEPALIVE  */
  YYSYMBOL_STARTUP = 298,                  /* STARTUP  */
  YYSYMBOL_VIA = 299,                      /* VIA  */
  YYSYMBOL_SELF = 300,                     /* SELF  */
  YYSYMBOL_PATH = 301,                     /* PATH  */
  YYSYMBOL_START = 302,                    /* START  */
  YYSYMBOL_DELAY = 303,                    /* DELAY  */
  YYSYMBOL_FORGET = 304,                   /* FORGET  */
  YYSYMBOL_AFTER = 305,                    /* AFTER  */
  YYSYMBOL_BGP_PATH = 306,                 /* BGP_PATH  */
  YYSYMBOL_BGP_LOCAL_PREF = 307,           /* BGP_LOCAL_PREF  */
  YYSYMBOL_BGP_MED = 308,                  /* BGP_MED  */
  YYSYMBOL_BGP_ORIGIN = 309,               /* BGP_ORIGIN  */
  YYSYMBOL_BGP_NEXT_HOP = 310,             /* BGP_NEXT_HOP  */
  YYSYMBOL_BGP_ATOMIC_AGGR = 311,          /* BGP_ATOMIC_AGGR  */
  YYSYMBOL_BGP_AGGREGATOR = 312,           /* BGP_AGGREGATOR  */
  YYSYMBOL_BGP_COMMUNITY = 313,            /* BGP_COMMUNITY  */
  YYSYMBOL_BGP_EXT_COMMUNITY = 314,        /* BGP_EXT_COMMUNITY  */
  YYSYMBOL_BGP_LARGE_COMMUNITY = 315,      /* BGP_LARGE_COMMUNITY  */
  YYSYMBOL_ADDRESS = 316,                  /* ADDRESS  */
  YYSYMBOL_RR = 317,                       /* RR  */
  YYSYMBOL_RS = 318,                       /* RS  */
  YYSYMBOL_CLIENT = 319,                   /* CLIENT  */
  YYSYMBOL_CLUSTER = 320,                  /* CLUSTER  */
  YYSYMBOL_AS4 = 321,                      /* AS4  */
  YYSYMBOL_ADVERTISE = 322,                /* ADVERTISE  */
  YYSYMBOL_CAPABILITIES = 323,             /* CAPABILITIES  */
  YYSYMBOL_PREFER = 324,                   /* PREFER  */
  YYSYMBOL_OLDER = 325,                    /* OLDER  */
  YYSYMBOL_MISSING = 326,                  /* MISSING  */
  YYSYMBOL_LLADDR = 327,                   /* LLADDR  */
  YYSYMBOL_DROP = 328,                     /* DROP  */
  YYSYMBOL_IGNORE = 329,                   /* IGNORE  */
  YYSYMBOL_REFRESH = 330,                  /* REFRESH  */
  YYSYMBOL_INTERPRET = 331,                /* INTERPRET  */
  YYSYMBOL_COMMUNITIES = 332,              /* COMMUNITIES  */
  YYSYMBOL_BGP_ORIGINATOR_ID = 333,        /* BGP_ORIGINATOR_ID  */
  YYSYMBOL_BGP_CLUSTER_LIST = 334,         /* BGP_CLUSTER_LIST  */
  YYSYMBOL_IGP = 335,                      /* IGP  */
  YYSYMBOL_GATEWAY = 336,                  /* GATEWAY  */
  YYSYMBOL_RECURSIVE = 337,                /* RECURSIVE  */
  YYSYMBOL_MED = 338,                      /* MED  */
  YYSYMBOL_TTL = 339,                      /* TTL  */
  YYSYMBOL_SECURITY = 340,                 /* SECURITY  */
  YYSYMBOL_DETERMINISTIC = 341,            /* DETERMINISTIC  */
  YYSYMBOL_SECONDARY = 342,                /* SECONDARY  */
  YYSYMBOL_ALLOW = 343,                    /* ALLOW  */
  YYSYMBOL_PATHS = 344,                    /* PATHS  */
  YYSYMBOL_AWARE = 345,                    /* AWARE  */
  YYSYMBOL_EXTENDED = 346,                 /* EXTENDED  */
  YYSYMBOL_SETKEY = 347,                   /* SETKEY  */
  YYSYMBOL_STRICT = 348,                   /* STRICT  */
  YYSYMBOL_BIND = 349,                     /* BIND  */
  YYSYMBOL_CONFEDERATION = 350,            /* CONFEDERATION  */
  YYSYMBOL_MEMBER = 351,                   /* MEMBER  */
  YYSYMBOL_MULTICAST = 352,                /* MULTICAST  */
  YYSYMBOL_LIVED = 353,                    /* LIVED  */
  YYSYMBOL_STALE = 354,                    /* STALE  */
  YYSYMBOL_IBGP = 355,                     /* IBGP  */
  YYSYMBOL_EBGP = 356,                     /* EBGP  */
  YYSYMBOL_MANDATORY = 357,                /* MANDATORY  */
  YYSYMBOL_INTERNAL = 358,                 /* INTERNAL  */
  YYSYMBOL_EXTERNAL = 359,                 /* EXTERNAL  */
  YYSYMBOL_SETS = 360,                     /* SETS  */
  YYSYMBOL_DYNAMIC = 361,                  /* DYNAMIC  */
  YYSYMBOL_RANGE = 362,                    /* RANGE  */
  YYSYMBOL_NAME = 363,                     /* NAME  */
  YYSYMBOL_DIGITS = 364,                   /* DIGITS  */
  YYSYMBOL_BGP_AIGP = 365,                 /* BGP_AIGP  */
  YYSYMBOL_AIGP = 366,                     /* AIGP  */
  YYSYMBOL_ORIGINATE = 367,                /* ORIGINATE  */
  YYSYMBOL_COST = 368,                     /* COST  */
  YYSYMBOL_ENFORCE = 369,                  /* ENFORCE  */
  YYSYMBOL_CEASE = 370,                    /* CEASE  */
  YYSYMBOL_HIT = 371,                      /* HIT  */
  YYSYMBOL_ADMINISTRATIVE = 372,           /* ADMINISTRATIVE  */
  YYSYMBOL_SHUTDOWN = 373,                 /* SHUTDOWN  */
  YYSYMBOL_PEER = 374,                     /* PEER  */
  YYSYMBOL_CONFIGURATION = 375,            /* CONFIGURATION  */
  YYSYMBOL_CHANGE = 376,                   /* CHANGE  */
  YYSYMBOL_DECONFIGURED = 377,             /* DECONFIGURED  */
  YYSYMBOL_CONNECTION = 378,               /* CONNECTION  */
  YYSYMBOL_REJECTED = 379,                 /* REJECTED  */
  YYSYMBOL_COLLISION = 380,                /* COLLISION  */
  YYSYMBOL_OF = 381,                       /* OF  */
  YYSYMBOL_MRT = 382,                      /* MRT  */
  YYSYMBOL_FILENAME = 383,                 /* FILENAME  */
  YYSYMBOL_PERIOD = 384,                   /* PERIOD  */
  YYSYMBOL_ALWAYS = 385,                   /* ALWAYS  */
  YYSYMBOL_OSPF = 386,                     /* OSPF  */
  YYSYMBOL_V2 = 387,                       /* V2  */
  YYSYMBOL_V3 = 388,                       /* V3  */
  YYSYMBOL_OSPF_METRIC1 = 389,             /* OSPF_METRIC1  */
  YYSYMBOL_OSPF_METRIC2 = 390,             /* OSPF_METRIC2  */
  YYSYMBOL_OSPF_TAG = 391,                 /* OSPF_TAG  */
  YYSYMBOL_OSPF_ROUTER_ID = 392,           /* OSPF_ROUTER_ID  */
  YYSYMBOL_AREA = 393,                     /* AREA  */
  YYSYMBOL_RFC1583COMPAT = 394,            /* RFC1583COMPAT  */
  YYSYMBOL_STUB = 395,                     /* STUB  */
  YYSYMBOL_TICK = 396,                     /* TICK  */
  YYSYMBOL_COST2 = 397,                    /* COST2  */
  YYSYMBOL_RETRANSMIT = 398,               /* RETRANSMIT  */
  YYSYMBOL_TRANSMIT = 399,                 /* TRANSMIT  */
  YYSYMBOL_DEAD = 400,                     /* DEAD  */
  YYSYMBOL_BROADCAST = 401,                /* BROADCAST  */
  YYSYMBOL_BCAST = 402,                    /* BCAST  */
  YYSYMBOL_NONBROADCAST = 403,             /* NONBROADCAST  */
  YYSYMBOL_NBMA = 404,                     /* NBMA  */
  YYSYMBOL_POINTOPOINT = 405,              /* POINTOPOINT  */
  YYSYMBOL_PTP = 406,                      /* PTP  */
  YYSYMBOL_POINTOMULTIPOINT = 407,         /* POINTOMULTIPOINT  */
  YYSYMBOL_PTMP = 408,                     /* PTMP  */
  YYSYMBOL_CRYPTOGRAPHIC = 409,            /* CRYPTOGRAPHIC  */
  YYSYMBOL_ELIGIBLE = 410,                 /* ELIGIBLE  */
  YYSYMBOL_POLL = 411,                     /* POLL  */
  YYSYMBOL_NETWORKS = 412,                 /* NETWORKS  */
  YYSYMBOL_HIDDEN = 413,                   /* HIDDEN  */
  YYSYMBOL_VIRTUAL = 414,                  /* VIRTUAL  */
  YYSYMBOL_ONLY = 415,                     /* ONLY  */
  YYSYMBOL_LARGE = 416,                    /* LARGE  */
  YYSYMBOL_NORMAL = 417,                   /* NORMAL  */
  YYSYMBOL_STUBNET = 418,                  /* STUBNET  */
  YYSYMBOL_TAG = 419,                      /* TAG  */
  YYSYMBOL_LSADB = 420,                    /* LSADB  */
  YYSYMBOL_ECMP = 421,                     /* ECMP  */
  YYSYMBOL_NSSA = 422,                     /* NSSA  */
  YYSYMBOL_TRANSLATOR = 423,               /* TRANSLATOR  */
  YYSYMBOL_STABILITY = 424,                /* STABILITY  */
  YYSYMBOL_GLOBAL = 425,                   /* GLOBAL  */
  YYSYMBOL_LSID = 426,                     /* LSID  */
  YYSYMBOL_INSTANCE = 427,                 /* INSTANCE  */
  YYSYMBOL_REAL = 428,                     /* REAL  */
  YYSYMBOL_NETMASK = 429,                  /* NETMASK  */
  YYSYMBOL_MERGE = 430,                    /* MERGE  */
  YYSYMBOL_LSA = 431,                      /* LSA  */
  YYSYMBOL_SUPPRESSION = 432,              /* SUPPRESSION  */
  YYSYMBOL_RFC5838 = 433,                  /* RFC5838  */
  YYSYMBOL_PE = 434,                       /* PE  */
  YYSYMBOL_TOPOLOGY = 435,                 /* TOPOLOGY  */
  YYSYMBOL_STATE = 436,                    /* STATE  */
  YYSYMBOL_PERF = 437,                     /* PERF  */
  YYSYMBOL_EXP = 438,                      /* EXP  */
  YYSYMBOL_REPEAT = 439,                   /* REPEAT  */
  YYSYMBOL_THRESHOLD = 440,                /* THRESHOLD  */
  YYSYMBOL_MODE = 441,                     /* MODE  */
  YYSYMBOL_PIPE = 442,                     /* PIPE  */
  YYSYMBOL_RADV = 443,                     /* RADV  */
  YYSYMBOL_RA = 444,                       /* RA  */
  YYSYMBOL_SOLICITED = 445,                /* SOLICITED  */
  YYSYMBOL_UNICAST = 446,                  /* UNICAST  */
  YYSYMBOL_MANAGED = 447,                  /* MANAGED  */
  YYSYMBOL_OTHER = 448,                    /* OTHER  */
  YYSYMBOL_CONFIG = 449,                   /* CONFIG  */
  YYSYMBOL_LINGER = 450,                   /* LINGER  */
  YYSYMBOL_MTU = 451,                      /* MTU  */
  YYSYMBOL_REACHABLE = 452,                /* REACHABLE  */
  YYSYMBOL_RETRANS = 453,                  /* RETRANS  */
  YYSYMBOL_TIMER = 454,                    /* TIMER  */
  YYSYMBOL_CURRENT = 455,                  /* CURRENT  */
  YYSYMBOL_VALID = 456,                    /* VALID  */
  YYSYMBOL_PREFERRED = 457,                /* PREFERRED  */
  YYSYMBOL_MULT = 458,                     /* MULT  */
  YYSYMBOL_LIFETIME = 459,                 /* LIFETIME  */
  YYSYMBOL_SKIP = 460,                     /* SKIP  */
  YYSYMBOL_ONLINK = 461,                   /* ONLINK  */
  YYSYMBOL_AUTONOMOUS = 462,               /* AUTONOMOUS  */
  YYSYMBOL_RDNSS = 463,                    /* RDNSS  */
  YYSYMBOL_DNSSL = 464,                    /* DNSSL  */
  YYSYMBOL_NS = 465,                       /* NS  */
  YYSYMBOL_DOMAIN = 466,                   /* DOMAIN  */
  YYSYMBOL_TRIGGER = 467,                  /* TRIGGER  */
  YYSYMBOL_SENSITIVE = 468,                /* SENSITIVE  */
  YYSYMBOL_LOW = 469,                      /* LOW  */
  YYSYMBOL_MEDIUM = 470,                   /* MEDIUM  */
  YYSYMBOL_HIGH = 471,                     /* HIGH  */
  YYSYMBOL_PROPAGATE = 472,                /* PROPAGATE  */
  YYSYMBOL_RA_PREFERENCE = 473,            /* RA_PREFERENCE  */
  YYSYMBOL_RA_LIFETIME = 474,              /* RA_LIFETIME  */
  YYSYMBOL_RIP = 475,                      /* RIP  */
  YYSYMBOL_NG = 476,                       /* NG  */
  YYSYMBOL_INFINITY = 477,                 /* INFINITY  */
  YYSYMBOL_TIMEOUT = 478,                  /* TIMEOUT  */
  YYSYMBOL_GARBAGE = 479,                  /* GARBAGE  */
  YYSYMBOL_VERSION = 480,                  /* VERSION  */
  YYSYMBOL_SPLIT = 481,                    /* SPLIT  */
  YYSYMBOL_HORIZON = 482,                  /* HORIZON  */
  YYSYMBOL_POISON = 483,                   /* POISON  */
  YYSYMBOL_REVERSE = 484,                  /* REVERSE  */
  YYSYMBOL_ZERO = 485,                     /* ZERO  */
  YYSYMBOL_PLAINTEXT = 486,                /* PLAINTEXT  */
  YYSYMBOL_DEMAND = 487,                   /* DEMAND  */
  YYSYMBOL_CIRCUIT = 488,                  /* CIRCUIT  */
  YYSYMBOL_RIP_METRIC = 489,               /* RIP_METRIC  */
  YYSYMBOL_RIP_TAG = 490,                  /* RIP_TAG  */
  YYSYMBOL_REMOTE = 491,                   /* REMOTE  */
  YYSYMBOL_BIRD = 492,                     /* BIRD  */
  YYSYMBOL_PRIVATE = 493,                  /* PRIVATE  */
  YYSYMBOL_PUBLIC = 494,                   /* PUBLIC  */
  YYSYMBOL_KEY = 495,                      /* KEY  */
  YYSYMBOL_SSH = 496,                      /* SSH  */
  YYSYMBOL_TRANSPORT = 497,                /* TRANSPORT  */
  YYSYMBOL_USER = 498,                     /* USER  */
  YYSYMBOL_EXPIRE = 499,                   /* EXPIRE  */
  YYSYMBOL_STATIC = 500,                   /* STATIC  */
  YYSYMBOL_PROHIBIT = 501,                 /* PROHIBIT  */
  YYSYMBOL_BLACKHOLE = 502,                /* BLACKHOLE  */
  YYSYMBOL_UNREACHABLE = 503,              /* UNREACHABLE  */
  YYSYMBOL_KERNEL = 504,                   /* KERNEL  */
  YYSYMBOL_KRT_PREFSRC = 505,              /* KRT_PREFSRC  */
  YYSYMBOL_KRT_REALM = 506,                /* KRT_REALM  */
  YYSYMBOL_KRT_SCOPE = 507,                /* KRT_SCOPE  */
  YYSYMBOL_KRT_MTU = 508,                  /* KRT_MTU  */
  YYSYMBOL_KRT_WINDOW = 509,               /* KRT_WINDOW  */
  YYSYMBOL_KRT_RTT = 510,                  /* KRT_RTT  */
  YYSYMBOL_KRT_RTTVAR = 511,               /* KRT_RTTVAR  */
  YYSYMBOL_KRT_SSTRESH = 512,              /* KRT_SSTRESH  */
  YYSYMBOL_KRT_CWND = 513,                 /* KRT_CWND  */
  YYSYMBOL_KRT_ADVMSS = 514,               /* KRT_ADVMSS  */
  YYSYMBOL_KRT_REORDERING = 515,           /* KRT_REORDERING  */
  YYSYMBOL_KRT_HOPLIMIT = 516,             /* KRT_HOPLIMIT  */
  YYSYMBOL_KRT_INITCWND = 517,             /* KRT_INITCWND  */
  YYSYMBOL_KRT_RTO_MIN = 518,              /* KRT_RTO_MIN  */
  YYSYMBOL_KRT_INITRWND = 519,             /* KRT_INITRWND  */
  YYSYMBOL_KRT_QUICKACK = 520,             /* KRT_QUICKACK  */
  YYSYMBOL_KRT_LOCK_MTU = 521,             /* KRT_LOCK_MTU  */
  YYSYMBOL_KRT_LOCK_WINDOW = 522,          /* KRT_LOCK_WINDOW  */
  YYSYMBOL_KRT_LOCK_RTT = 523,             /* KRT_LOCK_RTT  */
  YYSYMBOL_KRT_LOCK_RTTVAR = 524,          /* KRT_LOCK_RTTVAR  */
  YYSYMBOL_KRT_LOCK_SSTRESH = 525,         /* KRT_LOCK_SSTRESH  */
  YYSYMBOL_KRT_LOCK_CWND = 526,            /* KRT_LOCK_CWND  */
  YYSYMBOL_KRT_LOCK_ADVMSS = 527,          /* KRT_LOCK_ADVMSS  */
  YYSYMBOL_KRT_LOCK_REORDERING = 528,      /* KRT_LOCK_REORDERING  */
  YYSYMBOL_KRT_LOCK_HOPLIMIT = 529,        /* KRT_LOCK_HOPLIMIT  */
  YYSYMBOL_KRT_LOCK_RTO_MIN = 530,         /* KRT_LOCK_RTO_MIN  */
  YYSYMBOL_KRT_FEATURE_ECN = 531,          /* KRT_FEATURE_ECN  */
  YYSYMBOL_KRT_FEATURE_ALLFRAG = 532,      /* KRT_FEATURE_ALLFRAG  */
  YYSYMBOL_SYSLOG = 533,                   /* SYSLOG  */
  YYSYMBOL_TRACE = 534,                    /* TRACE  */
  YYSYMBOL_INFO = 535,                     /* INFO  */
  YYSYMBOL_WARNING = 536,                  /* WARNING  */
  YYSYMBOL_AUTH = 537,                     /* AUTH  */
  YYSYMBOL_FATAL = 538,                    /* FATAL  */
  YYSYMBOL_BUG = 539,                      /* BUG  */
  YYSYMBOL_STDERR = 540,                   /* STDERR  */
  YYSYMBOL_SOFT = 541,                     /* SOFT  */
  YYSYMBOL_CONFIRM = 542,                  /* CONFIRM  */
  YYSYMBOL_UNDO = 543,                     /* UNDO  */
  YYSYMBOL_LATENCY = 544,                  /* LATENCY  */
  YYSYMBOL_WATCHDOG = 545,                 /* WATCHDOG  */
  YYSYMBOL_CONFIGURE = 546,                /* CONFIGURE  */
  YYSYMBOL_DOWN = 547,                     /* DOWN  */
  YYSYMBOL_PERSIST = 548,                  /* PERSIST  */
  YYSYMBOL_SCAN = 549,                     /* SCAN  */
  YYSYMBOL_LEARN = 550,                    /* LEARN  */
  YYSYMBOL_DEVICE = 551,                   /* DEVICE  */
  YYSYMBOL_KRT_SOURCE = 552,               /* KRT_SOURCE  */
  YYSYMBOL_KRT_METRIC = 553,               /* KRT_METRIC  */
  YYSYMBOL_YYACCEPT = 554,                 /* $accept  */
  YYSYMBOL_cli_cmd = 555,                  /* cli_cmd  */
  YYSYMBOL_cmd_QUIT = 556,                 /* cmd_QUIT  */
  YYSYMBOL_cmd_EXIT = 557,                 /* cmd_EXIT  */
  YYSYMBOL_cmd_HELP = 558,                 /* cmd_HELP  */
  YYSYMBOL_config = 559,                   /* config  */
  YYSYMBOL_conf_entries = 560,             /* conf_entries  */
  YYSYMBOL_conf = 561,                     /* conf  */
  YYSYMBOL_definition = 562,               /* definition  */
  YYSYMBOL_expr = 563,                     /* expr  */
  YYSYMBOL_expr_us = 564,                  /* expr_us  */
  YYSYMBOL_symbol = 565,                   /* symbol  */
  YYSYMBOL_bool = 566,                     /* bool  */
  YYSYMBOL_ipa = 567,                      /* ipa  */
  YYSYMBOL_ipa_scope = 568,                /* ipa_scope  */
  YYSYMBOL_pxlen4 = 569,                   /* pxlen4  */
  YYSYMBOL_net_ip4_ = 570,                 /* net_ip4_  */
  YYSYMBOL_net_ip6_ = 571,                 /* net_ip6_  */
  YYSYMBOL_net_ip6_sadr_ = 572,            /* net_ip6_sadr_  */
  YYSYMBOL_net_vpn4_ = 573,                /* net_vpn4_  */
  YYSYMBOL_net_vpn6_ = 574,                /* net_vpn6_  */
  YYSYMBOL_net_roa4_ = 575,                /* net_roa4_  */
  YYSYMBOL_net_roa6_ = 576,                /* net_roa6_  */
  YYSYMBOL_net_mpls_ = 577,                /* net_mpls_  */
  YYSYMBOL_net_ip_ = 578,                  /* net_ip_  */
  YYSYMBOL_net_vpn_ = 579,                 /* net_vpn_  */
  YYSYMBOL_net_roa_ = 580,                 /* net_roa_  */
  YYSYMBOL_net_ = 581,                     /* net_  */
  YYSYMBOL_net_ip6 = 582,                  /* net_ip6  */
  YYSYMBOL_net_ip = 583,                   /* net_ip  */
  YYSYMBOL_net_any = 584,                  /* net_any  */
  YYSYMBOL_net_or_ipa = 585,               /* net_or_ipa  */
  YYSYMBOL_label_stack_start = 586,        /* label_stack_start  */
  YYSYMBOL_label_stack = 587,              /* label_stack  */
  YYSYMBOL_time = 588,                     /* time  */
  YYSYMBOL_text = 589,                     /* text  */
  YYSYMBOL_opttext = 590,                  /* opttext  */
  YYSYMBOL_flow_num_op = 591,              /* flow_num_op  */
  YYSYMBOL_flow_logic_op = 592,            /* flow_logic_op  */
  YYSYMBOL_flow_num_type_ = 593,           /* flow_num_type_  */
  YYSYMBOL_flow_num_type = 594,            /* flow_num_type  */
  YYSYMBOL_flow_flag_type = 595,           /* flow_flag_type  */
  YYSYMBOL_flow_frag_type = 596,           /* flow_frag_type  */
  YYSYMBOL_flow_label_type = 597,          /* flow_label_type  */
  YYSYMBOL_flow_srcdst = 598,              /* flow_srcdst  */
  YYSYMBOL_flow_num_opts = 599,            /* flow_num_opts  */
  YYSYMBOL_flow_num_opt_ext_expr = 600,    /* flow_num_opt_ext_expr  */
  YYSYMBOL_flow_num_opt_ext = 601,         /* flow_num_opt_ext  */
  YYSYMBOL_flow_bmk_opts = 602,            /* flow_bmk_opts  */
  YYSYMBOL_flow_neg = 603,                 /* flow_neg  */
  YYSYMBOL_flow_frag_val = 604,            /* flow_frag_val  */
  YYSYMBOL_flow_frag_opts = 605,           /* flow_frag_opts  */
  YYSYMBOL_flow4_item = 606,               /* flow4_item  */
  YYSYMBOL_flow6_item = 607,               /* flow6_item  */
  YYSYMBOL_flow4_opts = 608,               /* flow4_opts  */
  YYSYMBOL_flow6_opts = 609,               /* flow6_opts  */
  YYSYMBOL_flow_builder_init = 610,        /* flow_builder_init  */
  YYSYMBOL_flow_builder_set_ipv4 = 611,    /* flow_builder_set_ipv4  */
  YYSYMBOL_flow_builder_set_ipv6 = 612,    /* flow_builder_set_ipv6  */
  YYSYMBOL_net_flow4_ = 613,               /* net_flow4_  */
  YYSYMBOL_net_flow6_ = 614,               /* net_flow6_  */
  YYSYMBOL_net_flow_ = 615,                /* net_flow_  */
  YYSYMBOL_filter_def = 616,               /* filter_def  */
  YYSYMBOL_617_1 = 617,                    /* $@1  */
  YYSYMBOL_filter_eval = 618,              /* filter_eval  */
  YYSYMBOL_custom_attr = 619,              /* custom_attr  */
  YYSYMBOL_bt_test_suite = 620,            /* bt_test_suite  */
  YYSYMBOL_bt_test_same = 621,             /* bt_test_same  */
  YYSYMBOL_type = 622,                     /* type  */
  YYSYMBOL_function_argsn = 623,           /* function_argsn  */
  YYSYMBOL_function_args = 624,            /* function_args  */
  YYSYMBOL_function_vars = 625,            /* function_vars  */
  YYSYMBOL_filter_body = 626,              /* filter_body  */
  YYSYMBOL_filter = 627,                   /* filter  */
  YYSYMBOL_where_filter = 628,             /* where_filter  */
  YYSYMBOL_function_body = 629,            /* function_body  */
  YYSYMBOL_function_def = 630,             /* function_def  */
  YYSYMBOL_631_2 = 631,                    /* $@2  */
  YYSYMBOL_cmds = 632,                     /* cmds  */
  YYSYMBOL_cmd_prep = 633,                 /* cmd_prep  */
  YYSYMBOL_cmds_int = 634,                 /* cmds_int  */
  YYSYMBOL_block = 635,                    /* block  */
  YYSYMBOL_fipa = 636,                     /* fipa  */
  YYSYMBOL_set_atom = 637,                 /* set_atom  */
  YYSYMBOL_switch_atom = 638,              /* switch_atom  */
  YYSYMBOL_cnum = 639,                     /* cnum  */
  YYSYMBOL_pair_item = 640,                /* pair_item  */
  YYSYMBOL_ec_kind = 641,                  /* ec_kind  */
  YYSYMBOL_ec_item = 642,                  /* ec_item  */
  YYSYMBOL_lc_item = 643,                  /* lc_item  */
  YYSYMBOL_set_item = 644,                 /* set_item  */
  YYSYMBOL_switch_item = 645,              /* switch_item  */
  YYSYMBOL_set_items = 646,                /* set_items  */
  YYSYMBOL_switch_items = 647,             /* switch_items  */
  YYSYMBOL_fprefix = 648,                  /* fprefix  */
  YYSYMBOL_fprefix_set = 649,              /* fprefix_set  */
  YYSYMBOL_switch_body = 650,              /* switch_body  */
  YYSYMBOL_bgp_path_expr = 651,            /* bgp_path_expr  */
  YYSYMBOL_bgp_path = 652,                 /* bgp_path  */
  YYSYMBOL_bgp_path_tail = 653,            /* bgp_path_tail  */
  YYSYMBOL_constant = 654,                 /* constant  */
  YYSYMBOL_constructor = 655,              /* constructor  */
  YYSYMBOL_var_list = 656,                 /* var_list  */
  YYSYMBOL_function_call = 657,            /* function_call  */
  YYSYMBOL_symbol_value = 658,             /* symbol_value  */
  YYSYMBOL_static_attr = 659,              /* static_attr  */
  YYSYMBOL_term = 660,                     /* term  */
  YYSYMBOL_break_command = 661,            /* break_command  */
  YYSYMBOL_print_list = 662,               /* print_list  */
  YYSYMBOL_cmd = 663,                      /* cmd  */
  YYSYMBOL_get_cf_position = 664,          /* get_cf_position  */
  YYSYMBOL_lvalue = 665,                   /* lvalue  */
  YYSYMBOL_rtrid = 666,                    /* rtrid  */
  YYSYMBOL_idval = 667,                    /* idval  */
  YYSYMBOL_hostname_override = 668,        /* hostname_override  */
  YYSYMBOL_gr_opts = 669,                  /* gr_opts  */
  YYSYMBOL_net_type = 670,                 /* net_type  */
  YYSYMBOL_table_sorted = 671,             /* table_sorted  */
  YYSYMBOL_table = 672,                    /* table  */
  YYSYMBOL_proto_start = 673,              /* proto_start  */
  YYSYMBOL_proto_name = 674,               /* proto_name  */
  YYSYMBOL_proto_item = 675,               /* proto_item  */
  YYSYMBOL_channel_start = 676,            /* channel_start  */
  YYSYMBOL_channel_item_ = 677,            /* channel_item_  */
  YYSYMBOL_channel_item = 678,             /* channel_item  */
  YYSYMBOL_channel_opts = 679,             /* channel_opts  */
  YYSYMBOL_channel_opt_list = 680,         /* channel_opt_list  */
  YYSYMBOL_channel_end = 681,              /* channel_end  */
  YYSYMBOL_proto_channel = 682,            /* proto_channel  */
  YYSYMBOL_rtable = 683,                   /* rtable  */
  YYSYMBOL_imexport = 684,                 /* imexport  */
  YYSYMBOL_limit_action = 685,             /* limit_action  */
  YYSYMBOL_limit_spec = 686,               /* limit_spec  */
  YYSYMBOL_debug_default = 687,            /* debug_default  */
  YYSYMBOL_timeformat_which = 688,         /* timeformat_which  */
  YYSYMBOL_timeformat_spec = 689,          /* timeformat_spec  */
  YYSYMBOL_timeformat_base = 690,          /* timeformat_base  */
  YYSYMBOL_iface_patt_node_init = 691,     /* iface_patt_node_init  */
  YYSYMBOL_iface_patt_node_body = 692,     /* iface_patt_node_body  */
  YYSYMBOL_iface_negate = 693,             /* iface_negate  */
  YYSYMBOL_iface_patt_node = 694,          /* iface_patt_node  */
  YYSYMBOL_iface_patt_list = 695,          /* iface_patt_list  */
  YYSYMBOL_iface_patt_list_nopx = 696,     /* iface_patt_list_nopx  */
  YYSYMBOL_iface_patt_init = 697,          /* iface_patt_init  */
  YYSYMBOL_iface_patt = 698,               /* iface_patt  */
  YYSYMBOL_tos = 699,                      /* tos  */
  YYSYMBOL_proto = 700,                    /* proto  */
  YYSYMBOL_dev_proto_start = 701,          /* dev_proto_start  */
  YYSYMBOL_dev_proto = 702,                /* dev_proto  */
  YYSYMBOL_dev_iface_init = 703,           /* dev_iface_init  */
  YYSYMBOL_dev_iface_patt = 704,           /* dev_iface_patt  */
  YYSYMBOL_debug_mask = 705,               /* debug_mask  */
  YYSYMBOL_debug_list = 706,               /* debug_list  */
  YYSYMBOL_debug_flag = 707,               /* debug_flag  */
  YYSYMBOL_mrtdump_mask = 708,             /* mrtdump_mask  */
  YYSYMBOL_mrtdump_list = 709,             /* mrtdump_list  */
  YYSYMBOL_mrtdump_flag = 710,             /* mrtdump_flag  */
  YYSYMBOL_password_list = 711,            /* password_list  */
  YYSYMBOL_password_items = 712,           /* password_items  */
  YYSYMBOL_password_item = 713,            /* password_item  */
  YYSYMBOL_password_item_begin = 714,      /* password_item_begin  */
  YYSYMBOL_password_item_params = 715,     /* password_item_params  */
  YYSYMBOL_password_algorithm = 716,       /* password_algorithm  */
  YYSYMBOL_bfd_item = 717,                 /* bfd_item  */
  YYSYMBOL_bfd_items = 718,                /* bfd_items  */
  YYSYMBOL_bfd_opts = 719,                 /* bfd_opts  */
  YYSYMBOL_cmd_SHOW_STATUS = 720,          /* cmd_SHOW_STATUS  */
  YYSYMBOL_cmd_SHOW_MEMORY = 721,          /* cmd_SHOW_MEMORY  */
  YYSYMBOL_cmd_SHOW_PROTOCOLS = 722,       /* cmd_SHOW_PROTOCOLS  */
  YYSYMBOL_cmd_SHOW_PROTOCOLS_ALL = 723,   /* cmd_SHOW_PROTOCOLS_ALL  */
  YYSYMBOL_optproto = 724,                 /* optproto  */
  YYSYMBOL_cmd_SHOW_INTERFACES = 725,      /* cmd_SHOW_INTERFACES  */
  YYSYMBOL_cmd_SHOW_INTERFACES_SUMMARY = 726, /* cmd_SHOW_INTERFACES_SUMMARY  */
  YYSYMBOL_cmd_SHOW_ROUTE = 727,           /* cmd_SHOW_ROUTE  */
  YYSYMBOL_r_args = 728,                   /* r_args  */
  YYSYMBOL_r_args_for = 729,               /* r_args_for  */
  YYSYMBOL_r_args_for_val = 730,           /* r_args_for_val  */
  YYSYMBOL_export_mode = 731,              /* export_mode  */
  YYSYMBOL_channel_sym = 732,              /* channel_sym  */
  YYSYMBOL_channel_arg = 733,              /* channel_arg  */
  YYSYMBOL_cmd_SHOW_SYMBOLS = 734,         /* cmd_SHOW_SYMBOLS  */
  YYSYMBOL_sym_args = 735,                 /* sym_args  */
  YYSYMBOL_cmd_DUMP_RESOURCES = 736,       /* cmd_DUMP_RESOURCES  */
  YYSYMBOL_cmd_DUMP_SOCKETS = 737,         /* cmd_DUMP_SOCKETS  */
  YYSYMBOL_cmd_DUMP_EVENTS = 738,          /* cmd_DUMP_EVENTS  */
  YYSYMBOL_cmd_DUMP_INTERFACES = 739,      /* cmd_DUMP_INTERFACES  */
  YYSYMBOL_cmd_DUMP_NEIGHBORS = 740,       /* cmd_DUMP_NEIGHBORS  */
  YYSYMBOL_cmd_DUMP_ATTRIBUTES = 741,      /* cmd_DUMP_ATTRIBUTES  */
  YYSYMBOL_cmd_DUMP_ROUTES = 742,          /* cmd_DUMP_ROUTES  */
  YYSYMBOL_cmd_DUMP_PROTOCOLS = 743,       /* cmd_DUMP_PROTOCOLS  */
  YYSYMBOL_cmd_DUMP_FILTER_ALL = 744,      /* cmd_DUMP_FILTER_ALL  */
  YYSYMBOL_cmd_EVAL = 745,                 /* cmd_EVAL  */
  YYSYMBOL_cmd_ECHO = 746,                 /* cmd_ECHO  */
  YYSYMBOL_echo_mask = 747,                /* echo_mask  */
  YYSYMBOL_echo_size = 748,                /* echo_size  */
  YYSYMBOL_cmd_DISABLE = 749,              /* cmd_DISABLE  */
  YYSYMBOL_cmd_ENABLE = 750,               /* cmd_ENABLE  */
  YYSYMBOL_cmd_RESTART = 751,              /* cmd_RESTART  */
  YYSYMBOL_cmd_RELOAD = 752,               /* cmd_RELOAD  */
  YYSYMBOL_cmd_RELOAD_IN = 753,            /* cmd_RELOAD_IN  */
  YYSYMBOL_cmd_RELOAD_OUT = 754,           /* cmd_RELOAD_OUT  */
  YYSYMBOL_cmd_DEBUG = 755,                /* cmd_DEBUG  */
  YYSYMBOL_debug_args = 756,               /* debug_args  */
  YYSYMBOL_cmd_MRTDUMP = 757,              /* cmd_MRTDUMP  */
  YYSYMBOL_cmd_RESTRICT = 758,             /* cmd_RESTRICT  */
  YYSYMBOL_proto_patt = 759,               /* proto_patt  */
  YYSYMBOL_proto_patt2 = 760,              /* proto_patt2  */
  YYSYMBOL_dynamic_attr = 761,             /* dynamic_attr  */
  YYSYMBOL_babel_proto_start = 762,        /* babel_proto_start  */
  YYSYMBOL_babel_proto_item = 763,         /* babel_proto_item  */
  YYSYMBOL_babel_proto_opts = 764,         /* babel_proto_opts  */
  YYSYMBOL_babel_proto = 765,              /* babel_proto  */
  YYSYMBOL_babel_iface_start = 766,        /* babel_iface_start  */
  YYSYMBOL_babel_iface_finish = 767,       /* babel_iface_finish  */
  YYSYMBOL_babel_iface_item = 768,         /* babel_iface_item  */
  YYSYMBOL_babel_iface_opts = 769,         /* babel_iface_opts  */
  YYSYMBOL_babel_iface_opt_list = 770,     /* babel_iface_opt_list  */
  YYSYMBOL_babel_iface = 771,              /* babel_iface  */
  YYSYMBOL_cmd_SHOW_BABEL_INTERFACES = 772, /* cmd_SHOW_BABEL_INTERFACES  */
  YYSYMBOL_cmd_SHOW_BABEL_NEIGHBORS = 773, /* cmd_SHOW_BABEL_NEIGHBORS  */
  YYSYMBOL_cmd_SHOW_BABEL_ENTRIES = 774,   /* cmd_SHOW_BABEL_ENTRIES  */
  YYSYMBOL_cmd_SHOW_BABEL_ROUTES = 775,    /* cmd_SHOW_BABEL_ROUTES  */
  YYSYMBOL_bfd_proto_start = 776,          /* bfd_proto_start  */
  YYSYMBOL_bfd_proto_item = 777,           /* bfd_proto_item  */
  YYSYMBOL_bfd_proto_opts = 778,           /* bfd_proto_opts  */
  YYSYMBOL_bfd_proto = 779,                /* bfd_proto  */
  YYSYMBOL_bfd_accept_item = 780,          /* bfd_accept_item  */
  YYSYMBOL_bfd_accept = 781,               /* bfd_accept  */
  YYSYMBOL_bfd_iface_start = 782,          /* bfd_iface_start  */
  YYSYMBOL_bfd_iface_finish = 783,         /* bfd_iface_finish  */
  YYSYMBOL_bfd_iface_item = 784,           /* bfd_iface_item  */
  YYSYMBOL_bfd_auth_type = 785,            /* bfd_auth_type  */
  YYSYMBOL_bfd_iface_opts = 786,           /* bfd_iface_opts  */
  YYSYMBOL_bfd_iface_opt_list = 787,       /* bfd_iface_opt_list  */
  YYSYMBOL_bfd_iface = 788,                /* bfd_iface  */
  YYSYMBOL_bfd_multihop = 789,             /* bfd_multihop  */
  YYSYMBOL_bfd_neigh_iface = 790,          /* bfd_neigh_iface  */
  YYSYMBOL_bfd_neigh_local = 791,          /* bfd_neigh_local  */
  YYSYMBOL_bfd_neigh_multihop = 792,       /* bfd_neigh_multihop  */
  YYSYMBOL_bfd_neighbor = 793,             /* bfd_neighbor  */
  YYSYMBOL_cmd_SHOW_BFD_SESSIONS = 794,    /* cmd_SHOW_BFD_SESSIONS  */
  YYSYMBOL_bgp_proto_start = 795,          /* bgp_proto_start  */
  YYSYMBOL_bgp_loc_opts = 796,             /* bgp_loc_opts  */
  YYSYMBOL_bgp_nbr_opts = 797,             /* bgp_nbr_opts  */
  YYSYMBOL_bgp_cease_mask = 798,           /* bgp_cease_mask  */
  YYSYMBOL_bgp_cease_list = 799,           /* bgp_cease_list  */
  YYSYMBOL_bgp_cease_flag = 800,           /* bgp_cease_flag  */
  YYSYMBOL_bgp_proto = 801,                /* bgp_proto  */
  YYSYMBOL_802_3 = 802,                    /* $@3  */
  YYSYMBOL_803_4 = 803,                    /* $@4  */
  YYSYMBOL_bgp_afi = 804,                  /* bgp_afi  */
  YYSYMBOL_bgp_channel_start = 805,        /* bgp_channel_start  */
  YYSYMBOL_bgp_nh = 806,                   /* bgp_nh  */
  YYSYMBOL_bgp_lladdr = 807,               /* bgp_lladdr  */
  YYSYMBOL_bgp_channel_item = 808,         /* bgp_channel_item  */
  YYSYMBOL_bgp_channel_opts = 809,         /* bgp_channel_opts  */
  YYSYMBOL_bgp_channel_opt_list = 810,     /* bgp_channel_opt_list  */
  YYSYMBOL_bgp_channel_end = 811,          /* bgp_channel_end  */
  YYSYMBOL_bgp_proto_channel = 812,        /* bgp_proto_channel  */
  YYSYMBOL_mrt_proto_start = 813,          /* mrt_proto_start  */
  YYSYMBOL_mrt_proto_item = 814,           /* mrt_proto_item  */
  YYSYMBOL_mrt_proto_opts = 815,           /* mrt_proto_opts  */
  YYSYMBOL_mrt_proto = 816,                /* mrt_proto  */
  YYSYMBOL_cmd_MRT_DUMP = 817,             /* cmd_MRT_DUMP  */
  YYSYMBOL_mrt_dump_args = 818,            /* mrt_dump_args  */
  YYSYMBOL_ospf_variant = 819,             /* ospf_variant  */
  YYSYMBOL_ospf_proto_start = 820,         /* ospf_proto_start  */
  YYSYMBOL_ospf_proto = 821,               /* ospf_proto  */
  YYSYMBOL_ospf_af_mc = 822,               /* ospf_af_mc  */
  YYSYMBOL_ospf_channel_start = 823,       /* ospf_channel_start  */
  YYSYMBOL_ospf_channel = 824,             /* ospf_channel  */
  YYSYMBOL_ospf_proto_item = 825,          /* ospf_proto_item  */
  YYSYMBOL_ospf_area_start = 826,          /* ospf_area_start  */
  YYSYMBOL_ospf_area = 827,                /* ospf_area  */
  YYSYMBOL_ospf_area_opts = 828,           /* ospf_area_opts  */
  YYSYMBOL_ospf_area_item = 829,           /* ospf_area_item  */
  YYSYMBOL_830_5 = 830,                    /* $@5  */
  YYSYMBOL_831_6 = 831,                    /* $@6  */
  YYSYMBOL_ospf_stubnet = 832,             /* ospf_stubnet  */
  YYSYMBOL_ospf_stubnet_start = 833,       /* ospf_stubnet_start  */
  YYSYMBOL_ospf_stubnet_opts = 834,        /* ospf_stubnet_opts  */
  YYSYMBOL_ospf_stubnet_item = 835,        /* ospf_stubnet_item  */
  YYSYMBOL_ospf_vlink = 836,               /* ospf_vlink  */
  YYSYMBOL_ospf_vlink_opts = 837,          /* ospf_vlink_opts  */
  YYSYMBOL_ospf_vlink_item = 838,          /* ospf_vlink_item  */
  YYSYMBOL_ospf_vlink_start = 839,         /* ospf_vlink_start  */
  YYSYMBOL_ospf_iface_item = 840,          /* ospf_iface_item  */
  YYSYMBOL_pref_list = 841,                /* pref_list  */
  YYSYMBOL_pref_item = 842,                /* pref_item  */
  YYSYMBOL_pref_base = 843,                /* pref_base  */
  YYSYMBOL_pref_opt = 844,                 /* pref_opt  */
  YYSYMBOL_nbma_list = 845,                /* nbma_list  */
  YYSYMBOL_nbma_eligible = 846,            /* nbma_eligible  */
  YYSYMBOL_nbma_item = 847,                /* nbma_item  */
  YYSYMBOL_ospf_iface_start = 848,         /* ospf_iface_start  */
  YYSYMBOL_ospf_instance_id = 849,         /* ospf_instance_id  */
  YYSYMBOL_ospf_iface_patt_list = 850,     /* ospf_iface_patt_list  */
  YYSYMBOL_851_7 = 851,                    /* $@7  */
  YYSYMBOL_ospf_iface_opts = 852,          /* ospf_iface_opts  */
  YYSYMBOL_ospf_iface_opt_list = 853,      /* ospf_iface_opt_list  */
  YYSYMBOL_ospf_iface = 854,               /* ospf_iface  */
  YYSYMBOL_cmd_SHOW_OSPF = 855,            /* cmd_SHOW_OSPF  */
  YYSYMBOL_cmd_SHOW_OSPF_NEIGHBORS = 856,  /* cmd_SHOW_OSPF_NEIGHBORS  */
  YYSYMBOL_cmd_SHOW_OSPF_INTERFACE = 857,  /* cmd_SHOW_OSPF_INTERFACE  */
  YYSYMBOL_cmd_SHOW_OSPF_TOPOLOGY = 858,   /* cmd_SHOW_OSPF_TOPOLOGY  */
  YYSYMBOL_cmd_SHOW_OSPF_TOPOLOGY_ALL = 859, /* cmd_SHOW_OSPF_TOPOLOGY_ALL  */
  YYSYMBOL_cmd_SHOW_OSPF_STATE = 860,      /* cmd_SHOW_OSPF_STATE  */
  YYSYMBOL_cmd_SHOW_OSPF_STATE_ALL = 861,  /* cmd_SHOW_OSPF_STATE_ALL  */
  YYSYMBOL_cmd_SHOW_OSPF_LSADB = 862,      /* cmd_SHOW_OSPF_LSADB  */
  YYSYMBOL_lsadb_args = 863,               /* lsadb_args  */
  YYSYMBOL_perf_proto_start = 864,         /* perf_proto_start  */
  YYSYMBOL_perf_proto = 865,               /* perf_proto  */
  YYSYMBOL_perf_proto_item = 866,          /* perf_proto_item  */
  YYSYMBOL_pipe_proto_start = 867,         /* pipe_proto_start  */
  YYSYMBOL_868_8 = 868,                    /* $@8  */
  YYSYMBOL_pipe_proto = 869,               /* pipe_proto  */
  YYSYMBOL_radv_proto_start = 870,         /* radv_proto_start  */
  YYSYMBOL_radv_proto_item = 871,          /* radv_proto_item  */
  YYSYMBOL_872_9 = 872,                    /* $@9  */
  YYSYMBOL_873_10 = 873,                   /* $@10  */
  YYSYMBOL_radv_proto_opts = 874,          /* radv_proto_opts  */
  YYSYMBOL_radv_proto = 875,               /* radv_proto  */
  YYSYMBOL_radv_iface_start = 876,         /* radv_iface_start  */
  YYSYMBOL_radv_iface_item = 877,          /* radv_iface_item  */
  YYSYMBOL_878_11 = 878,                   /* $@11  */
  YYSYMBOL_879_12 = 879,                   /* $@12  */
  YYSYMBOL_radv_preference = 880,          /* radv_preference  */
  YYSYMBOL_radv_iface_finish = 881,        /* radv_iface_finish  */
  YYSYMBOL_radv_iface_opts = 882,          /* radv_iface_opts  */
  YYSYMBOL_radv_iface_opt_list = 883,      /* radv_iface_opt_list  */
  YYSYMBOL_radv_iface = 884,               /* radv_iface  */
  YYSYMBOL_radv_prefix_start = 885,        /* radv_prefix_start  */
  YYSYMBOL_radv_prefix_item = 886,         /* radv_prefix_item  */
  YYSYMBOL_radv_prefix_finish = 887,       /* radv_prefix_finish  */
  YYSYMBOL_radv_prefix_opts = 888,         /* radv_prefix_opts  */
  YYSYMBOL_radv_prefix_opt_list = 889,     /* radv_prefix_opt_list  */
  YYSYMBOL_radv_prefix = 890,              /* radv_prefix  */
  YYSYMBOL_radv_rdnss_node = 891,          /* radv_rdnss_node  */
  YYSYMBOL_radv_rdnss_start = 892,         /* radv_rdnss_start  */
  YYSYMBOL_radv_rdnss_item = 893,          /* radv_rdnss_item  */
  YYSYMBOL_radv_rdnss_finish = 894,        /* radv_rdnss_finish  */
  YYSYMBOL_radv_rdnss_opts = 895,          /* radv_rdnss_opts  */
  YYSYMBOL_radv_rdnss = 896,               /* radv_rdnss  */
  YYSYMBOL_radv_dnssl_node = 897,          /* radv_dnssl_node  */
  YYSYMBOL_radv_dnssl_start = 898,         /* radv_dnssl_start  */
  YYSYMBOL_radv_dnssl_item = 899,          /* radv_dnssl_item  */
  YYSYMBOL_radv_dnssl_finish = 900,        /* radv_dnssl_finish  */
  YYSYMBOL_radv_dnssl_opts = 901,          /* radv_dnssl_opts  */
  YYSYMBOL_radv_dnssl = 902,               /* radv_dnssl  */
  YYSYMBOL_radv_mult = 903,                /* radv_mult  */
  YYSYMBOL_radv_sensitive = 904,           /* radv_sensitive  */
  YYSYMBOL_rip_variant = 905,              /* rip_variant  */
  YYSYMBOL_rip_proto_start = 906,          /* rip_proto_start  */
  YYSYMBOL_rip_proto_item = 907,           /* rip_proto_item  */
  YYSYMBOL_rip_proto_opts = 908,           /* rip_proto_opts  */
  YYSYMBOL_rip_proto = 909,                /* rip_proto  */
  YYSYMBOL_rip_iface_start = 910,          /* rip_iface_start  */
  YYSYMBOL_rip_iface_finish = 911,         /* rip_iface_finish  */
  YYSYMBOL_rip_iface_item = 912,           /* rip_iface_item  */
  YYSYMBOL_rip_auth = 913,                 /* rip_auth  */
  YYSYMBOL_rip_iface_opts = 914,           /* rip_iface_opts  */
  YYSYMBOL_rip_iface_opt_list = 915,       /* rip_iface_opt_list  */
  YYSYMBOL_rip_iface = 916,                /* rip_iface  */
  YYSYMBOL_cmd_SHOW_RIP_INTERFACES = 917,  /* cmd_SHOW_RIP_INTERFACES  */
  YYSYMBOL_cmd_SHOW_RIP_NEIGHBORS = 918,   /* cmd_SHOW_RIP_NEIGHBORS  */
  YYSYMBOL_rpki_proto_start = 919,         /* rpki_proto_start  */
  YYSYMBOL_rpki_proto = 920,               /* rpki_proto  */
  YYSYMBOL_rpki_proto_opts = 921,          /* rpki_proto_opts  */
  YYSYMBOL_rpki_proto_item = 922,          /* rpki_proto_item  */
  YYSYMBOL_rpki_keep_interval = 923,       /* rpki_keep_interval  */
  YYSYMBOL_rpki_proto_item_port = 924,     /* rpki_proto_item_port  */
  YYSYMBOL_rpki_cache_addr = 925,          /* rpki_cache_addr  */
  YYSYMBOL_rpki_transport = 926,           /* rpki_transport  */
  YYSYMBOL_rpki_transport_tcp_init = 927,  /* rpki_transport_tcp_init  */
  YYSYMBOL_rpki_transport_ssh_init = 928,  /* rpki_transport_ssh_init  */
  YYSYMBOL_rpki_transport_ssh_opts = 929,  /* rpki_transport_ssh_opts  */
  YYSYMBOL_rpki_transport_ssh_item = 930,  /* rpki_transport_ssh_item  */
  YYSYMBOL_rpki_transport_ssh_check = 931, /* rpki_transport_ssh_check  */
  YYSYMBOL_static_proto_start = 932,       /* static_proto_start  */
  YYSYMBOL_static_proto = 933,             /* static_proto  */
  YYSYMBOL_stat_nexthop = 934,             /* stat_nexthop  */
  YYSYMBOL_stat_nexthops = 935,            /* stat_nexthops  */
  YYSYMBOL_stat_route0 = 936,              /* stat_route0  */
  YYSYMBOL_stat_route = 937,               /* stat_route  */
  YYSYMBOL_stat_route_item = 938,          /* stat_route_item  */
  YYSYMBOL_stat_route_opts = 939,          /* stat_route_opts  */
  YYSYMBOL_stat_route_opt_list = 940,      /* stat_route_opt_list  */
  YYSYMBOL_cmd_SHOW_STATIC = 941,          /* cmd_SHOW_STATIC  */
  YYSYMBOL_kern_proto = 942,               /* kern_proto  */
  YYSYMBOL_kern_sys_item = 943,            /* kern_sys_item  */
  YYSYMBOL_log_begin = 944,                /* log_begin  */
  YYSYMBOL_log_config = 945,               /* log_config  */
  YYSYMBOL_syslog_name = 946,              /* syslog_name  */
  YYSYMBOL_log_limit = 947,                /* log_limit  */
  YYSYMBOL_log_file = 948,                 /* log_file  */
  YYSYMBOL_log_mask = 949,                 /* log_mask  */
  YYSYMBOL_log_mask_list = 950,            /* log_mask_list  */
  YYSYMBOL_log_cat = 951,                  /* log_cat  */
  YYSYMBOL_mrtdump_base = 952,             /* mrtdump_base  */
  YYSYMBOL_debug_unix = 953,               /* debug_unix  */
  YYSYMBOL_cmd_CONFIGURE = 954,            /* cmd_CONFIGURE  */
  YYSYMBOL_cmd_CONFIGURE_SOFT = 955,       /* cmd_CONFIGURE_SOFT  */
  YYSYMBOL_cmd_CONFIGURE_CONFIRM = 956,    /* cmd_CONFIGURE_CONFIRM  */
  YYSYMBOL_cmd_CONFIGURE_UNDO = 957,       /* cmd_CONFIGURE_UNDO  */
  YYSYMBOL_cmd_CONFIGURE_STATUS = 958,     /* cmd_CONFIGURE_STATUS  */
  YYSYMBOL_cmd_CONFIGURE_CHECK = 959,      /* cmd_CONFIGURE_CHECK  */
  YYSYMBOL_cmd_DOWN = 960,                 /* cmd_DOWN  */
  YYSYMBOL_cmd_GRACEFUL_RESTART = 961,     /* cmd_GRACEFUL_RESTART  */
  YYSYMBOL_cfg_name = 962,                 /* cfg_name  */
  YYSYMBOL_cfg_timeout = 963,              /* cfg_timeout  */
  YYSYMBOL_kern_proto_start = 964,         /* kern_proto_start  */
  YYSYMBOL_kern_mp_limit = 965,            /* kern_mp_limit  */
  YYSYMBOL_kern_item = 966,                /* kern_item  */
  YYSYMBOL_kif_proto_start = 967,          /* kif_proto_start  */
  YYSYMBOL_kif_proto = 968,                /* kif_proto  */
  YYSYMBOL_kif_item = 969,                 /* kif_item  */
  YYSYMBOL_kif_iface_start = 970,          /* kif_iface_start  */
  YYSYMBOL_kif_iface_item = 971,           /* kif_iface_item  */
  YYSYMBOL_kif_iface_opts = 972,           /* kif_iface_opts  */
  YYSYMBOL_kif_iface_opt_list = 973,       /* kif_iface_opt_list  */
  YYSYMBOL_kif_iface = 974                 /* kif_iface  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  79
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6257

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  554
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  421
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1421
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2616

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   787


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    37,     2,     2,     2,    36,     2,     2,
      52,    53,    34,    32,    77,    33,    38,    35,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   150,    51,
      28,    27,    29,   153,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   151,     2,   152,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    78,     2,    79,    30,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    31,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   134,   134,   135,   138,   140,   143,   148,   151,   159,
     160,   161,   167,   168,   169,   172,   172,   177,   178,   179,
     180,   181,   182,   189,   190,   191,   198,   199,   206,   212,
     222,   235,   254,   260,   266,   274,   282,   288,   288,   289,
     289,   290,   290,   293,   294,   295,   296,   297,   298,   305,
     306,   314,   315,   323,   324,   332,   333,   334,   335,   336,
     346,   354,   355,   364,   372,   373,   380,   381,    37,    38,
      39,    40,    41,    42,    43,    44,    48,    49,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    64,    65,    66,
      67,    70,    71,    75,    79,    83,    84,    88,    92,   101,
     102,   106,   110,   114,   121,   122,   126,   127,   128,   129,
     133,   136,   139,   145,   149,   150,   151,   155,   159,   165,
     166,   167,   168,   171,   173,   176,   178,   182,   189,   190,
     192,   198,   204,   204,     9,     9,    10,    10,    11,    11,
     315,   317,   317,   327,   329,   332,   333,   337,   339,   350,
     352,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   403,   405,   412,
     413,   420,   421,   427,   430,   434,   442,   449,   455,   457,
     457,   470,   471,   474,   482,   483,   497,   500,   509,   510,
     523,   524,   525,   526,   527,   531,   539,   540,   541,   542,
     546,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   563,   564,   565,   566,   570,   571,   572,   576,   577,
     578,   579,   580,   581,   582,   583,   588,   589,   590,   591,
     592,   596,   597,   598,   599,   600,   604,   605,   609,   610,
     614,   615,   616,   617,   625,   626,   629,   630,   638,   648,
     649,   653,   657,   658,   659,   663,   664,   665,   666,   667,
     671,   672,   673,   674,   675,   676,   677,   678,   683,   684,
     688,   689,   690,   691,   696,   697,   698,   701,   725,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   757,
     758,   759,   760,   761,   762,   763,   764,   765,   766,   767,
     768,   769,   770,   771,   772,   773,   775,   776,   777,   779,
     781,   783,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   807,   808,   809,   810,   811,
     812,   813,   814,   816,   817,   819,   823,   827,   828,   829,
     832,   833,   834,   843,   846,   849,   861,   865,   868,   873,
     876,   879,   890,   894,   897,   898,   902,   903,   904,   905,
     906,   907,   908,   912,   917,   918,   919,   920,   133,   136,
     137,   141,   142,   143,   144,   154,   156,   158,   160,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   183,
     186,   187,   190,   200,   203,   204,   208,   214,   218,   228,
     238,   240,   241,   242,   243,   244,   245,   246,   250,   256,
     261,   262,   263,   264,   265,   266,   267,   268,   273,   274,
     277,   279,   282,   284,   288,   295,   298,   301,   302,   303,
     304,   308,   309,   310,   311,   312,   316,   317,   321,   324,
     325,   326,   331,   334,   335,   336,   337,   341,   342,   343,
     344,   345,   346,   347,   348,   352,   359,   367,   368,   372,
     373,   377,   382,   383,   387,   389,   397,   401,   402,   407,
     409,   416,   417,   418,   419,   420,   424,   432,   438,   439,
     440,   444,   445,   449,   450,   451,   452,   453,   454,   460,
     461,   462,   466,   467,   471,   472,   478,   479,   482,   484,
     488,   489,   493,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   541,   542,   543,   544,   545,   546,   547,   550,
     552,   556,   562,   562,   565,   565,   568,   568,   571,   571,
     575,   576,   579,   579,   582,   582,   586,   586,   590,   596,
     601,   607,   613,   620,   625,   630,   635,   640,   644,   648,
     652,   662,   669,   678,   682,   689,   693,   694,   695,   696,
     700,   704,   708,   722,   723,   724,   725,   728,   729,   730,
     731,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   759,   769,   769,   773,   776,   777,   778,   779,   780,
     781,   786,   786,   788,   788,   790,   790,   792,   792,   794,
     794,   796,   796,   798,   798,   800,   800,   802,   802,   805,
     805,   809,   809,   815,   816,   817,   821,   822,   828,   828,
     830,   830,   832,   832,   834,   834,   836,   836,   838,   838,
     842,   842,   846,   847,   851,   851,   854,   854,   858,   859,
     860,   864,   865,   866,   869,    34,    36,    46,    47,    48,
      49,    50,    53,    55,    59,    63,    64,    65,    66,    70,
      74,    78,    92,   112,   113,   114,   115,   116,   117,   118,
     119,   123,   124,   125,   126,   127,   128,   131,   133,   136,
     138,   142,   145,   150,   151,   152,   156,   157,   161,   162,
     165,   184,   184,    32,    34,    42,    43,    44,    45,    48,
      50,    54,    58,    72,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   114,
     116,   119,   121,   126,   128,   132,   132,   135,   135,   138,
     138,   141,   141,    47,    49,    80,    82,    83,    86,    88,
      89,    90,    91,    96,    97,   101,   102,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   118,   119,   120,   121,
     122,   126,   127,   133,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   197,   197,
     198,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   216,   242,   243,   244,   246,   246,   246,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   283,   285,   288,   290,   294,   301,   304,   306,
     308,   310,   312,   314,   316,   318,   320,   322,   324,   326,
     328,    26,    28,    34,    35,    36,    37,    38,    39,    40,
      41,    44,    46,    50,    53,    53,    57,    58,    59,    60,
      61,    62,   211,   214,   215,   216,   219,   235,   236,   240,
     241,   245,   255,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   275,   290,
     293,   295,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   308,   309,   309,   310,   311,   312,   316,   317,
     321,   329,   331,   335,   336,   337,   341,   342,   345,   347,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   363,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   423,   425,   428,   430,   438,   440,   441,   444,   446,
     450,   451,   454,   464,   486,   488,   492,   492,   495,   497,
     500,   502,   506,   509,   510,   511,   512,   515,   515,   518,
     518,   521,   521,   526,   526,   529,   529,   534,   534,   537,
     537,   541,   541,   550,   553,   554,   555,   556,   557,   558,
     559,   560,    24,    26,    40,    41,    42,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    23,    26,    25,
      40,    41,    42,    43,    44,    46,    57,    58,    59,    60,
      61,    61,    62,    62,    63,    64,    67,    69,    73,    77,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   115,   119,   120,   121,   122,   123,   124,   124,   125,
     125,   126,   127,   131,   132,   133,   136,   174,   176,   179,
     181,   185,   188,   200,   201,   202,   203,   207,   214,   222,
     224,   227,   229,   233,   237,   247,   252,   253,   254,   258,
     270,   272,   276,   277,   281,   294,   299,   300,   301,   305,
     317,   319,   323,   324,   329,   330,   334,   335,   338,   339,
      46,    49,    50,    53,    67,    68,    69,    70,    71,    72,
      75,    77,    81,    85,   110,   140,   141,   142,   143,   144,
     145,   146,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   173,   174,   175,   176,   179,   181,   184,   186,
     190,   193,   194,   198,   198,   201,   201,    41,    43,    50,
      52,    54,    58,    59,    60,    61,    62,    63,    64,    70,
      76,    82,    86,    87,    90,    93,    97,   108,   109,   113,
     120,   130,   132,   136,   137,   138,   142,    54,    56,    63,
      64,    65,    66,    67,    75,    79,    84,    89,    92,    95,
      99,   105,   106,   109,   121,   122,   126,   131,   132,   133,
     134,   135,   136,   140,   149,   151,   154,   156,   160,   160,
      22,    25,    26,    29,    30,    31,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    60,
      61,    31,    33,    35,    42,    43,    46,    48,    52,    62,
      63,    67,    68,    72,    73,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    89,    92,    93,   104,   107,   108,
     109,   110,   118,   118,   121,   121,   128,   128,   131,   131,
     134,   134,   137,   137,   140,   140,   145,   145,   150,   151,
     155,   156,   157,    41,    43,    48,    49,    52,    53,    57,
      58,    59,    60,    64,    71,    72,    83,    85,    88,    89,
      92,    93,    94,   101,   108,   111,   113,   116,   118,   122,
     125,   126
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "QUIT", "EXIT", "HELP",
  "END", "CLI_MARKER", "INVALID_TOKEN", "ELSECOL", "DDOT", "GEQ", "LEQ",
  "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM", "IP4", "IP6", "VPN_RD",
  "CF_SYM_KNOWN", "CF_SYM_UNDEFINED", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "VPN",
  "MPLS", "FROM", "';'", "'('", "')'", "FLOW4", "FLOW6", "DST", "SRC",
  "PROTO", "NEXT", "HEADER", "DPORT", "SPORT", "ICMP", "TYPE", "CODE",
  "TCP", "FLAGS", "LENGTH", "DSCP", "DONT_FRAGMENT", "IS_FRAGMENT",
  "FIRST_FRAGMENT", "LAST_FRAGMENT", "FRAGMENT", "LABEL", "OFFSET", "','",
  "'{'", "'}'", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "ERROR", "INT", "BOOL", "IP", "PREFIX", "RD", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "SOURCE", "SCOPE", "DEST",
  "IFNAME", "IFINDEX", "WEIGHT", "PREFERENCE", "ROA_CHECK", "ASN", "IS_V4",
  "IS_V6", "LEN", "MAXLEN", "DEFINED", "ADD", "DELETE", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "EMPTY", "FILTER", "WHERE", "EVAL", "ATTRIBUTE", "BT_ASSERT",
  "BT_TEST_SUITE", "BT_CHECK_ASSIGN", "BT_TEST_SAME", "FORMAT", "':'",
  "'['", "']'", "'?'", "ROUTER", "ID", "HOSTNAME", "PROTOCOL", "TEMPLATE",
  "DISABLED", "DEBUG", "ALL", "DIRECT", "INTERFACE", "IMPORT", "EXPORT",
  "NONE", "VRF", "DEFAULT", "TABLE", "STATES", "ROUTES", "FILTERS", "IPV4",
  "IPV6", "VPN4", "VPN6", "ROA4", "ROA6", "SADR", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED",
  "RPKI", "PASSWORD", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "CHANNELS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1",
  "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "BY", "FOR",
  "COMMANDS", "PREEXPORT", "NOEXPORT", "EXPORTED", "GENERATE", "BGP",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "TIMEFORMAT",
  "ISO", "SHORT", "LONG", "ROUTE", "BASE", "LOG", "GRACEFUL", "WAIT",
  "MAX", "FLUSH", "AS", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "CHECK", "LINK", "IPV4_MC", "IPV4_MPLS", "IPV6_MC",
  "IPV6_MPLS", "IPV6_SADR", "VPN4_MC", "VPN4_MPLS", "VPN6_MC", "VPN6_MPLS",
  "PRI", "SEC", "SHOW", "STATUS", "SUMMARY", "SYMBOLS", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "ECHO", "ENABLE",
  "BABEL", "METRIC", "RXCOST", "HELLO", "UPDATE", "WIRED", "WIRELESS",
  "BUFFER", "PRIORITY", "HOP", "BABEL_METRIC", "ENTRIES", "RANDOMIZE",
  "BFD", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "AUTHENTICATION",
  "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "TIME", "CONNECT", "RETRY",
  "KEEPALIVE", "STARTUP", "VIA", "SELF", "PATH", "START", "DELAY",
  "FORGET", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN",
  "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "BGP_LARGE_COMMUNITY", "ADDRESS", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "CAPABILITIES", "PREFER",
  "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH", "INTERPRET",
  "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY",
  "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC", "SECONDARY",
  "ALLOW", "PATHS", "AWARE", "EXTENDED", "SETKEY", "STRICT", "BIND",
  "CONFEDERATION", "MEMBER", "MULTICAST", "LIVED", "STALE", "IBGP", "EBGP",
  "MANDATORY", "INTERNAL", "EXTERNAL", "SETS", "DYNAMIC", "RANGE", "NAME",
  "DIGITS", "BGP_AIGP", "AIGP", "ORIGINATE", "COST", "ENFORCE", "CEASE",
  "HIT", "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT",
  "FILENAME", "PERIOD", "ALWAYS", "OSPF", "V2", "V3", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "AREA", "RFC1583COMPAT",
  "STUB", "TICK", "COST2", "RETRANSMIT", "TRANSMIT", "DEAD", "BROADCAST",
  "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL",
  "NETWORKS", "HIDDEN", "VIRTUAL", "ONLY", "LARGE", "NORMAL", "STUBNET",
  "TAG", "LSADB", "ECMP", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "MERGE", "LSA", "SUPPRESSION",
  "RFC5838", "PE", "TOPOLOGY", "STATE", "PERF", "EXP", "REPEAT",
  "THRESHOLD", "MODE", "PIPE", "RADV", "RA", "SOLICITED", "UNICAST",
  "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE", "RETRANS",
  "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME", "SKIP",
  "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN", "TRIGGER",
  "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE", "RA_PREFERENCE",
  "RA_LIFETIME", "RIP", "NG", "INFINITY", "TIMEOUT", "GARBAGE", "VERSION",
  "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO", "PLAINTEXT", "DEMAND",
  "CIRCUIT", "RIP_METRIC", "RIP_TAG", "REMOTE", "BIRD", "PRIVATE",
  "PUBLIC", "KEY", "SSH", "TRANSPORT", "USER", "EXPIRE", "STATIC",
  "PROHIBIT", "BLACKHOLE", "UNREACHABLE", "KERNEL", "KRT_PREFSRC",
  "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW", "KRT_RTT",
  "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS", "KRT_REORDERING",
  "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN", "KRT_INITRWND",
  "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW", "KRT_LOCK_RTT",
  "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "SYSLOG",
  "TRACE", "INFO", "WARNING", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "CONFIRM", "UNDO", "LATENCY", "WATCHDOG", "CONFIGURE", "DOWN", "PERSIST",
  "SCAN", "LEARN", "DEVICE", "KRT_SOURCE", "KRT_METRIC", "$accept",
  "cli_cmd", "cmd_QUIT", "cmd_EXIT", "cmd_HELP", "config", "conf_entries",
  "conf", "definition", "expr", "expr_us", "symbol", "bool", "ipa",
  "ipa_scope", "pxlen4", "net_ip4_", "net_ip6_", "net_ip6_sadr_",
  "net_vpn4_", "net_vpn6_", "net_roa4_", "net_roa6_", "net_mpls_",
  "net_ip_", "net_vpn_", "net_roa_", "net_", "net_ip6", "net_ip",
  "net_any", "net_or_ipa", "label_stack_start", "label_stack", "time",
  "text", "opttext", "flow_num_op", "flow_logic_op", "flow_num_type_",
  "flow_num_type", "flow_flag_type", "flow_frag_type", "flow_label_type",
  "flow_srcdst", "flow_num_opts", "flow_num_opt_ext_expr",
  "flow_num_opt_ext", "flow_bmk_opts", "flow_neg", "flow_frag_val",
  "flow_frag_opts", "flow4_item", "flow6_item", "flow4_opts", "flow6_opts",
  "flow_builder_init", "flow_builder_set_ipv4", "flow_builder_set_ipv6",
  "net_flow4_", "net_flow6_", "net_flow_", "filter_def", "$@1",
  "filter_eval", "custom_attr", "bt_test_suite", "bt_test_same", "type",
  "function_argsn", "function_args", "function_vars", "filter_body",
  "filter", "where_filter", "function_body", "function_def", "$@2", "cmds",
  "cmd_prep", "cmds_int", "block", "fipa", "set_atom", "switch_atom",
  "cnum", "pair_item", "ec_kind", "ec_item", "lc_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix", "fprefix_set",
  "switch_body", "bgp_path_expr", "bgp_path", "bgp_path_tail", "constant",
  "constructor", "var_list", "function_call", "symbol_value",
  "static_attr", "term", "break_command", "print_list", "cmd",
  "get_cf_position", "lvalue", "rtrid", "idval", "hostname_override",
  "gr_opts", "net_type", "table_sorted", "table", "proto_start",
  "proto_name", "proto_item", "channel_start", "channel_item_",
  "channel_item", "channel_opts", "channel_opt_list", "channel_end",
  "proto_channel", "rtable", "imexport", "limit_action", "limit_spec",
  "debug_default", "timeformat_which", "timeformat_spec",
  "timeformat_base", "iface_patt_node_init", "iface_patt_node_body",
  "iface_negate", "iface_patt_node", "iface_patt_list",
  "iface_patt_list_nopx", "iface_patt_init", "iface_patt", "tos", "proto",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "bfd_item", "bfd_items", "bfd_opts", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optproto", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "r_args_for", "r_args_for_val",
  "export_mode", "channel_sym", "channel_arg", "cmd_SHOW_SYMBOLS",
  "sym_args", "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_DUMP_FILTER_ALL",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "debug_args", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "dynamic_attr",
  "babel_proto_start", "babel_proto_item", "babel_proto_opts",
  "babel_proto", "babel_iface_start", "babel_iface_finish",
  "babel_iface_item", "babel_iface_opts", "babel_iface_opt_list",
  "babel_iface", "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "cmd_SHOW_BABEL_ROUTES", "bfd_proto_start",
  "bfd_proto_item", "bfd_proto_opts", "bfd_proto", "bfd_accept_item",
  "bfd_accept", "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item",
  "bfd_auth_type", "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface",
  "bfd_multihop", "bfd_neigh_iface", "bfd_neigh_local",
  "bfd_neigh_multihop", "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS",
  "bgp_proto_start", "bgp_loc_opts", "bgp_nbr_opts", "bgp_cease_mask",
  "bgp_cease_list", "bgp_cease_flag", "bgp_proto", "$@3", "$@4", "bgp_afi",
  "bgp_channel_start", "bgp_nh", "bgp_lladdr", "bgp_channel_item",
  "bgp_channel_opts", "bgp_channel_opt_list", "bgp_channel_end",
  "bgp_proto_channel", "mrt_proto_start", "mrt_proto_item",
  "mrt_proto_opts", "mrt_proto", "cmd_MRT_DUMP", "mrt_dump_args",
  "ospf_variant", "ospf_proto_start", "ospf_proto", "ospf_af_mc",
  "ospf_channel_start", "ospf_channel", "ospf_proto_item",
  "ospf_area_start", "ospf_area", "ospf_area_opts", "ospf_area_item",
  "$@5", "$@6", "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@7",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "perf_proto_start", "perf_proto", "perf_proto_item",
  "pipe_proto_start", "$@8", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@9", "$@10", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@11", "$@12", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_variant", "rip_proto_start", "rip_proto_item", "rip_proto_opts",
  "rip_proto", "rip_iface_start", "rip_iface_finish", "rip_iface_item",
  "rip_auth", "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS", "rpki_proto_start",
  "rpki_proto", "rpki_proto_opts", "rpki_proto_item", "rpki_keep_interval",
  "rpki_proto_item_port", "rpki_cache_addr", "rpki_transport",
  "rpki_transport_tcp_init", "rpki_transport_ssh_init",
  "rpki_transport_ssh_opts", "rpki_transport_ssh_item",
  "rpki_transport_ssh_check", "static_proto_start", "static_proto",
  "stat_nexthop", "stat_nexthops", "stat_route0", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "kern_proto", "kern_sys_item", "log_begin",
  "log_config", "syslog_name", "log_limit", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_STATUS", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cmd_GRACEFUL_RESTART", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_mp_limit", "kern_item", "kif_proto_start",
  "kif_proto", "kif_item", "kif_iface_start", "kif_iface_item",
  "kif_iface_opts", "kif_iface_opt_list", "kif_iface", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,    61,    60,    62,
     126,   282,    43,    45,    42,    47,    37,    33,    46,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,    59,    40,    41,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,    44,   123,   125,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
      58,    91,    93,    63,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   763,
     764,   765,   766,   767,   768,   769,   770,   771,   772,   773,
     774,   775,   776,   777,   778,   779,   780,   781,   782,   783,
     784,   785,   786,   787
};
#endif

#define YYPACT_NINF (-2233)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-838)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     185,    71,   240,    91,   279,   493,   516,  4467,   172,   182,
     182,   186,   182,   534,   232,  1204,  1284,   455,   182,   309,
      56,   614, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233,   903, -2233, -2233, -2233, -2233,   903,   903,  4467,  2404,
     583,   605,   541,   183, -2233, -2233,  -124, -2233,   533, -2233,
   -2233, -2233, -2233,   202,   470, -2233,   544,   127, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,   569,
   -2233,   459, -2233, -2233, -2233,   704,  1801,   704, -2233,   704,
   -2233,   704,  5888,   704, -2233,   704,  2118,   704,  2084,   670,
     739,   704, -2233,   704, -2233,   704, -2233,   704,  2254,   771,
   -2233, -2233, -2233,   704,   704,    10, -2233, -2233, -2233,  1259,
   -2233, -2233,   742,   807,   962,   815, -2233,   732,   171,  4467,
     870, -2233,  2631,   816,   819, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233,   848,   891,   898,
     909,   916,   925,   935,  1730, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,   684,   699,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
    4013, -2233,   957, -2233, -2233,   562,  1014,   562, -2233,   979,
     979,   182,   182,  1026,   592, -2233,  1039,   416,   131,  1043,
   -2233,  1060, -2233,   608,   788,    95,   290,  1061,   930,  1091,
    1095,  1105,  1118,  1125,  1149,  1153,  1156, -2233,   -67, -2233,
    1096,   979, -2233, -2233,  1109,  1176,  1109,  1179,  1191,   662,
   -2233, -2233, -2233,  1172, -2233, -2233,  4319, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233,   726,  1189,  1215,  1123, -2233, -2233,  1194,   562,
     562,   887,  1085, -2233,   592,  1196, -2233, -2233, -2233, -2233,
     123,  1199,    27,  1003,   887,   887,   903, -2233, -2233, -2233,
   -2233, -2233, -2233,   717, -2233, -2233, -2233,   784, -2233, -2233,
   -2233, -2233, -2233,  1245,  1247,  1192, -2233,  1163,  1494,   562,
   -2233,   504,   183,   592,  1076, -2233,  1275,  1226,  1278,  1280,
    1255,  1262,  1272, -2233, -2233, -2233,   297,  1050,  1320,  1366,
     885,    24,    75,    85,   100,  1104,   183,  1494,  1062,  1228,
    1170,   316,   601,   201,    80,   992,  1129,   423,  1135,  1140,
    1177,  1139,   883,  1144,  1288,  1494,  1141,  1132,  1200,  1201,
    1136,  1154,   392,  1494,  1131,   137,  1111,  1342,  1440, -2233,
    1417,  1446,  1421,  1424,  1072, -2233,  1326,   983,  1494,  1361,
     887,  1494,  1365,  1162,  1494,  1173, -2233,  1226, -2233,  1473,
    1448, -2233,  1463, -2233,  1494,  1525,    79,  1530,   555,  1056,
    1493, -2233,  1502, -2233, -2233,   887,  1239,   875,  1566,  1410,
    1373,  1435,  1554,  1555,  1529,  1532,  1533,  1537, -2233,  1663,
    1380,  1460,  1579,  1580,    -9,  1556, -2233,  1447,   887,  1294,
    1470,  1494,  1349,  1494, -2233, -2233,  1593,  1598,  1572,  1573,
   -2233, -2233,  1359, -2233,  1603,  1495, -2233,  1259,  1259,  4467,
    1782,  1259,  1259,  1638, -2233,  1641, -2233,  1642,   742,  1626,
   -2233, -2233,  4467,  1630,   377,  1631,  1627, -2233, -2233, -2233,
    1648, -2233,  1594,  3158, -2233, -2233,  1566,  4467,  4467,  4467,
    4467,  4467,  4467, -2233, -2233,  1626, -2233, -2233,  2091, -2233,
   -2233,   755, -2233,  1660, -2233, -2233, -2233, -2233,    84, -2233,
     143,  1655,  1656, -2233,  4467,  4467,  4467,  4467,  4467,  4467,
    4467,  4467,  4467,  4467,  4467,  4467,  4467,  4467,  2257,  2646,
   -2233,  1108, -2233, -2233, -2233, -2233, -2233,  1669,  1670,  1671,
    1672, -2233, -2233,   441, -2233,  1674, -2233, -2233, -2233,   570,
    1676, -2233,  1681, -2233,  4599, -2233,  1235,  1061,  1061,  1061,
    1061,  1061, -2233,  1061,  1061, -2233,    62,   145,  1689,  1061,
    1061,  1690,  1691, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
     594, -2233, -2233,  1692,  1693,   497,  1697, -2233,   662, -2233,
   -2233,   887,  1700,  4467,  1661, -2233, -2233,  1657,  1637,  1645,
   -2233, -2233, -2233, -2233,  4467,  1673, -2233, -2233, -2233, -2233,
   -2233,  4467, -2233, -2233, -2233, -2233, -2233,   887, -2233, -2233,
    1675, -2233,   887,   997, -2233,  1360, -2233,   887,    54,   887,
    1171, -2233, -2233,  1508, -2233, -2233,   704, -2233, -2233,  1706,
   -2233,   983, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  1494,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  1436,  1437,
     992, -2233,  1684,   887,   887, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233,    -1,  1696,  1703,   -57,   220,  1494,  1402,
    1494,  1517,  1709,  1712,  1664, -2233,  1714, -2233, -2233, -2233,
    1128,  1707,   147,  1707,    58,   887,  1450,  1475,   887,  1477,
    1494,  1478,  1494,  1612,  1494,  1494,  1724,  1494,  1494,  1494,
    1494,  1494,  1494,  1420,  1536,  1494,  1732,  1494,  1494,  1733,
     113,  1545, -2233, -2233, -2233, -2233, -2233, -2233,  1494,   641,
   -2233, -2233,  1494, -2233,  1605,   887,  1494, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233,  1777,  1778, -2233,   887,
     887, -2233, -2233, -2233, -2233, -2233,  1774,  4467, -2233, -2233,
    1142,  1619, -2233, -2233,  1142, -2233, -2233, -2233,  1142,  1494,
    1566, -2233, -2233, -2233, -2233, -2233, -2233,   807,   962, -2233,
   -2233, -2233,  1494,  1566, -2233, -2233, -2233,   944, -2233,   992,
   -2233, -2233, -2233,    -3,  1512, -2233,  1771,  1494, -2233,  1494,
     887, -2233,   887, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
     887, -2233,  1810, -2233, -2233, -2233,  3062, -2233, -2233,   383,
   -2233, -2233, -2233, -2233,  1780,  1813,   549,  4319, -2233,  1695,
    1800, -2233, -2233,  4467, -2233,  4467, -2233, -2233,   689,  3691,
    3097,  3192,  3401,  3468,  3770,  1759,   203,  1761,  3813, -2233,
   -2233,  1821,  1797,  1782, -2233,   962, -2233,  1600,  1601,  1866,
    1866,  1866,  2123,  2123,  1866,  1866,  1866,  1866,  1866,   825,
     825,  1627,  1627, -2233, -2233, -2233, -2233, -2233,  1790, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233,   615, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233,   881, -2233, -2233,  1837, -2233, -2233, -2233,  1774,  1822,
   -2233,  1677,  1678,   168, -2233, -2233, -2233, -2233,  1267, -2233,
   -2233, -2233, -2233, -2233,  1825, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233,   979,   979,   979,   979,  1846,   979,   979,   116,
    1061,   979,  1061,   979, -2233,   979,   979, -2233, -2233,   -67,
   -2233, -2233, -2233, -2233,  1774,   804,   183, -2233, -2233,  1847,
   -2233, -2233,  4598,  1806, -2233,  4752, -2233, -2233, -2233,   183,
    1831, -2233,  1809,  3915, -2233,  3980, -2233, -2233,  1836,  1271,
    1300,   183, -2233,   183, -2233,   -67, -2233,  1811,  1815, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233,  1835, -2233,  1787,
    1819,  1134, -2233,  2639,  1184,   887,   887,  1820, -2233,  1823,
    1830,  1494,  1467, -2233, -2233,  1687,  1588,   887,  1832,  1834,
    1838,  1494,  1839,  1494, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233,   903, -2233,   887, -2233,   887, -2233, -2233, -2233,
     887, -2233,   887,  1851,   887,   887,  1852,   887,  1854,   887,
    1855,   983,  1859,  1861, -2233,  1862,  1864,  1865,  1868,  1869,
    1871,  1494,   900,  1872, -2233,  1873,  1874, -2233,   887,  1875,
    1494,  2227, -2233,  1077, -2233,   887, -2233, -2233, -2233,   887,
   -2233, -2233, -2233,   233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233,  4319, -2233,  1735, -2233,  1494, -2233, -2233, -2233,  1877,
    1614,   255,  1449,  1878,  1879, -2233,  1707,  1824,  1913,   887,
    1494,  1494,    -3,  4781, -2233, -2233,  1751, -2233, -2233,  1787,
    1857, -2233,  1259, -2233,  1259,  1912, -2233, -2233,  4467,  1903,
    1904,  3498,  3303, -2233, -2233, -2233,  4467, -2233,  4467,  4467,
    4467,  4467, -2233,  2937,  4467,  3243,  4467, -2233,  1867,  4467,
   -2233, -2233, -2233,  1921,  1923,  4467,  1108, -2233,   441, -2233,
   -2233, -2233, -2233,  1919,  1919, -2233, -2233,   742,   194,  1292,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,   957, -2233,
    1937,  1939,  1941,  1943, -2233,  1944,  1945, -2233, -2233,  1934,
     983, -2233, -2233,   983, -2233,   983,   979,  1947,   979,  1948,
    1950,  1952, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
    2404, -2233,  5409,   726,  1906,  1885,  1787, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233,   896, -2233, -2233,
   -2233,  1942, -2233, -2233, -2233,   562, -2233,  1918, -2233, -2233,
    1833, -2233, -2233,  1922, -2233, -2233, -2233, -2233,   992, -2233,
    1935,  1908,  1940, -2233, -2233, -2233,  1946,   234, -2233,  1949,
     728,   887,  1951, -2233, -2233, -2233,  1953, -2233,  1954,   628,
    1955,   179, -2233,   271, -2233, -2233,   105, -2233, -2233, -2233,
    1956,  1960, -2233,  1962, -2233,  1963, -2233,  1967, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233,  1969, -2233,  1970, -2233,
   -2233, -2233,  1971, -2233,  1972,  1710, -2233,  1652,  1559,  1290,
    1639,  1814,  1708,  1829,   -29,  1494,  1977,  1494,   348,   887,
   -2233,  1986, -2233,  1774,   965,   183,   887,  1907, -2233, -2233,
    1989, -2233, -2233, -2233, -2233,   384,  1494, -2233,   160, -2233,
    1755,  1128, -2233,   144,  1990, -2233,  1615,  1347, -2233, -2233,
   -2233, -2233,   988, -2233, -2233, -2233,   988,  1876, -2233, -2233,
    1994, -2233, -2233,  1494,   887, -2233, -2233,  1995,   887, -2233,
    1863,  1817,  1863,  1054,   -31,  1863, -2233, -2233,  1998, -2233,
   -2233, -2233, -2233,  1913, -2233, -2233,  2017, -2233, -2233, -2233,
     411, -2233,  4467,  4467,  2001,  4467, -2233, -2233, -2233,  4467,
    4467,  2030,  2007,  2008,  2010,  2037,  4467, -2233,   345, -2233,
     887, -2233, -2233, -2233, -2233, -2233,  2031,  4319,  2032, -2233,
    4467, -2233,  4467,  2808,  2269,  3582,  4076,  4119,  4221,  4286,
     730,   597,  4319,  1992,   758,   165,  1996,  2049,  3813, -2233,
   -2233,  4382, -2233, -2233,   957, -2233, -2233,  2051,   742,  1626,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
    2068, -2233,  2070, -2233, -2233, -2233,   726,  2006, -2233,  5409,
   -2233,  2029, -2233,  2069, -2233,  1166,  1244, -2233, -2233, -2233,
   -2233, -2233, -2233,  1933, -2233,   571, -2233, -2233,  2012, -2233,
      59, -2233, -2233,   887, -2233, -2233,  1910,  1711, -2233,     7,
    1718,  1720,   969,   949, -2233, -2233,  2046,  2050,  2053, -2233,
   -2233, -2233, -2233,  1494, -2233,  1110,  1856,   887,   887,  2054,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233,   352,   749,  1494,  1494,     5,  1494,   586,
    1566, -2233, -2233, -2233,  1826, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233,  1807, -2233, -2233, -2233,   887,
     887,  1494, -2233,  2041,   887, -2233,  2042,   983, -2233, -2233,
    2043,   887, -2233, -2233,   887,  2044, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233,  2052, -2233, -2233, -2233,   834,   388, -2233,
    1494, -2233, -2233, -2233,  1961, -2233, -2233, -2233, -2233,   887,
    2061,   887, -2233, -2233, -2233,  2085, -2233, -2233, -2233,   887,
   -2233,  2017,  2113,  4467,  3610,  2086,  2093,  5349,  5308,  2814,
    3001,  4467, -2233, -2233, -2233,  4467,  2097,  4467,   998, -2233,
     -36,  2141,  2127,  4425,  4527, -2233, -2233, -2233, -2233,  2102,
   -2233, -2233,  1314,  2098, -2233, -2233, -2233, -2233, -2233,  1629,
    2131,  2131,  1128,  2119, -2233, -2233,  1629,  2131,  2131,  2131,
     988,  2120,  4467, -2233, -2233, -2233, -2233, -2233,  2130,  4467,
   -2233,  3549, -2233,  2135,  4467,  2164,  3855,  4161,  2096, -2233,
   -2233, -2233, -2233,  1070, -2233, -2233, -2233,  2124,   742,  1626,
   -2233, -2233, -2233, -2233,  2100,  1494, -2233, -2233, -2233, -2233,
   -2233,  2012, -2233, -2233,   903,   183,  1892,  2132,  1816,  1916,
   -2233, -2233, -2233, -2233, -2233, -2233,   234, -2233, -2233, -2233,
   -2233, -2233,  1973,  1974,  1975, -2233, -2233, -2233,   439,   439,
     992, -2233, -2233, -2233, -2233, -2233,  1997,  1890, -2233, -2233,
   -2233, -2233, -2233, -2233,  1494,  1494,  1787,  2107, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233,  2111, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233,  2114,   887, -2233,  1494, -2233, -2233, -2233,  2115, -2233,
   -2233,  5336,  4467, -2233, -2233,  2138, -2233,  5097, -2233,  5386,
    4467,  1049,  5414, -2233,  5470,  2142,  2143,  2146,  2156,  2165,
   -2233,   992,  2173, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  2206,
     887,  1372, -2233,  2148, -2233,   721,   887,  1526,   744, -2233,
   -2233,  1372,   721,   744,   721,  2151, -2233,  4689,  2175,  2176,
     775,   711,  2177,   818,  2179,  2180,   750,  2181,   787, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233,   963, -2233, -2233,
   -2233,   992,  1965, -2233, -2233, -2233, -2233,   887,   887,   887,
   -2233, -2233, -2233, -2233, -2233, -2233,  1494,   887, -2233, -2233,
    1615, -2233, -2233,   845,  1017,    31,   357,    64, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
    2184,  5409,  2133, -2233,  1316, -2233,  4319, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233,  4467,  4467,  4467, -2233,  4467, -2233,
   -2233,   887, -2233, -2233,   887,   943,   887, -2233,  2131,  2131,
    2201, -2233, -2233, -2233, -2233, -2233,  2131,  2131,  2219, -2233,
   -2233, -2233, -2233,  2207,  4467, -2233, -2233, -2233,  2211,  4467,
   -2233,  4467,  2236, -2233,  4467, -2233,   980, -2233, -2233, -2233,
     183,  1494,  2169,  1146,  2004,   887,   887,   397, -2233, -2233,
    2174,  2202, -2233,  1494, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233,  2642, -2233, -2233, -2233,   419, -2233, -2233,  1494,   887,
    1494,  2203, -2233,   887,   887,   -35,   887,  1964,   170, -2233,
    2204, -2233,  1804,  1805,  1494,  1494,  1494,  2205,   743, -2233,
     -14,   -19,   967, -2233,   -37, -2233,  2186,  5097,  5409, -2233,
   -2233,  2091, -2233, -2233,  2256, -2233, -2233, -2233, -2233,   104,
    2215,  2192,  4878,  4998,  5026,  5070, -2233,  2148,   887, -2233,
     887,   887,   887,  1526,  1526, -2233,  2217,  2220,  2221,  2198,
    2223,  2228,  2226,   887,  2002,  1121, -2233,   887,  2003,   231,
    2036,   887,  2045,  2055,  2237, -2233, -2233,  2099,  2056,  2059,
    2060, -2233, -2233, -2233,  1220, -2233,  2088, -2233,   584, -2233,
   -2233,  1624, -2233,   887,  2019,   421,  2062,  1880,  2234,   887,
     887,  1494,    -7,  1958,  1896,   887,  1494,   887,  2014,   198,
    -106,   887,  2193,  1928, -2233,  2268, -2233,   887,  2271, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,   887,
     887, -2233, -2233,   887,   887, -2233, -2233, -2233, -2233, -2233,
      36,   -61,   -24,  1895,  -152,  1889,  1898,  1494,  1902,  2026,
    1870,  2065,  2035,  2067,  2302, -2233,    26,   992,  2305, -2233,
      26,  2332,  2308,   887, -2233,  1494,  2082,   432,   -90,   887,
    2071,  1494,    16,   992,  2022,  2072,  2242,   361,  2073,  2074,
      98,  1887,  1886,  1883, -2233,  2323, -2233,  1881,  1888,   183,
    2325, -2233, -2233, -2233,  5098,  1289,  1354,  5409,  2329,  4467,
    2333,  2337,  2338,  2339, -2233,  2374,  2375, -2233, -2233, -2233,
   -2233, -2233, -2233,  4467, -2233,  4467, -2233, -2233,  1254, -2233,
   -2233, -2233,   887,   887,   887,   887,   887, -2233,  1494, -2233,
     887,   887, -2233,  2336,  2360,   887,   887,   887, -2233, -2233,
    1234,  2387,    94,   887,  2387,  1253,   140,  2340, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233,   102,   887,   887,
   -2233,  1494,  1985, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
     956,  1494, -2233, -2233, -2233,   887,   887, -2233,  1494,  1494,
   -2233,   887,  1494, -2233, -2233, -2233, -2233, -2233,  1966,  1966,
    2126, -2233,   803,   887,   803,  2128,   887,  2178,   887,  2188,
     887,  1980, -2233,  1494,   887,   887,  2255,  1494,   834,  1494,
     388, -2233, -2233,   887, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233,   887,   887,   887, -2233,  1494,  1494,
   -2233,   887, -2233, -2233, -2233, -2233, -2233, -2233, -2233,   982,
     887,   887, -2233, -2233,   887,   887,  1494, -2233,  1494,  1494,
    1494, -2233, -2233,  1957,  1959, -2233, -2233, -2233,  4467, -2233,
   -2233, -2233, -2233,  5194, -2233, -2233, -2233, -2233,   887,   887,
    2365,  2358,   992,   992, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233,  2099, -2233, -2233, -2233, -2233, -2233, -2233,
    2386,  2387,  2387,  2388,  2389,  1382,  1416,  2390,  2387,  2387,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233,  1494,  1027,  2023,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  1494, -2233,
   -2233,   887, -2233, -2233, -2233, -2233,  1966, -2233,   887,  1966,
     887, -2233,   887, -2233,  1494, -2233, -2233, -2233,   887, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
    2028, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
     183,   183,  5098,  2393, -2233, -2233, -2233,  4467, -2233, -2233,
   -2233,   584,  2394,  2395,   584,   584, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233,   584,  2398,  2399, -2233,
   -2233,  2047, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233,  2376, -2233,   584,
     584, -2233, -2233, -2233,   584,   584, -2233,  2400,  4467, -2233,
   -2233, -2233, -2233, -2233,  2402, -2233
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       4,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1388,     0,     3,   134,   136,   138,   532,   534,   536,   538,
     542,   544,   546,   602,   611,   613,   615,   617,   619,   621,
     623,   625,   627,   629,   631,   638,   640,   642,   644,   646,
     648,   650,   654,   656,   745,   747,   749,   751,   711,   914,
    1057,  1059,  1061,  1063,  1065,  1067,  1069,  1071,  1243,  1245,
    1308,  1372,  1374,  1376,  1378,  1380,  1382,  1384,  1386,     1,
       2,     0,   388,     6,   386,   387,     0,     0,     0,     0,
       0,     0,     0,     0,   394,   395,     0,   379,   380,   382,
     383,   384,   385,     0,     0,  1342,     0,     0,     5,     7,
     140,   143,   145,   147,   149,   178,   368,   375,   377,     0,
     389,     0,   438,   442,   393,   396,   400,   396,   713,   396,
     665,   396,   400,   396,   901,   396,   400,   396,   400,     0,
     400,   396,  1104,   396,  1190,   396,  1247,   396,   400,   400,
    1341,  1364,  1367,   396,   396,   400,   135,   137,   139,   259,
     260,   269,   188,   189,   265,   278,   263,     0,     0,     0,
       0,   279,     0,     0,     0,   282,   261,   262,   280,   281,
     283,   284,   285,   286,   287,   288,   309,     0,     0,     0,
       0,     0,     0,     0,     0,   664,   744,   889,   892,   891,
     888,   890,   893,   894,   895,   898,   900,   896,   897,   899,
    1053,  1054,  1055,  1056,  1188,  1189,  1241,  1242,  1313,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,  1323,  1324,
    1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1340,  1420,  1421,    37,    38,
      47,    39,    40,    41,    42,    48,    43,    44,    45,   266,
     132,   133,    46,   264,   273,   307,   308,   336,   306,   310,
       0,   311,   658,   660,   659,     0,     0,     0,   658,    67,
      67,     0,     0,     0,     0,   657,     0,   662,     0,     0,
     548,     0,   604,     0,     0,   541,     0,   541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   634,     0,   633,
     636,    67,   916,  1389,  1388,     0,  1388,     0,     0,  1390,
    1385,    16,    15,     0,   179,   141,   144,   151,   152,   153,
     155,   154,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,    65,    64,     0,     0,
       0,     0,    22,   381,     0,     0,   444,   443,   445,   446,
       0,     0,     0,     0,     0,     0,     0,   470,  1248,   754,
     714,   666,   902,   923,  1083,  1098,  1105,  1191,  1278,  1394,
    1407,   926,  1193,     0,   397,     0,   469,     0,    22,     0,
     476,     0,     0,     0,     0,   408,     0,   422,     0,     0,
       0,     0,     0,   851,   852,   753,     0,     0,     0,     0,
       0,   841,   842,     0,     0,     0,     0,    22,     0,     0,
       0,     0,    22,     0,   758,   755,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,     0,     0,    22,     0,     0,     0,     0,     0,   853,
     884,     0,     0,     0,     0,   922,     0,     0,    22,     0,
       0,    22,     0,     0,    22,   929,   933,   422,   934,     0,
       0,   947,     0,  1082,    22,     0,     0,     0,     0,     0,
       0,  1087,     0,  1100,  1097,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1277,     0,
       0,     0,     0,     0,  1297,  1306,  1393,     0,     0,     0,
       0,    22,     0,    22,  1399,  1400,     0,     0,     0,     0,
    1406,  1413,     0,  1410,     0,   259,   278,   259,   259,     0,
       0,   259,   259,     0,   249,     0,    29,     0,     0,     0,
      32,    33,   274,     0,     0,     0,   304,    36,   211,   212,
       0,   214,     0,     0,   127,   127,     0,     0,     0,     0,
       0,     0,     0,   190,   193,   189,   192,   195,     0,    37,
      38,   240,   191,   229,   226,   227,   228,   236,     0,   244,
       0,     0,     0,   630,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     479,     0,   478,   653,   651,   652,    66,     0,     0,     0,
       0,   645,   490,     0,   489,     0,  1387,   661,   663,   662,
       0,   543,     0,   535,     0,   533,     0,   541,   541,   541,
     541,   541,   540,   541,   541,  1073,   541,   541,     0,   541,
     541,     0,     0,   624,   616,   626,   618,   612,   614,   620,
     622,  1360,  1355,  1358,  1356,  1357,  1359,  1361,  1362,  1363,
       0,  1353,   637,     0,     0,     0,     0,  1381,  1390,  1377,
    1379,  1391,     0,     0,     0,   171,   166,     0,     0,     0,
     371,   373,   374,   465,     0,     0,   376,   439,   440,     9,
      11,     0,   441,    18,    20,    19,    21,     0,    17,  1368,
       0,  1366,   447,     0,   455,  1345,  1350,  1346,     0,     0,
       0,  1371,  1370,   390,   924,   925,   396,  1192,   398,     0,
     471,     0,   401,   402,   456,   407,   406,   405,   403,    22,
     472,   420,   424,   473,   474,   719,   672,   776,     0,     0,
       0,   792,     0,     0,     0,   845,   843,   846,   844,   847,
     849,   848,   850,     0,     0,     0,     0,    22,    22,     0,
      22,     0,     0,     0,     0,   793,     0,    23,    24,    25,
       0,    26,     0,    26,     0,     0,     0,     0,     0,     0,
      22,     0,    22,     0,    22,    22,     0,    22,    22,    22,
      22,    22,    22,     0,     0,    22,     0,    22,    22,     0,
       0,     0,   777,   882,   886,   778,   911,   927,    22,    22,
     948,   935,    22,   945,   942,     0,    22,   936,   930,   931,
     424,   928,   950,  1084,  1094,  1093,     0,     0,  1090,     0,
       0,  1095,  1096,  1086,  1085,   415,   171,     0,   429,   430,
       0,     0,   428,   410,     0,   411,   426,   409,     0,    22,
       0,  1101,  1102,  1116,  1200,  1250,  1279,     0,     0,    54,
      53,  1293,    22,     0,  1280,  1281,  1299,     0,  1298,     0,
    1302,  1300,  1301,  1291,  1294,  1304,     0,    22,  1312,    22,
       0,  1401,     0,  1403,  1310,  1396,  1395,  1408,   456,  1411,
       0,  1409,     0,   252,   257,   255,     0,   188,   189,     0,
     256,   258,   251,    28,    30,     0,     0,   275,   325,     0,
       0,   326,   213,     0,   289,     0,   128,   129,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   241,
     242,     0,     0,     0,   267,     0,   268,     0,     0,   301,
     299,   297,   294,   295,   296,   298,   300,   302,   303,   290,
     291,   292,   293,   320,   319,   313,   314,   315,     0,   318,
     312,   316,   317,   322,   323,   324,   598,   596,   597,   581,
     584,   588,   591,   594,   595,   582,   583,   585,   586,   587,
     589,   590,   592,   593,   599,   600,   601,   483,   484,   485,
     487,   488,   486,     0,   481,   643,   639,   647,   649,   494,
     495,     0,   492,   655,     0,   537,   545,   547,   171,     0,
     557,     0,   578,     0,   559,   558,   563,   564,     0,   577,
     579,   580,   549,   556,     0,   603,   606,   607,   608,   609,
     605,   610,    67,    67,    67,    67,     0,    67,    67,     0,
     541,    67,   541,    67,  1058,    67,    67,  1309,   628,     0,
     635,   632,   641,   915,   171,     0,     0,   920,  1383,     0,
    1392,  1373,     0,   167,   171,     0,   142,   173,   146,     0,
       0,   456,     0,     0,   369,     0,  1369,  1365,     0,   449,
     452,     0,  1349,     0,  1348,     0,  1351,     0,     0,    12,
      13,    14,   391,   392,  1099,   399,   404,   459,   462,   477,
       0,     0,   425,   400,   400,     0,     0,     0,   784,     0,
       0,    22,    22,   819,   821,     0,     0,     0,     0,     0,
       0,    22,     0,    22,   836,   835,   529,   838,   794,    52,
      51,   758,     0,   758,     0,   781,     0,   761,   762,   755,
       0,   779,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   818,     0,     0,     0,     0,     0,
       0,    22,     0,     0,   820,     0,     0,   788,     0,     0,
      22,     0,   887,   400,   937,     0,   940,   939,   938,     0,
     946,   944,   932,     0,  1088,  1089,  1092,  1091,   174,   175,
     427,   176,   437,   431,   413,    22,   414,   412,   417,     0,
     400,   400,   400,     0,     0,  1286,    26,  1295,     0,     0,
      22,    22,  1292,     0,  1284,  1404,  1397,  1311,  1402,   464,
    1417,  1412,   259,   250,   259,     0,    30,   277,     0,     0,
       0,     0,     0,   123,   125,   333,     0,   305,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   194,     0,     0,
     230,   237,   245,     0,     0,     0,     0,   480,     0,   491,
     539,   555,   562,     0,     0,   551,   552,   575,   576,     0,
     572,   573,   574,   568,   566,   567,   550,   565,   560,   561,
       0,     0,     0,     0,   712,     0,     0,  1072,  1081,     0,
       0,  1076,  1079,     0,  1074,     0,    67,     0,    67,     0,
       0,     0,  1354,   919,   918,   917,   921,  1375,     8,   169,
       0,   180,   181,     0,     0,     0,   466,   370,   372,    10,
     448,   450,   451,   453,   454,  1344,  1347,     0,  1343,   378,
     460,    67,   456,   475,   423,     0,   418,     0,   721,   722,
       0,   715,   716,     0,   674,   679,   681,   681,     0,   667,
       0,     0,     0,   805,   804,   803,     0,     0,   763,     0,
      22,     0,     0,   828,   827,   834,     0,   815,     0,     0,
       0,     0,    27,     0,   759,   760,     0,   756,   757,   790,
       0,     0,   809,     0,   798,     0,   786,     0,   787,   817,
     801,   822,   800,   799,   833,   802,     0,   823,     0,   825,
     797,   789,     0,   795,     0,     0,   885,     0,     0,     0,
       0,     0,     0,     0,     0,    22,     0,    22,    22,     0,
     860,     0,   913,   171,     0,     0,     0,     0,   907,   903,
       0,   941,   943,   949,  1043,     0,    22,   963,    22,   961,
       0,     0,   953,    22,     0,   967,  1044,     0,   436,   416,
    1103,  1118,     0,  1119,  1110,  1112,     0,     0,  1106,  1107,
       0,  1202,  1203,    22,     0,  1194,  1195,     0,     0,  1249,
    1262,     0,  1262,     0,     0,  1262,  1252,  1253,     0,  1256,
    1282,  1283,  1285,     0,    60,    61,  1287,  1289,  1290,  1288,
       0,  1307,   340,   340,     0,     0,   337,   338,   339,     0,
       0,     0,     0,     0,     0,     0,   340,  1303,     0,  1305,
       0,  1405,  1415,  1419,   253,   254,     0,   276,     0,   327,
       0,   270,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,     0,     0,     0,     0,     0,     0,    34,
      35,     0,   482,   493,     0,   553,   554,     0,   569,   570,
     752,   746,   748,   750,  1062,  1060,  1077,  1080,  1075,  1078,
       0,  1064,     0,  1068,  1244,  1246,     0,     0,   184,   182,
     183,     0,   148,     0,  1352,   457,     0,   461,   463,   419,
     421,   456,   717,     0,   720,   668,   456,   669,   699,   670,
     703,   671,   673,     0,   810,   812,     0,     0,   767,     0,
       0,     0,     0,     0,   765,   813,     0,     0,     0,   829,
     814,   816,   531,    22,   528,     0,     0,     0,     0,     0,
     839,   783,   782,   780,   808,   807,   791,   806,   785,   826,
     824,   796,   840,     0,    22,    22,    22,     0,    22,     0,
       0,   866,   867,   868,     0,   864,   879,   878,   880,   883,
     906,   905,   904,   908,   909,     0,   912,   456,   966,     0,
       0,    22,   954,     0,     0,   952,     0,     0,   970,   965,
     969,     0,   959,   951,     0,   977,   432,   433,   434,   435,
      50,    49,  1152,  1161,  1109,   456,  1108,     0,     0,  1114,
      22,  1117,   456,  1199,  1196,  1198,  1201,  1264,  1263,     0,
       0,     0,    25,  1266,  1265,  1254,  1269,  1270,  1257,     0,
    1251,  1296,     0,     0,   341,     0,     0,     0,     0,     0,
       0,     0,   363,   363,   354,     0,     0,     0,     0,  1398,
       0,     0,     0,     0,     0,    80,    91,    92,    78,     0,
      81,    82,     0,     0,    85,    86,    89,   130,    87,     0,
     104,   104,     0,     0,    90,   131,     0,   104,   104,   104,
       0,     0,     0,   330,   331,   329,   332,   209,     0,     0,
     207,     0,   203,     0,     0,   201,     0,     0,     0,   321,
     571,  1066,  1070,     0,   177,   185,   172,     0,    57,    58,
      59,    55,    56,   458,   741,    22,   677,   675,   676,   678,
     680,   699,   697,   682,     0,     0,   706,     0,     0,     0,
     771,   769,   770,   773,   772,   774,     0,   764,   831,   830,
     832,   527,     0,     0,     0,   522,   526,   530,    22,    22,
       0,   873,   874,   875,   876,   877,     0,     0,   869,   857,
     858,   859,   865,   881,    22,    22,  1046,  1050,   956,   957,
     955,  1031,   958,  1031,   991,   971,   960,  1045,   978,  1159,
    1158,  1149,  1165,  1164,  1172,  1111,  1174,  1175,  1182,  1113,
    1115,  1238,     0,  1259,    22,  1258,  1255,  1267,     0,  1260,
      62,     0,   340,   352,   353,     0,   346,     0,   246,     0,
       0,     0,     0,   351,     0,     0,     0,     0,     0,     0,
    1418,     0,     0,    31,   328,   271,   272,    79,    83,    84,
      88,    74,    72,    70,    69,    71,    73,    68,    75,    97,
       0,   114,    99,    95,   105,   115,     0,     0,   116,   113,
     124,   119,   120,   121,   122,   117,   126,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   243,
     168,   170,   150,   739,   723,   718,   682,     0,   702,   704,
     705,     0,   708,   811,   768,   775,   766,     0,     0,     0,
     855,   856,   854,   863,   862,   861,    22,     0,   872,   910,
    1044,  1048,  1052,     0,     0,     0,   980,     0,  1163,  1147,
    1146,  1170,  1180,  1236,  1204,  1197,  1261,  1271,   345,   342,
       0,   181,   343,   186,     0,   349,   363,   364,   365,   366,
     363,   367,   348,   347,     0,     0,     0,   356,     0,  1414,
    1416,     0,    93,    77,    76,     0,     0,    76,   104,   104,
       0,   106,   107,   108,   109,   110,   104,   104,     0,   334,
     224,   208,   206,     0,     0,   204,   222,   202,     0,     0,
     220,     0,   218,   217,     0,   215,   724,   743,   701,   700,
       0,    22,     0,     0,     0,     0,     0,     0,   690,   497,
     501,     0,   707,    22,   710,   523,   524,   525,   870,   871,
    1047,     0,   964,  1034,  1032,  1035,   962,   968,    22,     0,
      22,     0,   976,     0,     0,     0,     0,     0,     0,   990,
       0,  1162,     0,     0,    22,    22,    22,     0,     0,  1151,
    1166,  1176,     0,  1240,     0,   350,     0,     0,   181,   196,
     199,     0,   355,   198,   234,   231,   232,   233,   238,     0,
       0,     0,     0,     0,     0,     0,    98,    96,     0,   100,
       0,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   742,     0,     0,     0,
       0,     0,     0,     0,     0,   502,   688,   498,     0,     0,
       0,   683,   687,   691,     0,   692,     0,   689,   503,   698,
     709,     0,  1051,     0,     0,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,    22,     0,     0,     0,
       0,     0,     0,     0,  1030,     0,  1036,     0,     0,   974,
     975,   973,   972,   984,   981,   987,   988,   989,   982,     0,
       0,   985,   979,     0,     0,  1153,  1154,  1155,  1160,  1150,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,  1137,  1139,     0,  1169,     0,     0,     0,  1179,
       0,     0,     0,     0,  1239,    22,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1231,     0,  1276,     0,     0,     0,
       0,   187,   344,   248,   200,     0,     0,   181,     0,     0,
       0,     0,     0,     0,    94,     0,     0,   101,   112,   111,
     223,   205,   221,     0,   219,     0,   216,   725,     0,   728,
     729,   727,     0,     0,     0,     0,     0,   734,    22,   726,
       0,     0,   740,     0,     0,     0,     0,     0,   693,   694,
       0,     0,     0,     0,     0,     0,     0,     0,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,   996,     0,     0,     0,
    1024,    22,     0,  1038,   993,  1011,  1029,  1018,  1019,  1020,
      22,    22,   992,  1013,   995,     0,     0,   997,    22,    22,
     994,     0,    22,  1049,  1037,  1033,   983,   986,  1186,  1186,
       0,  1136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1124,    22,     0,     0,     0,    22,     0,    22,
       0,  1148,  1173,     0,  1184,  1168,  1167,  1171,  1183,  1178,
    1177,  1181,  1210,  1208,     0,     0,     0,  1224,    22,    22,
    1205,     0,  1229,  1232,  1235,  1234,  1233,  1230,  1209,    22,
       0,     0,  1206,  1207,     0,     0,    22,  1211,    22,    22,
      22,  1237,  1268,     0,     0,  1275,  1272,   197,     0,   235,
     239,   247,   361,     0,   358,   359,   357,   360,     0,     0,
       0,     0,     0,     0,   732,   733,   468,   467,   735,   736,
     730,   731,   496,   498,   684,   685,   686,   695,   696,    63,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     500,  1022,  1021,  1023,  1026,  1025,  1014,    22,     0,     0,
    1027,  1012,  1010,   998,  1009,  1008,  1015,  1007,    22,  1156,
    1157,     0,  1143,  1144,  1145,  1132,  1186,  1133,     0,  1186,
       0,  1122,     0,  1126,    22,  1125,  1127,  1128,     0,  1141,
    1138,  1142,  1140,  1185,  1222,  1223,  1225,  1228,  1215,  1217,
       0,  1226,  1220,  1221,  1218,  1219,  1212,  1213,  1214,  1216,
       0,     0,     0,     0,   103,   102,   210,     0,   737,   738,
     499,   503,     0,     0,   503,   503,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   503,     0,     0,  1016,
    1017,  1040,  1039,  1028,  1187,  1134,  1130,  1135,  1131,  1121,
    1120,  1123,  1129,  1227,  1274,  1273,   362,     0,   508,   503,
     503,   510,   509,   511,   503,   503,  1041,     0,     0,   506,
     507,   504,   505,  1042,     0,   225
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  -332,
    -355,   -65,   273,  -419,  -742, -2233,  -157,  -160,  1442,  1443,
    1444, -2233, -2233, -2233,  -170, -2233, -2233,  -221, -1387,  -767,
    1841, -2233, -2233,   975, -1764,  -103,  -154,   442,  -838, -2233,
     942,   946,   947, -2233,   950,   712,   447,   451,  -612, -1414,
    -686,   718, -2233, -2233, -2233, -2233,  1924, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  -986, -2233,
   -2233, -2233,  1803,  -947,  -597,  1422, -2233, -2233, -1802,   915,
   -2233,   368,  -192,  1557,   205, -1205, -1956,  2316, -1950, -1892,
    1558,   222,  1979, -2233,  1581, -2233, -2233, -2233, -2233,  -502,
   -2233, -2233, -2233, -1201,  -146, -1177,    -6, -2233, -1448, -1196,
   -1643, -2233, -2233,  -442, -2233, -2233,   169, -2233, -2233, -2233,
     -39,   -85, -2233,  2377,  1344, -2233,  2063,  1698,   -82,  -548,
    -473, -2233,  -190, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
    1187,  -715,  -772, -2233, -2233, -2011, -2233, -2233, -2233, -2233,
   -2233,  -266, -2233,  1264,   150, -2233,  1263, -1537,    53, -2050,
   -2233,  -806, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
    -279, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  -859,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233,   264,  1914, -1185, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  1180,   573,
   -2233, -2233, -2233,   731, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233,  1392,    43, -2233, -2233,   719, -2233, -2233, -2233,
   -2233, -2233,   707, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233,   685, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233,   557, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233,   156, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233,   311,   295, -2233, -2233,
   -2233, -2233,   146,   292, -2233, -2233, -2233, -2233,   149,   296,
   -2232, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,  -590,
     842, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
    1680, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233,  1465,  1503, -2233, -2233,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,   865,  1891,
   -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233, -2233,
   -2233
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    22,    23,    24,    25,     2,     3,   108,   109,   698,
     711,   384,  1972,  1863,  1133,   536,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1682,  2083,
     861,  1793,  1485,  1486,  2480,   348,   607,  1920,  2029,  1748,
    1749,  1750,  1751,  1759,  1752,  1921,  1922,  1923,  1925,  1926,
    2035,  1928,  1753,  1761,  1523,  1524,   916,  1233,  1234,   260,
     261,   262,   110,   675,   111,   112,   113,   114,   342,  1310,
    1064,  1065,  1189,  1190,   842,  1067,   115,   674,  1567,  1568,
    1569,  2002,   263,   573,  2124,   926,   574,   927,   575,   576,
     577,  2128,   578,  2129,   579,   580,  2004,   532,   264,   533,
     265,   266,   906,   267,   268,   269,  1532,  1506,  1715,  1570,
    1890,  2010,   116,   685,   117,   118,   395,  1093,   120,   121,
     385,   396,   397,  1336,  1337,  1101,   732,  1102,   398,   847,
     843,  1448,  1194,   122,   360,   361,   123,  1097,  1577,  1331,
    1098,  1219,  1220,  1071,  1072,  2317,   124,   125,   126,   724,
     399,   603,   993,   994,   615,  1001,  1002,  2068,  2323,  2069,
    2070,  2337,  2487,  1619,  1369,  1127,    26,    27,    28,    29,
     638,    30,    31,    32,   624,  1276,  1277,  1024,   986,   275,
      33,   626,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   310,   663,    45,    46,    47,    48,    49,
      50,    51,   276,    52,    53,   277,   620,   271,   127,  1343,
    1103,   128,  1581,  2057,  2164,  2056,  1954,  1582,    54,    55,
      56,    57,   129,  1350,  1104,   130,  1800,  1585,  1586,  1958,
    2071,  2177,  1957,  1803,  1587,  1589,  1806,  1962,  2074,  1591,
      58,   131,   774,   772,  1359,  1603,  1604,   132,   764,  1370,
     449,   450,  1973,  1842,  1421,  1171,   804,  1172,   451,   133,
    1430,  1173,   134,    59,   665,   381,   135,   136,   819,   467,
     468,   469,   470,   471,  1183,  1444,  1666,  1663,  1669,  1670,
    1985,  2091,  1445,  1986,  2100,  1446,  2205,  1983,  2084,  2085,
    2208,  2498,  2607,  2582,  1657,  1675,  1847,  1980,  2081,  1982,
    1658,    60,    61,    62,    63,    64,    65,    66,    67,  1039,
     137,   138,   482,   139,   716,   140,   141,  1460,  1687,  1688,
    1200,   142,  1685,  2244,  2398,  2400,  2515,  2109,  2108,  1990,
    1686,  1683,  2107,  1988,  1987,  1860,  1684,  1864,  1991,  2248,
    2402,  2110,  1865,  1868,  1992,  2252,  2408,  2111,  1869,  2405,
    2509,   382,   143,  1467,  1201,   144,  1692,  2113,  2275,  2427,
    2112,  1994,  1693,    68,    69,   145,   146,  1202,  1478,  1699,
    1479,  1705,  1708,  1877,  1878,  2114,  2280,  2442,   147,   148,
     873,   874,   504,   505,  1509,  1213,   876,    70,   149,   516,
     362,   150,  1082,  1084,   708,  1087,   660,   661,   151,   152,
      71,    72,    73,    74,    75,    76,    77,    78,   319,   672,
     153,  1511,   517,   154,   155,   524,   888,  1902,  1730,  1513,
     889
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     355,   270,   572,  1131,   541,   771,   773,   540,   918,  1099,
     712,   605,  1504,   534,   845,   810,   323,  1507,   641,   692,
     651,   324,   325,   893,   571,   894,   895,  1023,  1508,   900,
     901,  1139,   710,   710,   570,  1706,  1505,   569,  1531,  1533,
    1535,  1536,  2276,  1900,   689,  1716,  1208,   448,  2125,   690,
     346,   466,   347,   480,  2126,   492,   481,   539,  1726,  1680,
    2249,  1261,  2382,   502,   514,  2245,   503,   515,  1057,  1689,
     523,   349,   350,   745,     4,     5,     6,   866,   691,  1313,
    1891,   313,   326,   687,   688,   632,  1111,   351,   400,   520,
     401,   766,   402,   652,   452,  1804,   453,    80,   472,  2384,
     767,   768,   494,   769,   495,  1140,   496,  1303,   497,  1141,
    2087,  1504,  2127,   799,   518,   519,   689,  2324,   632,  1209,
     689,   690,  1287,   723,   747,   690,   608,  1508,   813,   826,
      81,  2215,  1085,  1641,   749,  1505,   346,   621,   347,  1288,
      82,  1810,    83,  2101,  2481,    84,    85,  2510,   702,   751,
     691,  2388,  1140,   835,   691,   689,  1623,   664,  2418,  2357,
     690,   933,   689,   546,   387,  1279,   553,   690,   632,   388,
     389,    86,   119,   521,  2350,  1774,   878,   391,   689,  1115,
    1289,  2286,  2423,   690,   693,   694,   695,   696,   689,   691,
    2488,  1265,     1,   690,  1134,   272,   691,   273,  1135,  2116,
     693,   694,   695,   696,   544,   278,   346,   273,   347,   278,
    2368,   273,   691,  1244,     7,  1086,   689,  2424,  1775,   689,
     935,   690,   691,  1040,   690,   346,  1134,   347,   392,   537,
    1621,     8,    87,   393,    88,    89,   934,    90,   689,    91,
      79,  1836,  1776,   690,  1547,    92,  2417,    93,    94,    95,
     691,    96,   765,   691,  2287,  2216,     9,    10,   633,   707,
     693,   694,   695,   696,    97,    98,    99,   100,   101,   102,
    1290,   827,   691,   279,   280,   283,   284,   677,   860,  1096,
    1245,  1210,   311,  2358,  2586,   156,  2482,  2588,   726,   727,
     867,    11,  2389,  2088,    12,   936,    13,  1116,  1142,  2313,
    2314,   713,  1199,   314,    82,   465,  1042,    14,  1642,    84,
      85,   545,  1433,   754,   103,  1204,  2283,   315,  1134,   868,
     104,  1107,  1622,  2369,  1566,  1596,   105,   106,   869,  1266,
    2125,    15,  2489,   274,  1461,    16,  2126,  1927,   572,  1060,
      17,    18,  1076,   274,  1927,  1142,  1805,   274,  1032,  1033,
    1034,  1035,  1036,   703,  1037,  1038,  1316,  1041,  1043,  1837,
    1045,  1046,   634,  2130,  1291,   710,   689,  2131,  1504,  1112,
    1078,   690,  1727,  1935,  2217,  1083,   746,  1088,  2220,   534,
    1811,   534,   534,  1728,  1508,   534,   534,  1136,   693,   694,
     695,   696,  1505,   622,  2127,  2419,  1434,   354,  2383,  2089,
     691,  1435,  2359,   860,  1545,  1546,  2366,   281,   282,   387,
     909,  1109,  1110,  1866,   388,   389,  1292,   286,  1462,  1136,
     352,  1901,   391,  2324,   653,  2425,  2385,   748,    97,    98,
      99,   100,   101,   102,  1999,  2386,  2092,   750,  1713,   617,
    2250,   618,   770,  1143,  2090,  2246,  1146,  2251,  1206,  2099,
    1207,  2247,   752,    19,  2277,  2278,  1597,   689,  1211,  2315,
     933,  2279,   690,   542,  1482,  1707,  1867,   654,   655,   656,
     657,   658,   659,   392,  1186,  1187,  1650,  1168,   393,   693,
     694,   695,   696,  1180,  2403,  2451,  2380,   639,   798,  2348,
    2314,   691,   870,   871,   872,  1436,   307,   710,   710,   157,
    2415,  2314,  2426,  1053,   700,  1137,  1138,  1305,  1193,  1293,
    2316,  1136,  1193,  2436,  1117,   635,  1193,   910,  2491,  2492,
    2102,  2103,   158,   896,  2104,  2105,  2106,   346,  1664,   347,
     636,   637,  1885,   308,   738,  1224,   907,  1137,  1138,  1828,
     285,  1294,  1295,   728,  2204,   609,   610,  2060,  1217,   759,
    1218,   919,   920,   921,   922,   923,   924,   640,  1221,   522,
     705,  1031,   928,  2173,  1939,  1118,  1941,   706,  1671,  1943,
    2484,  1946,  1948,   312,  2062,  2274,  1428,   619,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,  1437,   617,  2093,   618,  2174,   316,   317,   318,
    1130,   739,  1227,   600,  1598,   364,  1599,  1769,  1600,  1601,
     570,   999,  1602,   569,  2140,  2141,   309,    20,    21,   689,
     320,   367,  2143,  2144,   690,   699,  1228,   356,  1438,  1137,
    1138,  2094,   793,   612,  2331,   343,   107,   760,  1054,   837,
     601,   693,   694,   695,   696,  1439,  2095,  1440,   368,  2315,
    1770,  1441,  1829,   691,  1196,  1442,  1443,   344,  1197,   689,
    2315,   722,   761,   365,   690,  1000,  1055,  1062,  1830,  2332,
     613,  1049,   725,  1050,  1668,   369,  1463,  1094,  1073,  -837,
     794,   693,   694,   695,   696,  1075,  1504,  2175,  2176,  1056,
     755,  2003,  1256,   691,  1257,   763,   345,  1169,   541,   795,
    2349,   540,  1508,   357,   358,   359,  2011,  1612,   786,  1387,
    1505,  2416,   353,  2432,  2009,  1646,   796,  2562,  2563,   776,
    1514,  2044,  1515,   602,  2577,  2578,   777,   321,   322,   363,
     370,   811,  1464,  1796,   814,  2023,  2027,   817,   366,  2333,
     572,   572,  1235,   371,  1797,  1798,   689,   824,   483,   321,
     322,   690,  1659,   614,   383,  2096,  2097,  2098,  2023,  2027,
    2051,  1296,  2433,  1298,  2045,   571,  1236,   689,   693,   694,
     695,   696,   690,  1351,  1352,   570,  2334,   535,   569,   627,
     691,  1660,  2335,  1767,   881,  1362,   883,   929,   930,   693,
     694,   695,   696,   829,  1970,  1971,   830,  2054,  2028,  2336,
    1504,   691,  1374,  2052,  1375,   628,  1661,  1768,  1377,  1794,
    1378,  1772,  1380,  1381,  1801,  1383,  1508,  1385,   484,  1613,
      82,  2036,  2229,   676,  1505,    84,    85,   846,  2042,  1304,
    1398,  1191,  2206,   931,  2230,  1773,  1402,   762,  2207,  2147,
    2055,   372,   537,  1431,  2149,   373,  2150,  1432,  1557,  2152,
     506,  1558,  2043,  1559,   767,   768,  1799,   769,  1272,   596,
     597,  1271,   485,   598,  1614,   538,   539,   542,  1129,  1615,
    1616,  2047,   543,  1617,  1618,   629,  1652,  1487,  1280,  1281,
    1282,  1283,  1701,  1285,  1286,  1709,  1839,  1297,   547,  1299,
     630,  1300,  1301,   387,   554,  2048,   374,   555,   388,   389,
     556,   375,   376,   486,   487,   689,   391,  1231,   488,  1232,
     690,  2231,  1862,  1861,  1840,  1841,  1504,  1504,   689,   489,
    1871,  2003,   581,   690,  2082,   387,   321,   322,   490,  1590,
     388,   389,  1508,  1508,   377,  1175,   845,   582,   391,   691,
    1505,  1505,  1846,   557,    97,    98,    99,   100,   101,   102,
     558,  1397,   691,  1306,  1911,  1912,  1913,   392,  1258,   378,
    1259,   559,   393,   379,   767,   768,  1314,   769,   560,  1205,
    1914,  1915,  1916,  1049,   689,  1574,  2232,   561,  1325,   690,
    1326,  2233,   538,   539,  2234,  1929,  1176,   562,   846,   392,
    1651,  2235,  1831,  1832,   393,   599,   693,   694,   695,   696,
     689,   680,  1100,   681,   606,   690,   682,   507,   691,   539,
     380,  1680,   767,   768,  2253,   769,   836,   837,  1341,  1349,
     604,  1342,   693,   694,   695,   696,  1816,  2153,  1817,  1608,
    1119,  1120,   611,  1122,   691,   684,   838,   538,   539,  2154,
    1129,   839,  2059,   508,  2155,   616,  2254,   767,   768,   623,
     769,  1917,  1918,  1148,  1703,  1150,   844,  1152,  1153,  2156,
    1155,  1156,  1157,  1158,  1159,  1160,   625,  1372,  1163,  1579,
    1165,  1166,  2007,  1606,   767,   768,   534,  1702,   534,   347,
     631,  1174,  1177,  2025,   632,  1178,  1504,  1648,  1429,  1181,
    2037,   642,  1843,  2025,  1654,  2037,  2086,   643,  2460,   171,
    2461,   644,  1508,   689,   714,   715,  2580,   175,   690,   541,
    1505,   645,   540,   491,   662,  1458,  1465,  1476,  1459,  1466,
    1477,  1950,  1198,  1951,   646,   693,   694,   695,   696,  1895,
    1896,   647,  1695,  1897,   313,  1203,  1697,   691,  1898,  1899,
     671,   680,  1560,   681,  1562,  1932,   682,  1934,   538,   539,
    1215,  1129,  1216,  2060,  2061,   648,  1422,  2060,  2255,   649,
     689,  2157,   650,   178,   179,   690,   180,   181,   182,   183,
     184,   185,  2008,   683,  1371,   684,  1373,  1576,  1729,   666,
    2062,   668,   667,  1192,  2062,   669,   -66,   -66,  2236,   -66,
    2237,  2238,   743,   744,   691,  2239,  2240,   670,  2241,   673,
    2499,   509,   782,   783,  2063,  2064,  2242,  2243,  2065,  2066,
    2256,  2257,   678,  1334,  2258,  1089,  1090,  1091,  1423,   837,
     831,   832,  1517,  2158,  2159,  1854,  2540,  2160,  1079,  1080,
    1525,   387,  1526,  1527,  1528,  1529,   388,   389,   679,  2259,
     709,  1025,  2260,  1538,   391,   686,  1424,   701,  1571,  1541,
     704,  2261,  2067,  2161,  2162,  2163,  2262,   485,   321,   322,
     717,  1807,  1825,  1344,  1788,  1789,   697,  1790,   718,  1345,
     720,  1130,  2512,  2513,  2514,   510,   195,   525,   987,   988,
     989,   570,   526,  2263,   569,   710,  1826,  1267,  1268,  1269,
    1270,   527,  1681,   528,  1335,   392,  1681,   719,   486,   487,
     393,   990,   991,   488,   731,   992,  2264,  2119,  2120,   897,
     898,   529,  1548,  1549,   489,  1026,  1321,  1322,   721,   511,
     512,   513,  1653,   490,   729,  2118,   730,  1848,  1849,   733,
     196,   734,  1852,   735,  2119,  2120,   897,   898,   387,  1856,
     736,  2448,  1857,   388,   389,  1323,  1324,  1346,  1814,  1815,
     737,   391,  2597,  1822,  1823,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,  2265,   740,  1873,  2121,  1875,
    1704,   741,  2119,  2120,   897,   898,  1027,  1879,  1908,  1909,
     836,   837,   207,   208,  1356,  1358,  2023,  2024,  2266,  2168,
    2169,   742,  1028,  1029,  1366,  2122,  1368,  2309,  2310,   287,
     838,   288,   392,  2614,  1030,   839,  2121,   393,  2267,   753,
     530,  1975,   531,   757,   209,   756,  1792,  1919,   758,  1791,
     840,  2328,  2329,   775,  1919,   298,   841,  2462,  2463,   778,
     289,   836,   837,   779,  1396,  2477,  2478,   290,   210,   211,
     212,   213,   781,  1404,   785,  2268,  2269,  2270,  2271,   780,
    2272,   838,  2485,  2486,  2273,   299,   839,  2298,  2299,  1636,
    1425,  1426,  1427,   784,   788,   291,   787,   292,  1449,  1347,
    1348,   844,   789,   790,   800,   293,   791,   300,   801,   301,
     797,   302,  2019,  1488,  1489,   689,  1714,  1714,   294,  1718,
     690,   802,   792,  1719,  1720,   803,  1468,   805,    82,   806,
    1714,  1783,   807,    84,    85,   892,   808,   693,   694,   695,
     696,   809,   689,   525,  1733,   812,  1734,   690,   526,   691,
     815,   816,   214,   215,   821,   818,   822,   527,  1469,   528,
    1676,  1677,  1678,  1679,   693,   694,   695,   696,   216,   217,
    1995,   823,  2072,   825,   833,  1357,   691,   529,   828,   303,
     304,   305,   306,   834,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,  1130,  2566,  2567,  2568,  2569,  2570,  2022,   846,
     295,   848,   570,   849,  2030,   569,  2031,  2032,  2033,  2034,
    1681,   246,   247,   387,   850,   851,   852,   853,   388,   389,
     854,   855,  2075,  2076,  2077,   856,   391,  2571,  2572,  2573,
    2574,  2575,    97,    98,    99,   100,   101,   102,   862,   863,
     864,   865,   877,  1607,   875,   710,   710,   710,   879,   880,
    1911,  1912,  1913,   882,   884,  2079,   530,   689,   531,   885,
     886,   887,   690,   890,   891,   902,  1914,  1915,  1916,   903,
     904,   905,   908,    82,   911,   598,   912,   392,    84,    85,
     932,   913,   393,   937,   938,   995,   996,   997,   998,   296,
    1003,   691,  1005,   538,   857,   858,   859,  1006,  1643,  2136,
    1645,  1647,  1919,  1451,  1919,  1044,  1047,  1048,  1051,  1052,
     836,   837,  1960,  1058,   297,  1452,  1061,  1881,  1068,  1662,
    2171,  1665,   170,  1063,  1069,  1889,  1672,   173,   174,  1892,
     838,  1894,  1070,  1081,  1074,   839,  1077,  1092,  1635,  1095,
    1105,  1106,  1121,   710,  2172,  1108,  1694,  1917,  1918,  1959,
     840,  1123,  1126,  1132,  1144,  1470,   841,  1113,   563,   564,
     162,   565,   566,   567,  1114,  2598,  1937,  2210,  2601,  2602,
    1124,  2213,  2214,  1125,  2218,  1128,  2221,  1151,   387,  1145,
    2603,  1147,  1149,   388,   389,  1154,  1162,  1453,  1471,  1472,
    1161,   391,   568,  1164,  1167,  1170,  1179,    97,    98,    99,
     100,   101,   102,  2609,  2610,  1184,  1185,  1188,  2611,  2612,
     563,   564,   897,   898,   566,   567,  2294,  1195,  2295,  2296,
    2297,   867,  2123,  1130,  1130,   563,   564,   897,   898,   566,
     567,  2307,  1214,   570,   570,  2311,   569,   569,  1222,  2319,
    1225,  1226,   392,  1230,   568,  1229,  1243,   393,  1246,  1248,
    1253,  1254,  1255,  1260,  2428,  1262,  1263,  1264,  1278,  1249,
      82,  2346,  1284,  1307,  1315,    84,    85,  2354,  2355,  1309,
    1317,  1320,  1328,  2362,  1332,  2364,  1329,  2367,  1330,  2370,
    1333,  1353,  1360,  1483,  1354,  2374,  1714,  -838,  -838,  -838,
     386,  1355,  1361,  1363,  2006,  1364,  1821,  2376,  2377,  1365,
    1367,  2378,  2379,  -838,  -838,  -838,  -838,  -838,   594,   595,
     596,   597,  1379,  1382,   598,  1384,  1386,  1833,  1834,  1835,
    1388,  1838,  1389,  1390,  2404,  1391,  1392,  1447,  2404,  1393,
    1394,  2412,  1395,  1399,  1400,  1401,  1403,  2420,  1450,  1480,
    1481,  1484,  1510,  1516,  1850,  1512,  1518,  1519,  2437,  1539,
    1473,  1540,  1544,  1550,  1537,  1551,  1474,  1552,  1475,  1553,
    1554,  1555,  1556,  1561,  1563,   387,  1564,  2165,  1565,  1572,
     388,   389,  1573,  1870,   390,  2470,  2471,  1575,   391,  1580,
    2474,  2475,  2476,  1584,    97,    98,    99,   100,   101,   102,
    2464,  2465,  2466,  2467,  2468,  1593,  1592,  1583,   710,   710,
    1633,  1594,  1637,   710,   710,   710,  1634,  1595,  1640,  1638,
    1605,  2483,  1609,  1667,  1610,  1611,  1620,  1624,  2132,  2133,
    2134,  1625,  2135,  1626,  1627,  2493,  2494,  2495,  1628,   392,
    1629,  1630,  1631,  1632,   393,  2338,  2339,  2340,  2341,  2342,
    2343,  2344,  2345,  2502,  2503,  1639,  1644,  1649,  1655,  2506,
    1656,  1673,  1674,  2558,  2559,  1691,  1696,  1690,   394,  1710,
    1698,  2516,  1712,  1717,  2519,  1700,  2521,  1721,  2523,  1722,
    1723,  1724,  2526,  2527,  1725,  1732,  1731,  1778,  1955,  1771,
    1681,  2533,  1780,  1777,  1781,  2542,  1782,  1454,  1455,  2581,
    1786,  1456,  2534,  2535,  2536,  1784,  1457,  1787,  1795,  2539,
    1802,  1808,  1809,  2123,  2123,  1812,  1813,  1818,   710,  2543,
    1824,  1819,  2544,  2545,  1820,  1827,  1844,   159,  1845,   160,
     161,   162,   163,   164,   165,  2284,   166,  1978,  1979,  1851,
    1853,  1855,  1858,   167,   168,   925,  2554,  2555,   169,  1874,
    1859,  1880,  1468,    82,   584,   585,   586,  1883,    84,    85,
     170,   171,  1872,   172,  1884,   173,   174,  1996,  1893,   175,
     589,   590,   591,   592,   593,   594,   595,   596,   597,  1903,
    1904,   598,  1907,   473,  1938,  1910,   454,    82,  1924,  1942,
    1930,  1936,    84,    85,  1944,  1949,  2445,  1952,  1953,  2585,
    1961,  1965,  1976,  1963,  1977,  1981,  2587,  1964,  2589,  1989,
    2590,  2000,  1993,  1997,  2014,  2015,  2592,   455,  2016,   176,
     177,   548,   549,   550,   551,   178,   179,  2017,   180,   181,
     182,   183,   184,   185,   186,   187,  2021,  2018,  1967,  1968,
    1969,   188,   189,   190,  2020,  2026,   191,  2038,  2040,  2041,
    2046,  2049,   192,  2050,  2053,  2115,  2142,  2145,   387,  2117,
     193,  2146,   194,   388,   389,  2148,  2151,  2167,  2170,  2078,
    2073,   391,  2178,  2179,  2212,  2222,  2228,    97,    98,    99,
     100,   101,   102,  2223,  2224,  2281,  2285,  2219,  2288,  2289,
    2300,   474,   387,  2301,  2302,  2303,  2304,   388,   389,  2306,
    2305,  2312,  2308,  2453,  2318,   391,  1405,  2330,  2322,  2060,
    2320,    97,    98,    99,   100,   101,   102,  2347,  2360,  2361,
    2321,  2325,   392,    82,  2326,  2327,  1406,   393,    84,    85,
    2351,  2352,  2353,   953,   954,  2371,  1735,  2365,   195,  2373,
    2394,   955,  2375,  2397,  2395,  1736,  1737,  1738,  1739,  2372,
    1740,  1741,  1742,   498,  2166,  1743,   392,  1744,  1745,  2387,
    2390,   393,  2391,  1746,  1754,  2396,  2180,   956,  1755,   957,
     485,  2393,   475,  2401,   456,  2399,  2407,  1866,  1407,  2411,
    2414,  2209,  2429,  2211,  2431,  2421,  2430,  2434,  2435,  2438,
    2439,  2440,   196,   958,  2441,  2443,  2446,  2225,  2226,  2227,
    2452,  2444,   959,   960,  2454,   961,   962,  1335,  2455,  2456,
    2457,  1408,  1409,   963,   964,   965,   488,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   489,   387,  2458,
    2459,  2473,  2479,   388,   389,  2472,   490,  2497,  2556,  2490,
    2511,   391,  2518,  2520,   207,   208,  2524,    97,    98,    99,
     100,   101,   102,  2522,  2508,  2557,  2528,  2561,  2583,  2564,
    2565,  2576,  2552,  2593,  2596,  2599,  2600,  2594,  2595,  2604,
    2605,  2613,  2550,  2608,  2551,  2615,   209,  2606,  1711,  1410,
    1273,  1274,  1275,  1411,  2356,  1022,  1756,  2138,  1931,  2363,
    1757,  1758,   392,  2139,  1760,  2137,  1933,   393,  1066,   917,
     210,   211,   212,   213,  1785,  2282,  1311,   499,   552,  1250,
    2449,  1251,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   500,   336,   337,   338,   339,   340,   341,  2450,   899,
    2392,   457,   458,   459,   460,  1420,  1252,   493,  1182,  1578,
    1542,  1543,   476,   477,   478,   479,  2560,  1588,  2413,  2058,
     820,  1376,  1956,  1004,  2422,  1966,  1974,  2080,  1984,   461,
    2517,  2381,  2406,  2410,  2530,   462,  2409,  1876,   463,  2532,
    1327,   464,  1302,  1412,  1212,     0,     0,     0,     0,  1059,
       0,     0,  1413,  1414,   214,   215,     0,     0,     0,  1415,
       0,     0,     0,  1416,     0,     0,     0,     0,     0,     0,
     216,   217,     0,     0,  1417,     0,     0,     0,     0,   501,
       0,  2469,     0,  1418,     0,  1419,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,  2496,     0,     0,     0,     0,     0,
       0,     0,     0,  2500,  2501,     0,     0,     0,     0,     0,
       0,  2504,  2505,   246,   247,  2507,     0,   159,     0,   160,
     161,   162,   163,   164,   165,     0,   166,     0,     0,     0,
       0,     0,     0,   167,   168,     0,  2525,     0,   169,     0,
    2529,     0,  2531,     0,     0,     0,     0,     0,     0,     0,
     170,   171,     0,   172,     0,   173,   174,     0,    82,   175,
       0,  2537,  2538,    84,    85,   966,     0,     0,     0,     0,
     967,   968,  2541,     0,     0,     0,  2181,     0,     0,  2546,
       0,  2547,  2548,  2549,     0,     0,     0,     0,  1338,     0,
       0,  2182,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   176,
     177,   548,   549,   550,   551,   178,   179,     0,   180,   181,
     182,   183,   184,   185,   186,   187,     0,     0,     0,     0,
       0,   188,   189,   190,     0,     0,   191,     0,     0,     0,
    2579,     0,   192,     0,     0,     0,     0,     0,     0,     0,
     193,  2584,   194,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   387,     0,     0,     0,  2591,   388,   389,
       0,     0,  1339,     0,     0,     0,   391,     0,     0,     0,
       0,     0,    97,    98,    99,   100,   101,   102,     0,   969,
     970,   971,   972,   973,   974,   584,   585,   586,   587,   588,
       0,     0,  2060,     0,     0,     0,     0,     0,     0,     0,
       0,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,  1735,     0,   392,   195,  2062,
       0,     0,   393,     0,  1736,  1737,  1738,  1739,     0,  1740,
    1741,  1742,     0,     0,  1743,     0,  1744,  1745,     0,  2183,
       0,     0,  1746,     0,     0,  2184,  2185,  1747,     0,  2186,
    2187,     0,     0,     0,     0,   975,   976,   977,   978,   979,
     980,   981,   982,   983,   984,   985,     0,     0,     0,  2188,
       0,     0,   196,     0,     0,     0,  2189,     0,     0,  1887,
       0,  2190,  1340,     0,     0,     0,  2191,     0,     0,     0,
       0,  2192,     0,     0,     0,     0,     0,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,     0,     0,     0,
       0,     0,     0,   159,     0,   160,   161,   162,   163,   164,
     165,     0,   166,     0,   207,   208,     0,     0,     0,   167,
     168,  1530,     0,     0,   169,     0,     0,     0,     0,     0,
       0,  2193,     0,     0,     0,     0,   170,   171,     0,   172,
    2194,   173,   174,     0,     0,   175,   209,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2195,     0,   584,   585,   586,   587,   588,     0,     0,     0,
     210,   211,   212,   213,     0,     0,     0,     0,   589,   590,
     591,   592,   593,   594,   595,   596,   597,  2196,     0,   598,
    2197,  2198,  2199,     0,     0,   176,   177,     0,  2200,     0,
       0,   178,   179,  2201,   180,   181,   182,   183,   184,   185,
     186,   187,     0,  2202,     0,     0,     0,   188,   189,   190,
    2203,     0,   191,   584,   585,   586,   587,   588,   192,  1888,
       0,     0,     0,     0,     0,     0,   193,     0,   194,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,     0,   214,   215,     0,     0,   584,   585,
     586,   587,   588,     0,     0,  1223,     0,     0,     0,     0,
     216,   217,     0,     0,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,     0,   598,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   195,     0,     0,     0,     0,   584,
     585,   586,   587,   588,  1238,     0,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,     0,
       0,     0,     0,   584,   585,   586,   587,   588,     0,     0,
       0,   914,     0,     0,     0,     0,     0,     0,   196,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,     0,     0,   915,     0,     0,     0,     0,
       0,     0,     0,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,     0,     0,     0,     0,     0,     0,   159,
       0,   160,   161,   162,   163,   164,   165,     0,   166,  1239,
     207,   208,     0,     0,     0,   167,   168,  1534,     0,     0,
     169,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   170,   171,     0,   172,     0,   173,   174,     0,
       0,   175,   209,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   584,   585,   586,   587,   588,     0,
       0,     0,     0,     0,     0,     0,   210,   211,   212,   213,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
       0,   598,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   176,   177,     0,     0,     0,  1521,   178,   179,     0,
     180,   181,   182,   183,   184,   185,   186,   187,     0,     0,
       0,     0,     0,   188,   189,   190,     0,     0,   191,     0,
    1522,     0,     0,     0,   192,     0,     0,     0,     0,     0,
       0,     0,   193,     0,   194,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     214,   215,   584,   585,   586,   587,   588,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   216,   217,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     195,     0,     0,     0,     0,     0,     0,     0,  1240,   584,
     585,   586,   587,   588,     0,     0,     0,     0,     0,   246,
     247,     0,     0,     0,     0,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,   584,
     585,   586,   587,   588,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   196,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,     0,
       0,     0,     0,     0,     0,  1241,     0,     0,     0,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,     0,
       0,     0,     0,     0,     0,   159,     0,   160,   161,   162,
     163,   164,   165,     0,   166,  1520,   207,   208,     0,     0,
       0,   167,   168,  1940,     0,     0,   169,     0,     0,     0,
       0,     0,     0,   584,   585,   586,   587,   588,   170,   171,
       0,   172,     0,   173,   174,     0,     0,   175,   209,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,     0,
     598,   584,   585,   586,   587,   588,     0,     0,     0,     0,
       0,     0,   210,   211,   212,   213,     0,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,     0,     0,     0,     0,     0,     0,   176,   177,  1762,
       0,     0,     0,   178,   179,     0,   180,   181,   182,   183,
     184,   185,   186,   187,     0,     0,     0,     0,     0,   188,
     189,   190,     0,     0,   191,     0,     0,  1882,     0,     0,
     192,     0,     0,     0,     0,     0,     0,     0,   193,     0,
     194,     0,   584,   585,   586,   587,   588,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   214,   215,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,   216,   217,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1237,     0,     0,     0,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   195,     0,     0,     0,
       0,   584,   585,   586,   587,   588,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1242,   584,   585,   586,   587,   588,     0,
     196,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
       0,   598,     0,     0,     0,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,     0,  1247,     0,     0,     0,
       0,   159,     0,   160,   161,   162,   163,   164,   165,     0,
     166,     0,   207,   208,     0,     0,     0,   167,   168,  1945,
       0,     0,   169,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   170,   171,     0,   172,     0,   173,
     174,     0,     0,   175,   209,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   584,   585,   586,   587,
     588,     0,     0,     0,     0,     0,     0,     0,   210,   211,
     212,   213,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,     0,   598,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   176,   177,     0,     0,     0,  1318,   178,
     179,     0,   180,   181,   182,   183,   184,   185,   186,   187,
       0,     0,     0,     0,     0,   188,   189,   190,     0,     0,
     191,   584,   585,   586,   587,   588,   192,     0,     0,     0,
       0,     0,     0,     0,   193,     0,   194,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,     0,   598,   583,
       0,     0,   214,   215,   584,   585,   586,   587,   588,     0,
       0,     0,     0,  1319,     0,     0,     0,     0,   216,   217,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
       0,   598,     0,     0,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   195,     0,     0,     0,     0,   584,   585,   586,
     587,   588,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1763,
     584,   585,   586,   587,   588,     0,   196,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,     0,   598,     0,     0,
       0,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,     0,  1764,     0,     0,     0,     0,   159,     0,   160,
     161,   162,   163,   164,   165,     0,   166,     0,   207,   208,
       0,     0,     0,   167,   168,  1947,     0,     0,   169,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     170,   171,     0,   172,     0,   173,   174,     0,     0,   175,
     209,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   584,   585,   586,   587,   588,     0,     0,     0,
       0,     0,     0,     0,   210,   211,   212,   213,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,     0,   598,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   176,
     177,     0,     0,     0,  1765,   178,   179,     0,   180,   181,
     182,   183,   184,   185,   186,   187,     0,     0,     0,     0,
       0,   188,   189,   190,     0,     0,   191,   584,   585,   586,
     587,   588,   192,     0,     0,     0,     0,     0,     0,     0,
     193,     0,   194,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,     0,   214,   215,
     584,   585,   586,   587,   588,     0,     0,     0,     0,  1766,
       0,     0,     0,     0,   216,   217,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,     0,   598,     0,     0,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   195,     0,
       0,     0,     0,   584,   585,   586,   587,   588,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,     0,
     598,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1779,   584,   585,   586,   587,
     588,     0,   196,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,     0,   598,     0,     0,     0,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,     0,  1905,     0,
       0,     0,     0,   159,     0,   160,   161,   162,   163,   164,
     165,     0,   166,     0,   207,   208,     0,     0,     0,   167,
     168,     0,     0,     0,   169,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   170,   171,     0,   172,
       0,   173,   174,     0,     0,   175,   209,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   584,   585,
     586,   587,   588,     0,     0,     0,     0,     0,     0,     0,
     210,   211,   212,   213,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,     0,   598,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   176,   177,     0,     0,     0,
    1906,   178,   179,     0,   180,   181,   182,   183,   184,   185,
     186,   187,     0,     0,     0,     0,     0,   188,   189,   190,
       0,     0,   191,     0,     0,  1007,     0,     0,   192,   584,
     585,   586,   587,   588,     0,     0,   193,     0,   194,   538,
     857,   858,   859,     0,     0,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   214,   215,   598,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   170,  1308,
     216,   217,     0,   173,   174,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   195,     0,     0,     0,     0,     0,
     584,   585,   586,   587,   588,     0,     0,     0,     0,     0,
       0,     0,     0,   246,   247,     0,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,     0,   598,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1008,   837,  2039,     0,     0,     0,     0,     0,   196,     0,
       0,     0,     0,     0,     0,     0,  1009,     0,     0,     0,
    1010,     0,     0,  1011,  1012,     0,     0,     0,  1013,     0,
       0,     0,     0,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,     0,     0,     0,     0,  1014,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     207,   208,     0,     0,  1490,  1015,  1016,  1017,     0,  1018,
       0,  1019,  1020,  1021,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1312,   171,   209,     0,     0,     0,     0,     0,     0,   175,
     327,   328,   329,   330,   331,   332,   333,   334,   335,     0,
     336,   337,   338,   339,   340,   341,   210,   211,   212,   213,
    1491,     0,  1492,  1493,  1494,  1495,  1496,  1497,  1498,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1499,     0,     0,  1500,   584,
     585,   586,   587,   588,     0,   178,   179,     0,   180,   181,
     182,   183,   184,   185,  1501,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1502,     0,  1503,     0,
       0,  2290,     0,     0,     0,     0,     0,     0,     0,     0,
     214,   215,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   216,   217,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
       0,     0,     0,     0,     0,     0,     0,     0,   195,   584,
     585,   586,   587,   588,     0,     0,     0,     0,     0,   246,
     247,     0,     0,     0,     0,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,     0,   598,   584,   585,   586,
     587,   588,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2291,     0,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   196,     0,   598,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2292,
       0,   584,   585,   586,   587,   588,     0,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,     0,   598,   584,
     585,   586,   587,   588,   207,   208,     0,     0,     0,     0,
    1490,     0,     0,  2293,     0,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,     0,   598,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   209,   171,     0,     0,
       0,  2447,     0,     0,     0,   175,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     210,   211,   212,   213,     0,  2001,     0,     0,  1492,  1493,
    1494,  1495,  1496,  1497,  1498,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1499,     0,     0,  1500,   584,   585,   586,   587,   588,
       0,   178,   179,     0,   180,   181,   182,   183,   184,   185,
    1501,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1502,     0,  1503,     0,     0,  2553,     0,     0,
       0,     0,     0,     0,   214,   215,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     216,   217,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,     0,     0,     0,     0,     0,   584,
     585,   586,   587,   588,   195,     0,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,     0,   598,   584,   585,   586,
     587,   588,     0,     0,     0,     0,     0,     0,     0,  1886,
       0,     0,     0,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,     0,   598,     0,     0,     0,   196,     0,
       0,     0,     0,     0,     0,     0,     0,  1998,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   584,   585,   586,
     587,   588,     0,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,     0,   598,   584,   585,   586,   587,   588,
     207,   208,  1490,     0,     0,     0,     0,  2005,     0,     0,
       0,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,     0,   598,     0,     0,     0,     0,     0,     0,   171,
       0,     0,   209,     0,     0,  2012,     0,   175,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   584,   585,   586,   587,   588,   210,   211,   212,   213,
    1492,  1493,  1494,  1495,  1496,  1497,  1498,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,     0,   598,     0,
       0,     0,     0,  1499,     0,     0,  1500,     0,     0,     0,
       0,  2013,     0,   178,   179,     0,   180,   181,   182,   183,
     184,   185,  1501,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1502,     0,  1503,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     214,   215,     0,     0,     0,     0,   195,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   216,   217,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     196,     0,     0,     0,     0,     0,   195,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   246,
     247,     0,     0,     0,     0,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   207,   208,     0,     0,     0,     0,     0,     0,
     196,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   209,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   210,   211,
     212,   213,   207,   208,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   209,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   210,   211,
     212,   213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   214,   215,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   216,   217,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   214,   215,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   216,   217,
       0,   246,   247,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   403,   404,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   246,   247,     0,     0,     0,     0,   405,     0,     0,
       0,     0,     0,     0,     0,   406,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   407,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   387,     0,     0,     0,     0,   388,   389,     0,
     408,   409,     0,     0,     0,   391,   410,     0,     0,     0,
       0,   411,   412,   413,   414,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   415,     0,     0,     0,   416,   417,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   392,     0,     0,     0,
       0,   393,     0,     0,     0,     0,     0,     0,     0,     0,
     418,     0,     0,     0,   419,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   420,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   421,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   422,   423,   424,     0,   425,     0,     0,     0,
       0,   426,     0,   427,     0,   428,   429,     0,     0,   430,
     431,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   432,   433,     0,     0,     0,
     434,   435,   436,     0,     0,     0,     0,     0,     0,   437,
       0,     0,     0,   438,     0,     0,   439,   440,     0,   441,
       0,   442,     0,     0,     0,   443,   444,     0,   445,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   446,
       0,     0,     0,     0,     0,     0,     0,   447
};

static const yytype_int16 yycheck[] =
{
     103,     7,   194,   770,   164,   424,   425,   164,   556,   724,
     365,   277,  1213,   159,   487,   457,    81,  1213,   297,   351,
      87,    86,    87,   525,   194,   527,   528,   624,  1213,   531,
     532,   773,   364,   365,   194,    66,  1213,   194,  1243,  1244,
    1245,  1246,    79,    79,    18,  1493,    49,   132,  2004,    23,
      23,   136,    25,   138,  2004,   140,   138,    21,  1506,    23,
      79,  1008,   123,   148,   149,    79,   148,   149,   665,  1456,
     155,   195,   196,    49,     3,     4,     5,    86,    52,  1065,
    1723,    25,    88,   349,   350,    23,    87,   211,   127,    79,
     129,   423,   131,   160,   133,    36,   135,     6,   137,   123,
      20,    21,   141,    23,   143,    47,   145,  1054,   147,    51,
      79,  1312,  2004,   445,   153,   154,    18,  2167,    23,   122,
      18,    23,     6,   389,    49,    23,   280,  1312,   460,    50,
      39,   166,    78,   162,    49,  1312,    23,     6,    25,    23,
      49,   134,    51,    79,    50,    54,    55,  2379,    25,    49,
      52,   303,    47,   485,    52,    18,    51,   311,   248,   166,
      23,    77,    18,   169,   154,  1024,   172,    23,    23,   159,
     160,    80,     3,   163,  2185,    10,   508,   167,    18,   236,
      64,    77,   166,    23,    40,    41,    42,    43,    18,    52,
      50,    23,     7,    23,    47,    23,    52,    25,    51,  2001,
      40,    41,    42,    43,    33,    23,    23,    25,    25,    23,
     316,    25,    52,    10,   143,   161,    18,   201,    53,    18,
      77,    23,    52,   161,    23,    23,    47,    25,   218,    35,
      51,   160,   141,   223,   143,   144,   152,   146,    18,   148,
       0,   236,    77,    23,    50,   154,  2257,   156,   157,   158,
      52,   160,    51,    52,   150,   290,   185,   186,   163,   362,
      40,    41,    42,    43,   173,   174,   175,   176,   177,   178,
     154,   192,    52,     9,    10,    11,    12,   342,   499,   721,
      77,   284,    18,   290,  2516,     6,   192,  2519,   391,   392,
     299,   220,   444,   262,   223,   152,   225,   354,   240,    68,
      69,   366,   850,   247,    49,   136,   161,   236,   337,    54,
      55,   140,    79,   416,   223,   863,  2118,   261,    47,   328,
     229,   740,    51,   429,  1310,    91,   235,   236,   337,   161,
    2286,   260,   192,   161,    79,   264,  2286,  1751,   530,   671,
     269,   270,   697,   161,  1758,   240,   287,   161,   627,   628,
     629,   630,   631,   230,   633,   634,  1071,   636,   637,   354,
     639,   640,   267,  2006,   248,   697,    18,  2010,  1569,   370,
     702,    23,    27,  1760,   409,   707,   352,   709,   208,   525,
     373,   527,   528,    38,  1569,   531,   532,   240,    40,    41,
      42,    43,  1569,   262,  2286,   485,   163,   195,   459,   368,
      52,   168,   409,   624,  1263,  1264,   208,   221,   222,   154,
      33,   743,   744,    25,   159,   160,   300,   185,   163,   240,
     544,   457,   167,  2473,   491,   409,   450,   352,   173,   174,
     175,   176,   177,   178,  1882,   459,    79,   352,    27,    23,
     459,    25,   362,   775,   413,   459,   778,   466,   867,  1986,
     869,   465,   352,   382,   491,   492,   222,    18,   461,   228,
      77,   498,    23,    52,  1206,   496,    78,   534,   535,   536,
     537,   538,   539,   218,   829,   830,  1423,   364,   223,    40,
      41,    42,    43,   815,   458,  2287,   450,   197,   351,    68,
      69,    52,   501,   502,   503,   262,    41,   829,   830,     6,
      68,    69,   486,     6,   354,   358,   359,  1055,   840,   393,
     279,   240,   844,   415,   294,   420,   848,   140,   416,   417,
     456,   457,     6,   529,   460,   461,   462,    23,   368,    25,
     435,   436,  1717,    78,   237,   152,   542,   358,   359,   187,
       6,   425,   426,   393,  2081,   281,   282,   190,   880,   233,
     882,   557,   558,   559,   560,   561,   562,   267,   890,   549,
     533,   626,   568,   166,  1769,   345,  1771,   540,   424,  1774,
    2334,  1776,  1777,   264,   217,  2112,  1173,   161,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   359,    23,   237,    25,   199,   541,   542,   543,
     770,   304,    53,    41,   370,   478,   372,    10,   374,   375,
     770,   170,   378,   770,  2028,  2029,   161,   546,   547,    18,
       6,   162,  2036,  2037,    23,   352,    77,   157,   395,   358,
     359,   274,   240,    41,    50,    52,   545,   321,   141,   142,
      78,    40,    41,    42,    43,   412,   289,   414,   189,   228,
      53,   418,   300,    52,   844,   422,   423,    52,   848,    18,
     228,   388,   346,   536,    23,   224,   169,   673,   316,    85,
      78,    77,   168,    79,  1441,   216,   421,   716,   684,    78,
     288,    40,    41,    42,    43,   691,  1887,   290,   291,   192,
     417,  1887,    77,    52,    79,   422,   155,   800,   858,   307,
     279,   858,  1887,   233,   234,   235,  1891,    79,   435,  1151,
    1887,   279,   179,   352,  1891,   367,   443,  2481,  2482,   296,
    1222,    10,  1224,   161,  2488,  2489,   303,    23,    24,   185,
     271,   458,   477,   162,   461,    14,    15,   464,   169,   155,
     932,   933,    53,   284,   173,   174,    18,   474,    78,    23,
      24,    23,   368,   161,    50,   398,   399,   400,    14,    15,
      10,  1040,   401,  1042,    53,   935,    77,    18,    40,    41,
      42,    43,    23,  1105,  1106,   935,   192,    35,   935,   171,
      52,   397,   198,    53,   511,  1117,   513,    32,    33,    40,
      41,    42,    43,   238,   355,   356,   241,    10,    77,   215,
    2001,    52,  1134,    53,  1136,   197,   422,    77,  1140,  1581,
    1142,    53,  1144,  1145,  1586,  1147,  2001,  1149,    79,   191,
      49,    77,    79,    97,  2001,    54,    55,    23,    53,    25,
    1162,   837,   413,    78,    91,    77,  1168,   236,   419,  2044,
      53,   382,    35,  1175,  2049,   386,  2051,  1179,  1290,  2054,
      79,  1293,    77,  1295,    20,    21,   285,    23,  1018,    34,
      35,  1018,   123,    38,   236,    20,    21,    52,    23,   241,
     242,    53,   140,   245,   246,   267,  1424,  1209,  1032,  1033,
    1034,  1035,  1472,  1037,  1038,  1475,   300,  1041,    18,  1043,
     282,  1045,  1046,   154,    78,    77,   437,    78,   159,   160,
      52,   442,   443,   164,   165,    18,   167,   913,   169,   915,
      23,   168,    78,  1685,   328,   329,  2117,  2118,    18,   180,
    1692,  2117,   238,    23,    79,   154,    23,    24,   189,  1348,
     159,   160,  2117,  2118,   475,   294,  1409,   238,   167,    52,
    2117,  2118,  1657,    52,   173,   174,   175,   176,   177,   178,
      52,    51,    52,  1056,    11,    12,    13,   218,    77,   500,
      79,    52,   223,   504,    20,    21,  1069,    23,    52,    25,
      27,    28,    29,    77,    18,    79,   233,    52,  1081,    23,
    1083,   238,    20,    21,   241,  1752,   345,    52,    23,   218,
      25,   248,   243,   244,   223,    38,    40,    41,    42,    43,
      18,    18,   729,    20,    25,    23,    23,   236,    52,    21,
     551,    23,    20,    21,    47,    23,   141,   142,  1103,  1104,
       6,  1103,    40,    41,    42,    43,    77,    47,    79,  1361,
     757,   758,     6,   760,    52,    52,   161,    20,    21,    59,
      23,   166,    79,   272,    64,     6,    79,    20,    21,     6,
      23,   108,   109,   780,  1473,   782,   181,   784,   785,    79,
     787,   788,   789,   790,   791,   792,     6,  1132,   795,  1335,
     797,   798,    23,   345,    20,    21,  1222,    23,  1224,    25,
     292,   808,   809,  1921,    23,   812,  2287,  1419,  1173,   816,
    1928,   161,  1640,  1931,  1426,  1933,    79,     6,  2303,    50,
    2305,     6,  2287,    18,   387,   388,    79,    58,    23,  1269,
    2287,     6,  1269,   374,    18,  1200,  1201,  1202,  1200,  1201,
    1202,    51,   849,    53,     6,    40,    41,    42,    43,   131,
     132,     6,  1464,   135,    25,   862,  1468,    52,   140,   141,
     478,    18,  1296,    20,  1298,  1757,    23,  1759,    20,    21,
     877,    23,   879,   190,   191,     6,    79,   190,   191,     6,
      18,   181,     6,   114,   115,    23,   117,   118,   119,   120,
     121,   122,   123,    50,  1131,    52,  1133,  1331,  1510,   314,
     217,   316,     6,    41,   217,     6,    20,    21,   445,    23,
     447,   448,   307,   308,    52,   452,   453,     6,   455,    27,
     244,   430,   319,   320,   241,   242,   463,   464,   245,   246,
     243,   244,    23,    79,   247,    44,    45,    46,   141,   142,
     164,   165,  1228,   243,   244,  1667,   244,   247,   231,   232,
    1236,   154,  1238,  1239,  1240,  1241,   159,   160,    23,   272,
     237,     6,   275,  1249,   167,    51,   169,    51,  1313,  1255,
      51,   284,   289,   273,   274,   275,   289,   123,    23,    24,
     476,  1593,  1617,    79,    20,    21,   181,    23,    23,    85,
      78,  1441,   469,   470,   471,   504,   227,    18,   170,   171,
     172,  1441,    23,   316,  1441,  1617,  1618,    20,    21,    22,
      23,    32,  1452,    34,   160,   218,  1456,    50,   164,   165,
     223,   193,   194,   169,    78,   197,   339,    18,    19,    20,
      21,    52,    20,    21,   180,    80,    45,    46,   155,   548,
     549,   550,  1425,   189,   248,     9,    51,  1659,  1660,    51,
     281,    51,  1664,    78,    18,    19,    20,    21,   154,  1671,
      78,    52,  1674,   159,   160,    45,    46,   163,   379,   380,
      78,   167,  2557,   243,   244,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   398,   316,  1699,    52,  1701,
    1473,    51,    18,    19,    20,    21,   141,  1709,    64,    65,
     141,   142,   333,   334,  1111,  1112,    14,    15,   421,   243,
     244,    25,   157,   158,  1121,    79,  1123,   276,   277,   195,
     161,   197,   218,  2608,   169,   166,    52,   223,   441,   305,
     151,  1830,   153,   185,   365,   353,  1576,  1749,   248,  1576,
     181,   201,   202,   294,  1756,   141,   187,   173,   174,   294,
     226,   141,   142,   293,  1161,   201,   202,   233,   389,   390,
     391,   392,   303,  1170,   156,   478,   479,   480,   481,   272,
     483,   161,   199,   200,   487,   171,   166,  2143,  2144,   169,
     383,   384,   385,   319,   332,   261,   325,   263,  1195,   285,
     286,   181,   272,   272,   363,   271,   340,   193,   136,   195,
     349,   197,  1901,  1210,  1211,    18,  1492,  1493,   284,  1495,
      23,    51,   338,  1499,  1500,    78,    47,    51,    49,    78,
    1506,  1566,    78,    54,    55,    10,   434,    40,    41,    42,
      43,   185,    18,    18,  1520,   154,  1522,    23,    23,    52,
     155,   359,   473,   474,    51,   352,    78,    32,    79,    34,
     183,   184,   185,   186,    40,    41,    42,    43,   489,   490,
    1872,    78,  1961,    18,    51,    78,    52,    52,    18,   265,
     266,   267,   268,    51,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,  1752,   201,   202,   203,   204,   205,  1920,    23,
     386,   181,  1752,   220,  1926,  1752,    70,    71,    72,    73,
    1760,   552,   553,   154,   169,    51,    51,    78,   159,   160,
      78,    78,  1967,  1968,  1969,    78,   167,   201,   202,   203,
     204,   205,   173,   174,   175,   176,   177,   178,   248,   169,
      51,    51,   185,  1360,    78,  1967,  1968,  1969,   344,   169,
      11,    12,    13,   294,    51,  1977,   151,    18,   153,    51,
      78,    78,    23,   294,    51,    17,    27,    28,    29,    18,
      18,    35,    32,    49,    33,    38,    18,   218,    54,    55,
      10,    77,   223,    18,    18,     6,     6,     6,     6,   475,
       6,    52,     6,    20,    21,    22,    23,     6,  1415,  2021,
    1417,  1418,  2024,    79,  2026,     6,     6,     6,     6,     6,
     141,   142,  1805,     6,   500,    91,     6,  1713,    51,  1436,
    2065,  1438,    49,    52,    77,  1721,  1443,    54,    55,  1725,
     161,  1727,    77,   363,    51,   166,    51,   219,   169,    23,
     294,   294,   330,  2065,  2066,    51,  1463,   108,   109,  1804,
     181,   224,    78,    36,   294,   296,   187,    51,    18,    19,
      20,    21,    22,    23,    51,  2561,  1762,  2089,  2564,  2565,
      51,  2093,  2094,    51,  2096,    51,  2098,   155,   154,   294,
    2576,   294,   294,   159,   160,    51,   240,   163,   329,   330,
     360,   167,    52,    51,    51,   240,   181,   173,   174,   175,
     176,   177,   178,  2599,  2600,    18,    18,    23,  2604,  2605,
      18,    19,    20,    21,    22,    23,  2138,   188,  2140,  2141,
    2142,   299,  2004,  1983,  1984,    18,    19,    20,    21,    22,
      23,  2153,    51,  1983,  1984,  2157,  1983,  1984,    18,  2161,
      50,    18,   218,    33,    52,   140,    77,   223,    77,    18,
     240,   240,    52,     6,  2263,    23,   169,   169,    23,    52,
      49,  2183,     6,     6,    23,    54,    55,  2189,  2190,    53,
      51,    25,    51,  2195,    77,  2197,    51,  2199,    33,  2201,
      51,    51,   185,    49,    51,  2207,  1882,    11,    12,    13,
      79,    51,   294,    51,  1890,    51,  1613,  2219,  2220,    51,
      51,  2223,  2224,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    51,    51,    38,    51,    51,  1634,  1635,  1636,
      51,  1638,    51,    51,  2246,    51,    51,   182,  2250,    51,
      51,  2253,    51,    51,    51,    51,    51,  2259,    51,    51,
      51,    18,   181,    21,  1661,    78,    33,    33,  2270,    18,
     491,    18,    23,     6,    77,     6,   497,     6,   499,     6,
       6,     6,    18,     6,     6,   154,     6,  2060,     6,    53,
     159,   160,    77,  1690,   163,  2320,  2321,    25,   167,    51,
    2325,  2326,  2327,    51,   173,   174,   175,   176,   177,   178,
    2312,  2313,  2314,  2315,  2316,    77,    51,   154,  2320,  2321,
     280,    51,   353,  2325,  2326,  2327,   344,    51,   169,   185,
      51,  2333,    51,   248,    51,    51,    51,    51,  2014,  2015,
    2016,    51,  2018,    51,    51,  2347,  2348,  2349,    51,   218,
      51,    51,    51,    51,   223,   401,   402,   403,   404,   405,
     406,   407,   408,  2365,  2366,   327,    59,    51,   131,  2371,
      51,    51,   427,  2462,  2463,    51,    51,   171,   247,    51,
     187,  2383,    35,    52,  2386,   238,  2388,    27,  2390,    52,
      52,    51,  2394,  2395,    27,    33,    35,    18,  1795,    77,
    2230,  2403,    21,    77,     6,  2430,     6,   463,   464,  2498,
      51,   467,  2414,  2415,  2416,    79,   472,    18,   155,  2421,
      78,   181,   381,  2285,  2286,   377,   376,    51,  2430,  2431,
     244,    51,  2434,  2435,    51,    51,   280,    16,   301,    18,
      19,    20,    21,    22,    23,  2121,    25,  1844,  1845,    78,
      78,    78,    78,    32,    33,    34,  2458,  2459,    37,    68,
      78,    18,    47,    49,    11,    12,    13,    51,    54,    55,
      49,    50,   181,    52,    51,    54,    55,  1874,    51,    58,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    18,
      33,    38,    60,    79,    34,    67,    48,    49,    37,    34,
      51,    51,    54,    55,    10,    79,  2279,    53,    78,  2511,
     288,   265,   185,    51,   294,    78,  2518,   371,  2520,    78,
    2522,    53,    78,    78,    52,    52,  2528,    79,    52,   108,
     109,   110,   111,   112,   113,   114,   115,    51,   117,   118,
     119,   120,   121,   122,   123,   124,    10,    52,   245,   245,
     245,   130,   131,   132,    51,    77,   135,    76,    53,    53,
      53,    52,   141,    53,    53,    51,    35,    18,   154,   106,
     149,    34,   151,   159,   160,    34,    10,    78,   244,  1976,
     285,   167,    78,    51,    51,    51,    51,   173,   174,   175,
     176,   177,   178,   459,   459,    79,    10,   303,    53,    77,
      53,   187,   154,    53,    53,    77,    53,   159,   160,    53,
      52,   278,   280,  2289,   248,   167,    59,   199,    51,   190,
     245,   173,   174,   175,   176,   177,   178,   278,   340,   403,
     245,   245,   218,    49,   245,   245,    79,   223,    54,    55,
     248,   431,    78,    56,    57,   122,    47,   303,   227,    51,
     294,    64,    51,   288,   454,    56,    57,    58,    59,   401,
      61,    62,    63,    79,  2061,    66,   218,    68,    69,   444,
     451,   223,   444,    74,    75,   280,  2073,    90,    79,    92,
     123,   449,   268,    51,   236,   288,    51,    25,   131,    51,
     278,  2088,   340,  2090,   122,   294,   294,   294,   294,   482,
     484,   488,   281,   116,    51,   494,    51,  2104,  2105,  2106,
      51,   493,   125,   126,    51,   128,   129,   160,    51,    51,
      51,   164,   165,   136,   137,   138,   169,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   180,   154,    35,
      35,    51,    25,   159,   160,    79,   189,   432,    53,    79,
     294,   167,   294,   245,   333,   334,   446,   173,   174,   175,
     176,   177,   178,   245,   468,    77,   181,    51,   415,    51,
      51,    51,  2448,   415,    51,    51,    51,  2550,  2551,    51,
      51,    51,   495,    77,   495,    53,   365,   410,  1483,   232,
    1018,  1018,  1018,   236,  2191,   624,  1524,  2025,  1756,  2196,
    1524,  1524,   218,  2026,  1524,  2024,  1758,   223,   675,   555,
     389,   390,   391,   392,  1569,  2117,  1064,   233,   172,   932,
    2285,   933,    88,    89,    90,    91,    92,    93,    94,    95,
      96,   247,    98,    99,   100,   101,   102,   103,  2286,   530,
    2237,   393,   394,   395,   396,  1171,   935,   140,   820,  1332,
    1256,  1258,   438,   439,   440,   441,  2473,  1347,  2255,  1956,
     467,  1139,  1801,   619,  2261,  1816,  1829,  1980,  1853,   421,
    2384,  2230,  2247,  2251,  2398,   427,  2250,  1705,   430,  2400,
    1085,   433,  1049,   326,   874,    -1,    -1,    -1,    -1,   668,
      -1,    -1,   335,   336,   473,   474,    -1,    -1,    -1,   342,
      -1,    -1,    -1,   346,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,   357,    -1,    -1,    -1,    -1,   335,
      -1,  2318,    -1,   366,    -1,   368,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,  2351,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2360,  2361,    -1,    -1,    -1,    -1,    -1,
      -1,  2368,  2369,   552,   553,  2372,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    33,    -1,  2393,    -1,    37,    -1,
    2397,    -1,  2399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    50,    -1,    52,    -1,    54,    55,    -1,    49,    58,
      -1,  2418,  2419,    54,    55,    49,    -1,    -1,    -1,    -1,
      54,    55,  2429,    -1,    -1,    -1,    64,    -1,    -1,  2436,
      -1,  2438,  2439,  2440,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,
     109,   110,   111,   112,   113,   114,   115,    -1,   117,   118,
     119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
      -1,   130,   131,   132,    -1,    -1,   135,    -1,    -1,    -1,
    2497,    -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,  2508,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   154,    -1,    -1,    -1,  2524,   159,   160,
      -1,    -1,   163,    -1,    -1,    -1,   167,    -1,    -1,    -1,
      -1,    -1,   173,   174,   175,   176,   177,   178,    -1,   173,
     174,   175,   176,   177,   178,    11,    12,    13,    14,    15,
      -1,    -1,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    38,    -1,    -1,    47,    -1,   218,   227,   217,
      -1,    -1,   223,    -1,    56,    57,    58,    59,    -1,    61,
      62,    63,    -1,    -1,    66,    -1,    68,    69,    -1,   237,
      -1,    -1,    74,    -1,    -1,   243,   244,    79,    -1,   247,
     248,    -1,    -1,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,    -1,    -1,   267,
      -1,    -1,   281,    -1,    -1,    -1,   274,    -1,    -1,   105,
      -1,   279,   283,    -1,    -1,    -1,   284,    -1,    -1,    -1,
      -1,   289,    -1,    -1,    -1,    -1,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
      -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,    22,
      23,    -1,    25,    -1,   333,   334,    -1,    -1,    -1,    32,
      33,    34,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,    -1,    49,    50,    -1,    52,
     348,    54,    55,    -1,    -1,    58,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     368,    -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,
     389,   390,   391,   392,    -1,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    32,    33,    34,    35,   395,    -1,    38,
     398,   399,   400,    -1,    -1,   108,   109,    -1,   406,    -1,
      -1,   114,   115,   411,   117,   118,   119,   120,   121,   122,
     123,   124,    -1,   421,    -1,    -1,    -1,   130,   131,   132,
     428,    -1,   135,    11,    12,    13,    14,    15,   141,    78,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,   151,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      38,    -1,    -1,    -1,   473,   474,    -1,    -1,    11,    12,
      13,    14,    15,    -1,    -1,    53,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    38,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   227,    -1,    -1,    -1,    -1,    11,
      12,    13,    14,    15,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   552,   553,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,   281,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,    -1,    -1,    -1,    16,
      -1,    18,    19,    20,    21,    22,    23,    -1,    25,    77,
     333,   334,    -1,    -1,    -1,    32,    33,    34,    -1,    -1,
      37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    52,    -1,    54,    55,    -1,
      -1,    58,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   389,   390,   391,   392,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   108,   109,    -1,    -1,    -1,    53,   114,   115,    -1,
     117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
      -1,    -1,    -1,   130,   131,   132,    -1,    -1,   135,    -1,
      77,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,   151,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     473,   474,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    38,
      -1,    -1,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,   552,
     553,    -1,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   281,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,    -1,    -1,    -1,    16,    -1,    18,    19,    20,
      21,    22,    23,    -1,    25,    77,   333,   334,    -1,    -1,
      -1,    32,    33,    34,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    11,    12,    13,    14,    15,    49,    50,
      -1,    52,    -1,    54,    55,    -1,    -1,    58,   365,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      38,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,   389,   390,   391,   392,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,   109,    77,
      -1,    -1,    -1,   114,   115,    -1,   117,   118,   119,   120,
     121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
     131,   132,    -1,    -1,   135,    -1,    -1,    77,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
     151,    -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   473,   474,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    38,
      -1,    -1,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   227,    -1,    -1,    -1,
      -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   552,   553,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    53,    11,    12,    13,    14,    15,    -1,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    -1,    -1,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    53,    -1,    -1,    -1,
      -1,    16,    -1,    18,    19,    20,    21,    22,    23,    -1,
      25,    -1,   333,   334,    -1,    -1,    -1,    32,    33,    34,
      -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    52,    -1,    54,
      55,    -1,    -1,    58,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   389,   390,
     391,   392,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,   109,    -1,    -1,    -1,    53,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
      -1,    -1,    -1,    -1,    -1,   130,   131,   132,    -1,    -1,
     135,    11,    12,    13,    14,    15,   141,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,   151,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,     6,
      -1,    -1,   473,   474,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,   489,   490,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    -1,    -1,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   227,    -1,    -1,    -1,    -1,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   552,   553,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,
      11,    12,    13,    14,    15,    -1,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    53,    -1,    -1,    -1,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    -1,    25,    -1,   333,   334,
      -1,    -1,    -1,    32,    33,    34,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    50,    -1,    52,    -1,    54,    55,    -1,    -1,    58,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   389,   390,   391,   392,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,
     109,    -1,    -1,    -1,    53,   114,   115,    -1,   117,   118,
     119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
      -1,   130,   131,   132,    -1,    -1,   135,    11,    12,    13,
      14,    15,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,   151,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    38,    -1,    -1,    -1,   473,   474,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,   489,   490,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   227,    -1,
      -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   552,   553,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    11,    12,    13,    14,
      15,    -1,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    38,    -1,    -1,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    53,    -1,
      -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,    22,
      23,    -1,    25,    -1,   333,   334,    -1,    -1,    -1,    32,
      33,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    52,
      -1,    54,    55,    -1,    -1,    58,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     389,   390,   391,   392,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   108,   109,    -1,    -1,    -1,
      53,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
     123,   124,    -1,    -1,    -1,    -1,    -1,   130,   131,   132,
      -1,    -1,   135,    -1,    -1,     6,    -1,    -1,   141,    11,
      12,    13,    14,    15,    -1,    -1,   149,    -1,   151,    20,
      21,    22,    23,    -1,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,   473,   474,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    51,
     489,   490,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   227,    -1,    -1,    -1,    -1,    -1,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   552,   553,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     141,   142,    53,    -1,    -1,    -1,    -1,    -1,   281,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,
     161,    -1,    -1,   164,   165,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,    -1,   188,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     333,   334,    -1,    -1,    23,   206,   207,   208,    -1,   210,
      -1,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    50,   365,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   389,   390,   391,   392,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    11,
      12,    13,    14,    15,    -1,   114,   115,    -1,   117,   118,
     119,   120,   121,   122,   123,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,   147,    -1,
      -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     473,   474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,   552,
     553,    -1,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    53,    -1,    27,    28,    29,    30,    31,    32,    33,
      34,    35,   281,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,
      -1,    11,    12,    13,    14,    15,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    11,
      12,    13,    14,    15,   333,   334,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    53,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   365,    50,    -1,    -1,
      -1,    53,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     389,   390,   391,   392,    -1,    78,    -1,    -1,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    11,    12,    13,    14,    15,
      -1,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
     123,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   145,    -1,   147,    -1,    -1,    53,    -1,    -1,
      -1,    -1,    -1,    -1,   473,   474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,    -1,    -1,    -1,    -1,    -1,    11,
      12,    13,    14,    15,   227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   552,   553,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    38,    -1,    -1,    -1,   281,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    12,    13,
      14,    15,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    38,    11,    12,    13,    14,    15,
     333,   334,    23,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,   365,    -1,    -1,    51,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    11,    12,    13,    14,    15,   389,   390,   391,   392,
      81,    82,    83,    84,    85,    86,    87,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    -1,
      -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,
      -1,    51,    -1,   114,   115,    -1,   117,   118,   119,   120,
     121,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   145,    -1,   147,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     473,   474,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     281,    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   552,
     553,    -1,    -1,    -1,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   333,   334,    -1,    -1,    -1,    -1,    -1,    -1,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   365,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   389,   390,
     391,   392,   333,   334,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   389,   390,
     391,   392,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   473,   474,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   473,   474,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,   552,   553,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   552,   553,    -1,    -1,    -1,    -1,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   154,    -1,    -1,    -1,    -1,   159,   160,    -1,
     162,   163,    -1,    -1,    -1,   167,   168,    -1,    -1,    -1,
      -1,   173,   174,   175,   176,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,   191,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   218,    -1,    -1,    -1,
      -1,   223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     232,    -1,    -1,    -1,   236,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   270,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   284,   285,   286,    -1,   288,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,   297,   298,    -1,    -1,   301,
     302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   317,   318,    -1,    -1,    -1,
     322,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,   331,
      -1,    -1,    -1,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,    -1,    -1,    -1,   347,   348,    -1,   350,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   361,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   369
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,   559,   560,     3,     4,     5,   143,   160,   185,
     186,   220,   223,   225,   236,   260,   264,   269,   270,   382,
     546,   547,   555,   556,   557,   558,   720,   721,   722,   723,
     725,   726,   727,   734,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   749,   750,   751,   752,   753,
     754,   755,   757,   758,   772,   773,   774,   775,   794,   817,
     855,   856,   857,   858,   859,   860,   861,   862,   917,   918,
     941,   954,   955,   956,   957,   958,   959,   960,   961,     0,
       6,    39,    49,    51,    54,    55,    80,   141,   143,   144,
     146,   148,   154,   156,   157,   158,   160,   173,   174,   175,
     176,   177,   178,   223,   229,   235,   236,   545,   561,   562,
     616,   618,   619,   620,   621,   630,   666,   668,   669,   670,
     672,   673,   687,   690,   700,   701,   702,   762,   765,   776,
     779,   795,   801,   813,   816,   820,   821,   864,   865,   867,
     869,   870,   875,   906,   909,   919,   920,   932,   933,   942,
     945,   952,   953,   964,   967,   968,     6,     6,     6,    16,
      18,    19,    20,    21,    22,    23,    25,    32,    33,    37,
      49,    50,    52,    54,    55,    58,   108,   109,   114,   115,
     117,   118,   119,   120,   121,   122,   123,   124,   130,   131,
     132,   135,   141,   149,   151,   227,   281,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   333,   334,   365,
     389,   390,   391,   392,   473,   474,   489,   490,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   552,   553,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     613,   614,   615,   636,   652,   654,   655,   657,   658,   659,
     660,   761,    23,    25,   161,   733,   756,   759,    23,   759,
     759,   221,   222,   759,   759,     6,   185,   195,   197,   226,
     233,   261,   263,   271,   284,   386,   475,   500,   141,   171,
     193,   195,   197,   265,   266,   267,   268,    41,    78,   161,
     747,   759,   264,    25,   247,   261,   541,   542,   543,   962,
       6,    23,    24,   565,   565,   565,   660,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    98,    99,   100,   101,
     102,   103,   622,    52,    52,   155,    23,    25,   589,   195,
     196,   211,   544,   179,   195,   589,   157,   233,   234,   235,
     688,   689,   944,   185,   478,   536,   169,   162,   189,   216,
     271,   284,   382,   386,   437,   442,   443,   475,   500,   504,
     551,   819,   905,    50,   565,   674,    79,   154,   159,   160,
     163,   167,   218,   223,   247,   670,   675,   676,   682,   704,
     674,   674,   674,    54,    55,    79,    87,   117,   162,   163,
     168,   173,   174,   175,   176,   186,   190,   191,   232,   236,
     247,   270,   284,   285,   286,   288,   293,   295,   297,   298,
     301,   302,   317,   318,   322,   323,   324,   331,   335,   338,
     339,   341,   343,   347,   348,   350,   361,   369,   675,   804,
     805,   812,   674,   674,    48,    79,   236,   393,   394,   395,
     396,   421,   427,   430,   433,   670,   675,   823,   824,   825,
     826,   827,   674,    79,   187,   268,   438,   439,   440,   441,
     675,   682,   866,    78,    79,   123,   164,   165,   169,   180,
     189,   374,   675,   677,   674,   674,   674,   674,    79,   233,
     247,   335,   675,   682,   936,   937,    79,   236,   272,   430,
     504,   548,   549,   550,   675,   682,   943,   966,   674,   674,
      79,   163,   549,   675,   969,    18,    23,    32,    34,    52,
     151,   153,   651,   653,   658,    35,   569,    35,    20,    21,
     570,   571,    52,   140,    33,   140,   660,    18,   110,   111,
     112,   113,   641,   660,    78,    78,    52,    52,    52,    52,
      52,    52,    52,    18,    19,    21,    22,    23,    52,   570,
     571,   578,   636,   637,   640,   642,   643,   644,   646,   648,
     649,   238,   238,     6,    11,    12,    13,    14,    15,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    38,    38,
      41,    78,   161,   705,     6,   705,    25,   590,   590,   759,
     759,     6,    41,    78,   161,   708,     6,    23,    25,   161,
     760,     6,   262,     6,   728,     6,   735,   171,   197,   267,
     282,   292,    23,   163,   267,   420,   435,   436,   724,   197,
     267,   724,   161,     6,     6,     6,     6,     6,     6,     6,
       6,    87,   160,   491,   534,   535,   536,   537,   538,   539,
     950,   951,    18,   748,   590,   818,   962,     6,   962,     6,
       6,   478,   963,    27,   631,   617,    97,   565,    23,    23,
      18,    20,    23,    50,    52,   667,    51,   705,   705,    18,
      23,    52,   563,    40,    41,    42,    43,   181,   563,   566,
     708,    51,    25,   230,    51,   533,   540,   589,   948,   237,
     563,   564,   564,   565,   387,   388,   868,   476,    23,    50,
      78,   155,   566,   705,   703,   168,   589,   589,   708,   248,
      51,    78,   680,    51,    51,    78,    78,    78,   237,   304,
     316,    51,    25,   307,   308,    49,   352,    49,   352,    49,
     352,    49,   352,   305,   589,   566,   353,   185,   248,   233,
     321,   346,   236,   566,   802,    51,   563,    20,    21,    23,
     362,   567,   797,   567,   796,   294,   296,   303,   294,   293,
     272,   303,   319,   320,   319,   156,   566,   325,   332,   272,
     272,   340,   338,   240,   288,   307,   566,   349,   351,   563,
     363,   136,    51,    78,   810,    51,    78,    78,   434,   185,
     667,   566,   154,   563,   566,   155,   359,   566,   352,   822,
     680,    51,    78,    78,   566,    18,    50,   192,    18,   238,
     241,   164,   165,    51,    51,   563,   141,   142,   161,   166,
     181,   187,   628,   684,   181,   684,    23,   683,   181,   220,
     169,    51,    51,    78,    78,    78,    78,    21,    22,    23,
     581,   584,   248,   169,    51,    51,    86,   299,   328,   337,
     501,   502,   503,   934,   935,    78,   940,   185,   563,   344,
     169,   566,   294,   566,    51,    51,    78,    78,   970,   974,
     294,    51,    10,   653,   653,   653,   660,    20,    21,   646,
     653,   653,    17,    18,    18,    35,   656,   660,    32,    33,
     140,    33,    18,    77,    53,    77,   610,   610,   683,   660,
     660,   660,   660,   660,   660,    34,   639,   641,   660,    32,
      33,    78,    10,    77,   152,    77,   152,    18,    18,   660,
     660,   660,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   660,   660,    56,    57,    64,    90,    92,   116,   125,
     126,   128,   129,   136,   137,   138,    49,    54,    55,   173,
     174,   175,   176,   177,   178,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   732,   170,   171,   172,
     193,   194,   197,   706,   707,     6,     6,     6,     6,   170,
     224,   709,   710,     6,   760,     6,     6,     6,   141,   157,
     161,   164,   165,   169,   188,   206,   207,   208,   210,   212,
     213,   214,   584,   628,   731,     6,    80,   141,   157,   158,
     169,   565,   724,   724,   724,   724,   724,   724,   724,   863,
     161,   724,   161,   724,     6,   724,   724,     6,     6,    77,
      79,     6,     6,     6,   141,   169,   192,   628,     6,   963,
     563,     6,   660,    52,   624,   625,   626,   629,    51,    77,
      77,   697,   698,   660,    51,   660,   564,    51,   563,   231,
     232,   363,   946,   563,   947,    78,   161,   949,   563,    44,
      45,    46,   219,   671,   674,    23,   667,   691,   694,   695,
     566,   679,   681,   764,   778,   294,   294,   567,    51,   563,
     563,    87,   370,    51,    51,   236,   354,   294,   345,   566,
     566,   330,   566,   224,    51,    51,    78,   719,    51,    23,
     578,   583,    36,   568,    47,    51,   240,   358,   359,   568,
      47,    51,   240,   563,   294,   294,   563,   294,   566,   294,
     566,   155,   566,   566,    51,   566,   566,   566,   566,   566,
     566,   360,   240,   566,    51,   566,   566,    51,   364,   589,
     240,   809,   811,   815,   566,   294,   345,   566,   566,   181,
     563,   566,   681,   828,    18,    18,   564,   564,    23,   626,
     627,   660,    41,   563,   686,   188,   686,   686,   566,   683,
     874,   908,   921,   566,   683,    25,   567,   567,    49,   122,
     284,   461,   934,   939,    51,   566,   566,   563,   563,   695,
     696,   563,    18,    53,   152,    50,    18,    53,    77,   140,
      33,   660,   660,   611,   612,    53,    77,    53,    77,    77,
      77,    77,    53,    77,    10,    77,    77,    53,    18,    52,
     637,   644,   648,   240,   240,    52,    77,    79,    77,    79,
       6,   627,    23,   169,   169,    23,   161,    20,    21,    22,
      23,   570,   571,   572,   573,   574,   729,   730,    23,   733,
     590,   590,   590,   590,     6,   590,   590,     6,    23,    64,
     154,   248,   300,   393,   425,   426,   724,   590,   724,   590,
     590,   590,   951,   627,    25,   683,   589,     6,    51,    53,
     623,   629,    78,   622,   589,    23,   695,    51,    53,    53,
      25,    45,    46,    45,    46,   589,   589,   950,    51,    51,
      33,   693,    77,    51,    79,   160,   677,   678,    79,   163,
     283,   675,   682,   763,    79,    85,   163,   285,   286,   675,
     777,   563,   563,    51,    51,    51,   566,    78,   566,   798,
     185,   294,   563,    51,    51,    51,   566,    51,   566,   718,
     803,   797,   565,   797,   563,   563,   796,   563,   563,    51,
     563,   563,    51,   563,    51,   563,    51,   667,    51,    51,
      51,    51,    51,    51,    51,    51,   566,    51,   563,    51,
      51,    51,   563,    51,   566,    59,    79,   131,   164,   165,
     232,   236,   326,   335,   336,   342,   346,   357,   366,   368,
     678,   808,    79,   141,   169,   383,   384,   385,   628,   675,
     814,   563,   563,    79,   163,   168,   262,   359,   395,   412,
     414,   418,   422,   423,   829,   836,   839,   182,   685,   566,
      51,    79,    91,   163,   463,   464,   467,   472,   675,   682,
     871,    79,   163,   421,   477,   675,   682,   907,    47,    79,
     296,   329,   330,   491,   497,   499,   675,   682,   922,   924,
      51,    51,   568,    49,    18,   586,   587,   563,   566,   566,
      23,    79,    81,    82,    83,    84,    85,    86,    87,   104,
     107,   123,   145,   147,   657,   659,   661,   663,   761,   938,
     181,   965,    78,   973,   653,   653,    21,   660,    33,    33,
      77,    53,    77,   608,   609,   660,   660,   660,   660,   660,
      34,   639,   660,   639,    34,   639,   639,    77,   660,    18,
      18,   660,   707,   710,    23,   733,   733,    50,    20,    21,
       6,     6,     6,     6,     6,     6,    18,   667,   667,   667,
     590,     6,   590,     6,     6,     6,   622,   632,   633,   634,
     663,   565,    53,    77,    79,    25,   590,   692,   694,   705,
      51,   766,   771,   154,    51,   781,   782,   788,   782,   789,
     567,   793,    51,    77,    51,    51,    91,   222,   370,   372,
     374,   375,   378,   799,   800,    51,   345,   566,   563,    51,
      51,    51,    79,   191,   236,   241,   242,   245,   246,   717,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,   280,   344,   169,   169,   353,   185,   327,
     169,   162,   337,   566,    59,   566,   367,   566,   563,    51,
     627,    25,   683,   589,   563,   131,    51,   848,   854,   368,
     397,   422,   566,   831,   368,   566,   830,   248,   583,   832,
     833,   424,   566,    51,   427,   849,   183,   184,   185,   186,
      23,   571,   582,   885,   890,   876,   884,   872,   873,   582,
     171,    51,   910,   916,   566,   563,    51,   563,   187,   923,
     238,   923,    23,   567,   589,   925,    66,   496,   926,   923,
      51,   587,    35,    27,   660,   662,   662,    52,   660,   660,
     660,    27,    52,    52,    51,    27,   662,    27,    38,   563,
     972,    35,    33,   660,   660,    47,    56,    57,    58,    59,
      61,    62,    63,    66,    68,    69,    74,    79,   593,   594,
     595,   596,   598,   606,    75,    79,   594,   595,   596,   597,
     598,   607,    77,    53,    53,    53,    53,    53,    77,    10,
      53,    77,    53,    77,    10,    53,    77,    77,    18,    53,
      21,     6,     6,   565,    79,   633,    51,    18,    20,    21,
      23,   570,   571,   585,   696,   155,   162,   173,   174,   285,
     780,   696,    78,   787,    36,   287,   790,   563,   181,   381,
     134,   373,   377,   376,   379,   380,    77,    79,    51,    51,
      51,   566,   243,   244,   244,   564,   563,    51,   187,   300,
     316,   243,   244,   566,   566,   566,   236,   354,   566,   300,
     328,   329,   807,   683,   280,   301,   695,   850,   563,   563,
     566,    78,   563,    78,   667,    78,   563,   563,    78,    78,
     889,   696,    78,   567,   891,   896,    25,    78,   897,   902,
     566,   696,   181,   563,    68,   563,   924,   927,   928,   563,
      18,   660,    77,    51,    51,   761,    51,   105,    78,   660,
     664,   664,   660,    51,   660,   131,   132,   135,   140,   141,
      79,   457,   971,    18,    33,    53,    53,    60,    64,    65,
      67,    11,    12,    13,    27,    28,    29,   108,   109,   563,
     591,   599,   600,   601,    37,   602,   603,   603,   605,   583,
      51,   599,   602,   605,   602,   582,    51,   660,    34,   639,
      34,   639,    34,   639,    10,    34,   639,    34,   639,    79,
      51,    53,    53,    78,   770,   566,   787,   786,   783,   565,
     589,   288,   791,    51,   371,   265,   800,   245,   245,   245,
     355,   356,   566,   806,   806,   567,   185,   294,   566,   566,
     851,    78,   853,   841,   841,   834,   837,   888,   887,    78,
     883,   892,   898,    78,   915,   563,   566,    78,    51,   662,
      53,    78,   635,   663,   650,    51,   660,    23,   123,   659,
     665,   761,    51,    51,    52,    52,    52,    51,    52,   567,
      51,    10,   563,    14,    15,   592,    77,    15,    77,   592,
     563,    70,    71,    72,    73,   604,    77,   592,    76,    53,
      53,    53,    53,    77,    10,    53,    53,    53,    77,    52,
      53,    10,    53,    53,    10,    53,   769,   767,   783,    79,
     190,   191,   217,   241,   242,   245,   246,   289,   711,   713,
     714,   784,   567,   285,   792,   564,   564,   564,   566,   563,
     849,   852,    79,   583,   842,   843,    79,    79,   262,   368,
     413,   835,    79,   237,   274,   289,   398,   399,   400,   711,
     838,    79,   456,   457,   460,   461,   462,   886,   882,   881,
     895,   901,   914,   911,   929,    51,   632,   106,     9,    18,
      19,    52,    79,   636,   638,   640,   642,   643,   645,   647,
     664,   664,   660,   660,   660,   660,   563,   601,   591,   600,
     603,   603,    35,   603,   603,    18,    34,   639,    34,   639,
     639,    10,   639,    47,    59,    64,    79,   181,   243,   244,
     247,   273,   274,   275,   768,   589,   566,    78,   243,   244,
     244,   564,   563,   166,   199,   290,   291,   785,    78,    51,
     566,    64,    79,   237,   243,   244,   247,   248,   267,   274,
     279,   284,   289,   339,   348,   368,   395,   398,   399,   400,
     406,   411,   421,   428,   711,   840,   413,   419,   844,   566,
     563,   566,    51,   563,   563,   166,   290,   409,   563,   303,
     208,   563,    51,   459,   459,   566,   566,   566,    51,    79,
      91,   168,   233,   238,   241,   248,   445,   447,   448,   452,
     453,   455,   463,   464,   877,    79,   459,   465,   893,    79,
     459,   466,   899,    47,    79,   191,   243,   244,   247,   272,
     275,   284,   289,   316,   339,   398,   421,   441,   478,   479,
     480,   481,   483,   487,   711,   912,    79,   491,   492,   498,
     930,    79,   635,   632,   660,    10,    77,   150,    53,    77,
      53,    53,    53,    53,   563,   563,   563,   563,   604,   604,
      53,    53,    53,    77,    53,    52,    53,   563,   280,   276,
     277,   563,   278,    68,    69,   228,   279,   699,   248,   563,
     245,   245,    51,   712,   713,   245,   245,   245,   201,   202,
     199,    50,    85,   155,   192,   198,   215,   715,   401,   402,
     403,   404,   405,   406,   407,   408,   563,   278,    68,   279,
     699,   248,   431,    78,   563,   563,   566,   166,   290,   409,
     340,   403,   563,   566,   563,   303,   208,   563,   316,   429,
     563,   122,   401,    51,   563,    51,   563,   563,   563,   563,
     450,   890,   123,   459,   123,   450,   459,   444,   303,   444,
     451,   444,   566,   449,   294,   454,   280,   288,   878,   288,
     879,    51,   894,   458,   563,   903,   891,    51,   900,   903,
     897,    51,   563,   566,   278,    68,   279,   699,   248,   485,
     563,   294,   566,   166,   201,   409,   486,   913,   567,   340,
     294,   122,   352,   401,   294,   294,   415,   563,   482,   484,
     488,    51,   931,   494,   493,   589,    51,    53,    52,   638,
     645,   632,    51,   660,    51,    51,    51,    51,    35,    35,
     639,   639,   173,   174,   563,   563,   563,   563,   563,   566,
     564,   564,    79,    51,   564,   564,   564,   201,   202,    25,
     588,    50,   192,   563,   588,   199,   200,   716,    50,   192,
      79,   416,   417,   563,   563,   563,   566,   432,   845,   244,
     566,   566,   563,   563,   566,   566,   563,   566,   468,   904,
     904,   294,   469,   470,   471,   880,   563,   880,   294,   563,
     245,   563,   245,   563,   446,   566,   563,   563,   181,   566,
     896,   566,   902,   563,   563,   563,   563,   566,   566,   563,
     244,   566,   564,   563,   563,   563,   566,   566,   566,   566,
     495,   495,   660,    53,   563,   563,    53,    77,   567,   567,
     712,    51,   588,   588,    51,    51,   201,   202,   203,   204,
     205,   201,   202,   203,   204,   205,    51,   588,   588,   566,
      79,   567,   847,   415,   566,   563,   904,   563,   904,   563,
     563,   566,   563,   415,   589,   589,    51,   639,   715,    51,
      51,   715,   715,   715,    51,    51,   410,   846,    77,   715,
     715,   715,   715,    51,   639,    53
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   554,   559,   559,   560,   560,   561,   561,   562,   563,
     563,   563,   564,   564,   564,   565,   565,   566,   566,   566,
     566,   566,   566,   567,   567,   567,   568,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   578,   579,
     579,   580,   580,   581,   581,   581,   581,   581,   581,   582,
     582,   583,   583,   584,   584,   585,   585,   585,   585,   585,
     586,   587,   587,   588,   589,   589,   590,   590,   591,   591,
     591,   591,   591,   591,   591,   591,   592,   592,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   594,   595,   596,
     597,   598,   598,   599,   599,   599,   599,   600,   600,   601,
     601,   602,   602,   602,   603,   603,   604,   604,   604,   604,
     605,   605,   605,   606,   606,   606,   606,   607,   607,   607,
     607,   607,   607,   608,   608,   609,   609,   610,   611,   612,
     613,   614,   615,   615,   555,   556,   555,   557,   555,   558,
     561,   617,   616,   561,   618,   561,   619,   561,   620,   561,
     621,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   623,   623,   624,
     624,   625,   625,   626,   627,   627,   628,   629,   561,   631,
     630,   632,   632,   633,   634,   634,   635,   635,   636,   636,
     637,   637,   637,   637,   637,   637,   638,   638,   638,   638,
     639,   640,   640,   640,   640,   640,   640,   640,   640,   640,
     640,   641,   641,   641,   641,   642,   642,   642,   643,   643,
     643,   643,   643,   643,   643,   643,   644,   644,   644,   644,
     644,   645,   645,   645,   645,   645,   646,   646,   647,   647,
     648,   648,   648,   648,   649,   649,   650,   650,   650,   651,
     651,   652,   653,   653,   653,   653,   653,   653,   653,   653,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     655,   655,   655,   655,   656,   656,   656,   657,   658,   659,
     659,   659,   659,   659,   659,   659,   659,   659,   659,   660,
     660,   660,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   660,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   660,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   660,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   660,   660,   660,   660,   660,   660,   661,   661,   661,
     662,   662,   662,   663,   663,   663,   663,   663,   663,   663,
     663,   663,   663,   663,   663,   663,   663,   663,   663,   663,
     663,   663,   663,   664,   665,   665,   665,   665,   561,   666,
     666,   667,   667,   667,   667,   561,   668,   561,   669,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   561,
     671,   671,   672,   561,   673,   673,   674,   674,   674,   674,
     675,   675,   675,   675,   675,   675,   675,   675,   676,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   678,   678,
     679,   679,   680,   680,   681,   682,   683,   684,   684,   684,
     684,   685,   685,   685,   685,   685,   686,   686,   561,   687,
     687,   687,   561,   688,   688,   688,   688,   689,   689,   689,
     689,   689,   689,   689,   689,   690,   691,   692,   692,   693,
     693,   694,   695,   695,   696,   697,   698,   699,   699,   700,
     701,   702,   702,   702,   702,   702,   703,   704,   705,   705,
     705,   706,   706,   707,   707,   707,   707,   707,   707,   708,
     708,   708,   709,   709,   710,   710,   711,   711,   712,   712,
     713,   713,   714,   715,   715,   715,   715,   715,   715,   715,
     715,   715,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   717,   717,   717,   717,   717,   717,   717,   718,
     718,   719,   555,   720,   555,   721,   555,   722,   555,   723,
     724,   724,   555,   725,   555,   726,   555,   727,   728,   728,
     728,   728,   728,   728,   728,   728,   728,   728,   728,   728,
     728,   728,   728,   728,   728,   729,   729,   729,   729,   729,
     729,   729,   729,   730,   730,   730,   730,   731,   731,   731,
     731,   732,   732,   732,   732,   732,   732,   732,   732,   732,
     732,   732,   732,   732,   732,   732,   732,   732,   732,   732,
     732,   733,   555,   734,   735,   735,   735,   735,   735,   735,
     735,   555,   736,   555,   737,   555,   738,   555,   739,   555,
     740,   555,   741,   555,   742,   555,   743,   555,   744,   555,
     745,   555,   746,   747,   747,   747,   748,   748,   555,   749,
     555,   750,   555,   751,   555,   752,   555,   753,   555,   754,
     555,   755,   756,   756,   555,   757,   555,   758,   759,   759,
     759,   760,   760,   760,   761,   700,   776,   777,   777,   777,
     777,   777,   778,   778,   779,   780,   780,   780,   780,   781,
     781,   782,   783,   784,   784,   784,   784,   784,   784,   784,
     784,   785,   785,   785,   785,   785,   785,   786,   786,   787,
     787,   788,   789,   790,   790,   790,   791,   791,   792,   792,
     793,   555,   794,   700,   762,   763,   763,   763,   763,   764,
     764,   765,   766,   767,   768,   768,   768,   768,   768,   768,
     768,   768,   768,   768,   768,   768,   768,   768,   768,   769,
     769,   770,   770,   771,   761,   555,   772,   555,   773,   555,
     774,   555,   775,   700,   795,   796,   796,   796,   797,   797,
     797,   797,   797,   798,   798,   799,   799,   800,   800,   800,
     800,   800,   800,   800,   800,   800,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   802,   803,   801,
     801,   804,   804,   804,   804,   804,   804,   804,   804,   804,
     804,   804,   804,   805,   806,   806,   806,   807,   807,   807,
     808,   808,   808,   808,   808,   808,   808,   808,   808,   808,
     808,   808,   808,   808,   808,   808,   808,   808,   808,   808,
     808,   808,   809,   809,   810,   810,   811,   812,   761,   761,
     761,   761,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   700,   813,   814,   814,   814,   814,   814,   814,   814,
     814,   815,   815,   816,   555,   817,   818,   818,   818,   818,
     818,   818,   700,   819,   819,   819,   820,   821,   821,   822,
     822,   823,   824,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   826,   827,
     828,   828,   829,   829,   829,   829,   829,   829,   829,   829,
     829,   830,   829,   831,   829,   829,   829,   829,   832,   832,
     833,   834,   834,   835,   835,   835,   836,   836,   837,   837,
     838,   838,   838,   838,   838,   838,   838,   838,   838,   838,
     838,   839,   840,   840,   840,   840,   840,   840,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   840,
     840,   841,   841,   842,   843,   844,   844,   844,   845,   845,
     846,   846,   847,   848,   849,   849,   851,   850,   852,   852,
     853,   853,   854,   761,   761,   761,   761,   555,   855,   555,
     856,   555,   857,   555,   858,   555,   859,   555,   860,   555,
     861,   555,   862,   863,   863,   863,   863,   863,   863,   863,
     863,   863,   700,   864,   865,   865,   865,   866,   866,   866,
     866,   866,   866,   866,   866,   866,   866,   700,   868,   867,
     869,   869,   869,   869,   700,   870,   871,   871,   871,   871,
     872,   871,   873,   871,   871,   871,   874,   874,   875,   876,
     877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   877,   877,   877,   878,   877,   879,
     877,   877,   877,   880,   880,   880,   881,   882,   882,   883,
     883,   884,   885,   886,   886,   886,   886,   886,   887,   888,
     888,   889,   889,   890,   891,   892,   893,   893,   893,   894,
     895,   895,   896,   896,   897,   898,   899,   899,   899,   900,
     901,   901,   902,   902,   903,   903,   904,   904,   761,   761,
     700,   905,   905,   906,   907,   907,   907,   907,   907,   907,
     908,   908,   909,   910,   911,   912,   912,   912,   912,   912,
     912,   912,   912,   912,   912,   912,   912,   912,   912,   912,
     912,   912,   912,   912,   912,   912,   912,   912,   912,   912,
     912,   912,   913,   913,   913,   913,   914,   914,   915,   915,
     916,   761,   761,   555,   917,   555,   918,   700,   919,   920,
     921,   921,   922,   922,   922,   922,   922,   922,   922,   922,
     922,   922,   923,   923,   924,   925,   925,   926,   926,   927,
     928,   929,   929,   930,   930,   930,   931,   700,   932,   933,
     933,   933,   933,   933,   933,   934,   934,   934,   934,   934,
     934,   935,   935,   936,   937,   937,   937,   937,   937,   937,
     937,   937,   937,   938,   939,   939,   940,   940,   555,   941,
     942,   943,   943,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   761,   761,   761,   761,   761,   761,   761,   761,   761,
     761,   561,   944,   945,   946,   946,   947,   947,   948,   948,
     948,   949,   949,   950,   950,   951,   951,   951,   951,   951,
     951,   951,   951,   951,   561,   952,   952,   561,   953,   953,
     953,   953,   555,   954,   555,   955,   555,   956,   555,   957,
     555,   958,   555,   959,   555,   960,   555,   961,   962,   962,
     963,   963,   963,   700,   964,   942,   942,   965,   965,   966,
     966,   966,   966,   966,   966,   966,   700,   967,   968,   968,
     969,   969,   969,   970,   971,   972,   972,   973,   973,   974,
     761,   761
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     1,     5,     1,
       3,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     0,     2,     2,     2,
       3,     7,     2,     2,     5,     5,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     2,     2,     1,     1,     1,     2,     1,
       1,     1,     1,     2,     4,     1,     3,     1,     3,     1,
       3,     4,     6,     6,     0,     1,     1,     1,     1,     1,
       2,     4,     4,     2,     2,     2,     2,     2,     4,     2,
       2,     2,     2,     0,     3,     0,     3,     0,     0,     0,
       6,     6,     1,     1,     1,     2,     1,     2,     1,     2,
       1,     0,     4,     1,     2,     1,     4,     1,     6,     1,
       8,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     0,     4,     2,
       5,     0,     4,     1,     1,     1,     2,     4,     1,     0,
       5,     0,     1,     1,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     3,     1,     1,
       1,     5,     7,     5,     7,     9,     7,     5,     7,     5,
      11,     1,     1,     2,     1,     7,     9,     7,     7,     9,
       7,     9,     7,     9,     7,    15,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     3,     1,     3,     1,     3,
       1,     2,     2,     6,     1,     3,     0,     4,     3,     1,
       3,     3,     2,     4,     4,     2,     2,     2,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       5,     7,     7,     1,     0,     1,     3,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     4,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       0,     1,     3,     4,     6,     4,     3,     4,     4,     4,
       5,     3,     3,     3,     2,     5,     4,     7,     7,     7,
       7,     7,     9,     0,     1,     1,     1,     1,     1,     4,
       5,     1,     3,     1,     1,     1,     3,     1,     5,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     4,     1,     1,     1,     0,     1,     2,     3,
       0,     2,     2,     2,     3,     2,     2,     2,     1,     2,
       2,     2,     3,     3,     3,     2,     4,     3,     1,     2,
       0,     3,     0,     3,     0,     3,     1,     2,     1,     1,
       1,     0,     2,     2,     2,     2,     2,     1,     1,     3,
       3,     3,     1,     1,     1,     1,     1,     2,     4,     3,
       4,     4,     3,     4,     4,     3,     0,     1,     2,     0,
       1,     3,     1,     3,     1,     0,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     5,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     4,
       4,     4,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     4,     4,     4,     2,     2,     1,     0,
       3,     3,     1,     3,     1,     3,     1,     4,     1,     5,
       1,     0,     1,     3,     1,     4,     1,     4,     0,     2,
       3,     3,     3,     4,     4,     3,     2,     2,     2,     2,
       3,     3,     3,     2,     2,     1,     1,     1,     1,     2,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     4,     0,     2,     2,     2,     2,     2,
       2,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     4,     1,
       3,     1,     4,     1,     1,     3,     0,     1,     1,     4,
       1,     4,     1,     4,     1,     3,     1,     4,     1,     4,
       1,     3,     2,     2,     1,     4,     1,     2,     1,     1,
       1,     1,     0,     1,     1,     1,     2,     1,     2,     2,
       2,     2,     0,     3,     5,     1,     1,     1,     1,     0,
       2,     0,     0,     2,     4,     4,     4,     2,     2,     2,
       1,     1,     1,     2,     2,     3,     3,     0,     3,     0,
       3,     4,     3,     0,     2,     2,     0,     2,     0,     2,
       4,     1,     5,     1,     2,     1,     1,     2,     4,     0,
       3,     5,     0,     0,     0,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     2,     3,     3,     4,     4,     0,
       3,     0,     3,     4,     1,     1,     6,     1,     6,     1,
       6,     1,     6,     2,     2,     0,     3,     3,     0,     3,
       3,     2,     2,     1,     3,     1,     3,     1,     3,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     4,
       6,     4,     6,     6,     4,     6,     5,     5,     4,     5,
       5,     6,     3,     3,     4,     5,     6,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     6,     6,     6,     5,
       6,     8,     6,     6,     6,     5,     6,     5,     4,     4,
       4,     4,     5,     5,     6,     5,     6,     5,     5,     6,
       7,     7,     7,     5,     5,     4,     4,     0,     0,     6,
       6,     1,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     2,     3,     2,     2,     2,     3,
       5,     5,     4,     3,     3,     3,     3,     3,     2,     2,
       2,     3,     0,     3,     0,     3,     0,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     2,     2,     2,     1,     2,     2,
       4,     0,     3,     5,     1,     4,     0,     3,     3,     3,
       2,     3,     2,     1,     2,     2,     2,     3,     3,     0,
       1,     2,     3,     1,     1,     2,     2,     3,     3,     3,
       3,     4,     2,     4,     3,     2,     3,     1,     2,     4,
       0,     3,     2,     1,     2,     3,     3,     3,     3,     2,
       3,     0,     5,     0,     5,     2,     2,     1,     4,     1,
       1,     0,     3,     2,     2,     2,     5,     2,     0,     3,
       0,     2,     2,     3,     2,     2,     3,     2,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     2,     3,     2,     3,     3,     4,     4,     2,     2,
       2,     3,     3,     3,     2,     3,     3,     3,     4,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     1,     1,     1,     1,     1,     4,     1,
       6,     1,     6,     1,     6,     1,     7,     1,     6,     1,
       7,     1,     5,     0,     2,     3,     2,     3,     3,     2,
       3,     2,     2,     2,     3,     3,     3,     1,     3,     3,
       2,     3,     3,     2,     2,     2,     2,     2,     0,     4,
       2,     3,     3,     5,     1,     2,     1,     1,     2,     2,
       0,     3,     0,     3,     2,     3,     0,     3,     5,     0,
       4,     4,     3,     4,     2,     3,     3,     3,     3,     4,
       4,     4,     3,     3,     4,     4,     2,     0,     3,     0,
       3,     3,     3,     1,     1,     1,     0,     0,     3,     0,
       3,     4,     1,     2,     2,     2,     4,     4,     0,     0,
       3,     0,     3,     3,     1,     0,     0,     2,     2,     0,
       0,     3,     1,     5,     1,     0,     0,     2,     2,     0,
       0,     3,     1,     5,     1,     2,     0,     2,     1,     1,
       1,     1,     2,     2,     1,     1,     2,     4,     2,     2,
       0,     3,     5,     0,     0,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     4,     3,     2,
       2,     1,     1,     1,     1,     1,     0,     3,     0,     3,
       4,     1,     1,     1,     6,     1,     6,     1,     2,     5,
       0,     3,     1,     1,     2,     3,     1,     2,     3,     3,
       3,     4,     0,     1,     2,     1,     1,     2,     6,     0,
       0,     0,     3,     4,     4,     2,     0,     2,     2,     3,
       3,     3,     5,     5,     4,     3,     2,     3,     3,     3,
       3,     1,     2,     2,     2,     3,     5,     1,     2,     2,
       2,     2,     2,     1,     0,     2,     0,     3,     1,     4,
       3,     3,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     2,     0,     0,     2,     2,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     3,     1,     3,     4,
       3,     3,     1,     4,     1,     5,     1,     3,     1,     3,
       1,     3,     1,     4,     1,     2,     1,     3,     0,     1,
       0,     1,     2,     2,     2,     3,     3,     0,     2,     1,
       1,     2,     3,     2,     3,     4,     2,     2,     3,     3,
       1,     2,     3,     0,     2,     0,     3,     0,     3,     3,
       1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          goto yyexhaustedlab;                                          \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      YY_LAC_ESTABLISH;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 2: /* config: conf_entries END  */
#line 134 "conf/confbase.Y"
                         { return 0; }
#line 6156 "obj/conf/cf-parse.tab.c"
    break;

  case 3: /* config: CLI_MARKER cli_cmd  */
#line 135 "conf/confbase.Y"
                      { return 0; }
#line 6162 "obj/conf/cf-parse.tab.c"
    break;

  case 8: /* definition: DEFINE symbol '=' term ';'  */
#line 151 "conf/confbase.Y"
                              {
     struct f_val *val = cfg_allocz(sizeof(struct f_val));
     if (f_eval(f_linearize((yyvsp[-1].x)), cfg_mem, val) > F_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val, val);
   }
#line 6172 "obj/conf/cf-parse.tab.c"
    break;

  case 10: /* expr: '(' term ')'  */
#line 160 "conf/confbase.Y"
                { (yyval.i) = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 6178 "obj/conf/cf-parse.tab.c"
    break;

  case 11: /* expr: CF_SYM_KNOWN  */
#line 161 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number constant expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 6186 "obj/conf/cf-parse.tab.c"
    break;

  case 12: /* expr_us: expr S  */
#line 167 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) S_; }
#line 6192 "obj/conf/cf-parse.tab.c"
    break;

  case 13: /* expr_us: expr MS  */
#line 168 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) MS_; }
#line 6198 "obj/conf/cf-parse.tab.c"
    break;

  case 14: /* expr_us: expr US  */
#line 169 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) US_; }
#line 6204 "obj/conf/cf-parse.tab.c"
    break;

  case 17: /* bool: expr  */
#line 177 "conf/confbase.Y"
        { (yyval.i) = !!(yyvsp[0].i); }
#line 6210 "obj/conf/cf-parse.tab.c"
    break;

  case 18: /* bool: ON  */
#line 178 "conf/confbase.Y"
      { (yyval.i) = 1; }
#line 6216 "obj/conf/cf-parse.tab.c"
    break;

  case 19: /* bool: YES  */
#line 179 "conf/confbase.Y"
       { (yyval.i) = 1; }
#line 6222 "obj/conf/cf-parse.tab.c"
    break;

  case 20: /* bool: OFF  */
#line 180 "conf/confbase.Y"
       { (yyval.i) = 0; }
#line 6228 "obj/conf/cf-parse.tab.c"
    break;

  case 21: /* bool: NO  */
#line 181 "conf/confbase.Y"
      { (yyval.i) = 0; }
#line 6234 "obj/conf/cf-parse.tab.c"
    break;

  case 22: /* bool: %empty  */
#line 182 "conf/confbase.Y"
                                 { (yyval.i) = 1; }
#line 6240 "obj/conf/cf-parse.tab.c"
    break;

  case 23: /* ipa: IP4  */
#line 189 "conf/confbase.Y"
       { (yyval.a) = ipa_from_ip4((yyvsp[0].ip4)); }
#line 6246 "obj/conf/cf-parse.tab.c"
    break;

  case 24: /* ipa: IP6  */
#line 190 "conf/confbase.Y"
       { (yyval.a) = ipa_from_ip6((yyvsp[0].ip6)); }
#line 6252 "obj/conf/cf-parse.tab.c"
    break;

  case 25: /* ipa: CF_SYM_KNOWN  */
#line 191 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address constant expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).ip;
   }
#line 6261 "obj/conf/cf-parse.tab.c"
    break;

  case 26: /* ipa_scope: %empty  */
#line 198 "conf/confbase.Y"
               { (yyval.iface) = NULL; }
#line 6267 "obj/conf/cf-parse.tab.c"
    break;

  case 27: /* ipa_scope: '%' symbol  */
#line 199 "conf/confbase.Y"
              { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6273 "obj/conf/cf-parse.tab.c"
    break;

  case 28: /* pxlen4: '/' NUM  */
#line 206 "conf/confbase.Y"
           {
     if ((yyvsp[0].i) > IP4_MAX_PREFIX_LENGTH) cf_error("Invalid prefix length %u", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 6282 "obj/conf/cf-parse.tab.c"
    break;

  case 29: /* net_ip4_: IP4 pxlen4  */
#line 213 "conf/confbase.Y"
{
  net_fill_ip4(&((yyval.net)), (yyvsp[-1].ip4), (yyvsp[0].i));

  net_addr_ip4 *n = (void *) &((yyval.net));
  if (!net_validate_ip4(n))
    cf_error("Invalid IPv4 prefix %I4/%d, maybe you wanted %I4/%d",
	     n->prefix, n->pxlen, ip4_and(n->prefix, ip4_mkmask(n->pxlen)), n->pxlen);
}
#line 6295 "obj/conf/cf-parse.tab.c"
    break;

  case 30: /* net_ip6_: IP6 '/' NUM  */
#line 223 "conf/confbase.Y"
{
  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  net_fill_ip6(&((yyval.net)), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6 *n = (void *) &((yyval.net));
  if (!net_validate_ip6(n))
    cf_error("Invalid IPv6 prefix %I6/%d, maybe you wanted %I6/%d",
	     n->prefix, n->pxlen, ip6_and(n->prefix, ip6_mkmask(n->pxlen)), n->pxlen);
}
#line 6311 "obj/conf/cf-parse.tab.c"
    break;

  case 31: /* net_ip6_sadr_: IP6 '/' NUM FROM IP6 '/' NUM  */
#line 236 "conf/confbase.Y"
{
  if ((yyvsp[-4].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[-4].i));

  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
  net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-6].ip6), (yyvsp[-4].i), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6_sadr *n = (void *) (yyval.net_ptr);
  if (!net_validate_ip6_sadr(n))
    cf_error("Invalid SADR IPv6 prefix %I6/%d from %I6/%d, maybe you wanted %I6/%d from %I6/%d",
	     n->dst_prefix, n->dst_pxlen, n->src_prefix, n->src_pxlen,
	     ip6_and(n->dst_prefix, ip6_mkmask(n->dst_pxlen)), n->dst_pxlen,
	     ip6_and(n->src_prefix, ip6_mkmask(n->src_pxlen)), n->src_pxlen);
}
#line 6333 "obj/conf/cf-parse.tab.c"
    break;

  case 32: /* net_vpn4_: VPN_RD net_ip4_  */
#line 255 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
  net_fill_vpn4((yyval.net_ptr), net4_prefix(&(yyvsp[0].net)), net4_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 6342 "obj/conf/cf-parse.tab.c"
    break;

  case 33: /* net_vpn6_: VPN_RD net_ip6_  */
#line 261 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
  net_fill_vpn6((yyval.net_ptr), net6_prefix(&(yyvsp[0].net)), net6_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 6351 "obj/conf/cf-parse.tab.c"
    break;

  case 34: /* net_roa4_: net_ip4_ MAX NUM AS NUM  */
#line 267 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa4));
  net_fill_roa4((yyval.net_ptr), net4_prefix(&(yyvsp[-4].net)), net4_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net4_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP4_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 6362 "obj/conf/cf-parse.tab.c"
    break;

  case 35: /* net_roa6_: net_ip6_ MAX NUM AS NUM  */
#line 275 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_roa6((yyval.net_ptr), net6_prefix(&(yyvsp[-4].net)), net6_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net6_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 6373 "obj/conf/cf-parse.tab.c"
    break;

  case 36: /* net_mpls_: MPLS NUM  */
#line 283 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_mpls((yyval.net_ptr), (yyvsp[0].i));
}
#line 6382 "obj/conf/cf-parse.tab.c"
    break;

  case 43: /* net_: net_ip_  */
#line 293 "conf/confbase.Y"
           { (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length); net_copy((yyval.net_ptr), &((yyvsp[0].net))); }
#line 6388 "obj/conf/cf-parse.tab.c"
    break;

  case 50: /* net_ip6: CF_SYM_KNOWN  */
#line 306 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[0].s)).net->type != NET_IP6))
       cf_error("IPv6 network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 6398 "obj/conf/cf-parse.tab.c"
    break;

  case 52: /* net_ip: CF_SYM_KNOWN  */
#line 315 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || !net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       cf_error("IP network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 6408 "obj/conf/cf-parse.tab.c"
    break;

  case 54: /* net_any: CF_SYM_KNOWN  */
#line 324 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET))
       cf_error("Network constant expected");
     (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
   }
#line 6418 "obj/conf/cf-parse.tab.c"
    break;

  case 57: /* net_or_ipa: IP4  */
#line 334 "conf/confbase.Y"
       { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 6424 "obj/conf/cf-parse.tab.c"
    break;

  case 58: /* net_or_ipa: IP6  */
#line 335 "conf/confbase.Y"
       { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 6430 "obj/conf/cf-parse.tab.c"
    break;

  case 59: /* net_or_ipa: CF_SYM_KNOWN  */
#line 336 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       net_fill_ip_host(&((yyval.net)), SYM_VAL((yyvsp[0].s)).ip);
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
     else
       cf_error("IP address or network constant expected");
   }
#line 6443 "obj/conf/cf-parse.tab.c"
    break;

  case 60: /* label_stack_start: NUM  */
#line 347 "conf/confbase.Y"
{
  (yyval.mls) = cfg_allocz(sizeof(mpls_label_stack));
  (yyval.mls)->len = 1;
  (yyval.mls)->stack[0] = (yyvsp[0].i);
}
#line 6453 "obj/conf/cf-parse.tab.c"
    break;

  case 62: /* label_stack: label_stack '/' NUM  */
#line 355 "conf/confbase.Y"
                        {
    if ((yyvsp[-2].mls)->len >= MPLS_MAX_LABEL_STACK)
      cf_error("Too many labels in stack");
    (yyvsp[-2].mls)->stack[(yyvsp[-2].mls)->len++] = (yyvsp[0].i);
    (yyval.mls) = (yyvsp[-2].mls);
  }
#line 6464 "obj/conf/cf-parse.tab.c"
    break;

  case 63: /* time: TEXT  */
#line 364 "conf/confbase.Y"
        {
     (yyval.time) = tm_parse_time((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date/time");
   }
#line 6474 "obj/conf/cf-parse.tab.c"
    break;

  case 65: /* text: CF_SYM_KNOWN  */
#line 373 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String constant expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 6483 "obj/conf/cf-parse.tab.c"
    break;

  case 67: /* opttext: %empty  */
#line 381 "conf/confbase.Y"
               { (yyval.t) = NULL; }
#line 6489 "obj/conf/cf-parse.tab.c"
    break;

  case 68: /* flow_num_op: TRUE  */
#line 37 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_TRUE; }
#line 6495 "obj/conf/cf-parse.tab.c"
    break;

  case 69: /* flow_num_op: '='  */
#line 38 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_EQ;  }
#line 6501 "obj/conf/cf-parse.tab.c"
    break;

  case 70: /* flow_num_op: NEQ  */
#line 39 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_NEQ; }
#line 6507 "obj/conf/cf-parse.tab.c"
    break;

  case 71: /* flow_num_op: '<'  */
#line 40 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_LT;  }
#line 6513 "obj/conf/cf-parse.tab.c"
    break;

  case 72: /* flow_num_op: LEQ  */
#line 41 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_LEQ; }
#line 6519 "obj/conf/cf-parse.tab.c"
    break;

  case 73: /* flow_num_op: '>'  */
#line 42 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_GT;  }
#line 6525 "obj/conf/cf-parse.tab.c"
    break;

  case 74: /* flow_num_op: GEQ  */
#line 43 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_GEQ; }
#line 6531 "obj/conf/cf-parse.tab.c"
    break;

  case 75: /* flow_num_op: FALSE  */
#line 44 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_FALSE; }
#line 6537 "obj/conf/cf-parse.tab.c"
    break;

  case 76: /* flow_logic_op: OR  */
#line 48 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_OR; }
#line 6543 "obj/conf/cf-parse.tab.c"
    break;

  case 77: /* flow_logic_op: AND  */
#line 49 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_AND; }
#line 6549 "obj/conf/cf-parse.tab.c"
    break;

  case 78: /* flow_num_type_: PROTO  */
#line 53 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_IP_PROTOCOL; }
#line 6555 "obj/conf/cf-parse.tab.c"
    break;

  case 79: /* flow_num_type_: NEXT HEADER  */
#line 54 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_NEXT_HEADER; }
#line 6561 "obj/conf/cf-parse.tab.c"
    break;

  case 80: /* flow_num_type_: PORT  */
#line 55 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_PORT; }
#line 6567 "obj/conf/cf-parse.tab.c"
    break;

  case 81: /* flow_num_type_: DPORT  */
#line 56 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DST_PORT; }
#line 6573 "obj/conf/cf-parse.tab.c"
    break;

  case 82: /* flow_num_type_: SPORT  */
#line 57 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_SRC_PORT; }
#line 6579 "obj/conf/cf-parse.tab.c"
    break;

  case 83: /* flow_num_type_: ICMP TYPE  */
#line 58 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_ICMP_TYPE; }
#line 6585 "obj/conf/cf-parse.tab.c"
    break;

  case 84: /* flow_num_type_: ICMP CODE  */
#line 59 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_ICMP_CODE; }
#line 6591 "obj/conf/cf-parse.tab.c"
    break;

  case 85: /* flow_num_type_: LENGTH  */
#line 60 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_PACKET_LENGTH; }
#line 6597 "obj/conf/cf-parse.tab.c"
    break;

  case 86: /* flow_num_type_: DSCP  */
#line 61 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DSCP; }
#line 6603 "obj/conf/cf-parse.tab.c"
    break;

  case 87: /* flow_num_type: flow_num_type_  */
#line 64 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, (yyvsp[0].i32)); }
#line 6609 "obj/conf/cf-parse.tab.c"
    break;

  case 88: /* flow_flag_type: TCP FLAGS  */
#line 65 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_TCP_FLAGS); }
#line 6615 "obj/conf/cf-parse.tab.c"
    break;

  case 89: /* flow_frag_type: FRAGMENT  */
#line 66 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_FRAGMENT); }
#line 6621 "obj/conf/cf-parse.tab.c"
    break;

  case 90: /* flow_label_type: LABEL  */
#line 67 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_LABEL); }
#line 6627 "obj/conf/cf-parse.tab.c"
    break;

  case 91: /* flow_srcdst: DST  */
#line 70 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DST_PREFIX; }
#line 6633 "obj/conf/cf-parse.tab.c"
    break;

  case 92: /* flow_srcdst: SRC  */
#line 71 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_SRC_PREFIX; }
#line 6639 "obj/conf/cf-parse.tab.c"
    break;

  case 93: /* flow_num_opts: flow_num_op expr  */
#line 75 "conf/flowspec.Y"
                    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 6648 "obj/conf/cf-parse.tab.c"
    break;

  case 94: /* flow_num_opts: flow_num_opts flow_logic_op flow_num_op expr  */
#line 79 "conf/flowspec.Y"
                                                {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-2].i32) | (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 6657 "obj/conf/cf-parse.tab.c"
    break;

  case 97: /* flow_num_opt_ext_expr: expr  */
#line 88 "conf/flowspec.Y"
        {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_EQ, (yyvsp[0].i));
   }
#line 6666 "obj/conf/cf-parse.tab.c"
    break;

  case 98: /* flow_num_opt_ext_expr: expr DDOT expr  */
#line 92 "conf/flowspec.Y"
                  {
     flow_check_cf_value_length(this_flow, (yyvsp[-2].i));
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_GEQ, (yyvsp[-2].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_AND | FLOW_OP_LEQ, (yyvsp[0].i));
   }
#line 6677 "obj/conf/cf-parse.tab.c"
    break;

  case 101: /* flow_bmk_opts: flow_neg expr '/' expr  */
#line 106 "conf/flowspec.Y"
                          {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 6686 "obj/conf/cf-parse.tab.c"
    break;

  case 102: /* flow_bmk_opts: flow_bmk_opts flow_logic_op flow_neg expr '/' expr  */
#line 110 "conf/flowspec.Y"
                                                      {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-4].i32) | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 6695 "obj/conf/cf-parse.tab.c"
    break;

  case 103: /* flow_bmk_opts: flow_bmk_opts ',' flow_neg expr '/' expr  */
#line 114 "conf/flowspec.Y"
                                            {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, 0x40 | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i)); /* AND */
   }
#line 6704 "obj/conf/cf-parse.tab.c"
    break;

  case 104: /* flow_neg: %empty  */
#line 121 "conf/flowspec.Y"
                { (yyval.i32) = 0x00; }
#line 6710 "obj/conf/cf-parse.tab.c"
    break;

  case 105: /* flow_neg: '!'  */
#line 122 "conf/flowspec.Y"
                { (yyval.i32) = 0x02; }
#line 6716 "obj/conf/cf-parse.tab.c"
    break;

  case 106: /* flow_frag_val: DONT_FRAGMENT  */
#line 126 "conf/flowspec.Y"
                  { (yyval.i32) = 1; }
#line 6722 "obj/conf/cf-parse.tab.c"
    break;

  case 107: /* flow_frag_val: IS_FRAGMENT  */
#line 127 "conf/flowspec.Y"
                  { (yyval.i32) = 2; }
#line 6728 "obj/conf/cf-parse.tab.c"
    break;

  case 108: /* flow_frag_val: FIRST_FRAGMENT  */
#line 128 "conf/flowspec.Y"
                  { (yyval.i32) = 4; }
#line 6734 "obj/conf/cf-parse.tab.c"
    break;

  case 109: /* flow_frag_val: LAST_FRAGMENT  */
#line 129 "conf/flowspec.Y"
                  { (yyval.i32) = 8; }
#line 6740 "obj/conf/cf-parse.tab.c"
    break;

  case 110: /* flow_frag_opts: flow_neg flow_frag_val  */
#line 133 "conf/flowspec.Y"
                          {
     flow_builder_add_val_mask(this_flow, 0, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 6748 "obj/conf/cf-parse.tab.c"
    break;

  case 111: /* flow_frag_opts: flow_frag_opts flow_logic_op flow_neg flow_frag_val  */
#line 136 "conf/flowspec.Y"
                                                       {
     flow_builder_add_val_mask(this_flow, (yyvsp[-2].i32), ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 6756 "obj/conf/cf-parse.tab.c"
    break;

  case 112: /* flow_frag_opts: flow_frag_opts ',' flow_neg flow_frag_val  */
#line 139 "conf/flowspec.Y"
                                             {
     flow_builder_add_val_mask(this_flow, 0x40, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32)); /* AND */
   }
#line 6764 "obj/conf/cf-parse.tab.c"
    break;

  case 113: /* flow4_item: flow_srcdst net_ip  */
#line 145 "conf/flowspec.Y"
                      {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder4_add_pfx(this_flow, (net_addr_ip4 *) &((yyvsp[0].net)));
   }
#line 6773 "obj/conf/cf-parse.tab.c"
    break;

  case 117: /* flow6_item: flow_srcdst net_ip6  */
#line 155 "conf/flowspec.Y"
                       {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[0].net)), 0);
   }
#line 6782 "obj/conf/cf-parse.tab.c"
    break;

  case 118: /* flow6_item: flow_srcdst net_ip6 OFFSET NUM  */
#line 159 "conf/flowspec.Y"
                                  {
     if ((yyvsp[0].i) > (yyvsp[-2].net).pxlen)
       cf_error("Prefix offset is higher than prefix length");
     flow_builder_set_type(this_flow, (yyvsp[-3].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[-2].net)), (yyvsp[0].i));
   }
#line 6793 "obj/conf/cf-parse.tab.c"
    break;

  case 127: /* flow_builder_init: %empty  */
#line 182 "conf/flowspec.Y"
{
  if (this_flow == NULL)
    this_flow = flow_builder_init(&root_pool);
  else
    flow_builder_clear(this_flow);
}
#line 6804 "obj/conf/cf-parse.tab.c"
    break;

  case 128: /* flow_builder_set_ipv4: %empty  */
#line 189 "conf/flowspec.Y"
                       { this_flow->ipv6 = 0; }
#line 6810 "obj/conf/cf-parse.tab.c"
    break;

  case 129: /* flow_builder_set_ipv6: %empty  */
#line 190 "conf/flowspec.Y"
                       { this_flow->ipv6 = 1; }
#line 6816 "obj/conf/cf-parse.tab.c"
    break;

  case 130: /* net_flow4_: FLOW4 '{' flow_builder_init flow_builder_set_ipv4 flow4_opts '}'  */
#line 193 "conf/flowspec.Y"
{
  (yyval.net_ptr) = (net_addr *) flow_builder4_finalize(this_flow, cfg_mem);
  flow4_validate_cf((net_addr_flow4 *) (yyval.net_ptr));
}
#line 6825 "obj/conf/cf-parse.tab.c"
    break;

  case 131: /* net_flow6_: FLOW6 '{' flow_builder_init flow_builder_set_ipv6 flow6_opts '}'  */
#line 199 "conf/flowspec.Y"
{
  (yyval.net_ptr) = (net_addr *) flow_builder6_finalize(this_flow, cfg_mem);
  flow6_validate_cf((net_addr_flow6 *) (yyval.net_ptr));
}
#line 6834 "obj/conf/cf-parse.tab.c"
    break;

  case 141: /* $@1: %empty  */
#line 317 "filter/config.Y"
                 { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, filter, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 6840 "obj/conf/cf-parse.tab.c"
    break;

  case 142: /* filter_def: FILTER symbol $@1 filter_body  */
#line 318 "filter/config.Y"
                 {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .sym = (yyvsp[-2].s), .root = (yyvsp[0].fl) };
     (yyvsp[-2].s)->filter = f;

     cf_pop_scope();
   }
#line 6852 "obj/conf/cf-parse.tab.c"
    break;

  case 144: /* filter_eval: EVAL term  */
#line 329 "filter/config.Y"
             { f_eval_int(f_linearize((yyvsp[0].x))); }
#line 6858 "obj/conf/cf-parse.tab.c"
    break;

  case 146: /* custom_attr: ATTRIBUTE type symbol ';'  */
#line 333 "filter/config.Y"
                                       {
  cf_define_symbol((yyvsp[-1].s), SYM_ATTRIBUTE, attribute, ca_lookup(new_config->pool, (yyvsp[-1].s)->name, (yyvsp[-2].i))->fda);
}
#line 6866 "obj/conf/cf-parse.tab.c"
    break;

  case 148: /* bt_test_suite: BT_TEST_SUITE '(' CF_SYM_KNOWN ',' text ')'  */
#line 339 "filter/config.Y"
                                             {
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-3].s)->function;
  t->fn_name = (yyvsp[-3].s)->name;
  t->dsc = (yyvsp[-1].t);

  add_tail(&new_config->tests, &t->n);
 }
#line 6880 "obj/conf/cf-parse.tab.c"
    break;

  case 150: /* bt_test_same: BT_TEST_SAME '(' CF_SYM_KNOWN ',' CF_SYM_KNOWN ',' NUM ')'  */
#line 352 "filter/config.Y"
                                                            {
  cf_assert_symbol((yyvsp[-5].s), SYM_FUNCTION);
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-5].s)->function;
  t->cmp = (yyvsp[-3].s)->function;
  t->result = (yyvsp[-1].i);
  t->fn_name = (yyvsp[-5].s)->name;
  t->dsc = (yyvsp[-3].s)->name;
  add_tail(&new_config->tests, &t->n);
 }
#line 6896 "obj/conf/cf-parse.tab.c"
    break;

  case 151: /* type: INT  */
#line 366 "filter/config.Y"
       { (yyval.i) = T_INT; }
#line 6902 "obj/conf/cf-parse.tab.c"
    break;

  case 152: /* type: BOOL  */
#line 367 "filter/config.Y"
        { (yyval.i) = T_BOOL; }
#line 6908 "obj/conf/cf-parse.tab.c"
    break;

  case 153: /* type: IP  */
#line 368 "filter/config.Y"
      { (yyval.i) = T_IP; }
#line 6914 "obj/conf/cf-parse.tab.c"
    break;

  case 154: /* type: RD  */
#line 369 "filter/config.Y"
      { (yyval.i) = T_RD; }
#line 6920 "obj/conf/cf-parse.tab.c"
    break;

  case 155: /* type: PREFIX  */
#line 370 "filter/config.Y"
          { (yyval.i) = T_NET; }
#line 6926 "obj/conf/cf-parse.tab.c"
    break;

  case 156: /* type: PAIR  */
#line 371 "filter/config.Y"
        { (yyval.i) = T_PAIR; }
#line 6932 "obj/conf/cf-parse.tab.c"
    break;

  case 157: /* type: QUAD  */
#line 372 "filter/config.Y"
        { (yyval.i) = T_QUAD; }
#line 6938 "obj/conf/cf-parse.tab.c"
    break;

  case 158: /* type: EC  */
#line 373 "filter/config.Y"
      { (yyval.i) = T_EC; }
#line 6944 "obj/conf/cf-parse.tab.c"
    break;

  case 159: /* type: LC  */
#line 374 "filter/config.Y"
      { (yyval.i) = T_LC; }
#line 6950 "obj/conf/cf-parse.tab.c"
    break;

  case 160: /* type: STRING  */
#line 375 "filter/config.Y"
          { (yyval.i) = T_STRING; }
#line 6956 "obj/conf/cf-parse.tab.c"
    break;

  case 161: /* type: BGPMASK  */
#line 376 "filter/config.Y"
           { (yyval.i) = T_PATH_MASK; }
#line 6962 "obj/conf/cf-parse.tab.c"
    break;

  case 162: /* type: BGPPATH  */
#line 377 "filter/config.Y"
           { (yyval.i) = T_PATH; }
#line 6968 "obj/conf/cf-parse.tab.c"
    break;

  case 163: /* type: CLIST  */
#line 378 "filter/config.Y"
         { (yyval.i) = T_CLIST; }
#line 6974 "obj/conf/cf-parse.tab.c"
    break;

  case 164: /* type: ECLIST  */
#line 379 "filter/config.Y"
          { (yyval.i) = T_ECLIST; }
#line 6980 "obj/conf/cf-parse.tab.c"
    break;

  case 165: /* type: LCLIST  */
#line 380 "filter/config.Y"
          { (yyval.i) = T_LCLIST; }
#line 6986 "obj/conf/cf-parse.tab.c"
    break;

  case 166: /* type: type SET  */
#line 381 "filter/config.Y"
            {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_RD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_NET:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 7011 "obj/conf/cf-parse.tab.c"
    break;

  case 168: /* function_argsn: function_argsn type symbol ';'  */
#line 405 "filter/config.Y"
                                  {
     if ((yyvsp[-1].s)->scope->slots >= 0xfe) cf_error("Too many declarations, at most 255 allowed");
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
   }
#line 7020 "obj/conf/cf-parse.tab.c"
    break;

  case 169: /* function_args: '(' ')'  */
#line 412 "filter/config.Y"
           { (yyval.i) = 0; }
#line 7026 "obj/conf/cf-parse.tab.c"
    break;

  case 170: /* function_args: '(' function_argsn type symbol ')'  */
#line 413 "filter/config.Y"
                                      {
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
     (yyval.i) = (yyvsp[-1].s)->scope->slots;
   }
#line 7035 "obj/conf/cf-parse.tab.c"
    break;

  case 171: /* function_vars: %empty  */
#line 420 "filter/config.Y"
               { (yyval.i) = 0; }
#line 7041 "obj/conf/cf-parse.tab.c"
    break;

  case 172: /* function_vars: function_vars type symbol ';'  */
#line 421 "filter/config.Y"
                                 {
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
     (yyval.i) = (yyvsp[-3].i) + 1;
   }
#line 7050 "obj/conf/cf-parse.tab.c"
    break;

  case 174: /* filter: CF_SYM_KNOWN  */
#line 430 "filter/config.Y"
                {
     cf_assert_symbol((yyvsp[0].s), SYM_FILTER);
     (yyval.f) = (yyvsp[0].s)->filter;
   }
#line 7059 "obj/conf/cf-parse.tab.c"
    break;

  case 175: /* filter: filter_body  */
#line 434 "filter/config.Y"
               {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .root = (yyvsp[0].fl) };
     (yyval.f) = f;
   }
#line 7069 "obj/conf/cf-parse.tab.c"
    break;

  case 176: /* where_filter: WHERE term  */
#line 442 "filter/config.Y"
              {
     /* Construct 'IF term THEN { ACCEPT; } ELSE { REJECT; }' */
     (yyval.f) = f_new_where((yyvsp[0].x));
   }
#line 7078 "obj/conf/cf-parse.tab.c"
    break;

  case 177: /* function_body: function_vars '{' cmds '}'  */
#line 449 "filter/config.Y"
                              {
     (yyval.fl) = f_linearize((yyvsp[-1].x));
     (yyval.fl)->vars = (yyvsp[-3].i);
   }
#line 7087 "obj/conf/cf-parse.tab.c"
    break;

  case 179: /* $@2: %empty  */
#line 457 "filter/config.Y"
                   { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, function, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 7096 "obj/conf/cf-parse.tab.c"
    break;

  case 180: /* function_def: FUNCTION symbol $@2 function_args function_body  */
#line 460 "filter/config.Y"
                                 {
     DBG("Definition of function %s with %u args and %u local vars.\n", (yyvsp[-3].s)->name, (yyvsp[-1].i), (yyvsp[0].fl)->vars);
     (yyvsp[0].fl)->args = (yyvsp[-1].i);
     (yyvsp[-3].s)->function = (yyvsp[0].fl);
     cf_pop_scope();
   }
#line 7107 "obj/conf/cf-parse.tab.c"
    break;

  case 181: /* cmds: %empty  */
#line 470 "filter/config.Y"
                  { (yyval.x) = NULL; }
#line 7113 "obj/conf/cf-parse.tab.c"
    break;

  case 182: /* cmds: cmds_int  */
#line 471 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].xp).begin; }
#line 7119 "obj/conf/cf-parse.tab.c"
    break;

  case 183: /* cmd_prep: cmd  */
#line 474 "filter/config.Y"
              {
  (yyval.xp).begin = (yyval.xp).end = (yyvsp[0].x);
  if ((yyvsp[0].x))
    while ((yyval.xp).end->next)
      (yyval.xp).end = (yyval.xp).end->next;
}
#line 7130 "obj/conf/cf-parse.tab.c"
    break;

  case 185: /* cmds_int: cmds_int cmd_prep  */
#line 483 "filter/config.Y"
                     {
  if (!(yyvsp[-1].xp).begin)
    (yyval.xp) = (yyvsp[0].xp);
  else if (!(yyvsp[0].xp).begin)
    (yyval.xp) = (yyvsp[-1].xp);
  else {
    (yyval.xp).begin = (yyvsp[-1].xp).begin;
    (yyval.xp).end = (yyvsp[0].xp).end;
    (yyvsp[-1].xp).end->next = (yyvsp[0].xp).begin;
  }
 }
#line 7146 "obj/conf/cf-parse.tab.c"
    break;

  case 186: /* block: cmd  */
#line 497 "filter/config.Y"
       {
     (yyval.x)=(yyvsp[0].x);
   }
#line 7154 "obj/conf/cf-parse.tab.c"
    break;

  case 187: /* block: '{' cmds '}'  */
#line 500 "filter/config.Y"
                {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 7162 "obj/conf/cf-parse.tab.c"
    break;

  case 188: /* fipa: IP4  */
#line 509 "filter/config.Y"
                          { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip4((yyvsp[0].ip4)); }
#line 7168 "obj/conf/cf-parse.tab.c"
    break;

  case 189: /* fipa: IP6  */
#line 510 "filter/config.Y"
                          { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip6((yyvsp[0].ip6)); }
#line 7174 "obj/conf/cf-parse.tab.c"
    break;

  case 190: /* set_atom: NUM  */
#line 523 "filter/config.Y"
          { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 7180 "obj/conf/cf-parse.tab.c"
    break;

  case 191: /* set_atom: fipa  */
#line 524 "filter/config.Y"
          { (yyval.v) = (yyvsp[0].v); }
#line 7186 "obj/conf/cf-parse.tab.c"
    break;

  case 192: /* set_atom: VPN_RD  */
#line 525 "filter/config.Y"
          { (yyval.v).type = T_RD; (yyval.v).val.ec = (yyvsp[0].i64); }
#line 7192 "obj/conf/cf-parse.tab.c"
    break;

  case 193: /* set_atom: ENUM  */
#line 526 "filter/config.Y"
          { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 7198 "obj/conf/cf-parse.tab.c"
    break;

  case 194: /* set_atom: '(' term ')'  */
#line 527 "filter/config.Y"
                {
     if (f_eval(f_linearize((yyvsp[-1].x)), cfg_mem, &((yyval.v))) > F_RETURN) cf_error("Runtime error");
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 7207 "obj/conf/cf-parse.tab.c"
    break;

  case 195: /* set_atom: CF_SYM_KNOWN  */
#line 531 "filter/config.Y"
                {
     cf_assert_symbol((yyvsp[0].s), SYM_CONSTANT);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(yyvsp[0].s)->val;
   }
#line 7217 "obj/conf/cf-parse.tab.c"
    break;

  case 196: /* switch_atom: NUM  */
#line 539 "filter/config.Y"
         { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 7223 "obj/conf/cf-parse.tab.c"
    break;

  case 197: /* switch_atom: '(' term ')'  */
#line 540 "filter/config.Y"
                { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 7229 "obj/conf/cf-parse.tab.c"
    break;

  case 198: /* switch_atom: fipa  */
#line 541 "filter/config.Y"
         { (yyval.v) = (yyvsp[0].v); }
#line 7235 "obj/conf/cf-parse.tab.c"
    break;

  case 199: /* switch_atom: ENUM  */
#line 542 "filter/config.Y"
         { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 7241 "obj/conf/cf-parse.tab.c"
    break;

  case 200: /* cnum: term  */
#line 546 "filter/config.Y"
        { (yyval.i32) = f_eval_int(f_linearize((yyvsp[0].x))); }
#line 7247 "obj/conf/cf-parse.tab.c"
    break;

  case 201: /* pair_item: '(' cnum ',' cnum ')'  */
#line 549 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7253 "obj/conf/cf-parse.tab.c"
    break;

  case 202: /* pair_item: '(' cnum ',' cnum DDOT cnum ')'  */
#line 550 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7259 "obj/conf/cf-parse.tab.c"
    break;

  case 203: /* pair_item: '(' cnum ',' '*' ')'  */
#line 551 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 7265 "obj/conf/cf-parse.tab.c"
    break;

  case 204: /* pair_item: '(' cnum DDOT cnum ',' cnum ')'  */
#line 552 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7271 "obj/conf/cf-parse.tab.c"
    break;

  case 205: /* pair_item: '(' cnum DDOT cnum ',' cnum DDOT cnum ')'  */
#line 553 "filter/config.Y"
                                             { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7277 "obj/conf/cf-parse.tab.c"
    break;

  case 206: /* pair_item: '(' cnum DDOT cnum ',' '*' ')'  */
#line 554 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 7283 "obj/conf/cf-parse.tab.c"
    break;

  case 207: /* pair_item: '(' '*' ',' cnum ')'  */
#line 555 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7289 "obj/conf/cf-parse.tab.c"
    break;

  case 208: /* pair_item: '(' '*' ',' cnum DDOT cnum ')'  */
#line 556 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7295 "obj/conf/cf-parse.tab.c"
    break;

  case 209: /* pair_item: '(' '*' ',' '*' ')'  */
#line 557 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 7301 "obj/conf/cf-parse.tab.c"
    break;

  case 210: /* pair_item: '(' cnum ',' cnum ')' DDOT '(' cnum ',' cnum ')'  */
#line 559 "filter/config.Y"
   { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 7307 "obj/conf/cf-parse.tab.c"
    break;

  case 211: /* ec_kind: RT  */
#line 563 "filter/config.Y"
      { (yyval.ecs) = EC_RT; }
#line 7313 "obj/conf/cf-parse.tab.c"
    break;

  case 212: /* ec_kind: RO  */
#line 564 "filter/config.Y"
      { (yyval.ecs) = EC_RO; }
#line 7319 "obj/conf/cf-parse.tab.c"
    break;

  case 213: /* ec_kind: UNKNOWN NUM  */
#line 565 "filter/config.Y"
               { (yyval.ecs) = (yyvsp[0].i); }
#line 7325 "obj/conf/cf-parse.tab.c"
    break;

  case 214: /* ec_kind: GENERIC  */
#line 566 "filter/config.Y"
           { (yyval.ecs) = EC_GENERIC; }
#line 7331 "obj/conf/cf-parse.tab.c"
    break;

  case 215: /* ec_item: '(' ec_kind ',' cnum ',' cnum ')'  */
#line 570 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7337 "obj/conf/cf-parse.tab.c"
    break;

  case 216: /* ec_item: '(' ec_kind ',' cnum ',' cnum DDOT cnum ')'  */
#line 571 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-7].ecs), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7343 "obj/conf/cf-parse.tab.c"
    break;

  case 217: /* ec_item: '(' ec_kind ',' cnum ',' '*' ')'  */
#line 572 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 7349 "obj/conf/cf-parse.tab.c"
    break;

  case 218: /* lc_item: '(' cnum ',' cnum ',' cnum ')'  */
#line 576 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7355 "obj/conf/cf-parse.tab.c"
    break;

  case 219: /* lc_item: '(' cnum ',' cnum ',' cnum DDOT cnum ')'  */
#line 577 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7361 "obj/conf/cf-parse.tab.c"
    break;

  case 220: /* lc_item: '(' cnum ',' cnum ',' '*' ')'  */
#line 578 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 7367 "obj/conf/cf-parse.tab.c"
    break;

  case 221: /* lc_item: '(' cnum ',' cnum DDOT cnum ',' '*' ')'  */
#line 579 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 7373 "obj/conf/cf-parse.tab.c"
    break;

  case 222: /* lc_item: '(' cnum ',' '*' ',' '*' ')'  */
#line 580 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 7379 "obj/conf/cf-parse.tab.c"
    break;

  case 223: /* lc_item: '(' cnum DDOT cnum ',' '*' ',' '*' ')'  */
#line 581 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 7385 "obj/conf/cf-parse.tab.c"
    break;

  case 224: /* lc_item: '(' '*' ',' '*' ',' '*' ')'  */
#line 582 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 7391 "obj/conf/cf-parse.tab.c"
    break;

  case 225: /* lc_item: '(' cnum ',' cnum ',' cnum ')' DDOT '(' cnum ',' cnum ',' cnum ')'  */
#line 584 "filter/config.Y"
   { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 7397 "obj/conf/cf-parse.tab.c"
    break;

  case 229: /* set_item: set_atom  */
#line 591 "filter/config.Y"
            { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 7403 "obj/conf/cf-parse.tab.c"
    break;

  case 230: /* set_item: set_atom DDOT set_atom  */
#line 592 "filter/config.Y"
                          { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 7409 "obj/conf/cf-parse.tab.c"
    break;

  case 234: /* switch_item: switch_atom  */
#line 599 "filter/config.Y"
               { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 7415 "obj/conf/cf-parse.tab.c"
    break;

  case 235: /* switch_item: switch_atom DDOT switch_atom  */
#line 600 "filter/config.Y"
                                { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 7421 "obj/conf/cf-parse.tab.c"
    break;

  case 237: /* set_items: set_items ',' set_item  */
#line 605 "filter/config.Y"
                          { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 7427 "obj/conf/cf-parse.tab.c"
    break;

  case 239: /* switch_items: switch_items ',' switch_item  */
#line 610 "filter/config.Y"
                                { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 7433 "obj/conf/cf-parse.tab.c"
    break;

  case 240: /* fprefix: net_ip_  */
#line 614 "filter/config.Y"
                { (yyval.px).net = (yyvsp[0].net); (yyval.px).lo = (yyvsp[0].net).pxlen; (yyval.px).hi = (yyvsp[0].net).pxlen; }
#line 7439 "obj/conf/cf-parse.tab.c"
    break;

  case 241: /* fprefix: net_ip_ '+'  */
#line 615 "filter/config.Y"
                { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = (yyvsp[-1].net).pxlen; (yyval.px).hi = net_max_prefix_length[(yyvsp[-1].net).type]; }
#line 7445 "obj/conf/cf-parse.tab.c"
    break;

  case 242: /* fprefix: net_ip_ '-'  */
#line 616 "filter/config.Y"
                { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = 0; (yyval.px).hi = (yyvsp[-1].net).pxlen; }
#line 7451 "obj/conf/cf-parse.tab.c"
    break;

  case 243: /* fprefix: net_ip_ '{' NUM ',' NUM '}'  */
#line 617 "filter/config.Y"
                               {
     (yyval.px).net = (yyvsp[-5].net); (yyval.px).lo = (yyvsp[-3].i); (yyval.px).hi = (yyvsp[-1].i);
     if (((yyvsp[-3].i) > (yyvsp[-1].i)) || ((yyvsp[-1].i) > net_max_prefix_length[(yyvsp[-5].net).type]))
       cf_error("Invalid prefix pattern range: {%u, %u}", (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 7461 "obj/conf/cf-parse.tab.c"
    break;

  case 244: /* fprefix_set: fprefix  */
#line 625 "filter/config.Y"
           { (yyval.trie) = f_new_trie(cfg_mem, 0); trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi); }
#line 7467 "obj/conf/cf-parse.tab.c"
    break;

  case 245: /* fprefix_set: fprefix_set ',' fprefix  */
#line 626 "filter/config.Y"
                           { (yyval.trie) = (yyvsp[-2].trie); if (!trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi)) cf_error("Mixed IPv4/IPv6 prefixes in prefix set"); }
#line 7473 "obj/conf/cf-parse.tab.c"
    break;

  case 246: /* switch_body: %empty  */
#line 629 "filter/config.Y"
                         { (yyval.e) = NULL; }
#line 7479 "obj/conf/cf-parse.tab.c"
    break;

  case 247: /* switch_body: switch_body switch_items ':' cmds  */
#line 630 "filter/config.Y"
                                      {
     /* Fill data fields */
     struct f_tree *t;
     struct f_line *line = f_linearize((yyvsp[0].x));
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = line;
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 7492 "obj/conf/cf-parse.tab.c"
    break;

  case 248: /* switch_body: switch_body ELSECOL cmds  */
#line 638 "filter/config.Y"
                            {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = f_linearize((yyvsp[0].x));
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 7504 "obj/conf/cf-parse.tab.c"
    break;

  case 249: /* bgp_path_expr: symbol_value  */
#line 648 "filter/config.Y"
                { (yyval.x) = (yyvsp[0].x); }
#line 7510 "obj/conf/cf-parse.tab.c"
    break;

  case 250: /* bgp_path_expr: '(' term ')'  */
#line 649 "filter/config.Y"
                { (yyval.x) = (yyvsp[-1].x); }
#line 7516 "obj/conf/cf-parse.tab.c"
    break;

  case 251: /* bgp_path: PO bgp_path_tail PC  */
#line 653 "filter/config.Y"
                         { (yyval.x) = (yyvsp[-1].x); }
#line 7522 "obj/conf/cf-parse.tab.c"
    break;

  case 252: /* bgp_path_tail: NUM bgp_path_tail  */
#line 657 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .asn = (yyvsp[-1].i), .kind = PM_ASN, }, }); (yyval.x)->next = (yyvsp[0].x);  }
#line 7528 "obj/conf/cf-parse.tab.c"
    break;

  case 253: /* bgp_path_tail: NUM DDOT NUM bgp_path_tail  */
#line 658 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .from = (yyvsp[-3].i), .to = (yyvsp[-1].i), .kind = PM_ASN_RANGE }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7534 "obj/conf/cf-parse.tab.c"
    break;

  case 254: /* bgp_path_tail: '[' set_items ']' bgp_path_tail  */
#line 659 "filter/config.Y"
                                   {
   if ((yyvsp[-2].e)->from.type != T_INT) cf_error("Only integer sets allowed in path mask");
   (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .set = build_tree((yyvsp[-2].e)), .kind = PM_ASN_SET }, }); (yyval.x)->next = (yyvsp[0].x);
 }
#line 7543 "obj/conf/cf-parse.tab.c"
    break;

  case 255: /* bgp_path_tail: '*' bgp_path_tail  */
#line 663 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_ASTERISK }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7549 "obj/conf/cf-parse.tab.c"
    break;

  case 256: /* bgp_path_tail: '?' bgp_path_tail  */
#line 664 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_QUESTION }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7555 "obj/conf/cf-parse.tab.c"
    break;

  case 257: /* bgp_path_tail: '+' bgp_path_tail  */
#line 665 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_LOOP }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7561 "obj/conf/cf-parse.tab.c"
    break;

  case 258: /* bgp_path_tail: bgp_path_expr bgp_path_tail  */
#line 666 "filter/config.Y"
                                { (yyval.x) = (yyvsp[-1].x); (yyval.x)->next = (yyvsp[0].x); }
#line 7567 "obj/conf/cf-parse.tab.c"
    break;

  case 259: /* bgp_path_tail: %empty  */
#line 667 "filter/config.Y"
                                { (yyval.x) = NULL; }
#line 7573 "obj/conf/cf-parse.tab.c"
    break;

  case 260: /* constant: NUM  */
#line 671 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_INT, .val.i = (yyvsp[0].i), }); }
#line 7579 "obj/conf/cf-parse.tab.c"
    break;

  case 261: /* constant: TRUE  */
#line 672 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 1, }); }
#line 7585 "obj/conf/cf-parse.tab.c"
    break;

  case 262: /* constant: FALSE  */
#line 673 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 0, }); }
#line 7591 "obj/conf/cf-parse.tab.c"
    break;

  case 263: /* constant: TEXT  */
#line 674 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_STRING, .val.s = (yyvsp[0].t), }); }
#line 7597 "obj/conf/cf-parse.tab.c"
    break;

  case 264: /* constant: fipa  */
#line 675 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (yyvsp[0].v)); }
#line 7603 "obj/conf/cf-parse.tab.c"
    break;

  case 265: /* constant: VPN_RD  */
#line 676 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_RD, .val.ec = (yyvsp[0].i64), }); }
#line 7609 "obj/conf/cf-parse.tab.c"
    break;

  case 266: /* constant: net_  */
#line 677 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_NET, .val.net = (yyvsp[0].net_ptr), }); }
#line 7615 "obj/conf/cf-parse.tab.c"
    break;

  case 267: /* constant: '[' set_items ']'  */
#line 678 "filter/config.Y"
                     {
     DBG( "We've got a set here..." );
     (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_SET, .val.t = build_tree((yyvsp[-1].e)), });
     DBG( "ook\n" );
 }
#line 7625 "obj/conf/cf-parse.tab.c"
    break;

  case 268: /* constant: '[' fprefix_set ']'  */
#line 683 "filter/config.Y"
                       { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PREFIX_SET, .val.ti = (yyvsp[-1].trie), }); }
#line 7631 "obj/conf/cf-parse.tab.c"
    break;

  case 269: /* constant: ENUM  */
#line 684 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = (yyvsp[0].i) >> 16, .val.i = (yyvsp[0].i) & 0xffff, }); }
#line 7637 "obj/conf/cf-parse.tab.c"
    break;

  case 270: /* constructor: '(' term ',' term ')'  */
#line 688 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_PAIR_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7643 "obj/conf/cf-parse.tab.c"
    break;

  case 271: /* constructor: '(' ec_kind ',' term ',' term ')'  */
#line 689 "filter/config.Y"
                                     { (yyval.x) = f_new_inst(FI_EC_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].ecs)); }
#line 7649 "obj/conf/cf-parse.tab.c"
    break;

  case 272: /* constructor: '(' term ',' term ',' term ')'  */
#line 690 "filter/config.Y"
                                  { (yyval.x) = f_new_inst(FI_LC_CONSTRUCT, (yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7655 "obj/conf/cf-parse.tab.c"
    break;

  case 273: /* constructor: bgp_path  */
#line 691 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_PATHMASK_CONSTRUCT, (yyvsp[0].x)); }
#line 7661 "obj/conf/cf-parse.tab.c"
    break;

  case 274: /* var_list: %empty  */
#line 696 "filter/config.Y"
                      { (yyval.x) = NULL; }
#line 7667 "obj/conf/cf-parse.tab.c"
    break;

  case 275: /* var_list: term  */
#line 697 "filter/config.Y"
        { (yyval.x) = (yyvsp[0].x); }
#line 7673 "obj/conf/cf-parse.tab.c"
    break;

  case 276: /* var_list: var_list ',' term  */
#line 698 "filter/config.Y"
                     { (yyval.x) = (yyvsp[0].x); (yyval.x)->next = (yyvsp[-2].x); }
#line 7679 "obj/conf/cf-parse.tab.c"
    break;

  case 277: /* function_call: CF_SYM_KNOWN '(' var_list ')'  */
#line 701 "filter/config.Y"
                                 {
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");

     struct f_inst *fc = f_new_inst(FI_CALL, (yyvsp[-3].s));
     uint args = 0;
     while ((yyvsp[-1].x)) {
       args++;
       struct f_inst *tmp = (yyvsp[-1].x)->next;
       (yyvsp[-1].x)->next = fc;

       fc = (yyvsp[-1].x);
       (yyvsp[-1].x) = tmp;
     }

     if (args != (yyvsp[-3].s)->function->args)
       cf_error("Function call '%s' got %u arguments, need %u arguments.",
	   (yyvsp[-3].s)->name, args, (yyvsp[-3].s)->function->args);

     (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_VOID });
     (yyval.x)->next = fc;
   }
#line 7706 "obj/conf/cf-parse.tab.c"
    break;

  case 278: /* symbol_value: CF_SYM_KNOWN  */
#line 726 "filter/config.Y"
  {
    switch ((yyvsp[0].s)->class) {
      case SYM_CONSTANT_RANGE:
	(yyval.x) = f_new_inst(FI_CONSTANT, *((yyvsp[0].s)->val));
	break;
      case SYM_VARIABLE_RANGE:
	(yyval.x) = f_new_inst(FI_VAR_GET, (yyvsp[0].s));
	break;
      case SYM_ATTRIBUTE:
	(yyval.x) = f_new_inst(FI_EA_GET, *(yyvsp[0].s)->attribute);
	break;
      default:
	cf_error("Can't get value of symbol %s", (yyvsp[0].s)->name);
    }
  }
#line 7726 "obj/conf/cf-parse.tab.c"
    break;

  case 279: /* static_attr: FROM  */
#line 744 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	0); }
#line 7732 "obj/conf/cf-parse.tab.c"
    break;

  case 280: /* static_attr: GW  */
#line 745 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	0); }
#line 7738 "obj/conf/cf-parse.tab.c"
    break;

  case 281: /* static_attr: NET  */
#line 746 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_NET,	  SA_NET,	1); }
#line 7744 "obj/conf/cf-parse.tab.c"
    break;

  case 282: /* static_attr: PROTO  */
#line 747 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	1); }
#line 7750 "obj/conf/cf-parse.tab.c"
    break;

  case 283: /* static_attr: SOURCE  */
#line 748 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	1); }
#line 7756 "obj/conf/cf-parse.tab.c"
    break;

  case 284: /* static_attr: SCOPE  */
#line 749 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	0); }
#line 7762 "obj/conf/cf-parse.tab.c"
    break;

  case 285: /* static_attr: DEST  */
#line 750 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	0); }
#line 7768 "obj/conf/cf-parse.tab.c"
    break;

  case 286: /* static_attr: IFNAME  */
#line 751 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	0); }
#line 7774 "obj/conf/cf-parse.tab.c"
    break;

  case 287: /* static_attr: IFINDEX  */
#line 752 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	1); }
#line 7780 "obj/conf/cf-parse.tab.c"
    break;

  case 288: /* static_attr: WEIGHT  */
#line 753 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_WEIGHT,	0); }
#line 7786 "obj/conf/cf-parse.tab.c"
    break;

  case 289: /* term: '(' term ')'  */
#line 757 "filter/config.Y"
                        { (yyval.x) = (yyvsp[-1].x); }
#line 7792 "obj/conf/cf-parse.tab.c"
    break;

  case 290: /* term: term '+' term  */
#line 758 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_ADD, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7798 "obj/conf/cf-parse.tab.c"
    break;

  case 291: /* term: term '-' term  */
#line 759 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_SUBTRACT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7804 "obj/conf/cf-parse.tab.c"
    break;

  case 292: /* term: term '*' term  */
#line 760 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_MULTIPLY, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7810 "obj/conf/cf-parse.tab.c"
    break;

  case 293: /* term: term '/' term  */
#line 761 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_DIVIDE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7816 "obj/conf/cf-parse.tab.c"
    break;

  case 294: /* term: term AND term  */
#line 762 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_AND, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7822 "obj/conf/cf-parse.tab.c"
    break;

  case 295: /* term: term OR term  */
#line 763 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_OR, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7828 "obj/conf/cf-parse.tab.c"
    break;

  case 296: /* term: term '=' term  */
#line 764 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_EQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7834 "obj/conf/cf-parse.tab.c"
    break;

  case 297: /* term: term NEQ term  */
#line 765 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NEQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7840 "obj/conf/cf-parse.tab.c"
    break;

  case 298: /* term: term '<' term  */
#line 766 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7846 "obj/conf/cf-parse.tab.c"
    break;

  case 299: /* term: term LEQ term  */
#line 767 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7852 "obj/conf/cf-parse.tab.c"
    break;

  case 300: /* term: term '>' term  */
#line 768 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LT, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 7858 "obj/conf/cf-parse.tab.c"
    break;

  case 301: /* term: term GEQ term  */
#line 769 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 7864 "obj/conf/cf-parse.tab.c"
    break;

  case 302: /* term: term '~' term  */
#line 770 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7870 "obj/conf/cf-parse.tab.c"
    break;

  case 303: /* term: term NMA term  */
#line 771 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NOT_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7876 "obj/conf/cf-parse.tab.c"
    break;

  case 304: /* term: '!' term  */
#line 772 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NOT, (yyvsp[0].x)); }
#line 7882 "obj/conf/cf-parse.tab.c"
    break;

  case 305: /* term: DEFINED '(' term ')'  */
#line 773 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_DEFINED, (yyvsp[-1].x)); }
#line 7888 "obj/conf/cf-parse.tab.c"
    break;

  case 306: /* term: symbol_value  */
#line 775 "filter/config.Y"
                  { (yyval.x) = (yyvsp[0].x); }
#line 7894 "obj/conf/cf-parse.tab.c"
    break;

  case 307: /* term: constant  */
#line 776 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].x); }
#line 7900 "obj/conf/cf-parse.tab.c"
    break;

  case 308: /* term: constructor  */
#line 777 "filter/config.Y"
               { (yyval.x) = (yyvsp[0].x); }
#line 7906 "obj/conf/cf-parse.tab.c"
    break;

  case 309: /* term: PREFERENCE  */
#line 779 "filter/config.Y"
              { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 7912 "obj/conf/cf-parse.tab.c"
    break;

  case 310: /* term: static_attr  */
#line 781 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 7918 "obj/conf/cf-parse.tab.c"
    break;

  case 311: /* term: dynamic_attr  */
#line 783 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_EA_GET, (yyvsp[0].fda)); }
#line 7924 "obj/conf/cf-parse.tab.c"
    break;

  case 312: /* term: term '.' IS_V4  */
#line 785 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_IS_V4, (yyvsp[-2].x)); }
#line 7930 "obj/conf/cf-parse.tab.c"
    break;

  case 313: /* term: term '.' TYPE  */
#line 786 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_TYPE, (yyvsp[-2].x)); }
#line 7936 "obj/conf/cf-parse.tab.c"
    break;

  case 314: /* term: term '.' IP  */
#line 787 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_IP, (yyvsp[-2].x)); }
#line 7942 "obj/conf/cf-parse.tab.c"
    break;

  case 315: /* term: term '.' RD  */
#line 788 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_ROUTE_DISTINGUISHER, (yyvsp[-2].x)); }
#line 7948 "obj/conf/cf-parse.tab.c"
    break;

  case 316: /* term: term '.' LEN  */
#line 789 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_LENGTH, (yyvsp[-2].x)); }
#line 7954 "obj/conf/cf-parse.tab.c"
    break;

  case 317: /* term: term '.' MAXLEN  */
#line 790 "filter/config.Y"
                   { (yyval.x) = f_new_inst(FI_ROA_MAXLEN, (yyvsp[-2].x)); }
#line 7960 "obj/conf/cf-parse.tab.c"
    break;

  case 318: /* term: term '.' ASN  */
#line 791 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_ROA_ASN, (yyvsp[-2].x)); }
#line 7966 "obj/conf/cf-parse.tab.c"
    break;

  case 319: /* term: term '.' SRC  */
#line 792 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_NET_SRC, (yyvsp[-2].x)); }
#line 7972 "obj/conf/cf-parse.tab.c"
    break;

  case 320: /* term: term '.' DST  */
#line 793 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_NET_DST, (yyvsp[-2].x)); }
#line 7978 "obj/conf/cf-parse.tab.c"
    break;

  case 321: /* term: term '.' MASK '(' term ')'  */
#line 794 "filter/config.Y"
                              { (yyval.x) = f_new_inst(FI_IP_MASK, (yyvsp[-5].x), (yyvsp[-1].x)); }
#line 7984 "obj/conf/cf-parse.tab.c"
    break;

  case 322: /* term: term '.' FIRST  */
#line 795 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST, (yyvsp[-2].x)); }
#line 7990 "obj/conf/cf-parse.tab.c"
    break;

  case 323: /* term: term '.' LAST  */
#line 796 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_AS_PATH_LAST, (yyvsp[-2].x)); }
#line 7996 "obj/conf/cf-parse.tab.c"
    break;

  case 324: /* term: term '.' LAST_NONAGGREGATED  */
#line 797 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG, (yyvsp[-2].x)); }
#line 8002 "obj/conf/cf-parse.tab.c"
    break;

  case 325: /* term: '+' EMPTY '+'  */
#line 807 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_path); }
#line 8008 "obj/conf/cf-parse.tab.c"
    break;

  case 326: /* term: '-' EMPTY '-'  */
#line 808 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_clist); }
#line 8014 "obj/conf/cf-parse.tab.c"
    break;

  case 327: /* term: '-' '-' EMPTY '-' '-'  */
#line 809 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_eclist); }
#line 8020 "obj/conf/cf-parse.tab.c"
    break;

  case 328: /* term: '-' '-' '-' EMPTY '-' '-' '-'  */
#line 810 "filter/config.Y"
                                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_lclist); }
#line 8026 "obj/conf/cf-parse.tab.c"
    break;

  case 329: /* term: PREPEND '(' term ',' term ')'  */
#line 811 "filter/config.Y"
                                 { (yyval.x) = f_new_inst(FI_PATH_PREPEND, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8032 "obj/conf/cf-parse.tab.c"
    break;

  case 330: /* term: ADD '(' term ',' term ')'  */
#line 812 "filter/config.Y"
                             { (yyval.x) = f_new_inst(FI_CLIST_ADD, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8038 "obj/conf/cf-parse.tab.c"
    break;

  case 331: /* term: DELETE '(' term ',' term ')'  */
#line 813 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CLIST_DEL, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8044 "obj/conf/cf-parse.tab.c"
    break;

  case 332: /* term: FILTER '(' term ',' term ')'  */
#line 814 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CLIST_FILTER, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8050 "obj/conf/cf-parse.tab.c"
    break;

  case 333: /* term: ROA_CHECK '(' rtable ')'  */
#line 816 "filter/config.Y"
                            { (yyval.x) = f_new_inst(FI_ROA_CHECK_IMPLICIT, (yyvsp[-1].r)); }
#line 8056 "obj/conf/cf-parse.tab.c"
    break;

  case 334: /* term: ROA_CHECK '(' rtable ',' term ',' term ')'  */
#line 817 "filter/config.Y"
                                              { (yyval.x) = f_new_inst(FI_ROA_CHECK_EXPLICIT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].r)); }
#line 8062 "obj/conf/cf-parse.tab.c"
    break;

  case 335: /* term: FORMAT '(' term ')'  */
#line 819 "filter/config.Y"
                       {  (yyval.x) = f_new_inst(FI_FORMAT, (yyvsp[-1].x)); }
#line 8068 "obj/conf/cf-parse.tab.c"
    break;

  case 337: /* break_command: ACCEPT  */
#line 827 "filter/config.Y"
          { (yyval.fret) = F_ACCEPT; }
#line 8074 "obj/conf/cf-parse.tab.c"
    break;

  case 338: /* break_command: REJECT  */
#line 828 "filter/config.Y"
          { (yyval.fret) = F_REJECT; }
#line 8080 "obj/conf/cf-parse.tab.c"
    break;

  case 339: /* break_command: ERROR  */
#line 829 "filter/config.Y"
         { (yyval.fret) = F_ERROR; }
#line 8086 "obj/conf/cf-parse.tab.c"
    break;

  case 340: /* print_list: %empty  */
#line 832 "filter/config.Y"
                        { (yyval.x) = NULL; }
#line 8092 "obj/conf/cf-parse.tab.c"
    break;

  case 341: /* print_list: term  */
#line 833 "filter/config.Y"
        { (yyval.x) = (yyvsp[0].x); }
#line 8098 "obj/conf/cf-parse.tab.c"
    break;

  case 342: /* print_list: term ',' print_list  */
#line 834 "filter/config.Y"
                       {
     ASSERT((yyvsp[-2].x));
     ASSERT((yyvsp[-2].x)->next == NULL);
     (yyvsp[-2].x)->next = (yyvsp[0].x);
     (yyval.x) = (yyvsp[-2].x);
   }
#line 8109 "obj/conf/cf-parse.tab.c"
    break;

  case 343: /* cmd: IF term THEN block  */
#line 843 "filter/config.Y"
                      {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-2].x), (yyvsp[0].x), NULL);
   }
#line 8117 "obj/conf/cf-parse.tab.c"
    break;

  case 344: /* cmd: IF term THEN block ELSE block  */
#line 846 "filter/config.Y"
                                 {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-4].x), (yyvsp[-2].x), (yyvsp[0].x));
   }
#line 8125 "obj/conf/cf-parse.tab.c"
    break;

  case 345: /* cmd: CF_SYM_KNOWN '=' term ';'  */
#line 849 "filter/config.Y"
                             {
     switch ((yyvsp[-3].s)->class) {
       case SYM_VARIABLE_RANGE:
	 (yyval.x) = f_new_inst(FI_VAR_SET, (yyvsp[-1].x), (yyvsp[-3].s));
	 break;
       case SYM_ATTRIBUTE:
	 (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), *(yyvsp[-3].s)->attribute);
	 break;
       default:
	 cf_error("Can't assign to symbol %s", (yyvsp[-3].s)->name);
     }
   }
#line 8142 "obj/conf/cf-parse.tab.c"
    break;

  case 346: /* cmd: RETURN term ';'  */
#line 861 "filter/config.Y"
                   {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN, (yyvsp[-1].x));
   }
#line 8151 "obj/conf/cf-parse.tab.c"
    break;

  case 347: /* cmd: dynamic_attr '=' term ';'  */
#line 865 "filter/config.Y"
                             {
     (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), (yyvsp[-3].fda));
   }
#line 8159 "obj/conf/cf-parse.tab.c"
    break;

  case 348: /* cmd: static_attr '=' term ';'  */
#line 868 "filter/config.Y"
                            {
     if ((yyvsp[-3].fsa).readonly)
       cf_error( "This static attribute is read-only.");
     (yyval.x) = f_new_inst(FI_RTA_SET, (yyvsp[-1].x), (yyvsp[-3].fsa));
   }
#line 8169 "obj/conf/cf-parse.tab.c"
    break;

  case 349: /* cmd: PREFERENCE '=' term ';'  */
#line 873 "filter/config.Y"
                           {
     (yyval.x) = f_new_inst(FI_PREF_SET, (yyvsp[-1].x));
   }
#line 8177 "obj/conf/cf-parse.tab.c"
    break;

  case 350: /* cmd: UNSET '(' dynamic_attr ')' ';'  */
#line 876 "filter/config.Y"
                                  {
     (yyval.x) = f_new_inst(FI_EA_UNSET, (yyvsp[-2].fda));
   }
#line 8185 "obj/conf/cf-parse.tab.c"
    break;

  case 351: /* cmd: break_command print_list ';'  */
#line 879 "filter/config.Y"
                                {
    struct f_inst *breaker = f_new_inst(FI_DIE, (yyvsp[-2].fret));
    if ((yyvsp[-1].x)) {
      struct f_inst *printer = f_new_inst(FI_PRINT, (yyvsp[-1].x));
      struct f_inst *flusher = f_new_inst(FI_FLUSH);
      printer->next = flusher;
      flusher->next = breaker;
      (yyval.x) = printer;
    } else
      (yyval.x) = breaker;
   }
#line 8201 "obj/conf/cf-parse.tab.c"
    break;

  case 352: /* cmd: PRINT print_list ';'  */
#line 890 "filter/config.Y"
                        {
    (yyval.x) = f_new_inst(FI_PRINT, (yyvsp[-1].x));
    (yyval.x)->next = f_new_inst(FI_FLUSH);
   }
#line 8210 "obj/conf/cf-parse.tab.c"
    break;

  case 353: /* cmd: PRINTN print_list ';'  */
#line 894 "filter/config.Y"
                         {
    (yyval.x) = f_new_inst(FI_PRINT, (yyvsp[-1].x));
   }
#line 8218 "obj/conf/cf-parse.tab.c"
    break;

  case 354: /* cmd: function_call ';'  */
#line 897 "filter/config.Y"
                     { (yyval.x) = f_new_inst(FI_DROP_RESULT, (yyvsp[-1].x)); }
#line 8224 "obj/conf/cf-parse.tab.c"
    break;

  case 355: /* cmd: CASE term '{' switch_body '}'  */
#line 898 "filter/config.Y"
                                 {
      (yyval.x) = f_new_inst(FI_SWITCH, (yyvsp[-3].x), build_tree((yyvsp[-1].e)));
   }
#line 8232 "obj/conf/cf-parse.tab.c"
    break;

  case 356: /* cmd: dynamic_attr '.' EMPTY ';'  */
#line 902 "filter/config.Y"
                              { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 8238 "obj/conf/cf-parse.tab.c"
    break;

  case 357: /* cmd: dynamic_attr '.' PREPEND '(' term ')' ';'  */
#line 903 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8244 "obj/conf/cf-parse.tab.c"
    break;

  case 358: /* cmd: dynamic_attr '.' ADD '(' term ')' ';'  */
#line 904 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_ADD, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8250 "obj/conf/cf-parse.tab.c"
    break;

  case 359: /* cmd: dynamic_attr '.' DELETE '(' term ')' ';'  */
#line 905 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_DEL, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8256 "obj/conf/cf-parse.tab.c"
    break;

  case 360: /* cmd: dynamic_attr '.' FILTER '(' term ')' ';'  */
#line 906 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_FILTER, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8262 "obj/conf/cf-parse.tab.c"
    break;

  case 361: /* cmd: BT_ASSERT '(' get_cf_position term get_cf_position ')' ';'  */
#line 907 "filter/config.Y"
                                                              { (yyval.x) = assert_done((yyvsp[-3].x), (yyvsp[-4].t) + 1, (yyvsp[-2].t) - 1); }
#line 8268 "obj/conf/cf-parse.tab.c"
    break;

  case 362: /* cmd: BT_CHECK_ASSIGN '(' get_cf_position lvalue get_cf_position ',' term ')' ';'  */
#line 908 "filter/config.Y"
                                                                               { (yyval.x) = assert_assign(&(yyvsp[-5].flv), (yyvsp[-2].x), (yyvsp[-6].t) + 1, (yyvsp[-4].t) - 1); }
#line 8274 "obj/conf/cf-parse.tab.c"
    break;

  case 363: /* get_cf_position: %empty  */
#line 912 "filter/config.Y"
{
  (yyval.t) = cf_text;
}
#line 8282 "obj/conf/cf-parse.tab.c"
    break;

  case 364: /* lvalue: CF_SYM_KNOWN  */
#line 917 "filter/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_VARIABLE); (yyval.flv) = (struct f_lval) { .type = F_LVAL_VARIABLE, .sym = (yyvsp[0].s) }; }
#line 8288 "obj/conf/cf-parse.tab.c"
    break;

  case 365: /* lvalue: PREFERENCE  */
#line 918 "filter/config.Y"
              { (yyval.flv) = (struct f_lval) { .type = F_LVAL_PREFERENCE }; }
#line 8294 "obj/conf/cf-parse.tab.c"
    break;

  case 366: /* lvalue: static_attr  */
#line 919 "filter/config.Y"
               { (yyval.flv) = (struct f_lval) { .type = F_LVAL_SA, .sa = (yyvsp[0].fsa) }; }
#line 8300 "obj/conf/cf-parse.tab.c"
    break;

  case 367: /* lvalue: dynamic_attr  */
#line 920 "filter/config.Y"
                { (yyval.flv) = (struct f_lval) { .type = F_LVAL_EA, .da = (yyvsp[0].fda) }; }
#line 8306 "obj/conf/cf-parse.tab.c"
    break;

  case 369: /* rtrid: ROUTER ID idval ';'  */
#line 136 "nest/config.Y"
                       { new_config->router_id = (yyvsp[-1].i32); }
#line 8312 "obj/conf/cf-parse.tab.c"
    break;

  case 370: /* rtrid: ROUTER ID FROM iface_patt ';'  */
#line 137 "nest/config.Y"
                                 { new_config->router_id_from = this_ipatt; }
#line 8318 "obj/conf/cf-parse.tab.c"
    break;

  case 371: /* idval: NUM  */
#line 141 "nest/config.Y"
       { (yyval.i32) = (yyvsp[0].i); }
#line 8324 "obj/conf/cf-parse.tab.c"
    break;

  case 372: /* idval: '(' term ')'  */
#line 142 "nest/config.Y"
                { (yyval.i32) = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 8330 "obj/conf/cf-parse.tab.c"
    break;

  case 373: /* idval: IP4  */
#line 143 "nest/config.Y"
       { (yyval.i32) = ip4_to_u32((yyvsp[0].ip4)); }
#line 8336 "obj/conf/cf-parse.tab.c"
    break;

  case 374: /* idval: CF_SYM_KNOWN  */
#line 144 "nest/config.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP)) && ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).ip);
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 8349 "obj/conf/cf-parse.tab.c"
    break;

  case 376: /* hostname_override: HOSTNAME text ';'  */
#line 156 "nest/config.Y"
                                     { new_config->hostname = (yyvsp[-1].t); }
#line 8355 "obj/conf/cf-parse.tab.c"
    break;

  case 378: /* gr_opts: GRACEFUL RESTART WAIT expr ';'  */
#line 160 "nest/config.Y"
                                        { new_config->gr_wait = (yyvsp[-1].i); }
#line 8361 "obj/conf/cf-parse.tab.c"
    break;

  case 379: /* net_type: IPV4  */
#line 166 "nest/config.Y"
        { (yyval.i) = NET_IP4; }
#line 8367 "obj/conf/cf-parse.tab.c"
    break;

  case 380: /* net_type: IPV6  */
#line 167 "nest/config.Y"
        { (yyval.i) = NET_IP6; }
#line 8373 "obj/conf/cf-parse.tab.c"
    break;

  case 381: /* net_type: IPV6 SADR  */
#line 168 "nest/config.Y"
             { (yyval.i) = NET_IP6_SADR; }
#line 8379 "obj/conf/cf-parse.tab.c"
    break;

  case 382: /* net_type: VPN4  */
#line 169 "nest/config.Y"
        { (yyval.i) = NET_VPN4; }
#line 8385 "obj/conf/cf-parse.tab.c"
    break;

  case 383: /* net_type: VPN6  */
#line 170 "nest/config.Y"
        { (yyval.i) = NET_VPN6; }
#line 8391 "obj/conf/cf-parse.tab.c"
    break;

  case 384: /* net_type: ROA4  */
#line 171 "nest/config.Y"
        { (yyval.i) = NET_ROA4; }
#line 8397 "obj/conf/cf-parse.tab.c"
    break;

  case 385: /* net_type: ROA6  */
#line 172 "nest/config.Y"
        { (yyval.i) = NET_ROA6; }
#line 8403 "obj/conf/cf-parse.tab.c"
    break;

  case 386: /* net_type: FLOW4  */
#line 173 "nest/config.Y"
        { (yyval.i) = NET_FLOW4; }
#line 8409 "obj/conf/cf-parse.tab.c"
    break;

  case 387: /* net_type: FLOW6  */
#line 174 "nest/config.Y"
        { (yyval.i) = NET_FLOW6; }
#line 8415 "obj/conf/cf-parse.tab.c"
    break;

  case 388: /* net_type: MPLS  */
#line 175 "nest/config.Y"
        { (yyval.i) = NET_MPLS; }
#line 8421 "obj/conf/cf-parse.tab.c"
    break;

  case 390: /* table_sorted: %empty  */
#line 186 "nest/config.Y"
          { (yyval.i) = 0; }
#line 8427 "obj/conf/cf-parse.tab.c"
    break;

  case 391: /* table_sorted: SORTED  */
#line 187 "nest/config.Y"
          { (yyval.i) = 1; }
#line 8433 "obj/conf/cf-parse.tab.c"
    break;

  case 392: /* table: net_type TABLE symbol table_sorted  */
#line 190 "nest/config.Y"
                                          {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s), (yyvsp[-3].i));
   cf->sorted = (yyvsp[0].i);
   }
#line 8443 "obj/conf/cf-parse.tab.c"
    break;

  case 393: /* conf: proto  */
#line 200 "nest/config.Y"
            { proto_postconfig(); }
#line 8449 "obj/conf/cf-parse.tab.c"
    break;

  case 394: /* proto_start: PROTOCOL  */
#line 203 "nest/config.Y"
            { (yyval.i) = SYM_PROTO; }
#line 8455 "obj/conf/cf-parse.tab.c"
    break;

  case 395: /* proto_start: TEMPLATE  */
#line 204 "nest/config.Y"
            { (yyval.i) = SYM_TEMPLATE; }
#line 8461 "obj/conf/cf-parse.tab.c"
    break;

  case 396: /* proto_name: %empty  */
#line 208 "nest/config.Y"
               {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;
     }
#line 8472 "obj/conf/cf-parse.tab.c"
    break;

  case 397: /* proto_name: symbol  */
#line 214 "nest/config.Y"
          {
     cf_define_symbol((yyvsp[0].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 8481 "obj/conf/cf-parse.tab.c"
    break;

  case 398: /* proto_name: FROM CF_SYM_KNOWN  */
#line 218 "nest/config.Y"
                     {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 8496 "obj/conf/cf-parse.tab.c"
    break;

  case 399: /* proto_name: symbol FROM CF_SYM_KNOWN  */
#line 228 "nest/config.Y"
                            {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 8509 "obj/conf/cf-parse.tab.c"
    break;

  case 401: /* proto_item: DISABLED bool  */
#line 240 "nest/config.Y"
                 { this_proto->disabled = (yyvsp[0].i); }
#line 8515 "obj/conf/cf-parse.tab.c"
    break;

  case 402: /* proto_item: DEBUG debug_mask  */
#line 241 "nest/config.Y"
                    { this_proto->debug = (yyvsp[0].i); }
#line 8521 "obj/conf/cf-parse.tab.c"
    break;

  case 403: /* proto_item: MRTDUMP mrtdump_mask  */
#line 242 "nest/config.Y"
                        { this_proto->mrtdump = (yyvsp[0].i); }
#line 8527 "obj/conf/cf-parse.tab.c"
    break;

  case 404: /* proto_item: ROUTER ID idval  */
#line 243 "nest/config.Y"
                   { this_proto->router_id = (yyvsp[0].i32); }
#line 8533 "obj/conf/cf-parse.tab.c"
    break;

  case 405: /* proto_item: DESCRIPTION text  */
#line 244 "nest/config.Y"
                    { this_proto->dsc = (yyvsp[0].t); }
#line 8539 "obj/conf/cf-parse.tab.c"
    break;

  case 406: /* proto_item: VRF text  */
#line 245 "nest/config.Y"
            { this_proto->vrf = if_get_by_name((yyvsp[0].t)); this_proto->vrf_set = 1; }
#line 8545 "obj/conf/cf-parse.tab.c"
    break;

  case 407: /* proto_item: VRF DEFAULT  */
#line 246 "nest/config.Y"
               { this_proto->vrf = NULL; this_proto->vrf_set = 1; }
#line 8551 "obj/conf/cf-parse.tab.c"
    break;

  case 408: /* channel_start: net_type  */
#line 251 "nest/config.Y"
{
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[0].i)], (yyvsp[0].i), this_proto);
}
#line 8559 "obj/conf/cf-parse.tab.c"
    break;

  case 409: /* channel_item_: TABLE rtable  */
#line 256 "nest/config.Y"
                {
     if (this_channel->net_type && ((yyvsp[0].r)->addr_type != this_channel->net_type))
       cf_error("Incompatible table type");
     this_channel->table = (yyvsp[0].r);
   }
#line 8569 "obj/conf/cf-parse.tab.c"
    break;

  case 410: /* channel_item_: IMPORT imexport  */
#line 261 "nest/config.Y"
                   { this_channel->in_filter = (yyvsp[0].f); }
#line 8575 "obj/conf/cf-parse.tab.c"
    break;

  case 411: /* channel_item_: EXPORT imexport  */
#line 262 "nest/config.Y"
                   { this_channel->out_filter = (yyvsp[0].f); }
#line 8581 "obj/conf/cf-parse.tab.c"
    break;

  case 412: /* channel_item_: RECEIVE LIMIT limit_spec  */
#line 263 "nest/config.Y"
                            { this_channel->rx_limit = (yyvsp[0].cl); }
#line 8587 "obj/conf/cf-parse.tab.c"
    break;

  case 413: /* channel_item_: IMPORT LIMIT limit_spec  */
#line 264 "nest/config.Y"
                           { this_channel->in_limit = (yyvsp[0].cl); }
#line 8593 "obj/conf/cf-parse.tab.c"
    break;

  case 414: /* channel_item_: EXPORT LIMIT limit_spec  */
#line 265 "nest/config.Y"
                           { this_channel->out_limit = (yyvsp[0].cl); }
#line 8599 "obj/conf/cf-parse.tab.c"
    break;

  case 415: /* channel_item_: PREFERENCE expr  */
#line 266 "nest/config.Y"
                   { this_channel->preference = (yyvsp[0].i); check_u16((yyvsp[0].i)); }
#line 8605 "obj/conf/cf-parse.tab.c"
    break;

  case 416: /* channel_item_: IMPORT KEEP FILTERED bool  */
#line 267 "nest/config.Y"
                             { this_channel->in_keep_filtered = (yyvsp[0].i); }
#line 8611 "obj/conf/cf-parse.tab.c"
    break;

  case 417: /* channel_item_: RPKI RELOAD bool  */
#line 268 "nest/config.Y"
                    { this_channel->rpki_reload = (yyvsp[0].i); }
#line 8617 "obj/conf/cf-parse.tab.c"
    break;

  case 419: /* channel_item: DEBUG debug_mask  */
#line 274 "nest/config.Y"
                    { this_channel->debug = (yyvsp[0].i); }
#line 8623 "obj/conf/cf-parse.tab.c"
    break;

  case 424: /* channel_end: %empty  */
#line 288 "nest/config.Y"
{
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 8634 "obj/conf/cf-parse.tab.c"
    break;

  case 426: /* rtable: CF_SYM_KNOWN  */
#line 298 "nest/config.Y"
                     { cf_assert_symbol((yyvsp[0].s), SYM_TABLE); (yyval.r) = (yyvsp[0].s)->table; }
#line 8640 "obj/conf/cf-parse.tab.c"
    break;

  case 427: /* imexport: FILTER filter  */
#line 301 "nest/config.Y"
                 { (yyval.f) = (yyvsp[0].f); }
#line 8646 "obj/conf/cf-parse.tab.c"
    break;

  case 429: /* imexport: ALL  */
#line 303 "nest/config.Y"
       { (yyval.f) = FILTER_ACCEPT; }
#line 8652 "obj/conf/cf-parse.tab.c"
    break;

  case 430: /* imexport: NONE  */
#line 304 "nest/config.Y"
        { (yyval.f) = FILTER_REJECT; }
#line 8658 "obj/conf/cf-parse.tab.c"
    break;

  case 431: /* limit_action: %empty  */
#line 308 "nest/config.Y"
                 { (yyval.i) = PLA_DISABLE; }
#line 8664 "obj/conf/cf-parse.tab.c"
    break;

  case 432: /* limit_action: ACTION WARN  */
#line 309 "nest/config.Y"
               { (yyval.i) = PLA_WARN; }
#line 8670 "obj/conf/cf-parse.tab.c"
    break;

  case 433: /* limit_action: ACTION BLOCK  */
#line 310 "nest/config.Y"
                { (yyval.i) = PLA_BLOCK; }
#line 8676 "obj/conf/cf-parse.tab.c"
    break;

  case 434: /* limit_action: ACTION RESTART  */
#line 311 "nest/config.Y"
                  { (yyval.i) = PLA_RESTART; }
#line 8682 "obj/conf/cf-parse.tab.c"
    break;

  case 435: /* limit_action: ACTION DISABLE  */
#line 312 "nest/config.Y"
                  { (yyval.i) = PLA_DISABLE; }
#line 8688 "obj/conf/cf-parse.tab.c"
    break;

  case 436: /* limit_spec: expr limit_action  */
#line 316 "nest/config.Y"
                     { (yyval.cl) = (struct channel_limit){ .limit = (yyvsp[-1].i), (yyval.cl).action = (yyvsp[0].i) }; }
#line 8694 "obj/conf/cf-parse.tab.c"
    break;

  case 437: /* limit_spec: OFF  */
#line 317 "nest/config.Y"
       { (yyval.cl) = (struct channel_limit){}; }
#line 8700 "obj/conf/cf-parse.tab.c"
    break;

  case 439: /* debug_default: DEBUG PROTOCOLS debug_mask  */
#line 324 "nest/config.Y"
                              { new_config->proto_default_debug = (yyvsp[0].i); }
#line 8706 "obj/conf/cf-parse.tab.c"
    break;

  case 440: /* debug_default: DEBUG CHANNELS debug_mask  */
#line 325 "nest/config.Y"
                             { new_config->channel_default_debug = (yyvsp[0].i); }
#line 8712 "obj/conf/cf-parse.tab.c"
    break;

  case 441: /* debug_default: DEBUG COMMANDS expr  */
#line 326 "nest/config.Y"
                       { new_config->cli_debug = (yyvsp[0].i); }
#line 8718 "obj/conf/cf-parse.tab.c"
    break;

  case 443: /* timeformat_which: ROUTE  */
#line 334 "nest/config.Y"
         { (yyval.tf) = &new_config->tf_route; }
#line 8724 "obj/conf/cf-parse.tab.c"
    break;

  case 444: /* timeformat_which: PROTOCOL  */
#line 335 "nest/config.Y"
            { (yyval.tf) = &new_config->tf_proto; }
#line 8730 "obj/conf/cf-parse.tab.c"
    break;

  case 445: /* timeformat_which: BASE  */
#line 336 "nest/config.Y"
        { (yyval.tf) = &new_config->tf_base; }
#line 8736 "obj/conf/cf-parse.tab.c"
    break;

  case 446: /* timeformat_which: LOG  */
#line 337 "nest/config.Y"
       { (yyval.tf) = &new_config->tf_log; }
#line 8742 "obj/conf/cf-parse.tab.c"
    break;

  case 447: /* timeformat_spec: timeformat_which TEXT  */
#line 341 "nest/config.Y"
                         { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 8748 "obj/conf/cf-parse.tab.c"
    break;

  case 448: /* timeformat_spec: timeformat_which TEXT expr TEXT  */
#line 342 "nest/config.Y"
                                   { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (s64) (yyvsp[-1].i) S_}; }
#line 8754 "obj/conf/cf-parse.tab.c"
    break;

  case 449: /* timeformat_spec: timeformat_which ISO SHORT  */
#line 343 "nest/config.Y"
                                 { *(yyvsp[-2].tf) = TM_ISO_SHORT_S; }
#line 8760 "obj/conf/cf-parse.tab.c"
    break;

  case 450: /* timeformat_spec: timeformat_which ISO SHORT MS  */
#line 344 "nest/config.Y"
                                 { *(yyvsp[-3].tf) = TM_ISO_SHORT_MS; }
#line 8766 "obj/conf/cf-parse.tab.c"
    break;

  case 451: /* timeformat_spec: timeformat_which ISO SHORT US  */
#line 345 "nest/config.Y"
                                 { *(yyvsp[-3].tf) = TM_ISO_SHORT_US; }
#line 8772 "obj/conf/cf-parse.tab.c"
    break;

  case 452: /* timeformat_spec: timeformat_which ISO LONG  */
#line 346 "nest/config.Y"
                                { *(yyvsp[-2].tf) = TM_ISO_LONG_S; }
#line 8778 "obj/conf/cf-parse.tab.c"
    break;

  case 453: /* timeformat_spec: timeformat_which ISO LONG MS  */
#line 347 "nest/config.Y"
                                { *(yyvsp[-3].tf) = TM_ISO_LONG_MS; }
#line 8784 "obj/conf/cf-parse.tab.c"
    break;

  case 454: /* timeformat_spec: timeformat_which ISO LONG US  */
#line 348 "nest/config.Y"
                                { *(yyvsp[-3].tf) = TM_ISO_LONG_US; }
#line 8790 "obj/conf/cf-parse.tab.c"
    break;

  case 456: /* iface_patt_node_init: %empty  */
#line 359 "nest/config.Y"
               {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 8800 "obj/conf/cf-parse.tab.c"
    break;

  case 457: /* iface_patt_node_body: TEXT  */
#line 367 "nest/config.Y"
        { this_ipn->pattern = (yyvsp[0].t); /* this_ipn->prefix stays zero */ }
#line 8806 "obj/conf/cf-parse.tab.c"
    break;

  case 458: /* iface_patt_node_body: opttext net_or_ipa  */
#line 368 "nest/config.Y"
                      { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].net); }
#line 8812 "obj/conf/cf-parse.tab.c"
    break;

  case 459: /* iface_negate: %empty  */
#line 372 "nest/config.Y"
       { this_ipn->positive = 1; }
#line 8818 "obj/conf/cf-parse.tab.c"
    break;

  case 460: /* iface_negate: '-'  */
#line 373 "nest/config.Y"
       { this_ipn->positive = 0; }
#line 8824 "obj/conf/cf-parse.tab.c"
    break;

  case 464: /* iface_patt_list_nopx: iface_patt_list  */
#line 387 "nest/config.Y"
                                      { iface_patt_check(); }
#line 8830 "obj/conf/cf-parse.tab.c"
    break;

  case 465: /* iface_patt_init: %empty  */
#line 389 "nest/config.Y"
                 {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 8840 "obj/conf/cf-parse.tab.c"
    break;

  case 467: /* tos: CLASS expr  */
#line 401 "nest/config.Y"
              { (yyval.i) = (yyvsp[0].i) & 0xfc;        if ((yyvsp[0].i) > 255) cf_error("TX class must be in range 0-255"); }
#line 8846 "obj/conf/cf-parse.tab.c"
    break;

  case 468: /* tos: DSCP expr  */
#line 402 "nest/config.Y"
              { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if ((yyvsp[0].i) > 63)  cf_error("TX DSCP must be in range 0-63"); }
#line 8852 "obj/conf/cf-parse.tab.c"
    break;

  case 470: /* dev_proto_start: proto_start DIRECT  */
#line 409 "nest/config.Y"
                                    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 8861 "obj/conf/cf-parse.tab.c"
    break;

  case 475: /* dev_proto: dev_proto CHECK LINK bool ';'  */
#line 420 "nest/config.Y"
                                 { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 8867 "obj/conf/cf-parse.tab.c"
    break;

  case 476: /* dev_iface_init: %empty  */
#line 424 "nest/config.Y"
               {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 8877 "obj/conf/cf-parse.tab.c"
    break;

  case 478: /* debug_mask: ALL  */
#line 438 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 8883 "obj/conf/cf-parse.tab.c"
    break;

  case 479: /* debug_mask: OFF  */
#line 439 "nest/config.Y"
       { (yyval.i) = 0; }
#line 8889 "obj/conf/cf-parse.tab.c"
    break;

  case 480: /* debug_mask: '{' debug_list '}'  */
#line 440 "nest/config.Y"
                      { (yyval.i) = (yyvsp[-1].i); }
#line 8895 "obj/conf/cf-parse.tab.c"
    break;

  case 482: /* debug_list: debug_list ',' debug_flag  */
#line 445 "nest/config.Y"
                             { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 8901 "obj/conf/cf-parse.tab.c"
    break;

  case 483: /* debug_flag: STATES  */
#line 449 "nest/config.Y"
                { (yyval.i) = D_STATES; }
#line 8907 "obj/conf/cf-parse.tab.c"
    break;

  case 484: /* debug_flag: ROUTES  */
#line 450 "nest/config.Y"
                { (yyval.i) = D_ROUTES; }
#line 8913 "obj/conf/cf-parse.tab.c"
    break;

  case 485: /* debug_flag: FILTERS  */
#line 451 "nest/config.Y"
                { (yyval.i) = D_FILTERS; }
#line 8919 "obj/conf/cf-parse.tab.c"
    break;

  case 486: /* debug_flag: INTERFACES  */
#line 452 "nest/config.Y"
                { (yyval.i) = D_IFACES; }
#line 8925 "obj/conf/cf-parse.tab.c"
    break;

  case 487: /* debug_flag: EVENTS  */
#line 453 "nest/config.Y"
                { (yyval.i) = D_EVENTS; }
#line 8931 "obj/conf/cf-parse.tab.c"
    break;

  case 488: /* debug_flag: PACKETS  */
#line 454 "nest/config.Y"
                { (yyval.i) = D_PACKETS; }
#line 8937 "obj/conf/cf-parse.tab.c"
    break;

  case 489: /* mrtdump_mask: ALL  */
#line 460 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 8943 "obj/conf/cf-parse.tab.c"
    break;

  case 490: /* mrtdump_mask: OFF  */
#line 461 "nest/config.Y"
       { (yyval.i) = 0; }
#line 8949 "obj/conf/cf-parse.tab.c"
    break;

  case 491: /* mrtdump_mask: '{' mrtdump_list '}'  */
#line 462 "nest/config.Y"
                        { (yyval.i) = (yyvsp[-1].i); }
#line 8955 "obj/conf/cf-parse.tab.c"
    break;

  case 493: /* mrtdump_list: mrtdump_list ',' mrtdump_flag  */
#line 467 "nest/config.Y"
                                 { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 8961 "obj/conf/cf-parse.tab.c"
    break;

  case 494: /* mrtdump_flag: STATES  */
#line 471 "nest/config.Y"
                { (yyval.i) = MD_STATES; }
#line 8967 "obj/conf/cf-parse.tab.c"
    break;

  case 495: /* mrtdump_flag: MESSAGES  */
#line 472 "nest/config.Y"
                { (yyval.i) = MD_MESSAGES; }
#line 8973 "obj/conf/cf-parse.tab.c"
    break;

  case 502: /* password_item_begin: PASSWORD text  */
#line 493 "nest/config.Y"
                 {
     if (!this_p_list) {
	this_p_list = cfg_allocz(sizeof(list));
	init_list(this_p_list);
	password_id = 1;
     }
     this_p_item = cfg_allocz(sizeof(struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 8995 "obj/conf/cf-parse.tab.c"
    break;

  case 503: /* password_item_params: %empty  */
#line 513 "nest/config.Y"
               { }
#line 9001 "obj/conf/cf-parse.tab.c"
    break;

  case 504: /* password_item_params: GENERATE FROM time ';' password_item_params  */
#line 514 "nest/config.Y"
                                               { this_p_item->genfrom = (yyvsp[-2].time); }
#line 9007 "obj/conf/cf-parse.tab.c"
    break;

  case 505: /* password_item_params: GENERATE TO time ';' password_item_params  */
#line 515 "nest/config.Y"
                                             { this_p_item->gento = (yyvsp[-2].time); }
#line 9013 "obj/conf/cf-parse.tab.c"
    break;

  case 506: /* password_item_params: ACCEPT FROM time ';' password_item_params  */
#line 516 "nest/config.Y"
                                             { this_p_item->accfrom = (yyvsp[-2].time); }
#line 9019 "obj/conf/cf-parse.tab.c"
    break;

  case 507: /* password_item_params: ACCEPT TO time ';' password_item_params  */
#line 517 "nest/config.Y"
                                           { this_p_item->accto = (yyvsp[-2].time); }
#line 9025 "obj/conf/cf-parse.tab.c"
    break;

  case 508: /* password_item_params: FROM time ';' password_item_params  */
#line 518 "nest/config.Y"
                                      { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 9031 "obj/conf/cf-parse.tab.c"
    break;

  case 509: /* password_item_params: TO time ';' password_item_params  */
#line 519 "nest/config.Y"
                                    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 9037 "obj/conf/cf-parse.tab.c"
    break;

  case 510: /* password_item_params: ID expr ';' password_item_params  */
#line 520 "nest/config.Y"
                                    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) > 255) cf_error("Password ID must be in range 0-255"); }
#line 9043 "obj/conf/cf-parse.tab.c"
    break;

  case 511: /* password_item_params: ALGORITHM password_algorithm ';' password_item_params  */
#line 521 "nest/config.Y"
                                                         { this_p_item->alg = (yyvsp[-2].i); }
#line 9049 "obj/conf/cf-parse.tab.c"
    break;

  case 512: /* password_algorithm: KEYED MD5  */
#line 525 "nest/config.Y"
                { (yyval.i) = ALG_MD5; }
#line 9055 "obj/conf/cf-parse.tab.c"
    break;

  case 513: /* password_algorithm: KEYED SHA1  */
#line 526 "nest/config.Y"
                { (yyval.i) = ALG_SHA1; }
#line 9061 "obj/conf/cf-parse.tab.c"
    break;

  case 514: /* password_algorithm: KEYED SHA256  */
#line 527 "nest/config.Y"
                { (yyval.i) = ALG_SHA256; }
#line 9067 "obj/conf/cf-parse.tab.c"
    break;

  case 515: /* password_algorithm: KEYED SHA384  */
#line 528 "nest/config.Y"
                { (yyval.i) = ALG_SHA384; }
#line 9073 "obj/conf/cf-parse.tab.c"
    break;

  case 516: /* password_algorithm: KEYED SHA512  */
#line 529 "nest/config.Y"
                { (yyval.i) = ALG_SHA512; }
#line 9079 "obj/conf/cf-parse.tab.c"
    break;

  case 517: /* password_algorithm: HMAC MD5  */
#line 530 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_MD5; }
#line 9085 "obj/conf/cf-parse.tab.c"
    break;

  case 518: /* password_algorithm: HMAC SHA1  */
#line 531 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA1; }
#line 9091 "obj/conf/cf-parse.tab.c"
    break;

  case 519: /* password_algorithm: HMAC SHA256  */
#line 532 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA256; }
#line 9097 "obj/conf/cf-parse.tab.c"
    break;

  case 520: /* password_algorithm: HMAC SHA384  */
#line 533 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA384; }
#line 9103 "obj/conf/cf-parse.tab.c"
    break;

  case 521: /* password_algorithm: HMAC SHA512  */
#line 534 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA512; }
#line 9109 "obj/conf/cf-parse.tab.c"
    break;

  case 522: /* bfd_item: INTERVAL expr_us  */
#line 541 "nest/config.Y"
                    { this_bfd_opts->min_rx_int = this_bfd_opts->min_tx_int = (yyvsp[0].time); }
#line 9115 "obj/conf/cf-parse.tab.c"
    break;

  case 523: /* bfd_item: MIN RX INTERVAL expr_us  */
#line 542 "nest/config.Y"
                           { this_bfd_opts->min_rx_int = (yyvsp[0].time); }
#line 9121 "obj/conf/cf-parse.tab.c"
    break;

  case 524: /* bfd_item: MIN TX INTERVAL expr_us  */
#line 543 "nest/config.Y"
                           { this_bfd_opts->min_tx_int = (yyvsp[0].time); }
#line 9127 "obj/conf/cf-parse.tab.c"
    break;

  case 525: /* bfd_item: IDLE TX INTERVAL expr_us  */
#line 544 "nest/config.Y"
                            { this_bfd_opts->idle_tx_int = (yyvsp[0].time); }
#line 9133 "obj/conf/cf-parse.tab.c"
    break;

  case 526: /* bfd_item: MULTIPLIER expr  */
#line 545 "nest/config.Y"
                   { this_bfd_opts->multiplier = (yyvsp[0].i); }
#line 9139 "obj/conf/cf-parse.tab.c"
    break;

  case 527: /* bfd_item: PASSIVE bool  */
#line 546 "nest/config.Y"
                { this_bfd_opts->passive = (yyvsp[0].i); this_bfd_opts->passive_set = 1; }
#line 9145 "obj/conf/cf-parse.tab.c"
    break;

  case 528: /* bfd_item: GRACEFUL  */
#line 547 "nest/config.Y"
            { this_bfd_opts->mode = BGP_BFD_GRACEFUL; }
#line 9151 "obj/conf/cf-parse.tab.c"
    break;

  case 533: /* cmd_SHOW_STATUS: SHOW STATUS END  */
#line 563 "nest/config.Y"
{ cmd_show_status(); }
#line 9157 "obj/conf/cf-parse.tab.c"
    break;

  case 535: /* cmd_SHOW_MEMORY: SHOW MEMORY END  */
#line 566 "nest/config.Y"
{ cmd_show_memory(); }
#line 9163 "obj/conf/cf-parse.tab.c"
    break;

  case 537: /* cmd_SHOW_PROTOCOLS: SHOW PROTOCOLS proto_patt2 END  */
#line 569 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 9169 "obj/conf/cf-parse.tab.c"
    break;

  case 539: /* cmd_SHOW_PROTOCOLS_ALL: SHOW PROTOCOLS ALL proto_patt2 END  */
#line 572 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 9175 "obj/conf/cf-parse.tab.c"
    break;

  case 540: /* optproto: CF_SYM_KNOWN  */
#line 575 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.s) = (yyvsp[0].s); }
#line 9181 "obj/conf/cf-parse.tab.c"
    break;

  case 541: /* optproto: %empty  */
#line 576 "nest/config.Y"
               { (yyval.s) = NULL; }
#line 9187 "obj/conf/cf-parse.tab.c"
    break;

  case 543: /* cmd_SHOW_INTERFACES: SHOW INTERFACES END  */
#line 580 "nest/config.Y"
{ if_show(); }
#line 9193 "obj/conf/cf-parse.tab.c"
    break;

  case 545: /* cmd_SHOW_INTERFACES_SUMMARY: SHOW INTERFACES SUMMARY END  */
#line 583 "nest/config.Y"
{ if_show_summary(); }
#line 9199 "obj/conf/cf-parse.tab.c"
    break;

  case 547: /* cmd_SHOW_ROUTE: SHOW ROUTE r_args END  */
#line 587 "nest/config.Y"
{ rt_show((yyvsp[-1].ra)); }
#line 9205 "obj/conf/cf-parse.tab.c"
    break;

  case 548: /* r_args: %empty  */
#line 590 "nest/config.Y"
               {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     init_list(&((yyval.ra)->tables));
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->running_on_config = new_config->fallback;
   }
#line 9216 "obj/conf/cf-parse.tab.c"
    break;

  case 549: /* r_args: r_args net_any  */
#line 596 "nest/config.Y"
                  {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
   }
#line 9226 "obj/conf/cf-parse.tab.c"
    break;

  case 550: /* r_args: r_args FOR r_args_for  */
#line 601 "nest/config.Y"
                         {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->show_for = 1;
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
   }
#line 9237 "obj/conf/cf-parse.tab.c"
    break;

  case 551: /* r_args: r_args TABLE CF_SYM_KNOWN  */
#line 607 "nest/config.Y"
                             {
     cf_assert_symbol((yyvsp[0].s), SYM_TABLE);
     (yyval.ra) = (yyvsp[-2].ra);
     rt_show_add_table((yyval.ra), (yyvsp[0].s)->table->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9248 "obj/conf/cf-parse.tab.c"
    break;

  case 552: /* r_args: r_args TABLE ALL  */
#line 613 "nest/config.Y"
                    {
     struct rtable_config *t;
     (yyval.ra) = (yyvsp[-2].ra);
     WALK_LIST(t, config->tables)
       rt_show_add_table((yyval.ra), t->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_ALL;
   }
#line 9260 "obj/conf/cf-parse.tab.c"
    break;

  case 553: /* r_args: r_args IMPORT TABLE channel_arg  */
#line 620 "nest/config.Y"
                                   {
     if (!(yyvsp[0].c)->in_table) cf_error("No import table in channel %s.%s", (yyvsp[0].c)->proto->name, (yyvsp[0].c)->name);
     rt_show_add_table((yyval.ra), (yyvsp[0].c)->in_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9270 "obj/conf/cf-parse.tab.c"
    break;

  case 554: /* r_args: r_args EXPORT TABLE channel_arg  */
#line 625 "nest/config.Y"
                                   {
     if (!(yyvsp[0].c)->out_table) cf_error("No export table in channel %s.%s", (yyvsp[0].c)->proto->name, (yyvsp[0].c)->name);
     rt_show_add_table((yyval.ra), (yyvsp[0].c)->out_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9280 "obj/conf/cf-parse.tab.c"
    break;

  case 555: /* r_args: r_args FILTER filter  */
#line 630 "nest/config.Y"
                        {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 9290 "obj/conf/cf-parse.tab.c"
    break;

  case 556: /* r_args: r_args where_filter  */
#line 635 "nest/config.Y"
                       {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 9300 "obj/conf/cf-parse.tab.c"
    break;

  case 557: /* r_args: r_args ALL  */
#line 640 "nest/config.Y"
              {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 9309 "obj/conf/cf-parse.tab.c"
    break;

  case 558: /* r_args: r_args PRIMARY  */
#line 644 "nest/config.Y"
                  {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 9318 "obj/conf/cf-parse.tab.c"
    break;

  case 559: /* r_args: r_args FILTERED  */
#line 648 "nest/config.Y"
                   {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 9327 "obj/conf/cf-parse.tab.c"
    break;

  case 560: /* r_args: r_args export_mode CF_SYM_KNOWN  */
#line 652 "nest/config.Y"
                                   {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9342 "obj/conf/cf-parse.tab.c"
    break;

  case 561: /* r_args: r_args export_mode channel_arg  */
#line 662 "nest/config.Y"
                                  {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_channel = (yyvsp[0].c);
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9354 "obj/conf/cf-parse.tab.c"
    break;

  case 562: /* r_args: r_args PROTOCOL CF_SYM_KNOWN  */
#line 669 "nest/config.Y"
                                {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9368 "obj/conf/cf-parse.tab.c"
    break;

  case 563: /* r_args: r_args STATS  */
#line 678 "nest/config.Y"
                {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 9377 "obj/conf/cf-parse.tab.c"
    break;

  case 564: /* r_args: r_args COUNT  */
#line 682 "nest/config.Y"
                {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 9386 "obj/conf/cf-parse.tab.c"
    break;

  case 565: /* r_args_for: r_args_for_val  */
#line 689 "nest/config.Y"
                 {
    (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length);
    net_copy((yyval.net_ptr), &(yyvsp[0].net));
  }
#line 9395 "obj/conf/cf-parse.tab.c"
    break;

  case 569: /* r_args_for: VPN_RD IP4  */
#line 696 "nest/config.Y"
              {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
    net_fill_vpn4((yyval.net_ptr), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 9404 "obj/conf/cf-parse.tab.c"
    break;

  case 570: /* r_args_for: VPN_RD IP6  */
#line 700 "nest/config.Y"
              {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
    net_fill_vpn6((yyval.net_ptr), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 9413 "obj/conf/cf-parse.tab.c"
    break;

  case 571: /* r_args_for: IP6 FROM IP6  */
#line 704 "nest/config.Y"
                {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
    net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-2].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH);
  }
#line 9422 "obj/conf/cf-parse.tab.c"
    break;

  case 572: /* r_args_for: CF_SYM_KNOWN  */
#line 708 "nest/config.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
     {
       (yyval.net_ptr) = cfg_alloc(ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip) ? sizeof(net_addr_ip4) : sizeof(net_addr_ip6));
       net_fill_ip_host((yyval.net_ptr), SYM_VAL((yyvsp[0].s)).ip);
     }
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_type_match(SYM_VAL((yyvsp[0].s)).net, NB_IP | NB_VPN))
       (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
     else
       cf_error("IP address or network constant expected");
   }
#line 9438 "obj/conf/cf-parse.tab.c"
    break;

  case 575: /* r_args_for_val: IP4  */
#line 724 "nest/config.Y"
       { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 9444 "obj/conf/cf-parse.tab.c"
    break;

  case 576: /* r_args_for_val: IP6  */
#line 725 "nest/config.Y"
       { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 9450 "obj/conf/cf-parse.tab.c"
    break;

  case 577: /* export_mode: PREEXPORT  */
#line 728 "nest/config.Y"
                { (yyval.i) = RSEM_PREEXPORT; }
#line 9456 "obj/conf/cf-parse.tab.c"
    break;

  case 578: /* export_mode: EXPORT  */
#line 729 "nest/config.Y"
                { (yyval.i) = RSEM_EXPORT; }
#line 9462 "obj/conf/cf-parse.tab.c"
    break;

  case 579: /* export_mode: NOEXPORT  */
#line 730 "nest/config.Y"
                { (yyval.i) = RSEM_NOEXPORT; }
#line 9468 "obj/conf/cf-parse.tab.c"
    break;

  case 580: /* export_mode: EXPORTED  */
#line 731 "nest/config.Y"
                { (yyval.i) = RSEM_EXPORTED; }
#line 9474 "obj/conf/cf-parse.tab.c"
    break;

  case 581: /* channel_sym: IPV4  */
#line 736 "nest/config.Y"
                { (yyval.t) = "ipv4"; }
#line 9480 "obj/conf/cf-parse.tab.c"
    break;

  case 582: /* channel_sym: IPV4_MC  */
#line 737 "nest/config.Y"
                { (yyval.t) = "ipv4-mc"; }
#line 9486 "obj/conf/cf-parse.tab.c"
    break;

  case 583: /* channel_sym: IPV4_MPLS  */
#line 738 "nest/config.Y"
                { (yyval.t) = "ipv4-mpls"; }
#line 9492 "obj/conf/cf-parse.tab.c"
    break;

  case 584: /* channel_sym: IPV6  */
#line 739 "nest/config.Y"
                { (yyval.t) = "ipv6"; }
#line 9498 "obj/conf/cf-parse.tab.c"
    break;

  case 585: /* channel_sym: IPV6_MC  */
#line 740 "nest/config.Y"
                { (yyval.t) = "ipv6-mc"; }
#line 9504 "obj/conf/cf-parse.tab.c"
    break;

  case 586: /* channel_sym: IPV6_MPLS  */
#line 741 "nest/config.Y"
                { (yyval.t) = "ipv6-mpls"; }
#line 9510 "obj/conf/cf-parse.tab.c"
    break;

  case 587: /* channel_sym: IPV6_SADR  */
#line 742 "nest/config.Y"
                { (yyval.t) = "ipv6-sadr"; }
#line 9516 "obj/conf/cf-parse.tab.c"
    break;

  case 588: /* channel_sym: VPN4  */
#line 743 "nest/config.Y"
                { (yyval.t) = "vpn4"; }
#line 9522 "obj/conf/cf-parse.tab.c"
    break;

  case 589: /* channel_sym: VPN4_MC  */
#line 744 "nest/config.Y"
                { (yyval.t) = "vpn4-mc"; }
#line 9528 "obj/conf/cf-parse.tab.c"
    break;

  case 590: /* channel_sym: VPN4_MPLS  */
#line 745 "nest/config.Y"
                { (yyval.t) = "vpn4-mpls"; }
#line 9534 "obj/conf/cf-parse.tab.c"
    break;

  case 591: /* channel_sym: VPN6  */
#line 746 "nest/config.Y"
                { (yyval.t) = "vpn6"; }
#line 9540 "obj/conf/cf-parse.tab.c"
    break;

  case 592: /* channel_sym: VPN6_MC  */
#line 747 "nest/config.Y"
                { (yyval.t) = "vpn6-mc"; }
#line 9546 "obj/conf/cf-parse.tab.c"
    break;

  case 593: /* channel_sym: VPN6_MPLS  */
#line 748 "nest/config.Y"
                { (yyval.t) = "vpn6-mpls"; }
#line 9552 "obj/conf/cf-parse.tab.c"
    break;

  case 594: /* channel_sym: ROA4  */
#line 749 "nest/config.Y"
                { (yyval.t) = "roa4"; }
#line 9558 "obj/conf/cf-parse.tab.c"
    break;

  case 595: /* channel_sym: ROA6  */
#line 750 "nest/config.Y"
                { (yyval.t) = "roa6"; }
#line 9564 "obj/conf/cf-parse.tab.c"
    break;

  case 596: /* channel_sym: FLOW4  */
#line 751 "nest/config.Y"
                { (yyval.t) = "flow4"; }
#line 9570 "obj/conf/cf-parse.tab.c"
    break;

  case 597: /* channel_sym: FLOW6  */
#line 752 "nest/config.Y"
                { (yyval.t) = "flow6"; }
#line 9576 "obj/conf/cf-parse.tab.c"
    break;

  case 598: /* channel_sym: MPLS  */
#line 753 "nest/config.Y"
                { (yyval.t) = "mpls"; }
#line 9582 "obj/conf/cf-parse.tab.c"
    break;

  case 599: /* channel_sym: PRI  */
#line 754 "nest/config.Y"
                { (yyval.t) = "pri"; }
#line 9588 "obj/conf/cf-parse.tab.c"
    break;

  case 600: /* channel_sym: SEC  */
#line 755 "nest/config.Y"
                { (yyval.t) = "sec"; }
#line 9594 "obj/conf/cf-parse.tab.c"
    break;

  case 601: /* channel_arg: CF_SYM_KNOWN '.' channel_sym  */
#line 759 "nest/config.Y"
                                {
     cf_assert_symbol((yyvsp[-2].s), SYM_PROTO);
     struct proto *p =  (yyvsp[-2].s)->proto->proto;
     if (!p) cf_error("%s is not a protocol", (yyvsp[-2].s)->name);
     (yyval.c) = proto_find_channel_by_name(p, (yyvsp[0].t));
     if (!(yyval.c)) cf_error("Channel %s.%s not found", (yyvsp[-2].s)->name, (yyvsp[0].t));
   }
#line 9606 "obj/conf/cf-parse.tab.c"
    break;

  case 603: /* cmd_SHOW_SYMBOLS: SHOW SYMBOLS sym_args END  */
#line 770 "nest/config.Y"
{ cmd_show_symbols((yyvsp[-1].sd)); }
#line 9612 "obj/conf/cf-parse.tab.c"
    break;

  case 604: /* sym_args: %empty  */
#line 773 "nest/config.Y"
               {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 9620 "obj/conf/cf-parse.tab.c"
    break;

  case 605: /* sym_args: sym_args TABLE  */
#line 776 "nest/config.Y"
                  { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 9626 "obj/conf/cf-parse.tab.c"
    break;

  case 606: /* sym_args: sym_args FUNCTION  */
#line 777 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 9632 "obj/conf/cf-parse.tab.c"
    break;

  case 607: /* sym_args: sym_args FILTER  */
#line 778 "nest/config.Y"
                   { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 9638 "obj/conf/cf-parse.tab.c"
    break;

  case 608: /* sym_args: sym_args PROTOCOL  */
#line 779 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 9644 "obj/conf/cf-parse.tab.c"
    break;

  case 609: /* sym_args: sym_args TEMPLATE  */
#line 780 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 9650 "obj/conf/cf-parse.tab.c"
    break;

  case 610: /* sym_args: sym_args symbol  */
#line 781 "nest/config.Y"
                   { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 9656 "obj/conf/cf-parse.tab.c"
    break;

  case 612: /* cmd_DUMP_RESOURCES: DUMP RESOURCES END  */
#line 787 "nest/config.Y"
{ rdump(&root_pool); cli_msg(0, ""); }
#line 9662 "obj/conf/cf-parse.tab.c"
    break;

  case 614: /* cmd_DUMP_SOCKETS: DUMP SOCKETS END  */
#line 789 "nest/config.Y"
{ sk_dump_all(); cli_msg(0, ""); }
#line 9668 "obj/conf/cf-parse.tab.c"
    break;

  case 616: /* cmd_DUMP_EVENTS: DUMP EVENTS END  */
#line 791 "nest/config.Y"
{ io_log_dump(); cli_msg(0, ""); }
#line 9674 "obj/conf/cf-parse.tab.c"
    break;

  case 618: /* cmd_DUMP_INTERFACES: DUMP INTERFACES END  */
#line 793 "nest/config.Y"
{ if_dump_all(); cli_msg(0, ""); }
#line 9680 "obj/conf/cf-parse.tab.c"
    break;

  case 620: /* cmd_DUMP_NEIGHBORS: DUMP NEIGHBORS END  */
#line 795 "nest/config.Y"
{ neigh_dump_all(); cli_msg(0, ""); }
#line 9686 "obj/conf/cf-parse.tab.c"
    break;

  case 622: /* cmd_DUMP_ATTRIBUTES: DUMP ATTRIBUTES END  */
#line 797 "nest/config.Y"
{ rta_dump_all(); cli_msg(0, ""); }
#line 9692 "obj/conf/cf-parse.tab.c"
    break;

  case 624: /* cmd_DUMP_ROUTES: DUMP ROUTES END  */
#line 799 "nest/config.Y"
{ rt_dump_all(); cli_msg(0, ""); }
#line 9698 "obj/conf/cf-parse.tab.c"
    break;

  case 626: /* cmd_DUMP_PROTOCOLS: DUMP PROTOCOLS END  */
#line 801 "nest/config.Y"
{ protos_dump_all(); cli_msg(0, ""); }
#line 9704 "obj/conf/cf-parse.tab.c"
    break;

  case 628: /* cmd_DUMP_FILTER_ALL: DUMP FILTER ALL END  */
#line 803 "nest/config.Y"
{ filters_dump_all(); cli_msg(0, ""); }
#line 9710 "obj/conf/cf-parse.tab.c"
    break;

  case 630: /* cmd_EVAL: EVAL term END  */
#line 806 "nest/config.Y"
{ cmd_eval(f_linearize((yyvsp[-1].x))); }
#line 9716 "obj/conf/cf-parse.tab.c"
    break;

  case 632: /* cmd_ECHO: ECHO echo_mask echo_size END  */
#line 809 "nest/config.Y"
                                       {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 9725 "obj/conf/cf-parse.tab.c"
    break;

  case 633: /* echo_mask: ALL  */
#line 815 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 9731 "obj/conf/cf-parse.tab.c"
    break;

  case 634: /* echo_mask: OFF  */
#line 816 "nest/config.Y"
       { (yyval.i) = 0; }
#line 9737 "obj/conf/cf-parse.tab.c"
    break;

  case 635: /* echo_mask: '{' log_mask_list '}'  */
#line 817 "nest/config.Y"
                         { (yyval.i) = (yyvsp[-1].i); }
#line 9743 "obj/conf/cf-parse.tab.c"
    break;

  case 636: /* echo_size: %empty  */
#line 821 "nest/config.Y"
               { (yyval.i) = 4096; }
#line 9749 "obj/conf/cf-parse.tab.c"
    break;

  case 637: /* echo_size: NUM  */
#line 822 "nest/config.Y"
       {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 9758 "obj/conf/cf-parse.tab.c"
    break;

  case 639: /* cmd_DISABLE: DISABLE proto_patt opttext END  */
#line 829 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9764 "obj/conf/cf-parse.tab.c"
    break;

  case 641: /* cmd_ENABLE: ENABLE proto_patt opttext END  */
#line 831 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9770 "obj/conf/cf-parse.tab.c"
    break;

  case 643: /* cmd_RESTART: RESTART proto_patt opttext END  */
#line 833 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9776 "obj/conf/cf-parse.tab.c"
    break;

  case 645: /* cmd_RELOAD: RELOAD proto_patt END  */
#line 835 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 9782 "obj/conf/cf-parse.tab.c"
    break;

  case 647: /* cmd_RELOAD_IN: RELOAD IN proto_patt END  */
#line 837 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 9788 "obj/conf/cf-parse.tab.c"
    break;

  case 649: /* cmd_RELOAD_OUT: RELOAD OUT proto_patt END  */
#line 839 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 9794 "obj/conf/cf-parse.tab.c"
    break;

  case 651: /* cmd_DEBUG: DEBUG debug_args END  */
#line 843 "nest/config.Y"
{ /* Done in debug_args */  }
#line 9800 "obj/conf/cf-parse.tab.c"
    break;

  case 652: /* debug_args: proto_patt debug_mask  */
#line 846 "nest/config.Y"
                         { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_debug, 1, (yyvsp[0].i));  }
#line 9806 "obj/conf/cf-parse.tab.c"
    break;

  case 653: /* debug_args: channel_arg debug_mask  */
#line 847 "nest/config.Y"
                          { channel_cmd_debug((yyvsp[-1].c), (yyvsp[0].i)); }
#line 9812 "obj/conf/cf-parse.tab.c"
    break;

  case 655: /* cmd_MRTDUMP: MRTDUMP proto_patt mrtdump_mask END  */
#line 852 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 9818 "obj/conf/cf-parse.tab.c"
    break;

  case 657: /* cmd_RESTRICT: RESTRICT END  */
#line 855 "nest/config.Y"
{ this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 9824 "obj/conf/cf-parse.tab.c"
    break;

  case 658: /* proto_patt: CF_SYM_KNOWN  */
#line 858 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 9830 "obj/conf/cf-parse.tab.c"
    break;

  case 659: /* proto_patt: ALL  */
#line 859 "nest/config.Y"
        { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 9836 "obj/conf/cf-parse.tab.c"
    break;

  case 660: /* proto_patt: TEXT  */
#line 860 "nest/config.Y"
        { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 9842 "obj/conf/cf-parse.tab.c"
    break;

  case 661: /* proto_patt2: CF_SYM_KNOWN  */
#line 864 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 9848 "obj/conf/cf-parse.tab.c"
    break;

  case 662: /* proto_patt2: %empty  */
#line 865 "nest/config.Y"
        { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 9854 "obj/conf/cf-parse.tab.c"
    break;

  case 663: /* proto_patt2: TEXT  */
#line 866 "nest/config.Y"
        { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 9860 "obj/conf/cf-parse.tab.c"
    break;

  case 664: /* dynamic_attr: IGP_METRIC  */
#line 869 "nest/config.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 9866 "obj/conf/cf-parse.tab.c"
    break;

  case 666: /* bfd_proto_start: proto_start BFD  */
#line 37 "proto/bfd/config.Y"
{
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);
  BFD_CFG->accept_ipv4 = BFD_CFG->accept_ipv6 = 1;
  BFD_CFG->accept_direct = BFD_CFG->accept_multihop = 1;
}
#line 9878 "obj/conf/cf-parse.tab.c"
    break;

  case 675: /* bfd_accept_item: IPV4  */
#line 63 "proto/bfd/config.Y"
                        { BFD_CFG->accept_ipv4 = 1;  BFD_CFG->accept_ipv6 = 0; }
#line 9884 "obj/conf/cf-parse.tab.c"
    break;

  case 676: /* bfd_accept_item: IPV6  */
#line 64 "proto/bfd/config.Y"
                        { BFD_CFG->accept_ipv4 = 0;  BFD_CFG->accept_ipv6 = 1; }
#line 9890 "obj/conf/cf-parse.tab.c"
    break;

  case 677: /* bfd_accept_item: DIRECT  */
#line 65 "proto/bfd/config.Y"
                        { BFD_CFG->accept_direct = 1;  BFD_CFG->accept_multihop = 0; }
#line 9896 "obj/conf/cf-parse.tab.c"
    break;

  case 678: /* bfd_accept_item: MULTIHOP  */
#line 66 "proto/bfd/config.Y"
                        { BFD_CFG->accept_direct = 0;  BFD_CFG->accept_multihop = 1; }
#line 9902 "obj/conf/cf-parse.tab.c"
    break;

  case 679: /* bfd_accept: %empty  */
#line 70 "proto/bfd/config.Y"
   {
     BFD_CFG->accept_ipv4 = BFD_CFG->accept_ipv6 = 1;
     BFD_CFG->accept_direct = BFD_CFG->accept_multihop = 1;
   }
#line 9911 "obj/conf/cf-parse.tab.c"
    break;

  case 681: /* bfd_iface_start: %empty  */
#line 78 "proto/bfd/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 9928 "obj/conf/cf-parse.tab.c"
    break;

  case 682: /* bfd_iface_finish: %empty  */
#line 92 "proto/bfd/config.Y"
{
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 9951 "obj/conf/cf-parse.tab.c"
    break;

  case 683: /* bfd_iface_item: INTERVAL expr_us  */
#line 112 "proto/bfd/config.Y"
                    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 9957 "obj/conf/cf-parse.tab.c"
    break;

  case 684: /* bfd_iface_item: MIN RX INTERVAL expr_us  */
#line 113 "proto/bfd/config.Y"
                           { BFD_IFACE->min_rx_int = (yyvsp[0].time); }
#line 9963 "obj/conf/cf-parse.tab.c"
    break;

  case 685: /* bfd_iface_item: MIN TX INTERVAL expr_us  */
#line 114 "proto/bfd/config.Y"
                           { BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 9969 "obj/conf/cf-parse.tab.c"
    break;

  case 686: /* bfd_iface_item: IDLE TX INTERVAL expr_us  */
#line 115 "proto/bfd/config.Y"
                            { BFD_IFACE->idle_tx_int = (yyvsp[0].time); }
#line 9975 "obj/conf/cf-parse.tab.c"
    break;

  case 687: /* bfd_iface_item: MULTIPLIER expr  */
#line 116 "proto/bfd/config.Y"
                   { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 9981 "obj/conf/cf-parse.tab.c"
    break;

  case 688: /* bfd_iface_item: PASSIVE bool  */
#line 117 "proto/bfd/config.Y"
                { BFD_IFACE->passive = (yyvsp[0].i); }
#line 9987 "obj/conf/cf-parse.tab.c"
    break;

  case 689: /* bfd_iface_item: AUTHENTICATION bfd_auth_type  */
#line 118 "proto/bfd/config.Y"
                                { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 9993 "obj/conf/cf-parse.tab.c"
    break;

  case 690: /* bfd_iface_item: password_list  */
#line 119 "proto/bfd/config.Y"
                 {}
#line 9999 "obj/conf/cf-parse.tab.c"
    break;

  case 691: /* bfd_auth_type: NONE  */
#line 123 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_NONE; }
#line 10005 "obj/conf/cf-parse.tab.c"
    break;

  case 692: /* bfd_auth_type: SIMPLE  */
#line 124 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 10011 "obj/conf/cf-parse.tab.c"
    break;

  case 693: /* bfd_auth_type: KEYED MD5  */
#line 125 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 10017 "obj/conf/cf-parse.tab.c"
    break;

  case 694: /* bfd_auth_type: KEYED SHA1  */
#line 126 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 10023 "obj/conf/cf-parse.tab.c"
    break;

  case 695: /* bfd_auth_type: METICULOUS KEYED MD5  */
#line 127 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 10029 "obj/conf/cf-parse.tab.c"
    break;

  case 696: /* bfd_auth_type: METICULOUS KEYED SHA1  */
#line 128 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 10035 "obj/conf/cf-parse.tab.c"
    break;

  case 702: /* bfd_multihop: bfd_iface_start bfd_iface_opt_list bfd_iface_finish  */
#line 146 "proto/bfd/config.Y"
{ BFD_CFG->multihop = BFD_IFACE; }
#line 10041 "obj/conf/cf-parse.tab.c"
    break;

  case 703: /* bfd_neigh_iface: %empty  */
#line 150 "proto/bfd/config.Y"
               { (yyval.iface) = NULL; }
#line 10047 "obj/conf/cf-parse.tab.c"
    break;

  case 704: /* bfd_neigh_iface: '%' symbol  */
#line 151 "proto/bfd/config.Y"
              { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 10053 "obj/conf/cf-parse.tab.c"
    break;

  case 705: /* bfd_neigh_iface: DEV text  */
#line 152 "proto/bfd/config.Y"
            { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 10059 "obj/conf/cf-parse.tab.c"
    break;

  case 706: /* bfd_neigh_local: %empty  */
#line 156 "proto/bfd/config.Y"
               { (yyval.a) = IPA_NONE; }
#line 10065 "obj/conf/cf-parse.tab.c"
    break;

  case 707: /* bfd_neigh_local: LOCAL ipa  */
#line 157 "proto/bfd/config.Y"
             { (yyval.a) = (yyvsp[0].a); }
#line 10071 "obj/conf/cf-parse.tab.c"
    break;

  case 708: /* bfd_neigh_multihop: %empty  */
#line 161 "proto/bfd/config.Y"
               { (yyval.i) = 0; }
#line 10077 "obj/conf/cf-parse.tab.c"
    break;

  case 709: /* bfd_neigh_multihop: MULTIHOP bool  */
#line 162 "proto/bfd/config.Y"
                 { (yyval.i) = (yyvsp[0].i); }
#line 10083 "obj/conf/cf-parse.tab.c"
    break;

  case 710: /* bfd_neighbor: ipa bfd_neigh_iface bfd_neigh_local bfd_neigh_multihop  */
#line 166 "proto/bfd/config.Y"
{
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 10103 "obj/conf/cf-parse.tab.c"
    break;

  case 712: /* cmd_SHOW_BFD_SESSIONS: SHOW BFD SESSIONS optproto END  */
#line 185 "proto/bfd/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].s), &proto_bfd, p) bfd_show_sessions(p); }
#line 10109 "obj/conf/cf-parse.tab.c"
    break;

  case 714: /* babel_proto_start: proto_start BABEL  */
#line 35 "proto/babel/config.Y"
{
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
  BABEL_CFG->hold_time = 1 S_;
}
#line 10119 "obj/conf/cf-parse.tab.c"
    break;

  case 718: /* babel_proto_item: RANDOMIZE ROUTER ID bool  */
#line 45 "proto/babel/config.Y"
                            { BABEL_CFG->randomize_router_id = (yyvsp[0].i); }
#line 10125 "obj/conf/cf-parse.tab.c"
    break;

  case 722: /* babel_iface_start: %empty  */
#line 58 "proto/babel/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->limit = BABEL_HELLO_LIMIT;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 10141 "obj/conf/cf-parse.tab.c"
    break;

  case 723: /* babel_iface_finish: %empty  */
#line 72 "proto/babel/config.Y"
{
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);

  BABEL_CFG->hold_time = MAX_(BABEL_CFG->hold_time, BABEL_IFACE->update_interval*BABEL_HOLD_TIME_FACTOR);
}
#line 10169 "obj/conf/cf-parse.tab.c"
    break;

  case 725: /* babel_iface_item: PORT expr  */
#line 98 "proto/babel/config.Y"
             { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10175 "obj/conf/cf-parse.tab.c"
    break;

  case 726: /* babel_iface_item: RXCOST expr  */
#line 99 "proto/babel/config.Y"
               { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 10181 "obj/conf/cf-parse.tab.c"
    break;

  case 727: /* babel_iface_item: LIMIT expr  */
#line 100 "proto/babel/config.Y"
              { BABEL_IFACE->limit = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>16)) cf_error("Limit must be in range 1-16"); }
#line 10187 "obj/conf/cf-parse.tab.c"
    break;

  case 728: /* babel_iface_item: TYPE WIRED  */
#line 101 "proto/babel/config.Y"
              { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 10193 "obj/conf/cf-parse.tab.c"
    break;

  case 729: /* babel_iface_item: TYPE WIRELESS  */
#line 102 "proto/babel/config.Y"
                 { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 10199 "obj/conf/cf-parse.tab.c"
    break;

  case 730: /* babel_iface_item: HELLO INTERVAL expr_us  */
#line 103 "proto/babel/config.Y"
                          { BABEL_IFACE->hello_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Hello interval must be in range 10 ms - 655 s"); }
#line 10205 "obj/conf/cf-parse.tab.c"
    break;

  case 731: /* babel_iface_item: UPDATE INTERVAL expr_us  */
#line 104 "proto/babel/config.Y"
                           { BABEL_IFACE->update_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Update interval must be in range 10 ms - 655 s"); }
#line 10211 "obj/conf/cf-parse.tab.c"
    break;

  case 732: /* babel_iface_item: RX BUFFER expr  */
#line 105 "proto/babel/config.Y"
                  { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 10217 "obj/conf/cf-parse.tab.c"
    break;

  case 733: /* babel_iface_item: TX LENGTH expr  */
#line 106 "proto/babel/config.Y"
                  { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 10223 "obj/conf/cf-parse.tab.c"
    break;

  case 734: /* babel_iface_item: TX tos  */
#line 107 "proto/babel/config.Y"
          { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 10229 "obj/conf/cf-parse.tab.c"
    break;

  case 735: /* babel_iface_item: TX PRIORITY expr  */
#line 108 "proto/babel/config.Y"
                    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 10235 "obj/conf/cf-parse.tab.c"
    break;

  case 736: /* babel_iface_item: CHECK LINK bool  */
#line 109 "proto/babel/config.Y"
                   { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 10241 "obj/conf/cf-parse.tab.c"
    break;

  case 737: /* babel_iface_item: NEXT HOP IPV4 ipa  */
#line 110 "proto/babel/config.Y"
                     { BABEL_IFACE->next_hop_ip4 = (yyvsp[0].a); if (!ipa_is_ip4((yyvsp[0].a))) cf_error("Must be an IPv4 address"); }
#line 10247 "obj/conf/cf-parse.tab.c"
    break;

  case 738: /* babel_iface_item: NEXT HOP IPV6 ipa  */
#line 111 "proto/babel/config.Y"
                     { BABEL_IFACE->next_hop_ip6 = (yyvsp[0].a); if (!ipa_is_ip6((yyvsp[0].a))) cf_error("Must be an IPv6 address"); }
#line 10253 "obj/conf/cf-parse.tab.c"
    break;

  case 744: /* dynamic_attr: BABEL_METRIC  */
#line 128 "proto/babel/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_BABEL_METRIC); }
#line 10259 "obj/conf/cf-parse.tab.c"
    break;

  case 746: /* cmd_SHOW_BABEL_INTERFACES: SHOW BABEL INTERFACES optproto opttext END  */
#line 133 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_interfaces(p, (yyvsp[-1].t)); }
#line 10265 "obj/conf/cf-parse.tab.c"
    break;

  case 748: /* cmd_SHOW_BABEL_NEIGHBORS: SHOW BABEL NEIGHBORS optproto opttext END  */
#line 136 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_neighbors(p, (yyvsp[-1].t)); }
#line 10271 "obj/conf/cf-parse.tab.c"
    break;

  case 750: /* cmd_SHOW_BABEL_ENTRIES: SHOW BABEL ENTRIES optproto opttext END  */
#line 139 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_entries(p); }
#line 10277 "obj/conf/cf-parse.tab.c"
    break;

  case 752: /* cmd_SHOW_BABEL_ROUTES: SHOW BABEL ROUTES optproto opttext END  */
#line 142 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p)  babel_show_routes(p); }
#line 10283 "obj/conf/cf-parse.tab.c"
    break;

  case 754: /* bgp_proto_start: proto_start BGP  */
#line 49 "proto/bgp/config.Y"
                                 {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->local_port = BGP_PORT;
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->enable_hostname = 0;
     BGP_CFG->capabilities = 2;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->allow_as_sets = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
     BGP_CFG->dynamic_name = "dynbgp";
     BGP_CFG->check_link = -1;
   }
#line 10317 "obj/conf/cf-parse.tab.c"
    break;

  case 756: /* bgp_loc_opts: bgp_loc_opts PORT expr  */
#line 82 "proto/bgp/config.Y"
                          { BGP_CFG->local_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10323 "obj/conf/cf-parse.tab.c"
    break;

  case 757: /* bgp_loc_opts: bgp_loc_opts AS expr  */
#line 83 "proto/bgp/config.Y"
                        { BGP_CFG->local_as = (yyvsp[0].i); }
#line 10329 "obj/conf/cf-parse.tab.c"
    break;

  case 759: /* bgp_nbr_opts: bgp_nbr_opts PORT expr  */
#line 88 "proto/bgp/config.Y"
                          { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10335 "obj/conf/cf-parse.tab.c"
    break;

  case 760: /* bgp_nbr_opts: bgp_nbr_opts AS expr  */
#line 89 "proto/bgp/config.Y"
                        { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 10341 "obj/conf/cf-parse.tab.c"
    break;

  case 761: /* bgp_nbr_opts: bgp_nbr_opts INTERNAL  */
#line 90 "proto/bgp/config.Y"
                         { BGP_CFG->peer_type = BGP_PT_INTERNAL; }
#line 10347 "obj/conf/cf-parse.tab.c"
    break;

  case 762: /* bgp_nbr_opts: bgp_nbr_opts EXTERNAL  */
#line 91 "proto/bgp/config.Y"
                         { BGP_CFG->peer_type = BGP_PT_EXTERNAL; }
#line 10353 "obj/conf/cf-parse.tab.c"
    break;

  case 763: /* bgp_cease_mask: bool  */
#line 96 "proto/bgp/config.Y"
        { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 10359 "obj/conf/cf-parse.tab.c"
    break;

  case 764: /* bgp_cease_mask: '{' bgp_cease_list '}'  */
#line 97 "proto/bgp/config.Y"
                          { (yyval.i) = (yyvsp[-1].i); }
#line 10365 "obj/conf/cf-parse.tab.c"
    break;

  case 766: /* bgp_cease_list: bgp_cease_list ',' bgp_cease_flag  */
#line 102 "proto/bgp/config.Y"
                                     { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 10371 "obj/conf/cf-parse.tab.c"
    break;

  case 767: /* bgp_cease_flag: CEASE  */
#line 106 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 0; }
#line 10377 "obj/conf/cf-parse.tab.c"
    break;

  case 768: /* bgp_cease_flag: PREFIX LIMIT HIT  */
#line 107 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 1; }
#line 10383 "obj/conf/cf-parse.tab.c"
    break;

  case 769: /* bgp_cease_flag: ADMINISTRATIVE SHUTDOWN  */
#line 108 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 2; }
#line 10389 "obj/conf/cf-parse.tab.c"
    break;

  case 770: /* bgp_cease_flag: PEER DECONFIGURED  */
#line 109 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 3; }
#line 10395 "obj/conf/cf-parse.tab.c"
    break;

  case 771: /* bgp_cease_flag: ADMINISTRATIVE RESET  */
#line 110 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 4; }
#line 10401 "obj/conf/cf-parse.tab.c"
    break;

  case 772: /* bgp_cease_flag: CONNECTION REJECTED  */
#line 111 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 5; }
#line 10407 "obj/conf/cf-parse.tab.c"
    break;

  case 773: /* bgp_cease_flag: CONFIGURATION CHANGE  */
#line 112 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 6; }
#line 10413 "obj/conf/cf-parse.tab.c"
    break;

  case 774: /* bgp_cease_flag: CONNECTION COLLISION  */
#line 113 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 7; }
#line 10419 "obj/conf/cf-parse.tab.c"
    break;

  case 775: /* bgp_cease_flag: OUT OF RESOURCES  */
#line 114 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 8; }
#line 10425 "obj/conf/cf-parse.tab.c"
    break;

  case 780: /* bgp_proto: bgp_proto LOCAL ipa ipa_scope bgp_loc_opts ';'  */
#line 122 "proto/bgp/config.Y"
                                                  {
     BGP_CFG->local_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 10434 "obj/conf/cf-parse.tab.c"
    break;

  case 782: /* bgp_proto: bgp_proto NEIGHBOR ipa ipa_scope bgp_nbr_opts ';'  */
#line 127 "proto/bgp/config.Y"
                                                     {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 10445 "obj/conf/cf-parse.tab.c"
    break;

  case 783: /* bgp_proto: bgp_proto NEIGHBOR RANGE net_ip bgp_nbr_opts ';'  */
#line 133 "proto/bgp/config.Y"
                                                    {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     net_addr *n = cfg_alloc((yyvsp[-2].net).length);
     net_copy(n, &((yyvsp[-2].net)));
     BGP_CFG->remote_range = n;
   }
#line 10457 "obj/conf/cf-parse.tab.c"
    break;

  case 784: /* bgp_proto: bgp_proto INTERFACE TEXT ';'  */
#line 140 "proto/bgp/config.Y"
                                { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 10463 "obj/conf/cf-parse.tab.c"
    break;

  case 785: /* bgp_proto: bgp_proto RR CLUSTER ID idval ';'  */
#line 141 "proto/bgp/config.Y"
                                     { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 10469 "obj/conf/cf-parse.tab.c"
    break;

  case 786: /* bgp_proto: bgp_proto RR CLIENT bool ';'  */
#line 142 "proto/bgp/config.Y"
                                { BGP_CFG->rr_client = (yyvsp[-1].i); }
#line 10475 "obj/conf/cf-parse.tab.c"
    break;

  case 787: /* bgp_proto: bgp_proto RS CLIENT bool ';'  */
#line 143 "proto/bgp/config.Y"
                                { BGP_CFG->rs_client = (yyvsp[-1].i); }
#line 10481 "obj/conf/cf-parse.tab.c"
    break;

  case 788: /* bgp_proto: bgp_proto CONFEDERATION expr ';'  */
#line 144 "proto/bgp/config.Y"
                                    { BGP_CFG->confederation = (yyvsp[-1].i); }
#line 10487 "obj/conf/cf-parse.tab.c"
    break;

  case 789: /* bgp_proto: bgp_proto CONFEDERATION MEMBER bool ';'  */
#line 145 "proto/bgp/config.Y"
                                           { BGP_CFG->confederation_member = (yyvsp[-1].i); }
#line 10493 "obj/conf/cf-parse.tab.c"
    break;

  case 790: /* bgp_proto: bgp_proto HOLD TIME expr ';'  */
#line 146 "proto/bgp/config.Y"
                                { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 10499 "obj/conf/cf-parse.tab.c"
    break;

  case 791: /* bgp_proto: bgp_proto STARTUP HOLD TIME expr ';'  */
#line 147 "proto/bgp/config.Y"
                                        { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 10505 "obj/conf/cf-parse.tab.c"
    break;

  case 792: /* bgp_proto: bgp_proto DIRECT ';'  */
#line 148 "proto/bgp/config.Y"
                        { BGP_CFG->multihop = 0; }
#line 10511 "obj/conf/cf-parse.tab.c"
    break;

  case 793: /* bgp_proto: bgp_proto MULTIHOP ';'  */
#line 149 "proto/bgp/config.Y"
                          { BGP_CFG->multihop = 64; }
#line 10517 "obj/conf/cf-parse.tab.c"
    break;

  case 794: /* bgp_proto: bgp_proto MULTIHOP expr ';'  */
#line 150 "proto/bgp/config.Y"
                               { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 10523 "obj/conf/cf-parse.tab.c"
    break;

  case 795: /* bgp_proto: bgp_proto DYNAMIC NAME text ';'  */
#line 151 "proto/bgp/config.Y"
                                   {
     if (strchr((yyvsp[-1].t), '%')) cf_error("Forbidden character '%%' in dynamic name");
     if (strlen((yyvsp[-1].t)) > (SYM_MAX_LEN - 16)) cf_error("Dynamic name too long");
     BGP_CFG->dynamic_name = (yyvsp[-1].t);
   }
#line 10533 "obj/conf/cf-parse.tab.c"
    break;

  case 796: /* bgp_proto: bgp_proto DYNAMIC NAME DIGITS expr ';'  */
#line 156 "proto/bgp/config.Y"
                                          { BGP_CFG->dynamic_name_digits = (yyvsp[-1].i); if ((yyvsp[-1].i)>10) cf_error("Dynamic name digits must be at most 10"); }
#line 10539 "obj/conf/cf-parse.tab.c"
    break;

  case 797: /* bgp_proto: bgp_proto STRICT BIND bool ';'  */
#line 157 "proto/bgp/config.Y"
                                  { BGP_CFG->strict_bind = (yyvsp[-1].i); }
#line 10545 "obj/conf/cf-parse.tab.c"
    break;

  case 798: /* bgp_proto: bgp_proto PATH METRIC bool ';'  */
#line 158 "proto/bgp/config.Y"
                                  { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 10551 "obj/conf/cf-parse.tab.c"
    break;

  case 799: /* bgp_proto: bgp_proto MED METRIC bool ';'  */
#line 159 "proto/bgp/config.Y"
                                 { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 10557 "obj/conf/cf-parse.tab.c"
    break;

  case 800: /* bgp_proto: bgp_proto IGP METRIC bool ';'  */
#line 160 "proto/bgp/config.Y"
                                 { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 10563 "obj/conf/cf-parse.tab.c"
    break;

  case 801: /* bgp_proto: bgp_proto PREFER OLDER bool ';'  */
#line 161 "proto/bgp/config.Y"
                                   { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 10569 "obj/conf/cf-parse.tab.c"
    break;

  case 802: /* bgp_proto: bgp_proto DETERMINISTIC MED bool ';'  */
#line 162 "proto/bgp/config.Y"
                                        { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 10575 "obj/conf/cf-parse.tab.c"
    break;

  case 803: /* bgp_proto: bgp_proto DEFAULT BGP_MED expr ';'  */
#line 163 "proto/bgp/config.Y"
                                      { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 10581 "obj/conf/cf-parse.tab.c"
    break;

  case 804: /* bgp_proto: bgp_proto DEFAULT BGP_LOCAL_PREF expr ';'  */
#line 164 "proto/bgp/config.Y"
                                             { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 10587 "obj/conf/cf-parse.tab.c"
    break;

  case 805: /* bgp_proto: bgp_proto SOURCE ADDRESS ipa ';'  */
#line 165 "proto/bgp/config.Y"
                                    { BGP_CFG->local_ip = (yyvsp[-1].a); }
#line 10593 "obj/conf/cf-parse.tab.c"
    break;

  case 806: /* bgp_proto: bgp_proto START DELAY TIME expr ';'  */
#line 166 "proto/bgp/config.Y"
                                       { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 10599 "obj/conf/cf-parse.tab.c"
    break;

  case 807: /* bgp_proto: bgp_proto CONNECT DELAY TIME expr ';'  */
#line 167 "proto/bgp/config.Y"
                                         { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 10605 "obj/conf/cf-parse.tab.c"
    break;

  case 808: /* bgp_proto: bgp_proto CONNECT RETRY TIME expr ';'  */
#line 168 "proto/bgp/config.Y"
                                         { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 10611 "obj/conf/cf-parse.tab.c"
    break;

  case 809: /* bgp_proto: bgp_proto KEEPALIVE TIME expr ';'  */
#line 169 "proto/bgp/config.Y"
                                     { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 10617 "obj/conf/cf-parse.tab.c"
    break;

  case 810: /* bgp_proto: bgp_proto ERROR FORGET TIME expr ';'  */
#line 170 "proto/bgp/config.Y"
                                        { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 10623 "obj/conf/cf-parse.tab.c"
    break;

  case 811: /* bgp_proto: bgp_proto ERROR WAIT TIME expr ',' expr ';'  */
#line 171 "proto/bgp/config.Y"
                                               { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 10629 "obj/conf/cf-parse.tab.c"
    break;

  case 812: /* bgp_proto: bgp_proto DISABLE AFTER ERROR bool ';'  */
#line 172 "proto/bgp/config.Y"
                                          { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 10635 "obj/conf/cf-parse.tab.c"
    break;

  case 813: /* bgp_proto: bgp_proto DISABLE AFTER CEASE bgp_cease_mask ';'  */
#line 173 "proto/bgp/config.Y"
                                                    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 10641 "obj/conf/cf-parse.tab.c"
    break;

  case 814: /* bgp_proto: bgp_proto ENABLE ROUTE REFRESH bool ';'  */
#line 174 "proto/bgp/config.Y"
                                           { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 10647 "obj/conf/cf-parse.tab.c"
    break;

  case 815: /* bgp_proto: bgp_proto ENABLE AS4 bool ';'  */
#line 175 "proto/bgp/config.Y"
                                 { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 10653 "obj/conf/cf-parse.tab.c"
    break;

  case 816: /* bgp_proto: bgp_proto ENABLE EXTENDED MESSAGES bool ';'  */
#line 176 "proto/bgp/config.Y"
                                               { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 10659 "obj/conf/cf-parse.tab.c"
    break;

  case 817: /* bgp_proto: bgp_proto ADVERTISE HOSTNAME bool ';'  */
#line 177 "proto/bgp/config.Y"
                                         { BGP_CFG->enable_hostname = (yyvsp[-1].i); }
#line 10665 "obj/conf/cf-parse.tab.c"
    break;

  case 818: /* bgp_proto: bgp_proto CAPABILITIES bool ';'  */
#line 178 "proto/bgp/config.Y"
                                   { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 10671 "obj/conf/cf-parse.tab.c"
    break;

  case 819: /* bgp_proto: bgp_proto PASSWORD text ';'  */
#line 179 "proto/bgp/config.Y"
                               { BGP_CFG->password = (yyvsp[-1].t); }
#line 10677 "obj/conf/cf-parse.tab.c"
    break;

  case 820: /* bgp_proto: bgp_proto SETKEY bool ';'  */
#line 180 "proto/bgp/config.Y"
                             { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 10683 "obj/conf/cf-parse.tab.c"
    break;

  case 821: /* bgp_proto: bgp_proto PASSIVE bool ';'  */
#line 181 "proto/bgp/config.Y"
                              { BGP_CFG->passive = (yyvsp[-1].i); }
#line 10689 "obj/conf/cf-parse.tab.c"
    break;

  case 822: /* bgp_proto: bgp_proto INTERPRET COMMUNITIES bool ';'  */
#line 182 "proto/bgp/config.Y"
                                            { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 10695 "obj/conf/cf-parse.tab.c"
    break;

  case 823: /* bgp_proto: bgp_proto ALLOW LOCAL AS ';'  */
#line 183 "proto/bgp/config.Y"
                                { BGP_CFG->allow_local_as = -1; }
#line 10701 "obj/conf/cf-parse.tab.c"
    break;

  case 824: /* bgp_proto: bgp_proto ALLOW LOCAL AS expr ';'  */
#line 184 "proto/bgp/config.Y"
                                     { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 10707 "obj/conf/cf-parse.tab.c"
    break;

  case 825: /* bgp_proto: bgp_proto ALLOW BGP_LOCAL_PREF bool ';'  */
#line 185 "proto/bgp/config.Y"
                                           { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 10713 "obj/conf/cf-parse.tab.c"
    break;

  case 826: /* bgp_proto: bgp_proto ALLOW AS SETS bool ';'  */
#line 186 "proto/bgp/config.Y"
                                    { BGP_CFG->allow_as_sets = (yyvsp[-1].i); }
#line 10719 "obj/conf/cf-parse.tab.c"
    break;

  case 827: /* bgp_proto: bgp_proto GRACEFUL RESTART bool ';'  */
#line 187 "proto/bgp/config.Y"
                                       { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 10725 "obj/conf/cf-parse.tab.c"
    break;

  case 828: /* bgp_proto: bgp_proto GRACEFUL RESTART AWARE ';'  */
#line 188 "proto/bgp/config.Y"
                                        { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 10731 "obj/conf/cf-parse.tab.c"
    break;

  case 829: /* bgp_proto: bgp_proto GRACEFUL RESTART TIME expr ';'  */
#line 189 "proto/bgp/config.Y"
                                            { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 10737 "obj/conf/cf-parse.tab.c"
    break;

  case 830: /* bgp_proto: bgp_proto LONG LIVED GRACEFUL RESTART bool ';'  */
#line 190 "proto/bgp/config.Y"
                                                  { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 10743 "obj/conf/cf-parse.tab.c"
    break;

  case 831: /* bgp_proto: bgp_proto LONG LIVED GRACEFUL RESTART AWARE ';'  */
#line 191 "proto/bgp/config.Y"
                                                   { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 10749 "obj/conf/cf-parse.tab.c"
    break;

  case 832: /* bgp_proto: bgp_proto LONG LIVED STALE TIME expr ';'  */
#line 192 "proto/bgp/config.Y"
                                            { BGP_CFG->llgr_time = (yyvsp[-1].i); }
#line 10755 "obj/conf/cf-parse.tab.c"
    break;

  case 833: /* bgp_proto: bgp_proto TTL SECURITY bool ';'  */
#line 193 "proto/bgp/config.Y"
                                   { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 10761 "obj/conf/cf-parse.tab.c"
    break;

  case 834: /* bgp_proto: bgp_proto CHECK LINK bool ';'  */
#line 194 "proto/bgp/config.Y"
                                 { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 10767 "obj/conf/cf-parse.tab.c"
    break;

  case 835: /* bgp_proto: bgp_proto BFD bool ';'  */
#line 195 "proto/bgp/config.Y"
                          { if ((yyvsp[-1].i)) init_bfd_opts(&BGP_CFG->bfd); else BGP_CFG->bfd = NULL; }
#line 10773 "obj/conf/cf-parse.tab.c"
    break;

  case 836: /* bgp_proto: bgp_proto BFD GRACEFUL ';'  */
#line 196 "proto/bgp/config.Y"
                              { init_bfd_opts(&BGP_CFG->bfd); BGP_CFG->bfd->mode = BGP_BFD_GRACEFUL; }
#line 10779 "obj/conf/cf-parse.tab.c"
    break;

  case 837: /* $@3: %empty  */
#line 197 "proto/bgp/config.Y"
                 { open_bfd_opts(&BGP_CFG->bfd); }
#line 10785 "obj/conf/cf-parse.tab.c"
    break;

  case 838: /* $@4: %empty  */
#line 197 "proto/bgp/config.Y"
                                                            { close_bfd_opts(); }
#line 10791 "obj/conf/cf-parse.tab.c"
    break;

  case 840: /* bgp_proto: bgp_proto ENFORCE FIRST AS bool ';'  */
#line 198 "proto/bgp/config.Y"
                                       { BGP_CFG->enforce_first_as = (yyvsp[-1].i); }
#line 10797 "obj/conf/cf-parse.tab.c"
    break;

  case 841: /* bgp_afi: IPV4  */
#line 202 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4; }
#line 10803 "obj/conf/cf-parse.tab.c"
    break;

  case 842: /* bgp_afi: IPV6  */
#line 203 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6; }
#line 10809 "obj/conf/cf-parse.tab.c"
    break;

  case 843: /* bgp_afi: IPV4 MULTICAST  */
#line 204 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4_MC; }
#line 10815 "obj/conf/cf-parse.tab.c"
    break;

  case 844: /* bgp_afi: IPV6 MULTICAST  */
#line 205 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6_MC; }
#line 10821 "obj/conf/cf-parse.tab.c"
    break;

  case 845: /* bgp_afi: IPV4 MPLS  */
#line 206 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4_MPLS; }
#line 10827 "obj/conf/cf-parse.tab.c"
    break;

  case 846: /* bgp_afi: IPV6 MPLS  */
#line 207 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6_MPLS; }
#line 10833 "obj/conf/cf-parse.tab.c"
    break;

  case 847: /* bgp_afi: VPN4 MPLS  */
#line 208 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN4_MPLS; }
#line 10839 "obj/conf/cf-parse.tab.c"
    break;

  case 848: /* bgp_afi: VPN6 MPLS  */
#line 209 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN6_MPLS; }
#line 10845 "obj/conf/cf-parse.tab.c"
    break;

  case 849: /* bgp_afi: VPN4 MULTICAST  */
#line 210 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN4_MC; }
#line 10851 "obj/conf/cf-parse.tab.c"
    break;

  case 850: /* bgp_afi: VPN6 MULTICAST  */
#line 211 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN6_MC; }
#line 10857 "obj/conf/cf-parse.tab.c"
    break;

  case 851: /* bgp_afi: FLOW4  */
#line 212 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_FLOW4; }
#line 10863 "obj/conf/cf-parse.tab.c"
    break;

  case 852: /* bgp_afi: FLOW6  */
#line 213 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_FLOW6; }
#line 10869 "obj/conf/cf-parse.tab.c"
    break;

  case 853: /* bgp_channel_start: bgp_afi  */
#line 217 "proto/bgp/config.Y"
{
  const struct bgp_af_desc *desc = bgp_get_af_desc((yyvsp[0].i32));

  if (!desc)
    cf_error("Unknown AFI/SAFI");

  this_channel = channel_config_get(&channel_bgp, desc->name, desc->net, this_proto);

  /* New channel */
  if (!BGP_CC->desc)
  {
    BGP_CC->c.in_filter = FILTER_UNDEF;
    BGP_CC->c.out_filter = FILTER_UNDEF;
    BGP_CC->c.ra_mode = RA_UNDEF;
    BGP_CC->afi = (yyvsp[0].i32);
    BGP_CC->desc = desc;
    BGP_CC->next_hop_keep = 0xff; /* undefined */
    BGP_CC->gr_able = 0xff;	/* undefined */
    BGP_CC->llgr_able = 0xff;	/* undefined */
    BGP_CC->llgr_time = ~0U;	/* undefined */
    BGP_CC->aigp = 0xff;	/* undefined */
  }
}
#line 10897 "obj/conf/cf-parse.tab.c"
    break;

  case 854: /* bgp_nh: bool  */
#line 242 "proto/bgp/config.Y"
        { (yyval.i) = (yyvsp[0].i); }
#line 10903 "obj/conf/cf-parse.tab.c"
    break;

  case 855: /* bgp_nh: IBGP  */
#line 243 "proto/bgp/config.Y"
        { (yyval.i) = NH_IBGP; }
#line 10909 "obj/conf/cf-parse.tab.c"
    break;

  case 856: /* bgp_nh: EBGP  */
#line 244 "proto/bgp/config.Y"
        { (yyval.i) = NH_EBGP; }
#line 10915 "obj/conf/cf-parse.tab.c"
    break;

  case 861: /* bgp_channel_item: NEXT HOP ADDRESS ipa  */
#line 250 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_addr = (yyvsp[0].a); }
#line 10921 "obj/conf/cf-parse.tab.c"
    break;

  case 862: /* bgp_channel_item: NEXT HOP SELF bgp_nh  */
#line 251 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_self = (yyvsp[0].i); }
#line 10927 "obj/conf/cf-parse.tab.c"
    break;

  case 863: /* bgp_channel_item: NEXT HOP KEEP bgp_nh  */
#line 252 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_keep = (yyvsp[0].i); }
#line 10933 "obj/conf/cf-parse.tab.c"
    break;

  case 864: /* bgp_channel_item: MANDATORY bool  */
#line 253 "proto/bgp/config.Y"
                  { BGP_CC->mandatory = (yyvsp[0].i); }
#line 10939 "obj/conf/cf-parse.tab.c"
    break;

  case 865: /* bgp_channel_item: MISSING LLADDR bgp_lladdr  */
#line 254 "proto/bgp/config.Y"
                             { log(L_WARN "%s.%s: Missing lladdr option is deprecated and ignored, remove it", this_proto->name, this_channel->name); }
#line 10945 "obj/conf/cf-parse.tab.c"
    break;

  case 866: /* bgp_channel_item: GATEWAY DIRECT  */
#line 255 "proto/bgp/config.Y"
                  { BGP_CC->gw_mode = GW_DIRECT; }
#line 10951 "obj/conf/cf-parse.tab.c"
    break;

  case 867: /* bgp_channel_item: GATEWAY RECURSIVE  */
#line 256 "proto/bgp/config.Y"
                     { BGP_CC->gw_mode = GW_RECURSIVE; }
#line 10957 "obj/conf/cf-parse.tab.c"
    break;

  case 868: /* bgp_channel_item: SECONDARY bool  */
#line 257 "proto/bgp/config.Y"
                  { BGP_CC->secondary = (yyvsp[0].i); }
#line 10963 "obj/conf/cf-parse.tab.c"
    break;

  case 869: /* bgp_channel_item: GRACEFUL RESTART bool  */
#line 258 "proto/bgp/config.Y"
                         { BGP_CC->gr_able = (yyvsp[0].i); }
#line 10969 "obj/conf/cf-parse.tab.c"
    break;

  case 870: /* bgp_channel_item: LONG LIVED GRACEFUL RESTART bool  */
#line 259 "proto/bgp/config.Y"
                                    { BGP_CC->llgr_able = (yyvsp[0].i); }
#line 10975 "obj/conf/cf-parse.tab.c"
    break;

  case 871: /* bgp_channel_item: LONG LIVED STALE TIME expr  */
#line 260 "proto/bgp/config.Y"
                              { BGP_CC->llgr_time = (yyvsp[0].i); }
#line 10981 "obj/conf/cf-parse.tab.c"
    break;

  case 872: /* bgp_channel_item: EXTENDED NEXT HOP bool  */
#line 261 "proto/bgp/config.Y"
                          { BGP_CC->ext_next_hop = (yyvsp[0].i); }
#line 10987 "obj/conf/cf-parse.tab.c"
    break;

  case 873: /* bgp_channel_item: ADD PATHS RX  */
#line 262 "proto/bgp/config.Y"
                { BGP_CC->add_path = BGP_ADD_PATH_RX; }
#line 10993 "obj/conf/cf-parse.tab.c"
    break;

  case 874: /* bgp_channel_item: ADD PATHS TX  */
#line 263 "proto/bgp/config.Y"
                { BGP_CC->add_path = BGP_ADD_PATH_TX; }
#line 10999 "obj/conf/cf-parse.tab.c"
    break;

  case 875: /* bgp_channel_item: ADD PATHS bool  */
#line 264 "proto/bgp/config.Y"
                  { BGP_CC->add_path = (yyvsp[0].i) ? BGP_ADD_PATH_FULL : 0; }
#line 11005 "obj/conf/cf-parse.tab.c"
    break;

  case 876: /* bgp_channel_item: IMPORT TABLE bool  */
#line 265 "proto/bgp/config.Y"
                     { BGP_CC->import_table = (yyvsp[0].i); }
#line 11011 "obj/conf/cf-parse.tab.c"
    break;

  case 877: /* bgp_channel_item: EXPORT TABLE bool  */
#line 266 "proto/bgp/config.Y"
                     { BGP_CC->export_table = (yyvsp[0].i); }
#line 11017 "obj/conf/cf-parse.tab.c"
    break;

  case 878: /* bgp_channel_item: AIGP bool  */
#line 267 "proto/bgp/config.Y"
             { BGP_CC->aigp = (yyvsp[0].i); BGP_CC->aigp_originate = 0; }
#line 11023 "obj/conf/cf-parse.tab.c"
    break;

  case 879: /* bgp_channel_item: AIGP ORIGINATE  */
#line 268 "proto/bgp/config.Y"
                  { BGP_CC->aigp = 1; BGP_CC->aigp_originate = 1; }
#line 11029 "obj/conf/cf-parse.tab.c"
    break;

  case 880: /* bgp_channel_item: COST expr  */
#line 269 "proto/bgp/config.Y"
             { BGP_CC->cost = (yyvsp[0].i); if ((yyvsp[0].i) < 1) cf_error("Cost must be positive"); }
#line 11035 "obj/conf/cf-parse.tab.c"
    break;

  case 881: /* bgp_channel_item: IGP TABLE rtable  */
#line 270 "proto/bgp/config.Y"
                    {
    if (BGP_CC->desc->no_igp)
      cf_error("IGP table not allowed here");

    if ((yyvsp[0].r)->addr_type == NET_IP4)
      BGP_CC->igp_table_ip4 = (yyvsp[0].r);
    else if ((yyvsp[0].r)->addr_type == NET_IP6)
      BGP_CC->igp_table_ip6 = (yyvsp[0].r);
    else
      cf_error("Mismatched IGP table type");
   }
#line 11051 "obj/conf/cf-parse.tab.c"
    break;

  case 886: /* bgp_channel_end: %empty  */
#line 294 "proto/bgp/config.Y"
{
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 11062 "obj/conf/cf-parse.tab.c"
    break;

  case 888: /* dynamic_attr: BGP_ORIGIN  */
#line 305 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(PROTOCOL_BGP, BA_ORIGIN)); }
#line 11068 "obj/conf/cf-parse.tab.c"
    break;

  case 889: /* dynamic_attr: BGP_PATH  */
#line 307 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(PROTOCOL_BGP, BA_AS_PATH)); }
#line 11074 "obj/conf/cf-parse.tab.c"
    break;

  case 890: /* dynamic_attr: BGP_NEXT_HOP  */
#line 309 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(PROTOCOL_BGP, BA_NEXT_HOP)); }
#line 11080 "obj/conf/cf-parse.tab.c"
    break;

  case 891: /* dynamic_attr: BGP_MED  */
#line 311 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_MULTI_EXIT_DISC)); }
#line 11086 "obj/conf/cf-parse.tab.c"
    break;

  case 892: /* dynamic_attr: BGP_LOCAL_PREF  */
#line 313 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_LOCAL_PREF)); }
#line 11092 "obj/conf/cf-parse.tab.c"
    break;

  case 893: /* dynamic_attr: BGP_ATOMIC_AGGR  */
#line 315 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_ATOMIC_AGGR)); }
#line 11098 "obj/conf/cf-parse.tab.c"
    break;

  case 894: /* dynamic_attr: BGP_AGGREGATOR  */
#line 317 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AGGREGATOR)); }
#line 11104 "obj/conf/cf-parse.tab.c"
    break;

  case 895: /* dynamic_attr: BGP_COMMUNITY  */
#line 319 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_COMMUNITY)); }
#line 11110 "obj/conf/cf-parse.tab.c"
    break;

  case 896: /* dynamic_attr: BGP_ORIGINATOR_ID  */
#line 321 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(PROTOCOL_BGP, BA_ORIGINATOR_ID)); }
#line 11116 "obj/conf/cf-parse.tab.c"
    break;

  case 897: /* dynamic_attr: BGP_CLUSTER_LIST  */
#line 323 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_CLUSTER_LIST)); }
#line 11122 "obj/conf/cf-parse.tab.c"
    break;

  case 898: /* dynamic_attr: BGP_EXT_COMMUNITY  */
#line 325 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(PROTOCOL_BGP, BA_EXT_COMMUNITY)); }
#line 11128 "obj/conf/cf-parse.tab.c"
    break;

  case 899: /* dynamic_attr: BGP_AIGP  */
#line 327 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AIGP)); }
#line 11134 "obj/conf/cf-parse.tab.c"
    break;

  case 900: /* dynamic_attr: BGP_LARGE_COMMUNITY  */
#line 329 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(PROTOCOL_BGP, BA_LARGE_COMMUNITY)); }
#line 11140 "obj/conf/cf-parse.tab.c"
    break;

  case 902: /* mrt_proto_start: proto_start MRT  */
#line 29 "proto/mrt/config.Y"
{
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 11148 "obj/conf/cf-parse.tab.c"
    break;

  case 904: /* mrt_proto_item: TABLE rtable  */
#line 35 "proto/mrt/config.Y"
                        { MRT_CFG->table_cf = (yyvsp[0].r); }
#line 11154 "obj/conf/cf-parse.tab.c"
    break;

  case 905: /* mrt_proto_item: TABLE TEXT  */
#line 36 "proto/mrt/config.Y"
                        { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 11160 "obj/conf/cf-parse.tab.c"
    break;

  case 906: /* mrt_proto_item: FILTER filter  */
#line 37 "proto/mrt/config.Y"
                        { MRT_CFG->filter = (yyvsp[0].f); }
#line 11166 "obj/conf/cf-parse.tab.c"
    break;

  case 907: /* mrt_proto_item: where_filter  */
#line 38 "proto/mrt/config.Y"
                        { MRT_CFG->filter = (yyvsp[0].f); }
#line 11172 "obj/conf/cf-parse.tab.c"
    break;

  case 908: /* mrt_proto_item: FILENAME text  */
#line 39 "proto/mrt/config.Y"
                        { MRT_CFG->filename = (yyvsp[0].t); }
#line 11178 "obj/conf/cf-parse.tab.c"
    break;

  case 909: /* mrt_proto_item: PERIOD expr  */
#line 40 "proto/mrt/config.Y"
                        { MRT_CFG->period = (yyvsp[0].i); }
#line 11184 "obj/conf/cf-parse.tab.c"
    break;

  case 910: /* mrt_proto_item: ALWAYS ADD PATH bool  */
#line 41 "proto/mrt/config.Y"
                        { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 11190 "obj/conf/cf-parse.tab.c"
    break;

  case 913: /* mrt_proto: mrt_proto_start proto_name '{' mrt_proto_opts '}'  */
#line 50 "proto/mrt/config.Y"
                                                     { mrt_check_config(this_proto); }
#line 11196 "obj/conf/cf-parse.tab.c"
    break;

  case 915: /* cmd_MRT_DUMP: MRT DUMP mrt_dump_args END  */
#line 54 "proto/mrt/config.Y"
{ mrt_dump_cmd((yyvsp[-1].md)); }
#line 11202 "obj/conf/cf-parse.tab.c"
    break;

  case 916: /* mrt_dump_args: %empty  */
#line 57 "proto/mrt/config.Y"
               { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 11208 "obj/conf/cf-parse.tab.c"
    break;

  case 917: /* mrt_dump_args: mrt_dump_args TABLE rtable  */
#line 58 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 11214 "obj/conf/cf-parse.tab.c"
    break;

  case 918: /* mrt_dump_args: mrt_dump_args TABLE TEXT  */
#line 59 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 11220 "obj/conf/cf-parse.tab.c"
    break;

  case 919: /* mrt_dump_args: mrt_dump_args FILTER filter  */
#line 60 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 11226 "obj/conf/cf-parse.tab.c"
    break;

  case 920: /* mrt_dump_args: mrt_dump_args where_filter  */
#line 61 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 11232 "obj/conf/cf-parse.tab.c"
    break;

  case 921: /* mrt_dump_args: mrt_dump_args TO text  */
#line 62 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 11238 "obj/conf/cf-parse.tab.c"
    break;

  case 922: /* proto: ospf_proto '}'  */
#line 211 "proto/ospf/config.Y"
                      { ospf_proto_finish(); }
#line 11244 "obj/conf/cf-parse.tab.c"
    break;

  case 923: /* ospf_variant: OSPF  */
#line 214 "proto/ospf/config.Y"
           { (yyval.i) = 1; }
#line 11250 "obj/conf/cf-parse.tab.c"
    break;

  case 924: /* ospf_variant: OSPF V2  */
#line 215 "proto/ospf/config.Y"
           { (yyval.i) = 1; }
#line 11256 "obj/conf/cf-parse.tab.c"
    break;

  case 925: /* ospf_variant: OSPF V3  */
#line 216 "proto/ospf/config.Y"
           { (yyval.i) = 0; }
#line 11262 "obj/conf/cf-parse.tab.c"
    break;

  case 926: /* ospf_proto_start: proto_start ospf_variant  */
#line 220 "proto/ospf/config.Y"
{
  this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : 0;

  init_list(&OSPF_CFG->area_list);
  init_list(&OSPF_CFG->vlink_list);
  OSPF_CFG->ecmp = rt_default_ecmp;
  OSPF_CFG->tick = OSPF_DEFAULT_TICK;
  OSPF_CFG->ospf2 = (yyvsp[0].i);
  OSPF_CFG->af_ext = !(yyvsp[0].i);
  OSPF_CFG->gr_mode = OSPF_GR_AWARE;
  OSPF_CFG->gr_time = OSPF_DEFAULT_GR_TIME;
}
#line 11280 "obj/conf/cf-parse.tab.c"
    break;

  case 929: /* ospf_af_mc: %empty  */
#line 240 "proto/ospf/config.Y"
             { (yyval.i) = 0; }
#line 11286 "obj/conf/cf-parse.tab.c"
    break;

  case 930: /* ospf_af_mc: MULTICAST  */
#line 241 "proto/ospf/config.Y"
             { (yyval.i) = 1; }
#line 11292 "obj/conf/cf-parse.tab.c"
    break;

  case 931: /* ospf_channel_start: net_type ospf_af_mc  */
#line 246 "proto/ospf/config.Y"
{
  /* TODO: change name for multicast channels */
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[-1].i)], (yyvsp[-1].i), this_proto);

  /* Save the multicast flag */
  if (this_channel == proto_cf_main_channel(this_proto))
    OSPF_CFG->af_mc = (yyvsp[0].i);
}
#line 11305 "obj/conf/cf-parse.tab.c"
    break;

  case 934: /* ospf_proto_item: ospf_channel  */
#line 259 "proto/ospf/config.Y"
                { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 11311 "obj/conf/cf-parse.tab.c"
    break;

  case 935: /* ospf_proto_item: RFC1583COMPAT bool  */
#line 260 "proto/ospf/config.Y"
                      { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 11317 "obj/conf/cf-parse.tab.c"
    break;

  case 936: /* ospf_proto_item: RFC5838 bool  */
#line 261 "proto/ospf/config.Y"
                { OSPF_CFG->af_ext = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("RFC5838 option requires OSPFv3"); }
#line 11323 "obj/conf/cf-parse.tab.c"
    break;

  case 937: /* ospf_proto_item: VPN PE bool  */
#line 262 "proto/ospf/config.Y"
               { OSPF_CFG->vpn_pe = (yyvsp[0].i); }
#line 11329 "obj/conf/cf-parse.tab.c"
    break;

  case 938: /* ospf_proto_item: STUB ROUTER bool  */
#line 263 "proto/ospf/config.Y"
                    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 11335 "obj/conf/cf-parse.tab.c"
    break;

  case 939: /* ospf_proto_item: GRACEFUL RESTART bool  */
#line 264 "proto/ospf/config.Y"
                         { OSPF_CFG->gr_mode = (yyvsp[0].i); }
#line 11341 "obj/conf/cf-parse.tab.c"
    break;

  case 940: /* ospf_proto_item: GRACEFUL RESTART AWARE  */
#line 265 "proto/ospf/config.Y"
                          { OSPF_CFG->gr_mode = OSPF_GR_AWARE; }
#line 11347 "obj/conf/cf-parse.tab.c"
    break;

  case 941: /* ospf_proto_item: GRACEFUL RESTART TIME expr  */
#line 266 "proto/ospf/config.Y"
                              { OSPF_CFG->gr_time = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 1800)) cf_error("Graceful restart time must be in range 1-1800"); }
#line 11353 "obj/conf/cf-parse.tab.c"
    break;

  case 942: /* ospf_proto_item: ECMP bool  */
#line 267 "proto/ospf/config.Y"
             { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 11359 "obj/conf/cf-parse.tab.c"
    break;

  case 943: /* ospf_proto_item: ECMP bool LIMIT expr  */
#line 268 "proto/ospf/config.Y"
                        { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 11365 "obj/conf/cf-parse.tab.c"
    break;

  case 944: /* ospf_proto_item: MERGE EXTERNAL bool  */
#line 269 "proto/ospf/config.Y"
                       { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 11371 "obj/conf/cf-parse.tab.c"
    break;

  case 945: /* ospf_proto_item: TICK expr  */
#line 270 "proto/ospf/config.Y"
             { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i) <= 0) cf_error("Tick must be greater than zero"); }
#line 11377 "obj/conf/cf-parse.tab.c"
    break;

  case 946: /* ospf_proto_item: INSTANCE ID expr  */
#line 271 "proto/ospf/config.Y"
                    { OSPF_CFG->instance_id = (yyvsp[0].i); OSPF_CFG->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 11383 "obj/conf/cf-parse.tab.c"
    break;

  case 948: /* ospf_area_start: AREA idval  */
#line 275 "proto/ospf/config.Y"
                            {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 11401 "obj/conf/cf-parse.tab.c"
    break;

  case 949: /* ospf_area: ospf_area_start '{' ospf_area_opts '}'  */
#line 290 "proto/ospf/config.Y"
                                                  { ospf_area_finish(); }
#line 11407 "obj/conf/cf-parse.tab.c"
    break;

  case 952: /* ospf_area_item: STUB bool  */
#line 299 "proto/ospf/config.Y"
             { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 11413 "obj/conf/cf-parse.tab.c"
    break;

  case 953: /* ospf_area_item: NSSA  */
#line 300 "proto/ospf/config.Y"
        { this_area->type = OPT_N; }
#line 11419 "obj/conf/cf-parse.tab.c"
    break;

  case 954: /* ospf_area_item: SUMMARY bool  */
#line 301 "proto/ospf/config.Y"
                { this_area->summary = (yyvsp[0].i); }
#line 11425 "obj/conf/cf-parse.tab.c"
    break;

  case 955: /* ospf_area_item: DEFAULT NSSA bool  */
#line 302 "proto/ospf/config.Y"
                     { this_area->default_nssa = (yyvsp[0].i); }
#line 11431 "obj/conf/cf-parse.tab.c"
    break;

  case 956: /* ospf_area_item: DEFAULT COST expr  */
#line 303 "proto/ospf/config.Y"
                     { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 11437 "obj/conf/cf-parse.tab.c"
    break;

  case 957: /* ospf_area_item: DEFAULT COST2 expr  */
#line 304 "proto/ospf/config.Y"
                      { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 11443 "obj/conf/cf-parse.tab.c"
    break;

  case 958: /* ospf_area_item: STUB COST expr  */
#line 305 "proto/ospf/config.Y"
                  { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 11449 "obj/conf/cf-parse.tab.c"
    break;

  case 959: /* ospf_area_item: TRANSLATOR bool  */
#line 306 "proto/ospf/config.Y"
                   { this_area->translator = (yyvsp[0].i); }
#line 11455 "obj/conf/cf-parse.tab.c"
    break;

  case 960: /* ospf_area_item: TRANSLATOR STABILITY expr  */
#line 307 "proto/ospf/config.Y"
                             { this_area->transint = (yyvsp[0].i); }
#line 11461 "obj/conf/cf-parse.tab.c"
    break;

  case 961: /* $@5: %empty  */
#line 308 "proto/ospf/config.Y"
            { this_nets = &this_area->net_list; }
#line 11467 "obj/conf/cf-parse.tab.c"
    break;

  case 963: /* $@6: %empty  */
#line 309 "proto/ospf/config.Y"
            { this_nets = &this_area->enet_list; }
#line 11473 "obj/conf/cf-parse.tab.c"
    break;

  case 970: /* ospf_stubnet_start: net_ip  */
#line 321 "proto/ospf/config.Y"
          {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->prefix = (yyvsp[0].net);
     this_stubnet->cost = COST_D;
   }
#line 11484 "obj/conf/cf-parse.tab.c"
    break;

  case 973: /* ospf_stubnet_item: HIDDEN bool  */
#line 335 "proto/ospf/config.Y"
               { this_stubnet->hidden = (yyvsp[0].i); }
#line 11490 "obj/conf/cf-parse.tab.c"
    break;

  case 974: /* ospf_stubnet_item: SUMMARY bool  */
#line 336 "proto/ospf/config.Y"
                { this_stubnet->summary = (yyvsp[0].i); }
#line 11496 "obj/conf/cf-parse.tab.c"
    break;

  case 975: /* ospf_stubnet_item: COST expr  */
#line 337 "proto/ospf/config.Y"
             { this_stubnet->cost = (yyvsp[0].i); }
#line 11502 "obj/conf/cf-parse.tab.c"
    break;

  case 976: /* ospf_vlink: ospf_vlink_start ospf_instance_id '{' ospf_vlink_opts '}'  */
#line 341 "proto/ospf/config.Y"
                                                             { ospf_iface_finish(); }
#line 11508 "obj/conf/cf-parse.tab.c"
    break;

  case 977: /* ospf_vlink: ospf_vlink_start ospf_instance_id  */
#line 342 "proto/ospf/config.Y"
                                     { ospf_iface_finish(); }
#line 11514 "obj/conf/cf-parse.tab.c"
    break;

  case 981: /* ospf_vlink_item: HELLO expr  */
#line 351 "proto/ospf/config.Y"
              { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 11520 "obj/conf/cf-parse.tab.c"
    break;

  case 982: /* ospf_vlink_item: RETRANSMIT expr  */
#line 352 "proto/ospf/config.Y"
                   { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 11526 "obj/conf/cf-parse.tab.c"
    break;

  case 983: /* ospf_vlink_item: TRANSMIT DELAY expr  */
#line 353 "proto/ospf/config.Y"
                       { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 11532 "obj/conf/cf-parse.tab.c"
    break;

  case 984: /* ospf_vlink_item: WAIT expr  */
#line 354 "proto/ospf/config.Y"
             { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 11538 "obj/conf/cf-parse.tab.c"
    break;

  case 985: /* ospf_vlink_item: DEAD expr  */
#line 355 "proto/ospf/config.Y"
             { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 11544 "obj/conf/cf-parse.tab.c"
    break;

  case 986: /* ospf_vlink_item: DEAD COUNT expr  */
#line 356 "proto/ospf/config.Y"
                   { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 11550 "obj/conf/cf-parse.tab.c"
    break;

  case 987: /* ospf_vlink_item: AUTHENTICATION NONE  */
#line 357 "proto/ospf/config.Y"
                       { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 11556 "obj/conf/cf-parse.tab.c"
    break;

  case 988: /* ospf_vlink_item: AUTHENTICATION SIMPLE  */
#line 358 "proto/ospf/config.Y"
                         { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 11562 "obj/conf/cf-parse.tab.c"
    break;

  case 989: /* ospf_vlink_item: AUTHENTICATION CRYPTOGRAPHIC  */
#line 359 "proto/ospf/config.Y"
                                { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 11568 "obj/conf/cf-parse.tab.c"
    break;

  case 991: /* ospf_vlink_start: VIRTUAL LINK idval  */
#line 364 "proto/ospf/config.Y"
 {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 11588 "obj/conf/cf-parse.tab.c"
    break;

  case 992: /* ospf_iface_item: COST expr  */
#line 382 "proto/ospf/config.Y"
             { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 11594 "obj/conf/cf-parse.tab.c"
    break;

  case 993: /* ospf_iface_item: HELLO expr  */
#line 383 "proto/ospf/config.Y"
              { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 11600 "obj/conf/cf-parse.tab.c"
    break;

  case 994: /* ospf_iface_item: POLL expr  */
#line 384 "proto/ospf/config.Y"
             { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 11606 "obj/conf/cf-parse.tab.c"
    break;

  case 995: /* ospf_iface_item: RETRANSMIT expr  */
#line 385 "proto/ospf/config.Y"
                   { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 11612 "obj/conf/cf-parse.tab.c"
    break;

  case 996: /* ospf_iface_item: WAIT expr  */
#line 386 "proto/ospf/config.Y"
             { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 11618 "obj/conf/cf-parse.tab.c"
    break;

  case 997: /* ospf_iface_item: DEAD expr  */
#line 387 "proto/ospf/config.Y"
             { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 11624 "obj/conf/cf-parse.tab.c"
    break;

  case 998: /* ospf_iface_item: DEAD COUNT expr  */
#line 388 "proto/ospf/config.Y"
                   { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 11630 "obj/conf/cf-parse.tab.c"
    break;

  case 999: /* ospf_iface_item: TYPE BROADCAST  */
#line 389 "proto/ospf/config.Y"
                  { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 11636 "obj/conf/cf-parse.tab.c"
    break;

  case 1000: /* ospf_iface_item: TYPE BCAST  */
#line 390 "proto/ospf/config.Y"
              { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 11642 "obj/conf/cf-parse.tab.c"
    break;

  case 1001: /* ospf_iface_item: TYPE NONBROADCAST  */
#line 391 "proto/ospf/config.Y"
                     { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 11648 "obj/conf/cf-parse.tab.c"
    break;

  case 1002: /* ospf_iface_item: TYPE NBMA  */
#line 392 "proto/ospf/config.Y"
             { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 11654 "obj/conf/cf-parse.tab.c"
    break;

  case 1003: /* ospf_iface_item: TYPE POINTOPOINT  */
#line 393 "proto/ospf/config.Y"
                    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 11660 "obj/conf/cf-parse.tab.c"
    break;

  case 1004: /* ospf_iface_item: TYPE PTP  */
#line 394 "proto/ospf/config.Y"
            { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 11666 "obj/conf/cf-parse.tab.c"
    break;

  case 1005: /* ospf_iface_item: TYPE POINTOMULTIPOINT  */
#line 395 "proto/ospf/config.Y"
                         { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 11672 "obj/conf/cf-parse.tab.c"
    break;

  case 1006: /* ospf_iface_item: TYPE PTMP  */
#line 396 "proto/ospf/config.Y"
             { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 11678 "obj/conf/cf-parse.tab.c"
    break;

  case 1007: /* ospf_iface_item: REAL BROADCAST bool  */
#line 397 "proto/ospf/config.Y"
                       { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 11684 "obj/conf/cf-parse.tab.c"
    break;

  case 1008: /* ospf_iface_item: PTP NETMASK bool  */
#line 398 "proto/ospf/config.Y"
                    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 11690 "obj/conf/cf-parse.tab.c"
    break;

  case 1009: /* ospf_iface_item: PTP ADDRESS bool  */
#line 399 "proto/ospf/config.Y"
                    { OSPF_PATT->ptp_address = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP address option requires OSPFv2"); }
#line 11696 "obj/conf/cf-parse.tab.c"
    break;

  case 1010: /* ospf_iface_item: TRANSMIT DELAY expr  */
#line 400 "proto/ospf/config.Y"
                       { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 11702 "obj/conf/cf-parse.tab.c"
    break;

  case 1011: /* ospf_iface_item: PRIORITY expr  */
#line 401 "proto/ospf/config.Y"
                 { OSPF_PATT->priority = (yyvsp[0].i) ; if ((yyvsp[0].i)>255) cf_error("Priority must be in range 0-255"); }
#line 11708 "obj/conf/cf-parse.tab.c"
    break;

  case 1012: /* ospf_iface_item: STRICT NONBROADCAST bool  */
#line 402 "proto/ospf/config.Y"
                            { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 11714 "obj/conf/cf-parse.tab.c"
    break;

  case 1013: /* ospf_iface_item: STUB bool  */
#line 403 "proto/ospf/config.Y"
             { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 11720 "obj/conf/cf-parse.tab.c"
    break;

  case 1014: /* ospf_iface_item: CHECK LINK bool  */
#line 404 "proto/ospf/config.Y"
                   { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 11726 "obj/conf/cf-parse.tab.c"
    break;

  case 1015: /* ospf_iface_item: ECMP WEIGHT expr  */
#line 405 "proto/ospf/config.Y"
                    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 11732 "obj/conf/cf-parse.tab.c"
    break;

  case 1016: /* ospf_iface_item: LINK LSA SUPPRESSION bool  */
#line 406 "proto/ospf/config.Y"
                             { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 11738 "obj/conf/cf-parse.tab.c"
    break;

  case 1018: /* ospf_iface_item: AUTHENTICATION NONE  */
#line 408 "proto/ospf/config.Y"
                       { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 11744 "obj/conf/cf-parse.tab.c"
    break;

  case 1019: /* ospf_iface_item: AUTHENTICATION SIMPLE  */
#line 409 "proto/ospf/config.Y"
                         { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 11750 "obj/conf/cf-parse.tab.c"
    break;

  case 1020: /* ospf_iface_item: AUTHENTICATION CRYPTOGRAPHIC  */
#line 410 "proto/ospf/config.Y"
                                { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 11756 "obj/conf/cf-parse.tab.c"
    break;

  case 1021: /* ospf_iface_item: RX BUFFER NORMAL  */
#line 411 "proto/ospf/config.Y"
                    { OSPF_PATT->rx_buffer = 0; }
#line 11762 "obj/conf/cf-parse.tab.c"
    break;

  case 1022: /* ospf_iface_item: RX BUFFER LARGE  */
#line 412 "proto/ospf/config.Y"
                   { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 11768 "obj/conf/cf-parse.tab.c"
    break;

  case 1023: /* ospf_iface_item: RX BUFFER expr  */
#line 413 "proto/ospf/config.Y"
                  { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 11774 "obj/conf/cf-parse.tab.c"
    break;

  case 1024: /* ospf_iface_item: TX tos  */
#line 414 "proto/ospf/config.Y"
          { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 11780 "obj/conf/cf-parse.tab.c"
    break;

  case 1025: /* ospf_iface_item: TX PRIORITY expr  */
#line 415 "proto/ospf/config.Y"
                    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 11786 "obj/conf/cf-parse.tab.c"
    break;

  case 1026: /* ospf_iface_item: TX LENGTH expr  */
#line 416 "proto/ospf/config.Y"
                  { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 11792 "obj/conf/cf-parse.tab.c"
    break;

  case 1027: /* ospf_iface_item: TTL SECURITY bool  */
#line 417 "proto/ospf/config.Y"
                     { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 11798 "obj/conf/cf-parse.tab.c"
    break;

  case 1028: /* ospf_iface_item: TTL SECURITY TX ONLY  */
#line 418 "proto/ospf/config.Y"
                        { OSPF_PATT->ttl_security = 2; }
#line 11804 "obj/conf/cf-parse.tab.c"
    break;

  case 1029: /* ospf_iface_item: BFD bool  */
#line 419 "proto/ospf/config.Y"
            { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 11810 "obj/conf/cf-parse.tab.c"
    break;

  case 1034: /* pref_base: net_ip  */
#line 431 "proto/ospf/config.Y"
 {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->prefix = (yyvsp[0].net);
 }
#line 11820 "obj/conf/cf-parse.tab.c"
    break;

  case 1036: /* pref_opt: HIDDEN  */
#line 440 "proto/ospf/config.Y"
          { this_pref->hidden = 1; }
#line 11826 "obj/conf/cf-parse.tab.c"
    break;

  case 1037: /* pref_opt: TAG expr  */
#line 441 "proto/ospf/config.Y"
            { this_pref->tag = (yyvsp[0].i); }
#line 11832 "obj/conf/cf-parse.tab.c"
    break;

  case 1040: /* nbma_eligible: %empty  */
#line 450 "proto/ospf/config.Y"
             { (yyval.i) = 0; }
#line 11838 "obj/conf/cf-parse.tab.c"
    break;

  case 1041: /* nbma_eligible: ELIGIBLE  */
#line 451 "proto/ospf/config.Y"
            { (yyval.i) = 1; }
#line 11844 "obj/conf/cf-parse.tab.c"
    break;

  case 1042: /* nbma_item: ipa nbma_eligible ';'  */
#line 455 "proto/ospf/config.Y"
 {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 11855 "obj/conf/cf-parse.tab.c"
    break;

  case 1043: /* ospf_iface_start: %empty  */
#line 464 "proto/ospf/config.Y"
 {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->check_link = 1;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->ptp_address = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 11880 "obj/conf/cf-parse.tab.c"
    break;

  case 1045: /* ospf_instance_id: INSTANCE expr  */
#line 488 "proto/ospf/config.Y"
                 { OSPF_PATT->instance_id = (yyvsp[0].i); OSPF_PATT->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 11886 "obj/conf/cf-parse.tab.c"
    break;

  case 1046: /* $@7: %empty  */
#line 492 "proto/ospf/config.Y"
                   { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 11892 "obj/conf/cf-parse.tab.c"
    break;

  case 1052: /* ospf_iface: ospf_iface_start ospf_iface_patt_list ospf_iface_opt_list  */
#line 506 "proto/ospf/config.Y"
                                                            { ospf_iface_finish(); }
#line 11898 "obj/conf/cf-parse.tab.c"
    break;

  case 1053: /* dynamic_attr: OSPF_METRIC1  */
#line 509 "proto/ospf/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC1); }
#line 11904 "obj/conf/cf-parse.tab.c"
    break;

  case 1054: /* dynamic_attr: OSPF_METRIC2  */
#line 510 "proto/ospf/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC2); }
#line 11910 "obj/conf/cf-parse.tab.c"
    break;

  case 1055: /* dynamic_attr: OSPF_TAG  */
#line 511 "proto/ospf/config.Y"
                       { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_TAG); }
#line 11916 "obj/conf/cf-parse.tab.c"
    break;

  case 1056: /* dynamic_attr: OSPF_ROUTER_ID  */
#line 512 "proto/ospf/config.Y"
                             { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 11922 "obj/conf/cf-parse.tab.c"
    break;

  case 1058: /* cmd_SHOW_OSPF: SHOW OSPF optproto END  */
#line 516 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].s), &proto_ospf, p) ospf_sh(p); }
#line 11928 "obj/conf/cf-parse.tab.c"
    break;

  case 1060: /* cmd_SHOW_OSPF_NEIGHBORS: SHOW OSPF NEIGHBORS optproto opttext END  */
#line 519 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_ospf, p) ospf_sh_neigh(p, (yyvsp[-1].t)); }
#line 11934 "obj/conf/cf-parse.tab.c"
    break;

  case 1062: /* cmd_SHOW_OSPF_INTERFACE: SHOW OSPF INTERFACE optproto opttext END  */
#line 522 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_ospf, p) ospf_sh_iface(p, (yyvsp[-1].t)); }
#line 11940 "obj/conf/cf-parse.tab.c"
    break;

  case 1064: /* cmd_SHOW_OSPF_TOPOLOGY: SHOW OSPF TOPOLOGY optproto opttext END  */
#line 527 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 11946 "obj/conf/cf-parse.tab.c"
    break;

  case 1066: /* cmd_SHOW_OSPF_TOPOLOGY_ALL: SHOW OSPF TOPOLOGY ALL optproto opttext END  */
#line 530 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 11952 "obj/conf/cf-parse.tab.c"
    break;

  case 1068: /* cmd_SHOW_OSPF_STATE: SHOW OSPF STATE optproto opttext END  */
#line 535 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 11958 "obj/conf/cf-parse.tab.c"
    break;

  case 1070: /* cmd_SHOW_OSPF_STATE_ALL: SHOW OSPF STATE ALL optproto opttext END  */
#line 538 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 11964 "obj/conf/cf-parse.tab.c"
    break;

  case 1072: /* cmd_SHOW_OSPF_LSADB: SHOW OSPF LSADB lsadb_args END  */
#line 542 "proto/ospf/config.Y"
{
  if (!(yyvsp[-1].ld)->proto)
    (yyvsp[-1].ld)->proto = (struct ospf_proto *) proto_get_named(NULL, &proto_ospf);

  ospf_sh_lsadb((yyvsp[-1].ld));
}
#line 11975 "obj/conf/cf-parse.tab.c"
    break;

  case 1073: /* lsadb_args: %empty  */
#line 550 "proto/ospf/config.Y"
               {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 11983 "obj/conf/cf-parse.tab.c"
    break;

  case 1074: /* lsadb_args: lsadb_args GLOBAL  */
#line 553 "proto/ospf/config.Y"
                     { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 11989 "obj/conf/cf-parse.tab.c"
    break;

  case 1075: /* lsadb_args: lsadb_args AREA idval  */
#line 554 "proto/ospf/config.Y"
                         { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 11995 "obj/conf/cf-parse.tab.c"
    break;

  case 1076: /* lsadb_args: lsadb_args LINK  */
#line 555 "proto/ospf/config.Y"
                   { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 12001 "obj/conf/cf-parse.tab.c"
    break;

  case 1077: /* lsadb_args: lsadb_args TYPE NUM  */
#line 556 "proto/ospf/config.Y"
                       { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 12007 "obj/conf/cf-parse.tab.c"
    break;

  case 1078: /* lsadb_args: lsadb_args LSID idval  */
#line 557 "proto/ospf/config.Y"
                         { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 12013 "obj/conf/cf-parse.tab.c"
    break;

  case 1079: /* lsadb_args: lsadb_args SELF  */
#line 558 "proto/ospf/config.Y"
                   { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 12019 "obj/conf/cf-parse.tab.c"
    break;

  case 1080: /* lsadb_args: lsadb_args ROUTER idval  */
#line 559 "proto/ospf/config.Y"
                           { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 12025 "obj/conf/cf-parse.tab.c"
    break;

  case 1081: /* lsadb_args: lsadb_args CF_SYM_KNOWN  */
#line 560 "proto/ospf/config.Y"
                           { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->proto = (struct ospf_proto *) proto_get_named((yyvsp[0].s), &proto_ospf); }
#line 12031 "obj/conf/cf-parse.tab.c"
    break;

  case 1083: /* perf_proto_start: proto_start PERF  */
#line 27 "proto/perf/config.Y"
{
  this_proto = proto_config_new(&proto_perf, (yyvsp[-1].i));
  PERF_CFG->from = 10;
  PERF_CFG->to = 20;
  PERF_CFG->repeat = 4;
  PERF_CFG->threshold_max = 500 MS_;
  PERF_CFG->threshold_min = 1 MS_;
  PERF_CFG->attrs_per_rte = 0;
  PERF_CFG->keep = 0;
  PERF_CFG->mode = PERF_MODE_IMPORT;
}
#line 12047 "obj/conf/cf-parse.tab.c"
    break;

  case 1087: /* perf_proto_item: proto_channel  */
#line 46 "proto/perf/config.Y"
                 { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 12053 "obj/conf/cf-parse.tab.c"
    break;

  case 1088: /* perf_proto_item: EXP FROM NUM  */
#line 47 "proto/perf/config.Y"
                { PERF_CFG->from = (yyvsp[0].i); }
#line 12059 "obj/conf/cf-parse.tab.c"
    break;

  case 1089: /* perf_proto_item: EXP TO NUM  */
#line 48 "proto/perf/config.Y"
              { PERF_CFG->to = (yyvsp[0].i); }
#line 12065 "obj/conf/cf-parse.tab.c"
    break;

  case 1090: /* perf_proto_item: REPEAT NUM  */
#line 49 "proto/perf/config.Y"
              { PERF_CFG->repeat = (yyvsp[0].i); }
#line 12071 "obj/conf/cf-parse.tab.c"
    break;

  case 1091: /* perf_proto_item: THRESHOLD MIN expr_us  */
#line 50 "proto/perf/config.Y"
                         { PERF_CFG->threshold_min = (yyvsp[0].time); }
#line 12077 "obj/conf/cf-parse.tab.c"
    break;

  case 1092: /* perf_proto_item: THRESHOLD MAX expr_us  */
#line 51 "proto/perf/config.Y"
                         { PERF_CFG->threshold_max = (yyvsp[0].time); }
#line 12083 "obj/conf/cf-parse.tab.c"
    break;

  case 1093: /* perf_proto_item: ATTRIBUTES NUM  */
#line 52 "proto/perf/config.Y"
                  { PERF_CFG->attrs_per_rte = (yyvsp[0].i); }
#line 12089 "obj/conf/cf-parse.tab.c"
    break;

  case 1094: /* perf_proto_item: KEEP bool  */
#line 53 "proto/perf/config.Y"
             { PERF_CFG->keep = (yyvsp[0].i); }
#line 12095 "obj/conf/cf-parse.tab.c"
    break;

  case 1095: /* perf_proto_item: MODE IMPORT  */
#line 54 "proto/perf/config.Y"
               { PERF_CFG->mode = PERF_MODE_IMPORT; }
#line 12101 "obj/conf/cf-parse.tab.c"
    break;

  case 1096: /* perf_proto_item: MODE EXPORT  */
#line 55 "proto/perf/config.Y"
               { PERF_CFG->mode = PERF_MODE_EXPORT; }
#line 12107 "obj/conf/cf-parse.tab.c"
    break;

  case 1097: /* proto: pipe_proto '}'  */
#line 23 "proto/pipe/config.Y"
                      { this_channel = NULL; }
#line 12113 "obj/conf/cf-parse.tab.c"
    break;

  case 1098: /* $@8: %empty  */
#line 26 "proto/pipe/config.Y"
{
  this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
}
#line 12121 "obj/conf/cf-parse.tab.c"
    break;

  case 1099: /* pipe_proto_start: proto_start PIPE $@8 proto_name  */
#line 30 "proto/pipe/config.Y"
{
  this_channel = proto_cf_main_channel(this_proto);
  if (!this_channel) {
    this_channel = channel_config_new(NULL, NULL, 0, this_proto);
    this_channel->in_filter = FILTER_ACCEPT;
    this_channel->out_filter = FILTER_ACCEPT;
  }
}
#line 12134 "obj/conf/cf-parse.tab.c"
    break;

  case 1103: /* pipe_proto: pipe_proto PEER TABLE rtable ';'  */
#line 43 "proto/pipe/config.Y"
                                    { PIPE_CFG->peer = (yyvsp[-1].r); }
#line 12140 "obj/conf/cf-parse.tab.c"
    break;

  case 1105: /* radv_proto_start: proto_start RADV  */
#line 47 "proto/radv/config.Y"
{
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));

  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 12153 "obj/conf/cf-parse.tab.c"
    break;

  case 1109: /* radv_proto_item: PREFIX radv_prefix  */
#line 60 "proto/radv/config.Y"
                      { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 12159 "obj/conf/cf-parse.tab.c"
    break;

  case 1110: /* $@9: %empty  */
#line 61 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12165 "obj/conf/cf-parse.tab.c"
    break;

  case 1111: /* radv_proto_item: RDNSS $@9 radv_rdnss  */
#line 61 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 12171 "obj/conf/cf-parse.tab.c"
    break;

  case 1112: /* $@10: %empty  */
#line 62 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12177 "obj/conf/cf-parse.tab.c"
    break;

  case 1113: /* radv_proto_item: DNSSL $@10 radv_dnssl  */
#line 62 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 12183 "obj/conf/cf-parse.tab.c"
    break;

  case 1114: /* radv_proto_item: TRIGGER net_ip6  */
#line 63 "proto/radv/config.Y"
                   { RADV_CFG->trigger = (yyvsp[0].net); }
#line 12189 "obj/conf/cf-parse.tab.c"
    break;

  case 1115: /* radv_proto_item: PROPAGATE ROUTES bool  */
#line 64 "proto/radv/config.Y"
                         { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 12195 "obj/conf/cf-parse.tab.c"
    break;

  case 1119: /* radv_iface_start: %empty  */
#line 77 "proto/radv/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = (u32) -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = (u32) -1;
  RADV_IFACE->route_linger_time = (u32) -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = (u32) -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = (u32) -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 12221 "obj/conf/cf-parse.tab.c"
    break;

  case 1120: /* radv_iface_item: MIN RA INTERVAL expr  */
#line 100 "proto/radv/config.Y"
                        { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 12227 "obj/conf/cf-parse.tab.c"
    break;

  case 1121: /* radv_iface_item: MAX RA INTERVAL expr  */
#line 101 "proto/radv/config.Y"
                        { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 12233 "obj/conf/cf-parse.tab.c"
    break;

  case 1122: /* radv_iface_item: MIN DELAY expr  */
#line 102 "proto/radv/config.Y"
                  { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 12239 "obj/conf/cf-parse.tab.c"
    break;

  case 1123: /* radv_iface_item: SOLICITED RA UNICAST bool  */
#line 103 "proto/radv/config.Y"
                             { RADV_IFACE->solicited_ra_unicast = (yyvsp[0].i); }
#line 12245 "obj/conf/cf-parse.tab.c"
    break;

  case 1124: /* radv_iface_item: MANAGED bool  */
#line 104 "proto/radv/config.Y"
                { RADV_IFACE->managed = (yyvsp[0].i); }
#line 12251 "obj/conf/cf-parse.tab.c"
    break;

  case 1125: /* radv_iface_item: OTHER CONFIG bool  */
#line 105 "proto/radv/config.Y"
                     { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 12257 "obj/conf/cf-parse.tab.c"
    break;

  case 1126: /* radv_iface_item: LINK MTU expr  */
#line 106 "proto/radv/config.Y"
                 { RADV_IFACE->link_mtu = (yyvsp[0].i); }
#line 12263 "obj/conf/cf-parse.tab.c"
    break;

  case 1127: /* radv_iface_item: REACHABLE TIME expr  */
#line 107 "proto/radv/config.Y"
                       { RADV_IFACE->reachable_time = (yyvsp[0].i); if ((yyvsp[0].i) > 3600000) cf_error("Reachable time must be in range 0-3600000"); }
#line 12269 "obj/conf/cf-parse.tab.c"
    break;

  case 1128: /* radv_iface_item: RETRANS TIMER expr  */
#line 108 "proto/radv/config.Y"
                      { RADV_IFACE->retrans_timer = (yyvsp[0].i); }
#line 12275 "obj/conf/cf-parse.tab.c"
    break;

  case 1129: /* radv_iface_item: CURRENT HOP LIMIT expr  */
#line 109 "proto/radv/config.Y"
                          { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if ((yyvsp[0].i) > 255) cf_error("Current hop limit must be in range 0-255"); }
#line 12281 "obj/conf/cf-parse.tab.c"
    break;

  case 1130: /* radv_iface_item: DEFAULT LIFETIME expr radv_sensitive  */
#line 110 "proto/radv/config.Y"
                                        {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) > 9000)  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12291 "obj/conf/cf-parse.tab.c"
    break;

  case 1131: /* radv_iface_item: ROUTE LIFETIME expr radv_sensitive  */
#line 115 "proto/radv/config.Y"
                                      {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12300 "obj/conf/cf-parse.tab.c"
    break;

  case 1132: /* radv_iface_item: DEFAULT PREFERENCE radv_preference  */
#line 119 "proto/radv/config.Y"
                                      { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 12306 "obj/conf/cf-parse.tab.c"
    break;

  case 1133: /* radv_iface_item: ROUTE PREFERENCE radv_preference  */
#line 120 "proto/radv/config.Y"
                                    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 12312 "obj/conf/cf-parse.tab.c"
    break;

  case 1134: /* radv_iface_item: PREFIX LINGER TIME expr  */
#line 121 "proto/radv/config.Y"
                           { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 12318 "obj/conf/cf-parse.tab.c"
    break;

  case 1135: /* radv_iface_item: ROUTE LINGER TIME expr  */
#line 122 "proto/radv/config.Y"
                          { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 12324 "obj/conf/cf-parse.tab.c"
    break;

  case 1136: /* radv_iface_item: PREFIX radv_prefix  */
#line 123 "proto/radv/config.Y"
                      { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 12330 "obj/conf/cf-parse.tab.c"
    break;

  case 1137: /* $@11: %empty  */
#line 124 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12336 "obj/conf/cf-parse.tab.c"
    break;

  case 1138: /* radv_iface_item: RDNSS $@11 radv_rdnss  */
#line 124 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 12342 "obj/conf/cf-parse.tab.c"
    break;

  case 1139: /* $@12: %empty  */
#line 125 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12348 "obj/conf/cf-parse.tab.c"
    break;

  case 1140: /* radv_iface_item: DNSSL $@12 radv_dnssl  */
#line 125 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 12354 "obj/conf/cf-parse.tab.c"
    break;

  case 1141: /* radv_iface_item: RDNSS LOCAL bool  */
#line 126 "proto/radv/config.Y"
                    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 12360 "obj/conf/cf-parse.tab.c"
    break;

  case 1142: /* radv_iface_item: DNSSL LOCAL bool  */
#line 127 "proto/radv/config.Y"
                    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 12366 "obj/conf/cf-parse.tab.c"
    break;

  case 1143: /* radv_preference: LOW  */
#line 131 "proto/radv/config.Y"
       { (yyval.i) = RA_PREF_LOW; }
#line 12372 "obj/conf/cf-parse.tab.c"
    break;

  case 1144: /* radv_preference: MEDIUM  */
#line 132 "proto/radv/config.Y"
          { (yyval.i) = RA_PREF_MEDIUM; }
#line 12378 "obj/conf/cf-parse.tab.c"
    break;

  case 1145: /* radv_preference: HIGH  */
#line 133 "proto/radv/config.Y"
        { (yyval.i) = RA_PREF_HIGH; }
#line 12384 "obj/conf/cf-parse.tab.c"
    break;

  case 1146: /* radv_iface_finish: %empty  */
#line 136 "proto/radv/config.Y"
{
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval");

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 12425 "obj/conf/cf-parse.tab.c"
    break;

  case 1152: /* radv_prefix_start: net_ip6  */
#line 189 "proto/radv/config.Y"
{
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = *(net_addr_ip6 *) &((yyvsp[0].net));

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 12439 "obj/conf/cf-parse.tab.c"
    break;

  case 1153: /* radv_prefix_item: SKIP bool  */
#line 200 "proto/radv/config.Y"
             { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 12445 "obj/conf/cf-parse.tab.c"
    break;

  case 1154: /* radv_prefix_item: ONLINK bool  */
#line 201 "proto/radv/config.Y"
               { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 12451 "obj/conf/cf-parse.tab.c"
    break;

  case 1155: /* radv_prefix_item: AUTONOMOUS bool  */
#line 202 "proto/radv/config.Y"
                   { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 12457 "obj/conf/cf-parse.tab.c"
    break;

  case 1156: /* radv_prefix_item: VALID LIFETIME expr radv_sensitive  */
#line 203 "proto/radv/config.Y"
                                      {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12466 "obj/conf/cf-parse.tab.c"
    break;

  case 1157: /* radv_prefix_item: PREFERRED LIFETIME expr radv_sensitive  */
#line 207 "proto/radv/config.Y"
                                          {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12475 "obj/conf/cf-parse.tab.c"
    break;

  case 1158: /* radv_prefix_finish: %empty  */
#line 214 "proto/radv/config.Y"
{
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 12487 "obj/conf/cf-parse.tab.c"
    break;

  case 1164: /* radv_rdnss_node: ipa  */
#line 238 "proto/radv/config.Y"
{
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12499 "obj/conf/cf-parse.tab.c"
    break;

  case 1165: /* radv_rdnss_start: %empty  */
#line 247 "proto/radv/config.Y"
{
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12508 "obj/conf/cf-parse.tab.c"
    break;

  case 1168: /* radv_rdnss_item: LIFETIME radv_mult  */
#line 254 "proto/radv/config.Y"
                      { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 12514 "obj/conf/cf-parse.tab.c"
    break;

  case 1169: /* radv_rdnss_finish: %empty  */
#line 258 "proto/radv/config.Y"
{
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 12530 "obj/conf/cf-parse.tab.c"
    break;

  case 1174: /* radv_dnssl_node: TEXT  */
#line 282 "proto/radv/config.Y"
{
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 12545 "obj/conf/cf-parse.tab.c"
    break;

  case 1175: /* radv_dnssl_start: %empty  */
#line 294 "proto/radv/config.Y"
{
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12554 "obj/conf/cf-parse.tab.c"
    break;

  case 1178: /* radv_dnssl_item: LIFETIME radv_mult  */
#line 301 "proto/radv/config.Y"
                      { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 12560 "obj/conf/cf-parse.tab.c"
    break;

  case 1179: /* radv_dnssl_finish: %empty  */
#line 305 "proto/radv/config.Y"
{
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 12576 "obj/conf/cf-parse.tab.c"
    break;

  case 1184: /* radv_mult: expr  */
#line 329 "proto/radv/config.Y"
        { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 12582 "obj/conf/cf-parse.tab.c"
    break;

  case 1185: /* radv_mult: MULT expr  */
#line 330 "proto/radv/config.Y"
             { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 12588 "obj/conf/cf-parse.tab.c"
    break;

  case 1186: /* radv_sensitive: %empty  */
#line 334 "proto/radv/config.Y"
               { (yyval.i) = (uint) -1; }
#line 12594 "obj/conf/cf-parse.tab.c"
    break;

  case 1187: /* radv_sensitive: SENSITIVE bool  */
#line 335 "proto/radv/config.Y"
                  { (yyval.i) = (yyvsp[0].i); }
#line 12600 "obj/conf/cf-parse.tab.c"
    break;

  case 1188: /* dynamic_attr: RA_PREFERENCE  */
#line 338 "proto/radv/config.Y"
                            { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 12606 "obj/conf/cf-parse.tab.c"
    break;

  case 1189: /* dynamic_attr: RA_LIFETIME  */
#line 339 "proto/radv/config.Y"
                          { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 12612 "obj/conf/cf-parse.tab.c"
    break;

  case 1191: /* rip_variant: RIP  */
#line 49 "proto/rip/config.Y"
          { (yyval.i) = 1; }
#line 12618 "obj/conf/cf-parse.tab.c"
    break;

  case 1192: /* rip_variant: RIP NG  */
#line 50 "proto/rip/config.Y"
          { (yyval.i) = 0; }
#line 12624 "obj/conf/cf-parse.tab.c"
    break;

  case 1193: /* rip_proto_start: proto_start rip_variant  */
#line 54 "proto/rip/config.Y"
{
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : NET_IP6;

  init_list(&RIP_CFG->patt_list);
  RIP_CFG->rip2 = (yyvsp[0].i);
  RIP_CFG->ecmp = rt_default_ecmp;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;
  RIP_CFG->min_timeout_time = 60 S_;
  RIP_CFG->max_garbage_time = 60 S_;
}
#line 12640 "obj/conf/cf-parse.tab.c"
    break;

  case 1196: /* rip_proto_item: ECMP bool  */
#line 69 "proto/rip/config.Y"
                        { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 12646 "obj/conf/cf-parse.tab.c"
    break;

  case 1197: /* rip_proto_item: ECMP bool LIMIT expr  */
#line 70 "proto/rip/config.Y"
                        { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 12652 "obj/conf/cf-parse.tab.c"
    break;

  case 1198: /* rip_proto_item: INFINITY expr  */
#line 71 "proto/rip/config.Y"
                        { RIP_CFG->infinity = (yyvsp[0].i); }
#line 12658 "obj/conf/cf-parse.tab.c"
    break;

  case 1203: /* rip_iface_start: %empty  */
#line 85 "proto/rip/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->check_link = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
  RIP_IFACE->rxmt_time = RIP_DEFAULT_RXMT_TIME;
}
#line 12686 "obj/conf/cf-parse.tab.c"
    break;

  case 1204: /* rip_iface_finish: %empty  */
#line 110 "proto/rip/config.Y"
{
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 12719 "obj/conf/cf-parse.tab.c"
    break;

  case 1205: /* rip_iface_item: METRIC expr  */
#line 140 "proto/rip/config.Y"
                        { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 12725 "obj/conf/cf-parse.tab.c"
    break;

  case 1206: /* rip_iface_item: MODE MULTICAST  */
#line 141 "proto/rip/config.Y"
                        { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 12731 "obj/conf/cf-parse.tab.c"
    break;

  case 1207: /* rip_iface_item: MODE BROADCAST  */
#line 142 "proto/rip/config.Y"
                        { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 12737 "obj/conf/cf-parse.tab.c"
    break;

  case 1208: /* rip_iface_item: PASSIVE bool  */
#line 143 "proto/rip/config.Y"
                        { RIP_IFACE->passive = (yyvsp[0].i); }
#line 12743 "obj/conf/cf-parse.tab.c"
    break;

  case 1209: /* rip_iface_item: ADDRESS ipa  */
#line 144 "proto/rip/config.Y"
                        { RIP_IFACE->address = (yyvsp[0].a); if (ipa_is_ip4((yyvsp[0].a)) != rip_cfg_is_v2()) cf_error("IP address version mismatch"); }
#line 12749 "obj/conf/cf-parse.tab.c"
    break;

  case 1210: /* rip_iface_item: PORT expr  */
#line 145 "proto/rip/config.Y"
                        { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 12755 "obj/conf/cf-parse.tab.c"
    break;

  case 1211: /* rip_iface_item: VERSION expr  */
#line 146 "proto/rip/config.Y"
                        { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 12764 "obj/conf/cf-parse.tab.c"
    break;

  case 1212: /* rip_iface_item: VERSION ONLY bool  */
#line 150 "proto/rip/config.Y"
                        { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 12770 "obj/conf/cf-parse.tab.c"
    break;

  case 1213: /* rip_iface_item: SPLIT HORIZON bool  */
#line 151 "proto/rip/config.Y"
                        { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 12776 "obj/conf/cf-parse.tab.c"
    break;

  case 1214: /* rip_iface_item: POISON REVERSE bool  */
#line 152 "proto/rip/config.Y"
                        { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 12782 "obj/conf/cf-parse.tab.c"
    break;

  case 1215: /* rip_iface_item: CHECK ZERO bool  */
#line 153 "proto/rip/config.Y"
                        { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 12788 "obj/conf/cf-parse.tab.c"
    break;

  case 1216: /* rip_iface_item: DEMAND CIRCUIT bool  */
#line 154 "proto/rip/config.Y"
                        { RIP_IFACE->demand_circuit = (yyvsp[0].i); }
#line 12794 "obj/conf/cf-parse.tab.c"
    break;

  case 1217: /* rip_iface_item: UPDATE TIME expr  */
#line 155 "proto/rip/config.Y"
                        { RIP_IFACE->update_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 12800 "obj/conf/cf-parse.tab.c"
    break;

  case 1218: /* rip_iface_item: TIMEOUT TIME expr  */
#line 156 "proto/rip/config.Y"
                        { RIP_IFACE->timeout_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 12806 "obj/conf/cf-parse.tab.c"
    break;

  case 1219: /* rip_iface_item: GARBAGE TIME expr  */
#line 157 "proto/rip/config.Y"
                        { RIP_IFACE->garbage_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 12812 "obj/conf/cf-parse.tab.c"
    break;

  case 1220: /* rip_iface_item: RETRANSMIT TIME expr_us  */
#line 158 "proto/rip/config.Y"
                           { RIP_IFACE->rxmt_time = (yyvsp[0].time); if ((yyvsp[0].time)<=0) cf_error("Retransmit time must be positive"); }
#line 12818 "obj/conf/cf-parse.tab.c"
    break;

  case 1221: /* rip_iface_item: ECMP WEIGHT expr  */
#line 159 "proto/rip/config.Y"
                        { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 12824 "obj/conf/cf-parse.tab.c"
    break;

  case 1222: /* rip_iface_item: RX BUFFER expr  */
#line 160 "proto/rip/config.Y"
                        { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 12830 "obj/conf/cf-parse.tab.c"
    break;

  case 1223: /* rip_iface_item: TX LENGTH expr  */
#line 161 "proto/rip/config.Y"
                        { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 12836 "obj/conf/cf-parse.tab.c"
    break;

  case 1224: /* rip_iface_item: TX tos  */
#line 162 "proto/rip/config.Y"
                        { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 12842 "obj/conf/cf-parse.tab.c"
    break;

  case 1225: /* rip_iface_item: TX PRIORITY expr  */
#line 163 "proto/rip/config.Y"
                        { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 12848 "obj/conf/cf-parse.tab.c"
    break;

  case 1226: /* rip_iface_item: TTL SECURITY bool  */
#line 164 "proto/rip/config.Y"
                        { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 12854 "obj/conf/cf-parse.tab.c"
    break;

  case 1227: /* rip_iface_item: TTL SECURITY TX ONLY  */
#line 165 "proto/rip/config.Y"
                        { RIP_IFACE->ttl_security = 2; }
#line 12860 "obj/conf/cf-parse.tab.c"
    break;

  case 1228: /* rip_iface_item: CHECK LINK bool  */
#line 166 "proto/rip/config.Y"
                        { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 12866 "obj/conf/cf-parse.tab.c"
    break;

  case 1229: /* rip_iface_item: BFD bool  */
#line 167 "proto/rip/config.Y"
                        { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 12872 "obj/conf/cf-parse.tab.c"
    break;

  case 1230: /* rip_iface_item: AUTHENTICATION rip_auth  */
#line 168 "proto/rip/config.Y"
                           { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 12878 "obj/conf/cf-parse.tab.c"
    break;

  case 1231: /* rip_iface_item: password_list  */
#line 169 "proto/rip/config.Y"
                        { rip_check_auth(); }
#line 12884 "obj/conf/cf-parse.tab.c"
    break;

  case 1232: /* rip_auth: NONE  */
#line 173 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_NONE; }
#line 12890 "obj/conf/cf-parse.tab.c"
    break;

  case 1233: /* rip_auth: PLAINTEXT  */
#line 174 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_PLAIN; }
#line 12896 "obj/conf/cf-parse.tab.c"
    break;

  case 1234: /* rip_auth: CRYPTOGRAPHIC  */
#line 175 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 12902 "obj/conf/cf-parse.tab.c"
    break;

  case 1235: /* rip_auth: MD5  */
#line 176 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 12908 "obj/conf/cf-parse.tab.c"
    break;

  case 1241: /* dynamic_attr: RIP_METRIC  */
#line 193 "proto/rip/config.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_METRIC); }
#line 12914 "obj/conf/cf-parse.tab.c"
    break;

  case 1242: /* dynamic_attr: RIP_TAG  */
#line 194 "proto/rip/config.Y"
                      { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_TAG); }
#line 12920 "obj/conf/cf-parse.tab.c"
    break;

  case 1244: /* cmd_SHOW_RIP_INTERFACES: SHOW RIP INTERFACES optproto opttext END  */
#line 199 "proto/rip/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_rip, p) rip_show_interfaces(p, (yyvsp[-1].t)); }
#line 12926 "obj/conf/cf-parse.tab.c"
    break;

  case 1246: /* cmd_SHOW_RIP_NEIGHBORS: SHOW RIP NEIGHBORS optproto opttext END  */
#line 202 "proto/rip/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_rip, p) rip_show_neighbors(p, (yyvsp[-1].t)); }
#line 12932 "obj/conf/cf-parse.tab.c"
    break;

  case 1248: /* rpki_proto_start: proto_start RPKI  */
#line 43 "proto/rpki/config.Y"
                                   {
  this_proto = proto_config_new(&proto_rpki, (yyvsp[-1].i));
  RPKI_CFG->retry_interval = RPKI_RETRY_INTERVAL;
  RPKI_CFG->refresh_interval = RPKI_REFRESH_INTERVAL;
  RPKI_CFG->expire_interval = RPKI_EXPIRE_INTERVAL;
}
#line 12943 "obj/conf/cf-parse.tab.c"
    break;

  case 1249: /* rpki_proto: rpki_proto_start proto_name '{' rpki_proto_opts '}'  */
#line 50 "proto/rpki/config.Y"
                                                                { rpki_check_config(RPKI_CFG); }
#line 12949 "obj/conf/cf-parse.tab.c"
    break;

  case 1258: /* rpki_proto_item: REFRESH rpki_keep_interval expr  */
#line 64 "proto/rpki/config.Y"
                                   {
     if (rpki_check_refresh_interval((yyvsp[0].i)))
       cf_error(rpki_check_refresh_interval((yyvsp[0].i)));
     RPKI_CFG->refresh_interval = (yyvsp[0].i);
     RPKI_CFG->keep_refresh_interval = (yyvsp[-1].i);
   }
#line 12960 "obj/conf/cf-parse.tab.c"
    break;

  case 1259: /* rpki_proto_item: RETRY rpki_keep_interval expr  */
#line 70 "proto/rpki/config.Y"
                                 {
     if (rpki_check_retry_interval((yyvsp[0].i)))
       cf_error(rpki_check_retry_interval((yyvsp[0].i)));
     RPKI_CFG->retry_interval = (yyvsp[0].i);
     RPKI_CFG->keep_retry_interval = (yyvsp[-1].i);
   }
#line 12971 "obj/conf/cf-parse.tab.c"
    break;

  case 1260: /* rpki_proto_item: EXPIRE rpki_keep_interval expr  */
#line 76 "proto/rpki/config.Y"
                                  {
     if (rpki_check_expire_interval((yyvsp[0].i)))
       cf_error(rpki_check_expire_interval((yyvsp[0].i)));
     RPKI_CFG->expire_interval = (yyvsp[0].i);
     RPKI_CFG->keep_expire_interval = (yyvsp[-1].i);
   }
#line 12982 "obj/conf/cf-parse.tab.c"
    break;

  case 1261: /* rpki_proto_item: IGNORE MAX LENGTH bool  */
#line 82 "proto/rpki/config.Y"
                          { RPKI_CFG->ignore_max_length = (yyvsp[0].i); }
#line 12988 "obj/conf/cf-parse.tab.c"
    break;

  case 1262: /* rpki_keep_interval: %empty  */
#line 86 "proto/rpki/config.Y"
             { (yyval.i) = 0; }
#line 12994 "obj/conf/cf-parse.tab.c"
    break;

  case 1263: /* rpki_keep_interval: KEEP  */
#line 87 "proto/rpki/config.Y"
        { (yyval.i) = 1; }
#line 13000 "obj/conf/cf-parse.tab.c"
    break;

  case 1264: /* rpki_proto_item_port: PORT expr  */
#line 90 "proto/rpki/config.Y"
                                { check_u16((yyvsp[0].i)); RPKI_CFG->port = (yyvsp[0].i); }
#line 13006 "obj/conf/cf-parse.tab.c"
    break;

  case 1265: /* rpki_cache_addr: text  */
#line 93 "proto/rpki/config.Y"
        {
     rpki_check_unused_hostname();
     RPKI_CFG->hostname = (yyvsp[0].t);
   }
#line 13015 "obj/conf/cf-parse.tab.c"
    break;

  case 1266: /* rpki_cache_addr: ipa  */
#line 97 "proto/rpki/config.Y"
       {
     rpki_check_unused_hostname();
     RPKI_CFG->ip = (yyvsp[0].a);
     /* Ensure hostname is filled */
     char *hostname = cfg_allocz(INET6_ADDRSTRLEN + 1);
     bsnprintf(hostname, INET6_ADDRSTRLEN+1, "%I", RPKI_CFG->ip);
     RPKI_CFG->hostname = hostname;
   }
#line 13028 "obj/conf/cf-parse.tab.c"
    break;

  case 1269: /* rpki_transport_tcp_init: %empty  */
#line 113 "proto/rpki/config.Y"
{
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_tcp_config));
  RPKI_CFG->tr_config.type = RPKI_TR_TCP;
}
#line 13038 "obj/conf/cf-parse.tab.c"
    break;

  case 1270: /* rpki_transport_ssh_init: %empty  */
#line 120 "proto/rpki/config.Y"
{
#if HAVE_LIBSSH
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_ssh_config));
  RPKI_CFG->tr_config.type = RPKI_TR_SSH;
#else
  cf_error("This build doesn't support SSH");
#endif
}
#line 13052 "obj/conf/cf-parse.tab.c"
    break;

  case 1273: /* rpki_transport_ssh_item: BIRD PRIVATE KEY text  */
#line 136 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->bird_private_key = (yyvsp[0].t); }
#line 13058 "obj/conf/cf-parse.tab.c"
    break;

  case 1274: /* rpki_transport_ssh_item: REMOTE PUBLIC KEY text  */
#line 137 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->cache_public_key = (yyvsp[0].t); }
#line 13064 "obj/conf/cf-parse.tab.c"
    break;

  case 1275: /* rpki_transport_ssh_item: USER text  */
#line 138 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->user = (yyvsp[0].t); }
#line 13070 "obj/conf/cf-parse.tab.c"
    break;

  case 1276: /* rpki_transport_ssh_check: %empty  */
#line 142 "proto/rpki/config.Y"
{
  if (RPKI_TR_SSH_CFG->user == NULL)
    cf_error("User must be set");
}
#line 13079 "obj/conf/cf-parse.tab.c"
    break;

  case 1278: /* static_proto_start: proto_start STATIC  */
#line 57 "proto/static/config.Y"
{
  this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
  init_list(&STATIC_CFG->routes);
}
#line 13088 "obj/conf/cf-parse.tab.c"
    break;

  case 1281: /* static_proto: static_proto proto_channel ';'  */
#line 65 "proto/static/config.Y"
                                  { this_proto->net_type = (yyvsp[-1].cc)->net_type; }
#line 13094 "obj/conf/cf-parse.tab.c"
    break;

  case 1282: /* static_proto: static_proto CHECK LINK bool ';'  */
#line 66 "proto/static/config.Y"
                                    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 13100 "obj/conf/cf-parse.tab.c"
    break;

  case 1283: /* static_proto: static_proto IGP TABLE rtable ';'  */
#line 67 "proto/static/config.Y"
                                     {
    if ((yyvsp[-1].r)->addr_type == NET_IP4)
      STATIC_CFG->igp_table_ip4 = (yyvsp[-1].r);
    else if ((yyvsp[-1].r)->addr_type == NET_IP6)
      STATIC_CFG->igp_table_ip6 = (yyvsp[-1].r);
    else
      cf_error("Incompatible IGP table type");
   }
#line 13113 "obj/conf/cf-parse.tab.c"
    break;

  case 1284: /* static_proto: static_proto stat_route stat_route_opt_list ';'  */
#line 75 "proto/static/config.Y"
                                                   { static_route_finish(); }
#line 13119 "obj/conf/cf-parse.tab.c"
    break;

  case 1285: /* stat_nexthop: VIA ipa ipa_scope  */
#line 79 "proto/static/config.Y"
                      {
      this_snh = static_nexthop_new();
      this_snh->via = (yyvsp[-1].a);
      this_snh->iface = (yyvsp[0].iface);
    }
#line 13129 "obj/conf/cf-parse.tab.c"
    break;

  case 1286: /* stat_nexthop: VIA TEXT  */
#line 84 "proto/static/config.Y"
             {
      this_snh = static_nexthop_new();
      this_snh->via = IPA_NONE;
      this_snh->iface = if_get_by_name((yyvsp[0].t));
    }
#line 13139 "obj/conf/cf-parse.tab.c"
    break;

  case 1287: /* stat_nexthop: stat_nexthop MPLS label_stack  */
#line 89 "proto/static/config.Y"
                                  {
    this_snh->mls = (yyvsp[0].mls);
  }
#line 13147 "obj/conf/cf-parse.tab.c"
    break;

  case 1288: /* stat_nexthop: stat_nexthop ONLINK bool  */
#line 92 "proto/static/config.Y"
                             {
    this_snh->onlink = (yyvsp[0].i);
  }
#line 13155 "obj/conf/cf-parse.tab.c"
    break;

  case 1289: /* stat_nexthop: stat_nexthop WEIGHT expr  */
#line 95 "proto/static/config.Y"
                             {
    this_snh->weight = (yyvsp[0].i) - 1;
    if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256");
  }
#line 13164 "obj/conf/cf-parse.tab.c"
    break;

  case 1290: /* stat_nexthop: stat_nexthop BFD bool  */
#line 99 "proto/static/config.Y"
                          {
    this_snh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
  }
#line 13172 "obj/conf/cf-parse.tab.c"
    break;

  case 1293: /* stat_route0: ROUTE net_any  */
#line 109 "proto/static/config.Y"
                           {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->routes, &this_srt->n);
     this_srt->net = (yyvsp[0].net_ptr);
     this_srt_cmds = NULL;
     this_srt_last_cmd = NULL;
     this_srt->mp_next = NULL;
     this_snh = NULL;
  }
#line 13186 "obj/conf/cf-parse.tab.c"
    break;

  case 1295: /* stat_route: stat_route0 RECURSIVE ipa  */
#line 122 "proto/static/config.Y"
                             {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 13195 "obj/conf/cf-parse.tab.c"
    break;

  case 1296: /* stat_route: stat_route0 RECURSIVE ipa MPLS label_stack  */
#line 126 "proto/static/config.Y"
                                              {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[-2].a);
      this_srt->mls = (yyvsp[0].mls);
   }
#line 13205 "obj/conf/cf-parse.tab.c"
    break;

  case 1297: /* stat_route: stat_route0  */
#line 131 "proto/static/config.Y"
                                { this_srt->dest = RTD_NONE; }
#line 13211 "obj/conf/cf-parse.tab.c"
    break;

  case 1298: /* stat_route: stat_route0 DROP  */
#line 132 "proto/static/config.Y"
                                { this_srt->dest = RTD_BLACKHOLE; }
#line 13217 "obj/conf/cf-parse.tab.c"
    break;

  case 1299: /* stat_route: stat_route0 REJECT  */
#line 133 "proto/static/config.Y"
                                { this_srt->dest = RTD_UNREACHABLE; }
#line 13223 "obj/conf/cf-parse.tab.c"
    break;

  case 1300: /* stat_route: stat_route0 BLACKHOLE  */
#line 134 "proto/static/config.Y"
                                { this_srt->dest = RTD_BLACKHOLE; }
#line 13229 "obj/conf/cf-parse.tab.c"
    break;

  case 1301: /* stat_route: stat_route0 UNREACHABLE  */
#line 135 "proto/static/config.Y"
                                { this_srt->dest = RTD_UNREACHABLE; }
#line 13235 "obj/conf/cf-parse.tab.c"
    break;

  case 1302: /* stat_route: stat_route0 PROHIBIT  */
#line 136 "proto/static/config.Y"
                                { this_srt->dest = RTD_PROHIBIT; }
#line 13241 "obj/conf/cf-parse.tab.c"
    break;

  case 1303: /* stat_route_item: cmd  */
#line 140 "proto/static/config.Y"
       {
     if (this_srt_last_cmd)
       this_srt_last_cmd->next = (yyvsp[0].x);
     else
       this_srt_cmds = (yyvsp[0].x);
     this_srt_last_cmd = (yyvsp[0].x);
   }
#line 13253 "obj/conf/cf-parse.tab.c"
    break;

  case 1309: /* cmd_SHOW_STATIC: SHOW STATIC optproto END  */
#line 161 "proto/static/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].s), &proto_static, p) static_show(p); }
#line 13259 "obj/conf/cf-parse.tab.c"
    break;

  case 1311: /* kern_sys_item: KERNEL TABLE expr  */
#line 25 "sysdep/linux/netlink.Y"
                     { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 13265 "obj/conf/cf-parse.tab.c"
    break;

  case 1312: /* kern_sys_item: METRIC expr  */
#line 26 "sysdep/linux/netlink.Y"
               { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 13271 "obj/conf/cf-parse.tab.c"
    break;

  case 1313: /* dynamic_attr: KRT_PREFSRC  */
#line 29 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 13277 "obj/conf/cf-parse.tab.c"
    break;

  case 1314: /* dynamic_attr: KRT_REALM  */
#line 30 "sysdep/linux/netlink.Y"
                        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 13283 "obj/conf/cf-parse.tab.c"
    break;

  case 1315: /* dynamic_attr: KRT_SCOPE  */
#line 31 "sysdep/linux/netlink.Y"
                        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 13289 "obj/conf/cf-parse.tab.c"
    break;

  case 1316: /* dynamic_attr: KRT_MTU  */
#line 33 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 13295 "obj/conf/cf-parse.tab.c"
    break;

  case 1317: /* dynamic_attr: KRT_WINDOW  */
#line 34 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 13301 "obj/conf/cf-parse.tab.c"
    break;

  case 1318: /* dynamic_attr: KRT_RTT  */
#line 35 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 13307 "obj/conf/cf-parse.tab.c"
    break;

  case 1319: /* dynamic_attr: KRT_RTTVAR  */
#line 36 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 13313 "obj/conf/cf-parse.tab.c"
    break;

  case 1320: /* dynamic_attr: KRT_SSTRESH  */
#line 37 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 13319 "obj/conf/cf-parse.tab.c"
    break;

  case 1321: /* dynamic_attr: KRT_CWND  */
#line 38 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 13325 "obj/conf/cf-parse.tab.c"
    break;

  case 1322: /* dynamic_attr: KRT_ADVMSS  */
#line 39 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 13331 "obj/conf/cf-parse.tab.c"
    break;

  case 1323: /* dynamic_attr: KRT_REORDERING  */
#line 40 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 13337 "obj/conf/cf-parse.tab.c"
    break;

  case 1324: /* dynamic_attr: KRT_HOPLIMIT  */
#line 41 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 13343 "obj/conf/cf-parse.tab.c"
    break;

  case 1325: /* dynamic_attr: KRT_INITCWND  */
#line 42 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 13349 "obj/conf/cf-parse.tab.c"
    break;

  case 1326: /* dynamic_attr: KRT_RTO_MIN  */
#line 43 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 13355 "obj/conf/cf-parse.tab.c"
    break;

  case 1327: /* dynamic_attr: KRT_INITRWND  */
#line 44 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 13361 "obj/conf/cf-parse.tab.c"
    break;

  case 1328: /* dynamic_attr: KRT_QUICKACK  */
#line 45 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 13367 "obj/conf/cf-parse.tab.c"
    break;

  case 1329: /* dynamic_attr: KRT_LOCK_MTU  */
#line 49 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(2, T_BOOL, EA_KRT_LOCK); }
#line 13373 "obj/conf/cf-parse.tab.c"
    break;

  case 1330: /* dynamic_attr: KRT_LOCK_WINDOW  */
#line 50 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(3, T_BOOL, EA_KRT_LOCK); }
#line 13379 "obj/conf/cf-parse.tab.c"
    break;

  case 1331: /* dynamic_attr: KRT_LOCK_RTT  */
#line 51 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(4, T_BOOL, EA_KRT_LOCK); }
#line 13385 "obj/conf/cf-parse.tab.c"
    break;

  case 1332: /* dynamic_attr: KRT_LOCK_RTTVAR  */
#line 52 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(5, T_BOOL, EA_KRT_LOCK); }
#line 13391 "obj/conf/cf-parse.tab.c"
    break;

  case 1333: /* dynamic_attr: KRT_LOCK_SSTRESH  */
#line 53 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(6, T_BOOL, EA_KRT_LOCK); }
#line 13397 "obj/conf/cf-parse.tab.c"
    break;

  case 1334: /* dynamic_attr: KRT_LOCK_CWND  */
#line 54 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(7, T_BOOL, EA_KRT_LOCK); }
#line 13403 "obj/conf/cf-parse.tab.c"
    break;

  case 1335: /* dynamic_attr: KRT_LOCK_ADVMSS  */
#line 55 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(8, T_BOOL, EA_KRT_LOCK); }
#line 13409 "obj/conf/cf-parse.tab.c"
    break;

  case 1336: /* dynamic_attr: KRT_LOCK_REORDERING  */
#line 56 "sysdep/linux/netlink.Y"
                                  { (yyval.fda) = f_new_dynamic_attr_bit(9, T_BOOL, EA_KRT_LOCK); }
#line 13415 "obj/conf/cf-parse.tab.c"
    break;

  case 1337: /* dynamic_attr: KRT_LOCK_HOPLIMIT  */
#line 57 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(10, T_BOOL, EA_KRT_LOCK); }
#line 13421 "obj/conf/cf-parse.tab.c"
    break;

  case 1338: /* dynamic_attr: KRT_LOCK_RTO_MIN  */
#line 58 "sysdep/linux/netlink.Y"
                               { (yyval.fda) = f_new_dynamic_attr_bit(13, T_BOOL, EA_KRT_LOCK); }
#line 13427 "obj/conf/cf-parse.tab.c"
    break;

  case 1339: /* dynamic_attr: KRT_FEATURE_ECN  */
#line 60 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(0, T_BOOL, EA_KRT_FEATURES); }
#line 13433 "obj/conf/cf-parse.tab.c"
    break;

  case 1340: /* dynamic_attr: KRT_FEATURE_ALLFRAG  */
#line 61 "sysdep/linux/netlink.Y"
                                  { (yyval.fda) = f_new_dynamic_attr(3, T_BOOL, EA_KRT_FEATURES); }
#line 13439 "obj/conf/cf-parse.tab.c"
    break;

  case 1342: /* log_begin: %empty  */
#line 33 "sysdep/unix/config.Y"
           { this_log = cfg_allocz(sizeof(struct log_config)); }
#line 13445 "obj/conf/cf-parse.tab.c"
    break;

  case 1343: /* log_config: LOG log_begin log_file log_mask ';'  */
#line 35 "sysdep/unix/config.Y"
                                                {
    this_log->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &this_log->n);
  }
#line 13454 "obj/conf/cf-parse.tab.c"
    break;

  case 1344: /* syslog_name: NAME text  */
#line 42 "sysdep/unix/config.Y"
             { (yyval.t) = (yyvsp[0].t); }
#line 13460 "obj/conf/cf-parse.tab.c"
    break;

  case 1345: /* syslog_name: %empty  */
#line 43 "sysdep/unix/config.Y"
   { (yyval.t) = bird_name; }
#line 13466 "obj/conf/cf-parse.tab.c"
    break;

  case 1347: /* log_limit: expr text  */
#line 48 "sysdep/unix/config.Y"
             { this_log->limit = (yyvsp[-1].i); this_log->backup = (yyvsp[0].t); }
#line 13472 "obj/conf/cf-parse.tab.c"
    break;

  case 1348: /* log_file: text log_limit  */
#line 52 "sysdep/unix/config.Y"
                  {
     if (!parse_and_exit)
     {
       this_log->rf = rf_open(new_config->pool, (yyvsp[-1].t), "a");
       if (!this_log->rf) cf_error("Unable to open log file '%s': %m", (yyvsp[-1].t));
       this_log->fh = rf_file(this_log->rf);
     }
     this_log->pos = -1;
     this_log->filename = (yyvsp[-1].t);
   }
#line 13487 "obj/conf/cf-parse.tab.c"
    break;

  case 1349: /* log_file: SYSLOG syslog_name  */
#line 62 "sysdep/unix/config.Y"
                      { this_log->fh = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 13493 "obj/conf/cf-parse.tab.c"
    break;

  case 1350: /* log_file: STDERR  */
#line 63 "sysdep/unix/config.Y"
          { this_log->fh = stderr; }
#line 13499 "obj/conf/cf-parse.tab.c"
    break;

  case 1351: /* log_mask: ALL  */
#line 67 "sysdep/unix/config.Y"
       { (yyval.i) = ~0; }
#line 13505 "obj/conf/cf-parse.tab.c"
    break;

  case 1352: /* log_mask: '{' log_mask_list '}'  */
#line 68 "sysdep/unix/config.Y"
                         { (yyval.i) = (yyvsp[-1].i); }
#line 13511 "obj/conf/cf-parse.tab.c"
    break;

  case 1353: /* log_mask_list: log_cat  */
#line 72 "sysdep/unix/config.Y"
           { (yyval.i) = 1 << (yyvsp[0].i); }
#line 13517 "obj/conf/cf-parse.tab.c"
    break;

  case 1354: /* log_mask_list: log_mask_list ',' log_cat  */
#line 73 "sysdep/unix/config.Y"
                             { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 13523 "obj/conf/cf-parse.tab.c"
    break;

  case 1355: /* log_cat: DEBUG  */
#line 77 "sysdep/unix/config.Y"
         { (yyval.i) = L_DEBUG[0]; }
#line 13529 "obj/conf/cf-parse.tab.c"
    break;

  case 1356: /* log_cat: TRACE  */
#line 78 "sysdep/unix/config.Y"
         { (yyval.i) = L_TRACE[0]; }
#line 13535 "obj/conf/cf-parse.tab.c"
    break;

  case 1357: /* log_cat: INFO  */
#line 79 "sysdep/unix/config.Y"
        { (yyval.i) = L_INFO[0]; }
#line 13541 "obj/conf/cf-parse.tab.c"
    break;

  case 1358: /* log_cat: REMOTE  */
#line 80 "sysdep/unix/config.Y"
          { (yyval.i) = L_REMOTE[0]; }
#line 13547 "obj/conf/cf-parse.tab.c"
    break;

  case 1359: /* log_cat: WARNING  */
#line 81 "sysdep/unix/config.Y"
           { (yyval.i) = L_WARN[0]; }
#line 13553 "obj/conf/cf-parse.tab.c"
    break;

  case 1360: /* log_cat: ERROR  */
#line 82 "sysdep/unix/config.Y"
         { (yyval.i) = L_ERR[0]; }
#line 13559 "obj/conf/cf-parse.tab.c"
    break;

  case 1361: /* log_cat: AUTH  */
#line 83 "sysdep/unix/config.Y"
        { (yyval.i) = L_AUTH[0]; }
#line 13565 "obj/conf/cf-parse.tab.c"
    break;

  case 1362: /* log_cat: FATAL  */
#line 84 "sysdep/unix/config.Y"
         { (yyval.i) = L_FATAL[0]; }
#line 13571 "obj/conf/cf-parse.tab.c"
    break;

  case 1363: /* log_cat: BUG  */
#line 85 "sysdep/unix/config.Y"
       { (yyval.i) = L_BUG[0]; }
#line 13577 "obj/conf/cf-parse.tab.c"
    break;

  case 1365: /* mrtdump_base: MRTDUMP PROTOCOLS mrtdump_mask ';'  */
#line 92 "sysdep/unix/config.Y"
                                      { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 13583 "obj/conf/cf-parse.tab.c"
    break;

  case 1366: /* mrtdump_base: MRTDUMP text ';'  */
#line 93 "sysdep/unix/config.Y"
                    {
     if (!parse_and_exit)
     {
       struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
       if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
       new_config->mrtdump_file = rf_fileno(f);
     }
   }
#line 13596 "obj/conf/cf-parse.tab.c"
    break;

  case 1368: /* debug_unix: DEBUG LATENCY bool  */
#line 107 "sysdep/unix/config.Y"
                      { new_config->latency_debug = (yyvsp[0].i); }
#line 13602 "obj/conf/cf-parse.tab.c"
    break;

  case 1369: /* debug_unix: DEBUG LATENCY LIMIT expr_us  */
#line 108 "sysdep/unix/config.Y"
                               { new_config->latency_limit = (yyvsp[0].time); }
#line 13608 "obj/conf/cf-parse.tab.c"
    break;

  case 1370: /* debug_unix: WATCHDOG WARNING expr_us  */
#line 109 "sysdep/unix/config.Y"
                            { new_config->watchdog_warning = (yyvsp[0].time); }
#line 13614 "obj/conf/cf-parse.tab.c"
    break;

  case 1371: /* debug_unix: WATCHDOG TIMEOUT expr_us  */
#line 110 "sysdep/unix/config.Y"
                            { new_config->watchdog_timeout = ((yyvsp[0].time) + 999999) TO_S; }
#line 13620 "obj/conf/cf-parse.tab.c"
    break;

  case 1373: /* cmd_CONFIGURE: CONFIGURE cfg_name cfg_timeout END  */
#line 119 "sysdep/unix/config.Y"
{ cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 13626 "obj/conf/cf-parse.tab.c"
    break;

  case 1375: /* cmd_CONFIGURE_SOFT: CONFIGURE SOFT cfg_name cfg_timeout END  */
#line 122 "sysdep/unix/config.Y"
{ cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 13632 "obj/conf/cf-parse.tab.c"
    break;

  case 1377: /* cmd_CONFIGURE_CONFIRM: CONFIGURE CONFIRM END  */
#line 129 "sysdep/unix/config.Y"
{ cmd_reconfig_confirm(); }
#line 13638 "obj/conf/cf-parse.tab.c"
    break;

  case 1379: /* cmd_CONFIGURE_UNDO: CONFIGURE UNDO END  */
#line 132 "sysdep/unix/config.Y"
{ cmd_reconfig_undo(); }
#line 13644 "obj/conf/cf-parse.tab.c"
    break;

  case 1381: /* cmd_CONFIGURE_STATUS: CONFIGURE STATUS END  */
#line 135 "sysdep/unix/config.Y"
{ cmd_reconfig_status(); }
#line 13650 "obj/conf/cf-parse.tab.c"
    break;

  case 1383: /* cmd_CONFIGURE_CHECK: CONFIGURE CHECK cfg_name END  */
#line 138 "sysdep/unix/config.Y"
{ cmd_check_config((yyvsp[-1].t)); }
#line 13656 "obj/conf/cf-parse.tab.c"
    break;

  case 1385: /* cmd_DOWN: DOWN END  */
#line 141 "sysdep/unix/config.Y"
{ cmd_shutdown(); }
#line 13662 "obj/conf/cf-parse.tab.c"
    break;

  case 1387: /* cmd_GRACEFUL_RESTART: GRACEFUL RESTART END  */
#line 146 "sysdep/unix/config.Y"
{ cmd_graceful_restart(); }
#line 13668 "obj/conf/cf-parse.tab.c"
    break;

  case 1388: /* cfg_name: %empty  */
#line 150 "sysdep/unix/config.Y"
               { (yyval.t) = NULL; }
#line 13674 "obj/conf/cf-parse.tab.c"
    break;

  case 1390: /* cfg_timeout: %empty  */
#line 155 "sysdep/unix/config.Y"
               { (yyval.i) = 0; }
#line 13680 "obj/conf/cf-parse.tab.c"
    break;

  case 1391: /* cfg_timeout: TIMEOUT  */
#line 156 "sysdep/unix/config.Y"
           { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 13686 "obj/conf/cf-parse.tab.c"
    break;

  case 1392: /* cfg_timeout: TIMEOUT expr  */
#line 157 "sysdep/unix/config.Y"
                { (yyval.i) = (yyvsp[0].i); }
#line 13692 "obj/conf/cf-parse.tab.c"
    break;

  case 1394: /* kern_proto_start: proto_start KERNEL  */
#line 43 "sysdep/unix/krt.Y"
                                     {
     this_proto = krt_init_config((yyvsp[-1].i));
}
#line 13700 "obj/conf/cf-parse.tab.c"
    break;

  case 1397: /* kern_mp_limit: %empty  */
#line 52 "sysdep/unix/krt.Y"
               { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 13706 "obj/conf/cf-parse.tab.c"
    break;

  case 1398: /* kern_mp_limit: LIMIT expr  */
#line 53 "sysdep/unix/krt.Y"
               { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 13712 "obj/conf/cf-parse.tab.c"
    break;

  case 1400: /* kern_item: proto_channel  */
#line 58 "sysdep/unix/krt.Y"
                 { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 13718 "obj/conf/cf-parse.tab.c"
    break;

  case 1401: /* kern_item: PERSIST bool  */
#line 59 "sysdep/unix/krt.Y"
                { THIS_KRT->persist = (yyvsp[0].i); }
#line 13724 "obj/conf/cf-parse.tab.c"
    break;

  case 1402: /* kern_item: SCAN TIME expr  */
#line 60 "sysdep/unix/krt.Y"
                  {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i) S_;
   }
#line 13733 "obj/conf/cf-parse.tab.c"
    break;

  case 1403: /* kern_item: LEARN bool  */
#line 64 "sysdep/unix/krt.Y"
              {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 13745 "obj/conf/cf-parse.tab.c"
    break;

  case 1404: /* kern_item: GRACEFUL RESTART bool  */
#line 71 "sysdep/unix/krt.Y"
                         { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 13751 "obj/conf/cf-parse.tab.c"
    break;

  case 1405: /* kern_item: MERGE PATHS bool kern_mp_limit  */
#line 72 "sysdep/unix/krt.Y"
                                  {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 13763 "obj/conf/cf-parse.tab.c"
    break;

  case 1407: /* kif_proto_start: proto_start DEVICE  */
#line 85 "sysdep/unix/krt.Y"
                                    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 13769 "obj/conf/cf-parse.tab.c"
    break;

  case 1412: /* kif_item: SCAN TIME expr  */
#line 94 "sysdep/unix/krt.Y"
                  {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i) S_;
   }
#line 13778 "obj/conf/cf-parse.tab.c"
    break;

  case 1413: /* kif_iface_start: %empty  */
#line 101 "sysdep/unix/krt.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct kif_iface_config));
  add_tail(&THIS_KIF->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
}
#line 13788 "obj/conf/cf-parse.tab.c"
    break;

  case 1414: /* kif_iface_item: PREFERRED ipa  */
#line 108 "sysdep/unix/krt.Y"
                 { kif_set_preferred((yyvsp[0].a)); }
#line 13794 "obj/conf/cf-parse.tab.c"
    break;

  case 1420: /* dynamic_attr: KRT_SOURCE  */
#line 125 "sysdep/unix/krt.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SOURCE); }
#line 13800 "obj/conf/cf-parse.tab.c"
    break;

  case 1421: /* dynamic_attr: KRT_METRIC  */
#line 126 "sysdep/unix/krt.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_METRIC); }
#line 13806 "obj/conf/cf-parse.tab.c"
    break;


#line 13810 "obj/conf/cf-parse.tab.c"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 50 "conf/gen_parser.m4"

#line 385 "conf/confbase.Y"
/* C Code from conf/confbase.Y */

#line 207 "conf/flowspec.Y"
/* C Code from conf/flowspec.Y */

#line 872 "nest/config.Y"
/* C Code from nest/config.Y */

#line 187 "proto/bfd/config.Y"
/* C Code from proto/bfd/config.Y */

#line 144 "proto/babel/config.Y"
/* C Code from proto/babel/config.Y */

#line 335 "proto/bgp/config.Y"
/* C Code from proto/bgp/config.Y */

#line 66 "proto/mrt/config.Y"
/* C Code from proto/mrt/config.Y */

#line 563 "proto/ospf/config.Y"
/* C Code from proto/ospf/config.Y */

#line 59 "proto/perf/config.Y"
/* C Code from proto/perf/config.Y */

#line 46 "proto/pipe/config.Y"
/* C Code from proto/pipe/config.Y */

#line 341 "proto/radv/config.Y"
/* C Code from proto/radv/config.Y */

#line 205 "proto/rip/config.Y"
/* C Code from proto/rip/config.Y */

#line 147 "proto/rpki/config.Y"
/* C Code from proto/rpki/config.Y */

#line 163 "proto/static/config.Y"
/* C Code from proto/static/config.Y */

#line 64 "sysdep/linux/netlink.Y"
/* C Code from sysdep/linux/netlink.Y */

#line 160 "sysdep/unix/config.Y"
/* C Code from sysdep/unix/config.Y */

#line 128 "sysdep/unix/krt.Y"
/* C Code from sysdep/unix/krt.Y */

