#line 439 "filter/decl.m4"


#if defined(__GNUC__) && __GNUC__ >= 6
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmisleading-indentation"
#endif

#include "nest/bird.h"
#include "filter/filter.h"
#include "filter/f-inst.h"

/* Instruction codes to string */
static const char * const f_instruction_name_str[] = {
#line 227 "filter/f-inst.c"
 /* Code enum to string for FI_ADD */
#line 227
  [FI_ADD] = "FI_ADD",
#line 232 "filter/f-inst.c"
 /* Code enum to string for FI_SUBTRACT */
#line 232
  [FI_SUBTRACT] = "FI_SUBTRACT",
#line 237 "filter/f-inst.c"
 /* Code enum to string for FI_MULTIPLY */
#line 237
  [FI_MULTIPLY] = "FI_MULTIPLY",
#line 243 "filter/f-inst.c"
 /* Code enum to string for FI_DIVIDE */
#line 243
  [FI_DIVIDE] = "FI_DIVIDE",
#line 253 "filter/f-inst.c"
 /* Code enum to string for FI_AND */
#line 253
  [FI_AND] = "FI_AND",
#line 264 "filter/f-inst.c"
 /* Code enum to string for FI_OR */
#line 264
  [FI_OR] = "FI_OR",
#line 274 "filter/f-inst.c"
 /* Code enum to string for FI_PAIR_CONSTRUCT */
#line 274
  [FI_PAIR_CONSTRUCT] = "FI_PAIR_CONSTRUCT",
#line 314 "filter/f-inst.c"
 /* Code enum to string for FI_EC_CONSTRUCT */
#line 314
  [FI_EC_CONSTRUCT] = "FI_EC_CONSTRUCT",
#line 321 "filter/f-inst.c"
 /* Code enum to string for FI_LC_CONSTRUCT */
#line 321
  [FI_LC_CONSTRUCT] = "FI_LC_CONSTRUCT",
#line 371 "filter/f-inst.c"
 /* Code enum to string for FI_PATHMASK_CONSTRUCT */
#line 371
  [FI_PATHMASK_CONSTRUCT] = "FI_PATHMASK_CONSTRUCT",
#line 377 "filter/f-inst.c"
 /* Code enum to string for FI_NEQ */
#line 377
  [FI_NEQ] = "FI_NEQ",
#line 383 "filter/f-inst.c"
 /* Code enum to string for FI_EQ */
#line 383
  [FI_EQ] = "FI_EQ",
#line 394 "filter/f-inst.c"
 /* Code enum to string for FI_LT */
#line 394
  [FI_LT] = "FI_LT",
#line 405 "filter/f-inst.c"
 /* Code enum to string for FI_LTE */
#line 405
  [FI_LTE] = "FI_LTE",
#line 410 "filter/f-inst.c"
 /* Code enum to string for FI_NOT */
#line 410
  [FI_NOT] = "FI_NOT",
#line 419 "filter/f-inst.c"
 /* Code enum to string for FI_MATCH */
#line 419
  [FI_MATCH] = "FI_MATCH",
#line 428 "filter/f-inst.c"
 /* Code enum to string for FI_NOT_MATCH */
#line 428
  [FI_NOT_MATCH] = "FI_NOT_MATCH",
#line 433 "filter/f-inst.c"
 /* Code enum to string for FI_DEFINED */
#line 433
  [FI_DEFINED] = "FI_DEFINED",
#line 445 "filter/f-inst.c"
 /* Code enum to string for FI_TYPE */
#line 445
  [FI_TYPE] = "FI_TYPE",
#line 451 "filter/f-inst.c"
 /* Code enum to string for FI_IS_V4 */
#line 451
  [FI_IS_V4] = "FI_IS_V4",
#line 460 "filter/f-inst.c"
 /* Code enum to string for FI_VAR_SET */
#line 460
  [FI_VAR_SET] = "FI_VAR_SET",
#line 467 "filter/f-inst.c"
 /* Code enum to string for FI_VAR_GET */
#line 467
  [FI_VAR_GET] = "FI_VAR_GET",
#line 480 "filter/f-inst.c"
 /* Code enum to string for FI_CONSTANT */
#line 480
  [FI_CONSTANT] = "FI_CONSTANT",
#line 488 "filter/f-inst.c"
 /* Code enum to string for FI_CONDITION */
#line 488
  [FI_CONDITION] = "FI_CONDITION",
#line 497 "filter/f-inst.c"
 /* Code enum to string for FI_PRINT */
#line 497
  [FI_PRINT] = "FI_PRINT",
#line 504 "filter/f-inst.c"
 /* Code enum to string for FI_FLUSH */
#line 504
  [FI_FLUSH] = "FI_FLUSH",
#line 518 "filter/f-inst.c"
 /* Code enum to string for FI_DIE */
#line 518
  [FI_DIE] = "FI_DIE",
#line 543 "filter/f-inst.c"
 /* Code enum to string for FI_RTA_GET */
#line 543
  [FI_RTA_GET] = "FI_RTA_GET",
#line 627 "filter/f-inst.c"
 /* Code enum to string for FI_RTA_SET */
#line 627
  [FI_RTA_SET] = "FI_RTA_SET",
#line 702 "filter/f-inst.c"
 /* Code enum to string for FI_EA_GET */
#line 702
  [FI_EA_GET] = "FI_EA_GET",
#line 766 "filter/f-inst.c"
 /* Code enum to string for FI_EA_SET */
#line 766
  [FI_EA_SET] = "FI_EA_SET",
#line 788 "filter/f-inst.c"
 /* Code enum to string for FI_EA_UNSET */
#line 788
  [FI_EA_UNSET] = "FI_EA_UNSET",
#line 793 "filter/f-inst.c"
 /* Code enum to string for FI_PREF_GET */
#line 793
  [FI_PREF_GET] = "FI_PREF_GET",
#line 802 "filter/f-inst.c"
 /* Code enum to string for FI_PREF_SET */
#line 802
  [FI_PREF_SET] = "FI_PREF_SET",
#line 814 "filter/f-inst.c"
 /* Code enum to string for FI_LENGTH */
#line 814
  [FI_LENGTH] = "FI_LENGTH",
#line 849 "filter/f-inst.c"
 /* Code enum to string for FI_NET_SRC */
#line 849
  [FI_NET_SRC] = "FI_NET_SRC",
#line 884 "filter/f-inst.c"
 /* Code enum to string for FI_NET_DST */
#line 884
  [FI_NET_DST] = "FI_NET_DST",
#line 894 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_MAXLEN */
#line 894
  [FI_ROA_MAXLEN] = "FI_ROA_MAXLEN",
#line 904 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_ASN */
#line 904
  [FI_ROA_ASN] = "FI_ROA_ASN",
#line 909 "filter/f-inst.c"
 /* Code enum to string for FI_IP */
#line 909
  [FI_IP] = "FI_IP",
#line 916 "filter/f-inst.c"
 /* Code enum to string for FI_ROUTE_DISTINGUISHER */
#line 916
  [FI_ROUTE_DISTINGUISHER] = "FI_ROUTE_DISTINGUISHER",
#line 923 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_FIRST */
#line 923
  [FI_AS_PATH_FIRST] = "FI_AS_PATH_FIRST",
#line 930 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_LAST */
#line 930
  [FI_AS_PATH_LAST] = "FI_AS_PATH_LAST",
#line 935 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_LAST_NAG */
#line 935
  [FI_AS_PATH_LAST_NAG] = "FI_AS_PATH_LAST_NAG",
#line 961 "filter/f-inst.c"
 /* Code enum to string for FI_RETURN */
#line 961
  [FI_RETURN] = "FI_RETURN",
#line 991 "filter/f-inst.c"
 /* Code enum to string for FI_CALL */
#line 991
  [FI_CALL] = "FI_CALL",
#line 996 "filter/f-inst.c"
 /* Code enum to string for FI_DROP_RESULT */
#line 996
  [FI_DROP_RESULT] = "FI_DROP_RESULT",
#line 1019 "filter/f-inst.c"
 /* Code enum to string for FI_SWITCH */
#line 1019
  [FI_SWITCH] = "FI_SWITCH",
#line 1027 "filter/f-inst.c"
 /* Code enum to string for FI_IP_MASK */
#line 1027
  [FI_IP_MASK] = "FI_IP_MASK",
#line 1033 "filter/f-inst.c"
 /* Code enum to string for FI_PATH_PREPEND */
#line 1033
  [FI_PATH_PREPEND] = "FI_PATH_PREPEND",
#line 1090 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_ADD */
#line 1090
  [FI_CLIST_ADD] = "FI_CLIST_ADD",
#line 1152 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_DEL */
#line 1152
  [FI_CLIST_DEL] = "FI_CLIST_DEL",
#line 1200 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_FILTER */
#line 1200
  [FI_CLIST_FILTER] = "FI_CLIST_FILTER",
#line 1230 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_CHECK_IMPLICIT */
#line 1230
  [FI_ROA_CHECK_IMPLICIT] = "FI_ROA_CHECK_IMPLICIT",
#line 1252 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_CHECK_EXPLICIT */
#line 1252
  [FI_ROA_CHECK_EXPLICIT] = "FI_ROA_CHECK_EXPLICIT",
#line 1257 "filter/f-inst.c"
 /* Code enum to string for FI_FORMAT */
#line 1257
  [FI_FORMAT] = "FI_FORMAT",
#line 668 "filter/decl.m4"
 /* Code enum to string for FI_ASSERT */
#line 668
  [FI_ASSERT] = "FI_ASSERT",
#line 452 "filter/decl.m4"

};

const char *
f_instruction_name_(enum f_instruction_code fi)
{
  if (fi < (sizeof(f_instruction_name_str) / sizeof(f_instruction_name_str[0])))
    return f_instruction_name_str[fi];
  else
    bug("Got unknown instruction code: %d", fi);
}

static inline struct f_inst *
fi_new(enum f_instruction_code fi_code)
{
  struct f_inst *what = cfg_allocz(sizeof(struct f_inst));
  what->lineno = ifs->lino;
  what->size = 1;
  what->fi_code = fi_code;
  return what;
}

static inline struct f_inst *
fi_constant(struct f_inst *what, struct f_val val)
{
  what->fi_code = FI_CONSTANT;
  what->i_FI_CONSTANT.val = val;
  return what;
}

static int
f_const_promotion(struct f_inst *arg, enum f_type want)
{
  if (arg->fi_code != FI_CONSTANT)
    return 0;

  struct f_val *c = &arg->i_FI_CONSTANT.val;

  if ((c->type == T_IP) && ipa_is_ip4(c->val.ip) && (want == T_QUAD)) {
    *c = (struct f_val) {
      .type = T_QUAD,
      .val.i = ipa_to_u32(c->val.ip),
    };
    return 1;
  }

  return 0;
}

#define v1 whati->f1->i_FI_CONSTANT.val
#define v2 whati->f2->i_FI_CONSTANT.val
#define v3 whati->f3->i_FI_CONSTANT.val
#define vv(i) items[i]->i_FI_CONSTANT.val
#define runtime(fmt, ...) cf_error("filter preevaluation, line %d: " fmt, ifs->lino, ##__VA_ARGS__)
#define fpool cfg_mem
#define falloc(size) cfg_alloc(size)
/* Instruction constructors */
#line 227 "filter/f-inst.c"
 /* Constructor for FI_ADD */
#line 227
struct f_inst *f_new_inst_FI_ADD(enum f_instruction_code fi_code
#line 223 "filter/f-inst.c"
  , struct f_inst * f1
#line 224 "filter/f-inst.c"
  , struct f_inst * f2
#line 227 "filter/f-inst.c"
)
#line 227
  {
#line 227
    /* Allocate the structure */
#line 227
    struct f_inst *what = fi_new(fi_code);
#line 227
    uint constargs = 1;
#line 227

#line 227
    /* Initialize all the members */
#line 227
  #define whati (&(what->i_FI_ADD))
#line 227
  #line 223 "filter/f-inst.c"
whati->f1 = f1;
#line 223
for (const struct f_inst *child = f1; child; child = child->next) {
#line 223
  what->size += child->size;
#line 223

#line 223
  if (child->fi_code != FI_CONSTANT)
#line 223
    constargs = 0;
#line 223

#line 223
}
#line 223 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 223
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 223
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 224 "filter/f-inst.c"
whati->f2 = f2;
#line 224
for (const struct f_inst *child = f2; child; child = child->next) {
#line 224
  what->size += child->size;
#line 224

#line 224
  if (child->fi_code != FI_CONSTANT)
#line 224
    constargs = 0;
#line 224

#line 224
}
#line 224 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 224
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 224
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 225 "filter/f-inst.c"
what->type = T_INT;

#line 227 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 227
    if (!constargs)
#line 227
      return what;
#line 227

#line 227
    /* Try to pre-calculate the result */
#line 227
    #line 222 "filter/f-inst.c"
 {
    
#line 223 "filter/f-inst.c"
 
#line 223 "filter/f-inst.c"
 
#line 223 "filter/f-inst.c"
;
    
#line 224 "filter/f-inst.c"
 
#line 224 "filter/f-inst.c"
 
#line 224 "filter/f-inst.c"
;
     
#line 225 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i + v2.val.i } );
  }
  
  #undef whati
#line 227 "filter/f-inst.c"
  }
#line 227

#line 227

#line 232 "filter/f-inst.c"
 /* Constructor for FI_SUBTRACT */
#line 232
struct f_inst *f_new_inst_FI_SUBTRACT(enum f_instruction_code fi_code
#line 228 "filter/f-inst.c"
  , struct f_inst * f1
#line 229 "filter/f-inst.c"
  , struct f_inst * f2
#line 232 "filter/f-inst.c"
)
#line 232
  {
#line 232
    /* Allocate the structure */
#line 232
    struct f_inst *what = fi_new(fi_code);
#line 232
    uint constargs = 1;
#line 232

#line 232
    /* Initialize all the members */
#line 232
  #define whati (&(what->i_FI_SUBTRACT))
#line 232
  #line 228 "filter/f-inst.c"
whati->f1 = f1;
#line 228
for (const struct f_inst *child = f1; child; child = child->next) {
#line 228
  what->size += child->size;
#line 228

#line 228
  if (child->fi_code != FI_CONSTANT)
#line 228
    constargs = 0;
#line 228

#line 228
}
#line 228 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 228
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 228
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 229 "filter/f-inst.c"
whati->f2 = f2;
#line 229
for (const struct f_inst *child = f2; child; child = child->next) {
#line 229
  what->size += child->size;
#line 229

#line 229
  if (child->fi_code != FI_CONSTANT)
#line 229
    constargs = 0;
#line 229

#line 229
}
#line 229 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 229
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 229
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 230 "filter/f-inst.c"
what->type = T_INT;

#line 232 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 232
    if (!constargs)
#line 232
      return what;
#line 232

#line 232
    /* Try to pre-calculate the result */
#line 232
    #line 227 "filter/f-inst.c"
 {
    
#line 228 "filter/f-inst.c"
 
#line 228 "filter/f-inst.c"
 
#line 228 "filter/f-inst.c"
;
    
#line 229 "filter/f-inst.c"
 
#line 229 "filter/f-inst.c"
 
#line 229 "filter/f-inst.c"
;
     
#line 230 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i - v2.val.i } );
  }
  
  #undef whati
#line 232 "filter/f-inst.c"
  }
#line 232

#line 232

#line 237 "filter/f-inst.c"
 /* Constructor for FI_MULTIPLY */
#line 237
struct f_inst *f_new_inst_FI_MULTIPLY(enum f_instruction_code fi_code
#line 233 "filter/f-inst.c"
  , struct f_inst * f1
#line 234 "filter/f-inst.c"
  , struct f_inst * f2
#line 237 "filter/f-inst.c"
)
#line 237
  {
#line 237
    /* Allocate the structure */
#line 237
    struct f_inst *what = fi_new(fi_code);
#line 237
    uint constargs = 1;
#line 237

#line 237
    /* Initialize all the members */
#line 237
  #define whati (&(what->i_FI_MULTIPLY))
#line 237
  #line 233 "filter/f-inst.c"
whati->f1 = f1;
#line 233
for (const struct f_inst *child = f1; child; child = child->next) {
#line 233
  what->size += child->size;
#line 233

#line 233
  if (child->fi_code != FI_CONSTANT)
#line 233
    constargs = 0;
#line 233

#line 233
}
#line 233 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 233
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 233
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 234 "filter/f-inst.c"
whati->f2 = f2;
#line 234
for (const struct f_inst *child = f2; child; child = child->next) {
#line 234
  what->size += child->size;
#line 234

#line 234
  if (child->fi_code != FI_CONSTANT)
#line 234
    constargs = 0;
#line 234

#line 234
}
#line 234 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 234
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 234
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 235 "filter/f-inst.c"
what->type = T_INT;

#line 237 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 237
    if (!constargs)
#line 237
      return what;
#line 237

#line 237
    /* Try to pre-calculate the result */
#line 237
    #line 232 "filter/f-inst.c"
 {
    
#line 233 "filter/f-inst.c"
 
#line 233 "filter/f-inst.c"
 
#line 233 "filter/f-inst.c"
;
    
#line 234 "filter/f-inst.c"
 
#line 234 "filter/f-inst.c"
 
#line 234 "filter/f-inst.c"
;
     
#line 235 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i * v2.val.i } );
  }
  
  #undef whati
#line 237 "filter/f-inst.c"
  }
#line 237

#line 237

#line 243 "filter/f-inst.c"
 /* Constructor for FI_DIVIDE */
#line 243
struct f_inst *f_new_inst_FI_DIVIDE(enum f_instruction_code fi_code
#line 238 "filter/f-inst.c"
  , struct f_inst * f1
#line 239 "filter/f-inst.c"
  , struct f_inst * f2
#line 243 "filter/f-inst.c"
)
#line 243
  {
#line 243
    /* Allocate the structure */
#line 243
    struct f_inst *what = fi_new(fi_code);
#line 243
    uint constargs = 1;
#line 243

#line 243
    /* Initialize all the members */
#line 243
  #define whati (&(what->i_FI_DIVIDE))
#line 243
  #line 238 "filter/f-inst.c"
whati->f1 = f1;
#line 238
for (const struct f_inst *child = f1; child; child = child->next) {
#line 238
  what->size += child->size;
#line 238

#line 238
  if (child->fi_code != FI_CONSTANT)
#line 238
    constargs = 0;
#line 238

#line 238
}
#line 238 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 238
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 238
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 239 "filter/f-inst.c"
whati->f2 = f2;
#line 239
for (const struct f_inst *child = f2; child; child = child->next) {
#line 239
  what->size += child->size;
#line 239

#line 239
  if (child->fi_code != FI_CONSTANT)
#line 239
    constargs = 0;
#line 239

#line 239
}
#line 239 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 239
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 239
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 241 "filter/f-inst.c"
what->type = T_INT;

#line 243 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 243
    if (!constargs)
#line 243
      return what;
#line 243

#line 243
    /* Try to pre-calculate the result */
#line 243
    #line 237 "filter/f-inst.c"
 {
    
#line 238 "filter/f-inst.c"
 
#line 238 "filter/f-inst.c"
 
#line 238 "filter/f-inst.c"
;
    
#line 239 "filter/f-inst.c"
 
#line 239 "filter/f-inst.c"
 
#line 239 "filter/f-inst.c"
;
    if (v2.val.i == 0) runtime( "Mother told me not to divide by 0" );
     
#line 241 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i / v2.val.i } );
  }
  
  #undef whati
#line 243 "filter/f-inst.c"
  }
#line 243

#line 243

#line 253 "filter/f-inst.c"
 /* Constructor for FI_AND */
#line 253
struct f_inst *f_new_inst_FI_AND(enum f_instruction_code fi_code
#line 244 "filter/f-inst.c"
  , struct f_inst * f1
#line 249 "filter/f-inst.c"
  , struct f_inst * f2
#line 253 "filter/f-inst.c"
)
#line 253
  {
#line 253
    /* Allocate the structure */
#line 253
    struct f_inst *what = fi_new(fi_code);
#line 253
    uint constargs = 1;
#line 253

#line 253
    /* Initialize all the members */
#line 253
  #define whati (&(what->i_FI_AND))
#line 253
  #line 244 "filter/f-inst.c"
whati->f1 = f1;
#line 244
for (const struct f_inst *child = f1; child; child = child->next) {
#line 244
  what->size += child->size;
#line 244

#line 244
  if (child->fi_code != FI_CONSTANT)
#line 244
    constargs = 0;
#line 244

#line 244
}
#line 244 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 244
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 244
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 245 "filter/f-inst.c"
if (f2->type && (f2->type != (T_BOOL)) && !f_const_promotion(f2, (T_BOOL)))
#line 245
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 245
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f2->type));
#line 246 "filter/f-inst.c"
what->type = T_BOOL;
#line 249 "filter/f-inst.c"
whati->f2 = f2;

#line 253 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 253
    if (!constargs)
#line 253
      return what;
#line 253

#line 253
    /* Try to pre-calculate the result */
#line 253
    #line 243 "filter/f-inst.c"
 {
    
#line 244 "filter/f-inst.c"
 
#line 244 "filter/f-inst.c"
 
#line 244 "filter/f-inst.c"
;
    
#line 245 "filter/f-inst.c"
;
     
#line 246 "filter/f-inst.c"
;

    if (v1.val.i)
      
#line 249 "filter/f-inst.c"
return whati->f2
#line 249
;
    else
      return fi_constant(what, v1);
  }
  
  #undef whati
#line 253 "filter/f-inst.c"
  }
#line 253

#line 253

#line 264 "filter/f-inst.c"
 /* Constructor for FI_OR */
#line 264
struct f_inst *f_new_inst_FI_OR(enum f_instruction_code fi_code
#line 254 "filter/f-inst.c"
  , struct f_inst * f1
#line 259 "filter/f-inst.c"
  , struct f_inst * f2
#line 264 "filter/f-inst.c"
)
#line 264
  {
#line 264
    /* Allocate the structure */
#line 264
    struct f_inst *what = fi_new(fi_code);
#line 264
    uint constargs = 1;
#line 264

#line 264
    /* Initialize all the members */
#line 264
  #define whati (&(what->i_FI_OR))
#line 264
  #line 254 "filter/f-inst.c"
whati->f1 = f1;
#line 254
for (const struct f_inst *child = f1; child; child = child->next) {
#line 254
  what->size += child->size;
#line 254

#line 254
  if (child->fi_code != FI_CONSTANT)
#line 254
    constargs = 0;
#line 254

#line 254
}
#line 254 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 254
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 254
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 255 "filter/f-inst.c"
if (f2->type && (f2->type != (T_BOOL)) && !f_const_promotion(f2, (T_BOOL)))
#line 255
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 255
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f2->type));
#line 256 "filter/f-inst.c"
what->type = T_BOOL;
#line 259 "filter/f-inst.c"
whati->f2 = f2;

#line 264 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 264
    if (!constargs)
#line 264
      return what;
#line 264

#line 264
    /* Try to pre-calculate the result */
#line 264
    #line 253 "filter/f-inst.c"
 {
    
#line 254 "filter/f-inst.c"
 
#line 254 "filter/f-inst.c"
 
#line 254 "filter/f-inst.c"
;
    
#line 255 "filter/f-inst.c"
;
     
#line 256 "filter/f-inst.c"
;

    if (!v1.val.i)
      
#line 259 "filter/f-inst.c"
return whati->f2
#line 259
;
    else
      return fi_constant(what, v1);
  }

  
  #undef whati
#line 264 "filter/f-inst.c"
  }
#line 264

#line 264

#line 274 "filter/f-inst.c"
 /* Constructor for FI_PAIR_CONSTRUCT */
#line 274
struct f_inst *f_new_inst_FI_PAIR_CONSTRUCT(enum f_instruction_code fi_code
#line 265 "filter/f-inst.c"
  , struct f_inst * f1
#line 266 "filter/f-inst.c"
  , struct f_inst * f2
#line 274 "filter/f-inst.c"
)
#line 274
  {
#line 274
    /* Allocate the structure */
#line 274
    struct f_inst *what = fi_new(fi_code);
#line 274
    uint constargs = 1;
#line 274

#line 274
    /* Initialize all the members */
#line 274
  #define whati (&(what->i_FI_PAIR_CONSTRUCT))
#line 274
  #line 265 "filter/f-inst.c"
whati->f1 = f1;
#line 265
for (const struct f_inst *child = f1; child; child = child->next) {
#line 265
  what->size += child->size;
#line 265

#line 265
  if (child->fi_code != FI_CONSTANT)
#line 265
    constargs = 0;
#line 265

#line 265
}
#line 265 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 265
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 265
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 266 "filter/f-inst.c"
whati->f2 = f2;
#line 266
for (const struct f_inst *child = f2; child; child = child->next) {
#line 266
  what->size += child->size;
#line 266

#line 266
  if (child->fi_code != FI_CONSTANT)
#line 266
    constargs = 0;
#line 266

#line 266
}
#line 266 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 266
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 266
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 271 "filter/f-inst.c"
what->type = T_PAIR;

#line 274 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 274
    if (!constargs)
#line 274
      return what;
#line 274

#line 274
    /* Try to pre-calculate the result */
#line 274
    #line 264 "filter/f-inst.c"
 {
    
#line 265 "filter/f-inst.c"
 
#line 265 "filter/f-inst.c"
 
#line 265 "filter/f-inst.c"
;
    
#line 266 "filter/f-inst.c"
 
#line 266 "filter/f-inst.c"
 
#line 266 "filter/f-inst.c"
;
    uint u1 = v1.val.i;
    uint u2 = v2.val.i;
    if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
      runtime( "Can't operate with value out of bounds in pair constructor" );
     
#line 271 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_PAIR, .val.i = (u1 << 16) | u2 } );
  }

  
  #undef whati
#line 274 "filter/f-inst.c"
  }
#line 274

#line 274

#line 314 "filter/f-inst.c"
 /* Constructor for FI_EC_CONSTRUCT */
#line 314
struct f_inst *f_new_inst_FI_EC_CONSTRUCT(enum f_instruction_code fi_code
#line 275 "filter/f-inst.c"
  , struct f_inst * f1
#line 276 "filter/f-inst.c"
  , struct f_inst * f2
#line 278 "filter/f-inst.c"
  , enum ec_subtype ecs
#line 314 "filter/f-inst.c"
)
#line 314
  {
#line 314
    /* Allocate the structure */
#line 314
    struct f_inst *what = fi_new(fi_code);
#line 314
    uint constargs = 1;
#line 314

#line 314
    /* Initialize all the members */
#line 314
  #define whati (&(what->i_FI_EC_CONSTRUCT))
#line 314
  #line 275 "filter/f-inst.c"
whati->f1 = f1;
#line 275
for (const struct f_inst *child = f1; child; child = child->next) {
#line 275
  what->size += child->size;
#line 275

#line 275
  if (child->fi_code != FI_CONSTANT)
#line 275
    constargs = 0;
#line 275

#line 275
}
#line 276 "filter/f-inst.c"
whati->f2 = f2;
#line 276
for (const struct f_inst *child = f2; child; child = child->next) {
#line 276
  what->size += child->size;
#line 276

#line 276
  if (child->fi_code != FI_CONSTANT)
#line 276
    constargs = 0;
#line 276

#line 276
}
#line 276 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 276
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 276
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 278 "filter/f-inst.c"
whati->ecs = ecs;
#line 299 "filter/f-inst.c"
what->type = T_EC;

#line 314 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 314
    if (!constargs)
#line 314
      return what;
#line 314

#line 314
    /* Try to pre-calculate the result */
#line 314
    #line 274 "filter/f-inst.c"
 {
    
#line 275 "filter/f-inst.c"
;
    
#line 276 "filter/f-inst.c"
 
#line 276 "filter/f-inst.c"
 
#line 276 "filter/f-inst.c"
;

    #line 278 "filter/f-inst.c"
;

    int ipv4_used;
    u32 key, val;

    if (v1.type == T_INT) {
      ipv4_used = 0; key = v1.val.i;
    }
    else if (v1.type == T_QUAD) {
      ipv4_used = 1; key = v1.val.i;
    }
    /* IP->Quad implicit conversion */
    else if (val_is_ip4(&v1)) {
      ipv4_used = 1; key = ipa_to_u32(v1.val.ip);
    }
    else
      runtime("Argument 1 of EC constructor must be integer or IPv4 address, got 0x%02x", v1.type);

    val = v2.val.i;

    if (ecs == EC_GENERIC)
       
#line 299 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_generic(key, val) } );
    else if (ipv4_used)
      if (val <= 0xFFFF)
	 return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_ip4(ecs, key, val) } );
      else
	runtime("4-byte value %u can't be used with IP-address key in extended community", val);
    else if (key < 0x10000)
       return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_as2(ecs, key, val) } );
    else
      if (val <= 0xFFFF)
	 return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_as4(ecs, key, val) } );
      else
	runtime("4-byte value %u can't be used with 4-byte ASN in extended community", val);
  }

  
  #undef whati
#line 314 "filter/f-inst.c"
  }
#line 314

#line 314

#line 321 "filter/f-inst.c"
 /* Constructor for FI_LC_CONSTRUCT */
#line 321
struct f_inst *f_new_inst_FI_LC_CONSTRUCT(enum f_instruction_code fi_code
#line 315 "filter/f-inst.c"
  , struct f_inst * f1
#line 316 "filter/f-inst.c"
  , struct f_inst * f2
#line 317 "filter/f-inst.c"
  , struct f_inst * f3
#line 321 "filter/f-inst.c"
)
#line 321
  {
#line 321
    /* Allocate the structure */
#line 321
    struct f_inst *what = fi_new(fi_code);
#line 321
    uint constargs = 1;
#line 321

#line 321
    /* Initialize all the members */
#line 321
  #define whati (&(what->i_FI_LC_CONSTRUCT))
#line 321
  #line 315 "filter/f-inst.c"
whati->f1 = f1;
#line 315
for (const struct f_inst *child = f1; child; child = child->next) {
#line 315
  what->size += child->size;
#line 315

#line 315
  if (child->fi_code != FI_CONSTANT)
#line 315
    constargs = 0;
#line 315

#line 315
}
#line 315 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 315
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 315
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));
#line 316 "filter/f-inst.c"
whati->f2 = f2;
#line 316
for (const struct f_inst *child = f2; child; child = child->next) {
#line 316
  what->size += child->size;
#line 316

#line 316
  if (child->fi_code != FI_CONSTANT)
#line 316
    constargs = 0;
#line 316

#line 316
}
#line 316 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 316
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 316
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 317 "filter/f-inst.c"
whati->f3 = f3;
#line 317
for (const struct f_inst *child = f3; child; child = child->next) {
#line 317
  what->size += child->size;
#line 317

#line 317
  if (child->fi_code != FI_CONSTANT)
#line 317
    constargs = 0;
#line 317

#line 317
}
#line 317 "filter/f-inst.c"
if (f3->type && (f3->type != (T_INT)) && !f_const_promotion(f3, (T_INT)))
#line 317
  cf_error("Argument 3 of %s must be of type %s, got type %s",
#line 317
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f3->type));
#line 318 "filter/f-inst.c"
what->type = T_LC;

#line 321 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 321
    if (!constargs)
#line 321
      return what;
#line 321

#line 321
    /* Try to pre-calculate the result */
#line 321
    #line 314 "filter/f-inst.c"
 {
    
#line 315 "filter/f-inst.c"
 
#line 315 "filter/f-inst.c"
 
#line 315 "filter/f-inst.c"
;
    
#line 316 "filter/f-inst.c"
 
#line 316 "filter/f-inst.c"
 
#line 316 "filter/f-inst.c"
;
    
#line 317 "filter/f-inst.c"
 
#line 317 "filter/f-inst.c"
 
#line 317 "filter/f-inst.c"
;
     
#line 318 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_LC, .val.lc = (lcomm) { v1.val.i, v2.val.i, v3.val.i } } );
  }

  
  #undef whati
#line 321 "filter/f-inst.c"
  }
#line 321

#line 321

#line 371 "filter/f-inst.c"
 /* Constructor for FI_PATHMASK_CONSTRUCT */
#line 371
struct f_inst *f_new_inst_FI_PATHMASK_CONSTRUCT(enum f_instruction_code fi_code
#line 322 "filter/f-inst.c"
  , struct f_inst * fvar
#line 371 "filter/f-inst.c"
)
#line 371
  {
#line 371
    /* Allocate the structure */
#line 371
    struct f_inst *what = fi_new(fi_code);
#line 371
    uint constargs = 1;
#line 371

#line 371
    /* Initialize all the members */
#line 371
  #define whati (&(what->i_FI_PATHMASK_CONSTRUCT))
#line 371
  #line 322 "filter/f-inst.c"
whati->varcount = 0;
#line 322
whati->fvar = fvar;
#line 322
for (const struct f_inst *child = fvar; child; child = child->next, whati->varcount++) {
#line 322
  what->size += child->size;
#line 322

#line 322
  if (child->fi_code != FI_CONSTANT)
#line 322
    constargs = 0;
#line 322

#line 322
}
#line 322

#line 322
  const struct f_inst **items = NULL;
#line 322
  if (constargs && whati->varcount) {
#line 322
    items = alloca(whati->varcount * sizeof(struct f_inst *));
#line 322
    const struct f_inst *child = fvar;
#line 322
    for (uint i=0; child; i++)
#line 322
      child = (items[i] = child)->next;
#line 322
  }
#line 322

#line 366 "filter/f-inst.c"
what->type = T_PATH_MASK;

#line 371 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 371
    if (!constargs)
#line 371
      return what;
#line 371

#line 371
    /* Try to pre-calculate the result */
#line 371
    #line 321 "filter/f-inst.c"
 {
    
#line 322 "filter/f-inst.c"

#line 322

#line 322
;

    struct f_path_mask *pm = falloc(sizeof(struct f_path_mask) + whati->varcount * sizeof(struct f_path_mask_item));
    pm->len = whati->varcount;

    for (uint i=0; i<whati->varcount; i++) {
      switch (vv(i).type) {
	case T_PATH_MASK_ITEM:
	  if (vv(i).val.pmi.kind == PM_LOOP)
	  {
	    if (i == 0)
	      runtime("Path mask iterator '+' cannot be first");

	    /* We want PM_LOOP as prefix operator */
	    pm->item[i] = pm->item[i - 1];
	    pm->item[i - 1] = vv(i).val.pmi;
	    break;
	  }

	  pm->item[i] = vv(i).val.pmi;
	  break;

	case T_INT:
	  pm->item[i] = (struct f_path_mask_item) {
	    .asn = vv(i).val.i,
	    .kind = PM_ASN,
	  };
	  break;

	case T_SET:
	  if (vv(i).val.t->from.type != T_INT)
	    runtime("Only integer sets allowed in path mask");

	  pm->item[i] = (struct f_path_mask_item) {
	    .set = vv(i).val.t,
	    .kind = PM_ASN_SET,
	  };
	  break;

	default:
	  runtime( "Error resolving path mask template: value not an integer" );
      }
    }

     
#line 366 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_PATH_MASK, .val.path_mask = pm } );
  }

/* Relational operators */

  
  #undef whati
#line 371 "filter/f-inst.c"
  }
#line 371

#line 371

#line 377 "filter/f-inst.c"
 /* Constructor for FI_NEQ */
#line 377
struct f_inst *f_new_inst_FI_NEQ(enum f_instruction_code fi_code
#line 372 "filter/f-inst.c"
  , struct f_inst * f1
#line 373 "filter/f-inst.c"
  , struct f_inst * f2
#line 377 "filter/f-inst.c"
)
#line 377
  {
#line 377
    /* Allocate the structure */
#line 377
    struct f_inst *what = fi_new(fi_code);
#line 377
    uint constargs = 1;
#line 377

#line 377
    /* Initialize all the members */
#line 377
  #define whati (&(what->i_FI_NEQ))
#line 377
  #line 372 "filter/f-inst.c"
whati->f1 = f1;
#line 372
for (const struct f_inst *child = f1; child; child = child->next) {
#line 372
  what->size += child->size;
#line 372

#line 372
  if (child->fi_code != FI_CONSTANT)
#line 372
    constargs = 0;
#line 372

#line 372
}
#line 373 "filter/f-inst.c"
whati->f2 = f2;
#line 373
for (const struct f_inst *child = f2; child; child = child->next) {
#line 373
  what->size += child->size;
#line 373

#line 373
  if (child->fi_code != FI_CONSTANT)
#line 373
    constargs = 0;
#line 373

#line 373
}
#line 374 "filter/f-inst.c"
what->type = T_BOOL;

#line 377 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 377
    if (!constargs)
#line 377
      return what;
#line 377

#line 377
    /* Try to pre-calculate the result */
#line 377
    #line 371 "filter/f-inst.c"
 {
    
#line 372 "filter/f-inst.c"
;
    
#line 373 "filter/f-inst.c"
;
     
#line 374 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !val_same(&v1, &v2) } );
  }

  
  #undef whati
#line 377 "filter/f-inst.c"
  }
#line 377

#line 377

#line 383 "filter/f-inst.c"
 /* Constructor for FI_EQ */
#line 383
struct f_inst *f_new_inst_FI_EQ(enum f_instruction_code fi_code
#line 378 "filter/f-inst.c"
  , struct f_inst * f1
#line 379 "filter/f-inst.c"
  , struct f_inst * f2
#line 383 "filter/f-inst.c"
)
#line 383
  {
#line 383
    /* Allocate the structure */
#line 383
    struct f_inst *what = fi_new(fi_code);
#line 383
    uint constargs = 1;
#line 383

#line 383
    /* Initialize all the members */
#line 383
  #define whati (&(what->i_FI_EQ))
#line 383
  #line 378 "filter/f-inst.c"
whati->f1 = f1;
#line 378
for (const struct f_inst *child = f1; child; child = child->next) {
#line 378
  what->size += child->size;
#line 378

#line 378
  if (child->fi_code != FI_CONSTANT)
#line 378
    constargs = 0;
#line 378

#line 378
}
#line 379 "filter/f-inst.c"
whati->f2 = f2;
#line 379
for (const struct f_inst *child = f2; child; child = child->next) {
#line 379
  what->size += child->size;
#line 379

#line 379
  if (child->fi_code != FI_CONSTANT)
#line 379
    constargs = 0;
#line 379

#line 379
}
#line 380 "filter/f-inst.c"
what->type = T_BOOL;

#line 383 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 383
    if (!constargs)
#line 383
      return what;
#line 383

#line 383
    /* Try to pre-calculate the result */
#line 383
    #line 377 "filter/f-inst.c"
 {
    
#line 378 "filter/f-inst.c"
;
    
#line 379 "filter/f-inst.c"
;
     
#line 380 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = val_same(&v1, &v2) } );
  }

  
  #undef whati
#line 383 "filter/f-inst.c"
  }
#line 383

#line 383

#line 394 "filter/f-inst.c"
 /* Constructor for FI_LT */
#line 394
struct f_inst *f_new_inst_FI_LT(enum f_instruction_code fi_code
#line 384 "filter/f-inst.c"
  , struct f_inst * f1
#line 385 "filter/f-inst.c"
  , struct f_inst * f2
#line 394 "filter/f-inst.c"
)
#line 394
  {
#line 394
    /* Allocate the structure */
#line 394
    struct f_inst *what = fi_new(fi_code);
#line 394
    uint constargs = 1;
#line 394

#line 394
    /* Initialize all the members */
#line 394
  #define whati (&(what->i_FI_LT))
#line 394
  #line 384 "filter/f-inst.c"
whati->f1 = f1;
#line 384
for (const struct f_inst *child = f1; child; child = child->next) {
#line 384
  what->size += child->size;
#line 384

#line 384
  if (child->fi_code != FI_CONSTANT)
#line 384
    constargs = 0;
#line 384

#line 384
}
#line 385 "filter/f-inst.c"
whati->f2 = f2;
#line 385
for (const struct f_inst *child = f2; child; child = child->next) {
#line 385
  what->size += child->size;
#line 385

#line 385
  if (child->fi_code != FI_CONSTANT)
#line 385
    constargs = 0;
#line 385

#line 385
}
#line 386 "filter/f-inst.c"
if (f1->type && f2->type && (f1->type != f2->type) &&
#line 386
   !f_const_promotion(f2, f1->type) && !f_const_promotion(f1, f2->type))
#line 386
  cf_error("Arguments 1 and 2 of %s must be of the same type", f_instruction_name(what->fi_code));
#line 391 "filter/f-inst.c"
what->type = T_BOOL;

#line 394 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 394
    if (!constargs)
#line 394
      return what;
#line 394

#line 394
    /* Try to pre-calculate the result */
#line 394
    #line 383 "filter/f-inst.c"
 {
    
#line 384 "filter/f-inst.c"
;
    
#line 385 "filter/f-inst.c"
;
    
#line 386 "filter/f-inst.c"
;

    int i = val_compare(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "Can't compare values of incompatible types" );
     
#line 391 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (i == -1) } );
  }

  
  #undef whati
#line 394 "filter/f-inst.c"
  }
#line 394

#line 394

#line 405 "filter/f-inst.c"
 /* Constructor for FI_LTE */
#line 405
struct f_inst *f_new_inst_FI_LTE(enum f_instruction_code fi_code
#line 395 "filter/f-inst.c"
  , struct f_inst * f1
#line 396 "filter/f-inst.c"
  , struct f_inst * f2
#line 405 "filter/f-inst.c"
)
#line 405
  {
#line 405
    /* Allocate the structure */
#line 405
    struct f_inst *what = fi_new(fi_code);
#line 405
    uint constargs = 1;
#line 405

#line 405
    /* Initialize all the members */
#line 405
  #define whati (&(what->i_FI_LTE))
#line 405
  #line 395 "filter/f-inst.c"
whati->f1 = f1;
#line 395
for (const struct f_inst *child = f1; child; child = child->next) {
#line 395
  what->size += child->size;
#line 395

#line 395
  if (child->fi_code != FI_CONSTANT)
#line 395
    constargs = 0;
#line 395

#line 395
}
#line 396 "filter/f-inst.c"
whati->f2 = f2;
#line 396
for (const struct f_inst *child = f2; child; child = child->next) {
#line 396
  what->size += child->size;
#line 396

#line 396
  if (child->fi_code != FI_CONSTANT)
#line 396
    constargs = 0;
#line 396

#line 396
}
#line 397 "filter/f-inst.c"
if (f1->type && f2->type && (f1->type != f2->type) &&
#line 397
   !f_const_promotion(f2, f1->type) && !f_const_promotion(f1, f2->type))
#line 397
  cf_error("Arguments 1 and 2 of %s must be of the same type", f_instruction_name(what->fi_code));
#line 402 "filter/f-inst.c"
what->type = T_BOOL;

#line 405 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 405
    if (!constargs)
#line 405
      return what;
#line 405

#line 405
    /* Try to pre-calculate the result */
#line 405
    #line 394 "filter/f-inst.c"
 {
    
#line 395 "filter/f-inst.c"
;
    
#line 396 "filter/f-inst.c"
;
    
#line 397 "filter/f-inst.c"
;

    int i = val_compare(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "Can't compare values of incompatible types" );
     
#line 402 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (i != 1) } );
  }

  
  #undef whati
#line 405 "filter/f-inst.c"
  }
#line 405

#line 405

#line 410 "filter/f-inst.c"
 /* Constructor for FI_NOT */
#line 410
struct f_inst *f_new_inst_FI_NOT(enum f_instruction_code fi_code
#line 406 "filter/f-inst.c"
  , struct f_inst * f1
#line 410 "filter/f-inst.c"
)
#line 410
  {
#line 410
    /* Allocate the structure */
#line 410
    struct f_inst *what = fi_new(fi_code);
#line 410
    uint constargs = 1;
#line 410

#line 410
    /* Initialize all the members */
#line 410
  #define whati (&(what->i_FI_NOT))
#line 410
  #line 406 "filter/f-inst.c"
whati->f1 = f1;
#line 406
for (const struct f_inst *child = f1; child; child = child->next) {
#line 406
  what->size += child->size;
#line 406

#line 406
  if (child->fi_code != FI_CONSTANT)
#line 406
    constargs = 0;
#line 406

#line 406
}
#line 406 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 406
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 406
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 407 "filter/f-inst.c"
what->type = T_BOOL;

#line 410 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 410
    if (!constargs)
#line 410
      return what;
#line 410

#line 410
    /* Try to pre-calculate the result */
#line 410
    #line 405 "filter/f-inst.c"
 {
    
#line 406 "filter/f-inst.c"
 
#line 406 "filter/f-inst.c"
 
#line 406 "filter/f-inst.c"
;
     
#line 407 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !v1.val.i } );
  }

  
  #undef whati
#line 410 "filter/f-inst.c"
  }
#line 410

#line 410

#line 419 "filter/f-inst.c"
 /* Constructor for FI_MATCH */
#line 419
struct f_inst *f_new_inst_FI_MATCH(enum f_instruction_code fi_code
#line 411 "filter/f-inst.c"
  , struct f_inst * f1
#line 412 "filter/f-inst.c"
  , struct f_inst * f2
#line 419 "filter/f-inst.c"
)
#line 419
  {
#line 419
    /* Allocate the structure */
#line 419
    struct f_inst *what = fi_new(fi_code);
#line 419
    uint constargs = 1;
#line 419

#line 419
    /* Initialize all the members */
#line 419
  #define whati (&(what->i_FI_MATCH))
#line 419
  #line 411 "filter/f-inst.c"
whati->f1 = f1;
#line 411
for (const struct f_inst *child = f1; child; child = child->next) {
#line 411
  what->size += child->size;
#line 411

#line 411
  if (child->fi_code != FI_CONSTANT)
#line 411
    constargs = 0;
#line 411

#line 411
}
#line 412 "filter/f-inst.c"
whati->f2 = f2;
#line 412
for (const struct f_inst *child = f2; child; child = child->next) {
#line 412
  what->size += child->size;
#line 412

#line 412
  if (child->fi_code != FI_CONSTANT)
#line 412
    constargs = 0;
#line 412

#line 412
}
#line 416 "filter/f-inst.c"
what->type = T_BOOL;

#line 419 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 419
    if (!constargs)
#line 419
      return what;
#line 419

#line 419
    /* Try to pre-calculate the result */
#line 419
    #line 410 "filter/f-inst.c"
 {
    
#line 411 "filter/f-inst.c"
;
    
#line 412 "filter/f-inst.c"
;
    int i = val_in_range(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "~ applied on unknown type pair" );
     
#line 416 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !!i } );
  }

  
  #undef whati
#line 419 "filter/f-inst.c"
  }
#line 419

#line 419

#line 428 "filter/f-inst.c"
 /* Constructor for FI_NOT_MATCH */
#line 428
struct f_inst *f_new_inst_FI_NOT_MATCH(enum f_instruction_code fi_code
#line 420 "filter/f-inst.c"
  , struct f_inst * f1
#line 421 "filter/f-inst.c"
  , struct f_inst * f2
#line 428 "filter/f-inst.c"
)
#line 428
  {
#line 428
    /* Allocate the structure */
#line 428
    struct f_inst *what = fi_new(fi_code);
#line 428
    uint constargs = 1;
#line 428

#line 428
    /* Initialize all the members */
#line 428
  #define whati (&(what->i_FI_NOT_MATCH))
#line 428
  #line 420 "filter/f-inst.c"
whati->f1 = f1;
#line 420
for (const struct f_inst *child = f1; child; child = child->next) {
#line 420
  what->size += child->size;
#line 420

#line 420
  if (child->fi_code != FI_CONSTANT)
#line 420
    constargs = 0;
#line 420

#line 420
}
#line 421 "filter/f-inst.c"
whati->f2 = f2;
#line 421
for (const struct f_inst *child = f2; child; child = child->next) {
#line 421
  what->size += child->size;
#line 421

#line 421
  if (child->fi_code != FI_CONSTANT)
#line 421
    constargs = 0;
#line 421

#line 421
}
#line 425 "filter/f-inst.c"
what->type = T_BOOL;

#line 428 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 428
    if (!constargs)
#line 428
      return what;
#line 428

#line 428
    /* Try to pre-calculate the result */
#line 428
    #line 419 "filter/f-inst.c"
 {
    
#line 420 "filter/f-inst.c"
;
    
#line 421 "filter/f-inst.c"
;
    int i = val_in_range(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "!~ applied on unknown type pair" );
     
#line 425 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !i } );
  }

  
  #undef whati
#line 428 "filter/f-inst.c"
  }
#line 428

#line 428

#line 433 "filter/f-inst.c"
 /* Constructor for FI_DEFINED */
#line 433
struct f_inst *f_new_inst_FI_DEFINED(enum f_instruction_code fi_code
#line 429 "filter/f-inst.c"
  , struct f_inst * f1
#line 433 "filter/f-inst.c"
)
#line 433
  {
#line 433
    /* Allocate the structure */
#line 433
    struct f_inst *what = fi_new(fi_code);
#line 433
    uint constargs = 1;
#line 433

#line 433
    /* Initialize all the members */
#line 433
  #define whati (&(what->i_FI_DEFINED))
#line 433
  #line 429 "filter/f-inst.c"
whati->f1 = f1;
#line 429
for (const struct f_inst *child = f1; child; child = child->next) {
#line 429
  what->size += child->size;
#line 429

#line 429
  if (child->fi_code != FI_CONSTANT)
#line 429
    constargs = 0;
#line 429

#line 429
}
#line 430 "filter/f-inst.c"
what->type = T_BOOL;

#line 433 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 433
    if (!constargs)
#line 433
      return what;
#line 433

#line 433
    /* Try to pre-calculate the result */
#line 433
    #line 428 "filter/f-inst.c"
 {
    
#line 429 "filter/f-inst.c"
;
     
#line 430 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (v1.type != T_VOID) && !undef_value(v1) } );
  }

  
  #undef whati
#line 433 "filter/f-inst.c"
  }
#line 433

#line 433

#line 445 "filter/f-inst.c"
 /* Constructor for FI_TYPE */
#line 445
struct f_inst *f_new_inst_FI_TYPE(enum f_instruction_code fi_code
#line 434 "filter/f-inst.c"
  , struct f_inst * f1
#line 445 "filter/f-inst.c"
)
#line 445
  {
#line 445
    /* Allocate the structure */
#line 445
    struct f_inst *what = fi_new(fi_code);
#line 445
    uint constargs = 1;
#line 445

#line 445
    /* Initialize all the members */
#line 445
  #define whati (&(what->i_FI_TYPE))
#line 445
  #line 434 "filter/f-inst.c"
whati->f1 = f1;
#line 434
for (const struct f_inst *child = f1; child; child = child->next) {
#line 434
  what->size += child->size;
#line 434

#line 434
  if (child->fi_code != FI_CONSTANT)
#line 434
    constargs = 0;
#line 434

#line 434
}
#line 438 "filter/f-inst.c"
what->type = T_ENUM_NETTYPE;

#line 445 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 445
    if (!constargs)
#line 445
      return what;
#line 445

#line 445
    /* Try to pre-calculate the result */
#line 445
    #line 433 "filter/f-inst.c"
 {
    
#line 434 "filter/f-inst.c"
; /* There may be more types supporting this operation */
    switch (v1.type)
    {
      case T_NET:
	 
#line 438 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_ENUM_NETTYPE, .val.i = v1.val.net->type } );
	break;
      default:
	runtime( "Can't determine type of this item" );
    }
  }

  
  #undef whati
#line 445 "filter/f-inst.c"
  }
#line 445

#line 445

#line 451 "filter/f-inst.c"
 /* Constructor for FI_IS_V4 */
#line 451
struct f_inst *f_new_inst_FI_IS_V4(enum f_instruction_code fi_code
#line 446 "filter/f-inst.c"
  , struct f_inst * f1
#line 451 "filter/f-inst.c"
)
#line 451
  {
#line 451
    /* Allocate the structure */
#line 451
    struct f_inst *what = fi_new(fi_code);
#line 451
    uint constargs = 1;
#line 451

#line 451
    /* Initialize all the members */
#line 451
  #define whati (&(what->i_FI_IS_V4))
#line 451
  #line 446 "filter/f-inst.c"
whati->f1 = f1;
#line 446
for (const struct f_inst *child = f1; child; child = child->next) {
#line 446
  what->size += child->size;
#line 446

#line 446
  if (child->fi_code != FI_CONSTANT)
#line 446
    constargs = 0;
#line 446

#line 446
}
#line 446 "filter/f-inst.c"
if (f1->type && (f1->type != (T_IP)) && !f_const_promotion(f1, (T_IP)))
#line 446
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 446
	   f_instruction_name(what->fi_code), f_type_name(T_IP), f_type_name(f1->type));
#line 447 "filter/f-inst.c"
what->type = T_BOOL;

#line 451 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 451
    if (!constargs)
#line 451
      return what;
#line 451

#line 451
    /* Try to pre-calculate the result */
#line 451
    #line 445 "filter/f-inst.c"
 {
    
#line 446 "filter/f-inst.c"
 
#line 446 "filter/f-inst.c"
 
#line 446 "filter/f-inst.c"
;
     
#line 447 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = ipa_is_ip4(v1.val.ip) } );
  }

  /* Set to indirect value prepared in v1 */
  
  #undef whati
#line 451 "filter/f-inst.c"
  }
#line 451

#line 451

#line 460 "filter/f-inst.c"
 /* Constructor for FI_VAR_SET */
#line 460
struct f_inst *f_new_inst_FI_VAR_SET(enum f_instruction_code fi_code
#line 453 "filter/f-inst.c"
  , struct f_inst * f1
#line 454 "filter/f-inst.c"
  , struct symbol * sym
#line 460 "filter/f-inst.c"
)
#line 460
  {
#line 460
    /* Allocate the structure */
#line 460
    struct f_inst *what = fi_new(fi_code);
#line 460
    
#line 460

#line 460
    /* Initialize all the members */
#line 460
  #define whati (&(what->i_FI_VAR_SET))
#line 460
  #line 453 "filter/f-inst.c"
whati->f1 = f1;
#line 453
for (const struct f_inst *child = f1; child; child = child->next) {
#line 453
  what->size += child->size;
#line 453

#line 453
}
#line 454 "filter/f-inst.c"
whati->sym = sym;
#line 455 "filter/f-inst.c"
if (f1->type && (f1->type != (sym->class & 0xff)) && !f_const_promotion(f1, (sym->class & 0xff)))
#line 455
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 455
	   f_instruction_name(what->fi_code), f_type_name(sym->class & 0xff), f_type_name(f1->type));

#line 460 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 460
    
#line 460
      return what;
#line 460

#line 460
    /* Try to pre-calculate the result */
#line 460
      #undef whati
#line 460
  }
#line 460

#line 460

#line 467 "filter/f-inst.c"
 /* Constructor for FI_VAR_GET */
#line 467
struct f_inst *f_new_inst_FI_VAR_GET(enum f_instruction_code fi_code
#line 461 "filter/f-inst.c"
  , struct symbol * sym
#line 467 "filter/f-inst.c"
)
#line 467
  {
#line 467
    /* Allocate the structure */
#line 467
    struct f_inst *what = fi_new(fi_code);
#line 467
    
#line 467

#line 467
    /* Initialize all the members */
#line 467
  #define whati (&(what->i_FI_VAR_GET))
#line 467
  #line 461 "filter/f-inst.c"
whati->sym = sym;
#line 463 "filter/f-inst.c"
what->type = sym->class & 0xff;

#line 467 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 467
    
#line 467
      return what;
#line 467

#line 467
    /* Try to pre-calculate the result */
#line 467
      #undef whati
#line 467
  }
#line 467

#line 467

#line 480 "filter/f-inst.c"
 /* Constructor for FI_CONSTANT */
#line 480
struct f_inst *f_new_inst_FI_CONSTANT(enum f_instruction_code fi_code
#line 468 "filter/f-inst.c"
  , struct f_val val
#line 480 "filter/f-inst.c"
)
#line 480
  {
#line 480
    /* Allocate the structure */
#line 480
    struct f_inst *what = fi_new(fi_code);
#line 480
    uint constargs = 1;
#line 480

#line 480
    /* Initialize all the members */
#line 480
  #define whati (&(what->i_FI_CONSTANT))
#line 480
  #line 468 "filter/f-inst.c"
whati->val = val;
#line 476 "filter/f-inst.c"
what->type = val.type;

#line 480 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 480
    if (!constargs)
#line 480
      return what;
#line 480

#line 480
    /* Try to pre-calculate the result */
#line 480
    #line 467 "filter/f-inst.c"
 {
    #line 474 "filter/f-inst.c"
;

     
#line 476 "filter/f-inst.c"
;
    return fi_constant(what, val);
  }

  
  #undef whati
#line 480 "filter/f-inst.c"
  }
#line 480

#line 480

#line 488 "filter/f-inst.c"
 /* Constructor for FI_CONDITION */
#line 488
struct f_inst *f_new_inst_FI_CONDITION(enum f_instruction_code fi_code
#line 481 "filter/f-inst.c"
  , struct f_inst * f1
#line 483 "filter/f-inst.c"
  , struct f_inst * f2
#line 485 "filter/f-inst.c"
  , struct f_inst * f3
#line 488 "filter/f-inst.c"
)
#line 488
  {
#line 488
    /* Allocate the structure */
#line 488
    struct f_inst *what = fi_new(fi_code);
#line 488
    uint constargs = 1;
#line 488

#line 488
    /* Initialize all the members */
#line 488
  #define whati (&(what->i_FI_CONDITION))
#line 488
  #line 481 "filter/f-inst.c"
whati->f1 = f1;
#line 481
for (const struct f_inst *child = f1; child; child = child->next) {
#line 481
  what->size += child->size;
#line 481

#line 481
  if (child->fi_code != FI_CONSTANT)
#line 481
    constargs = 0;
#line 481

#line 481
}
#line 481 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 481
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 481
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 483 "filter/f-inst.c"
whati->f2 = f2;
#line 485 "filter/f-inst.c"
whati->f3 = f3;

#line 488 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 488
    if (!constargs)
#line 488
      return what;
#line 488

#line 488
    /* Try to pre-calculate the result */
#line 488
    #line 480 "filter/f-inst.c"
 {
    
#line 481 "filter/f-inst.c"
 
#line 481 "filter/f-inst.c"
 
#line 481 "filter/f-inst.c"
;
    if (v1.val.i)
      
#line 483 "filter/f-inst.c"
return whati->f2
#line 483
;
    else
      
#line 485 "filter/f-inst.c"
return whati->f3
#line 485
;
  }

  
  #undef whati
#line 488 "filter/f-inst.c"
  }
#line 488

#line 488

#line 497 "filter/f-inst.c"
 /* Constructor for FI_PRINT */
#line 497
struct f_inst *f_new_inst_FI_PRINT(enum f_instruction_code fi_code
#line 490 "filter/f-inst.c"
  , struct f_inst * fvar
#line 497 "filter/f-inst.c"
)
#line 497
  {
#line 497
    /* Allocate the structure */
#line 497
    struct f_inst *what = fi_new(fi_code);
#line 497
    
#line 497

#line 497
    /* Initialize all the members */
#line 497
  #define whati (&(what->i_FI_PRINT))
#line 497
  #line 490 "filter/f-inst.c"
whati->varcount = 0;
#line 490
whati->fvar = fvar;
#line 490
for (const struct f_inst *child = fvar; child; child = child->next, whati->varcount++) {
#line 490
  what->size += child->size;
#line 490

#line 490
}
#line 490


#line 497 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 497
    
#line 497
      return what;
#line 497

#line 497
    /* Try to pre-calculate the result */
#line 497
      #undef whati
#line 497
  }
#line 497

#line 497

#line 504 "filter/f-inst.c"
 /* Constructor for FI_FLUSH */
#line 504
struct f_inst *f_new_inst_FI_FLUSH(enum f_instruction_code fi_code
#line 504
)
#line 504
  {
#line 504
    /* Allocate the structure */
#line 504
    struct f_inst *what = fi_new(fi_code);
#line 504
    
#line 504

#line 504
    /* Initialize all the members */
#line 504
  #define whati (&(what->i_FI_FLUSH))
#line 504
  
#line 504
    /* If not constant, return the instruction itself */
#line 504
    
#line 504
      return what;
#line 504

#line 504
    /* Try to pre-calculate the result */
#line 504
      #undef whati
#line 504
  }
#line 504

#line 504

#line 518 "filter/f-inst.c"
 /* Constructor for FI_DIE */
#line 518
struct f_inst *f_new_inst_FI_DIE(enum f_instruction_code fi_code
#line 506 "filter/f-inst.c"
  , enum filter_return fret
#line 518 "filter/f-inst.c"
)
#line 518
  {
#line 518
    /* Allocate the structure */
#line 518
    struct f_inst *what = fi_new(fi_code);
#line 518
    
#line 518

#line 518
    /* Initialize all the members */
#line 518
  #define whati (&(what->i_FI_DIE))
#line 518
  #line 506 "filter/f-inst.c"
whati->fret = fret;

#line 518 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 518
    
#line 518
      return what;
#line 518

#line 518
    /* Try to pre-calculate the result */
#line 518
      #undef whati
#line 518
  }
#line 518

#line 518

#line 543 "filter/f-inst.c"
 /* Constructor for FI_RTA_GET */
#line 543
struct f_inst *f_new_inst_FI_RTA_GET(enum f_instruction_code fi_code
#line 520 "filter/f-inst.c"
  , struct f_static_attr sa
#line 543 "filter/f-inst.c"
)
#line 543
  {
#line 543
    /* Allocate the structure */
#line 543
    struct f_inst *what = fi_new(fi_code);
#line 543
    
#line 543

#line 543
    /* Initialize all the members */
#line 543
  #define whati (&(what->i_FI_RTA_GET))
#line 543
  #line 520 "filter/f-inst.c"
whati->sa = sa;
#line 526 "filter/f-inst.c"
what->type = sa.f_type;

#line 543 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 543
    
#line 543
      return what;
#line 543

#line 543
    /* Try to pre-calculate the result */
#line 543
      #undef whati
#line 543
  }
#line 543

#line 543

#line 627 "filter/f-inst.c"
 /* Constructor for FI_RTA_SET */
#line 627
struct f_inst *f_new_inst_FI_RTA_SET(enum f_instruction_code fi_code
#line 545 "filter/f-inst.c"
  , struct f_inst * f1
#line 546 "filter/f-inst.c"
  , struct f_static_attr sa
#line 627 "filter/f-inst.c"
)
#line 627
  {
#line 627
    /* Allocate the structure */
#line 627
    struct f_inst *what = fi_new(fi_code);
#line 627
    
#line 627

#line 627
    /* Initialize all the members */
#line 627
  #define whati (&(what->i_FI_RTA_SET))
#line 627
  #line 545 "filter/f-inst.c"
whati->f1 = f1;
#line 545
for (const struct f_inst *child = f1; child; child = child->next) {
#line 545
  what->size += child->size;
#line 545

#line 545
}
#line 546 "filter/f-inst.c"
whati->sa = sa;
#line 547 "filter/f-inst.c"
if (f1->type && (f1->type != (sa.f_type)) && !f_const_promotion(f1, (sa.f_type)))
#line 547
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 547
	   f_instruction_name(what->fi_code), f_type_name(sa.f_type), f_type_name(f1->type));

#line 627 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 627
    
#line 627
      return what;
#line 627

#line 627
    /* Try to pre-calculate the result */
#line 627
      #undef whati
#line 627
  }
#line 627

#line 627

#line 702 "filter/f-inst.c"
 /* Constructor for FI_EA_GET */
#line 702
struct f_inst *f_new_inst_FI_EA_GET(enum f_instruction_code fi_code
#line 628 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 702 "filter/f-inst.c"
)
#line 702
  {
#line 702
    /* Allocate the structure */
#line 702
    struct f_inst *what = fi_new(fi_code);
#line 702
    
#line 702

#line 702
    /* Initialize all the members */
#line 702
  #define whati (&(what->i_FI_EA_GET))
#line 702
  #line 628 "filter/f-inst.c"
whati->da = da;
#line 631 "filter/f-inst.c"
what->type = da.f_type;

#line 702 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 702
    
#line 702
      return what;
#line 702

#line 702
    /* Try to pre-calculate the result */
#line 702
      #undef whati
#line 702
  }
#line 702

#line 702

#line 766 "filter/f-inst.c"
 /* Constructor for FI_EA_SET */
#line 766
struct f_inst *f_new_inst_FI_EA_SET(enum f_instruction_code fi_code
#line 705 "filter/f-inst.c"
  , struct f_inst * f1
#line 706 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 766 "filter/f-inst.c"
)
#line 766
  {
#line 766
    /* Allocate the structure */
#line 766
    struct f_inst *what = fi_new(fi_code);
#line 766
    
#line 766

#line 766
    /* Initialize all the members */
#line 766
  #define whati (&(what->i_FI_EA_SET))
#line 766
  #line 705 "filter/f-inst.c"
whati->f1 = f1;
#line 705
for (const struct f_inst *child = f1; child; child = child->next) {
#line 705
  what->size += child->size;
#line 705

#line 705
}
#line 706 "filter/f-inst.c"
whati->da = da;
#line 707 "filter/f-inst.c"
if (f1->type && (f1->type != (da.f_type)) && !f_const_promotion(f1, (da.f_type)))
#line 707
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 707
	   f_instruction_name(what->fi_code), f_type_name(da.f_type), f_type_name(f1->type));

#line 766 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 766
    
#line 766
      return what;
#line 766

#line 766
    /* Try to pre-calculate the result */
#line 766
      #undef whati
#line 766
  }
#line 766

#line 766

#line 788 "filter/f-inst.c"
 /* Constructor for FI_EA_UNSET */
#line 788
struct f_inst *f_new_inst_FI_EA_UNSET(enum f_instruction_code fi_code
#line 767 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 788 "filter/f-inst.c"
)
#line 788
  {
#line 788
    /* Allocate the structure */
#line 788
    struct f_inst *what = fi_new(fi_code);
#line 788
    
#line 788

#line 788
    /* Initialize all the members */
#line 788
  #define whati (&(what->i_FI_EA_UNSET))
#line 788
  #line 767 "filter/f-inst.c"
whati->da = da;

#line 788 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 788
    
#line 788
      return what;
#line 788

#line 788
    /* Try to pre-calculate the result */
#line 788
      #undef whati
#line 788
  }
#line 788

#line 788

#line 793 "filter/f-inst.c"
 /* Constructor for FI_PREF_GET */
#line 793
struct f_inst *f_new_inst_FI_PREF_GET(enum f_instruction_code fi_code
#line 793
)
#line 793
  {
#line 793
    /* Allocate the structure */
#line 793
    struct f_inst *what = fi_new(fi_code);
#line 793
    
#line 793

#line 793
    /* Initialize all the members */
#line 793
  #define whati (&(what->i_FI_PREF_GET))
#line 793
  #line 790 "filter/f-inst.c"
what->type = T_INT;

#line 793 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 793
    
#line 793
      return what;
#line 793

#line 793
    /* Try to pre-calculate the result */
#line 793
      #undef whati
#line 793
  }
#line 793

#line 793

#line 802 "filter/f-inst.c"
 /* Constructor for FI_PREF_SET */
#line 802
struct f_inst *f_new_inst_FI_PREF_SET(enum f_instruction_code fi_code
#line 795 "filter/f-inst.c"
  , struct f_inst * f1
#line 802 "filter/f-inst.c"
)
#line 802
  {
#line 802
    /* Allocate the structure */
#line 802
    struct f_inst *what = fi_new(fi_code);
#line 802
    
#line 802

#line 802
    /* Initialize all the members */
#line 802
  #define whati (&(what->i_FI_PREF_SET))
#line 802
  #line 795 "filter/f-inst.c"
whati->f1 = f1;
#line 795
for (const struct f_inst *child = f1; child; child = child->next) {
#line 795
  what->size += child->size;
#line 795

#line 795
}
#line 795 "filter/f-inst.c"
if (f1->type && (f1->type != (T_INT)) && !f_const_promotion(f1, (T_INT)))
#line 795
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 795
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f1->type));

#line 802 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 802
    
#line 802
      return what;
#line 802

#line 802
    /* Try to pre-calculate the result */
#line 802
      #undef whati
#line 802
  }
#line 802

#line 802

#line 814 "filter/f-inst.c"
 /* Constructor for FI_LENGTH */
#line 814
struct f_inst *f_new_inst_FI_LENGTH(enum f_instruction_code fi_code
#line 803 "filter/f-inst.c"
  , struct f_inst * f1
#line 814 "filter/f-inst.c"
)
#line 814
  {
#line 814
    /* Allocate the structure */
#line 814
    struct f_inst *what = fi_new(fi_code);
#line 814
    uint constargs = 1;
#line 814

#line 814
    /* Initialize all the members */
#line 814
  #define whati (&(what->i_FI_LENGTH))
#line 814
  #line 803 "filter/f-inst.c"
whati->f1 = f1;
#line 803
for (const struct f_inst *child = f1; child; child = child->next) {
#line 803
  what->size += child->size;
#line 803

#line 803
  if (child->fi_code != FI_CONSTANT)
#line 803
    constargs = 0;
#line 803

#line 803
}
#line 805 "filter/f-inst.c"
what->type = T_INT;

#line 814 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 814
    if (!constargs)
#line 814
      return what;
#line 814

#line 814
    /* Try to pre-calculate the result */
#line 814
    #line 802 "filter/f-inst.c"
 {	/* Get length of */
    
#line 803 "filter/f-inst.c"
;
    switch(v1.type) {
    case T_NET:     
#line 805 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = net_pxlen(v1.val.net) } ); break;
    case T_PATH:    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as_path_getlen(v1.val.ad) } ); break;
    case T_CLIST:   return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = int_set_get_size(v1.val.ad) } ); break;
    case T_ECLIST:  return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = ec_set_get_size(v1.val.ad) } ); break;
    case T_LCLIST:  return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = lc_set_get_size(v1.val.ad) } ); break;
    default: runtime( "Prefix, path, clist or eclist expected" );
    }
  }

  
  #undef whati
#line 814 "filter/f-inst.c"
  }
#line 814

#line 814

#line 849 "filter/f-inst.c"
 /* Constructor for FI_NET_SRC */
#line 849
struct f_inst *f_new_inst_FI_NET_SRC(enum f_instruction_code fi_code
#line 815 "filter/f-inst.c"
  , struct f_inst * f1
#line 849 "filter/f-inst.c"
)
#line 849
  {
#line 849
    /* Allocate the structure */
#line 849
    struct f_inst *what = fi_new(fi_code);
#line 849
    uint constargs = 1;
#line 849

#line 849
    /* Initialize all the members */
#line 849
  #define whati (&(what->i_FI_NET_SRC))
#line 849
  #line 815 "filter/f-inst.c"
whati->f1 = f1;
#line 815
for (const struct f_inst *child = f1; child; child = child->next) {
#line 815
  what->size += child->size;
#line 815

#line 815
  if (child->fi_code != FI_CONSTANT)
#line 815
    constargs = 0;
#line 815

#line 815
}
#line 815 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 815
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 815
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 846 "filter/f-inst.c"
what->type = T_NET;

#line 849 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 849
    if (!constargs)
#line 849
      return what;
#line 849

#line 849
    /* Try to pre-calculate the result */
#line 849
    #line 814 "filter/f-inst.c"
 { 	/* Get src prefix */
    
#line 815 "filter/f-inst.c"
 
#line 815 "filter/f-inst.c"
 
#line 815 "filter/f-inst.c"
;

    net_addr_union *net = (void *) v1.val.net;
    net_addr *src = falloc(sizeof(net_addr_ip6));
    const byte *part;

    switch(v1.val.net->type) {
    case NET_FLOW4:
      part = flow4_get_part(&net->flow4, FLOW_TYPE_SRC_PREFIX);
      if (part)
	net_fill_ip4(src, flow_read_ip4_part(part), flow_read_pxlen(part));
      else
	net_fill_ip4(src, IP4_NONE, 0);
      break;

    case NET_FLOW6:
      part = flow6_get_part(&net->flow6, FLOW_TYPE_SRC_PREFIX);
      if (part)
	net_fill_ip6(src, flow_read_ip6_part(part), flow_read_pxlen(part));
      else
	net_fill_ip6(src, IP6_NONE, 0);
      break;

    case NET_IP6_SADR:
      net_fill_ip6(src, net->ip6_sadr.src_prefix, net->ip6_sadr.src_pxlen);
      break;

    default:
      runtime( "Flow or SADR expected" );
    }

     
#line 846 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_NET, .val.net = src } );
  }

  
  #undef whati
#line 849 "filter/f-inst.c"
  }
#line 849

#line 849

#line 884 "filter/f-inst.c"
 /* Constructor for FI_NET_DST */
#line 884
struct f_inst *f_new_inst_FI_NET_DST(enum f_instruction_code fi_code
#line 850 "filter/f-inst.c"
  , struct f_inst * f1
#line 884 "filter/f-inst.c"
)
#line 884
  {
#line 884
    /* Allocate the structure */
#line 884
    struct f_inst *what = fi_new(fi_code);
#line 884
    uint constargs = 1;
#line 884

#line 884
    /* Initialize all the members */
#line 884
  #define whati (&(what->i_FI_NET_DST))
#line 884
  #line 850 "filter/f-inst.c"
whati->f1 = f1;
#line 850
for (const struct f_inst *child = f1; child; child = child->next) {
#line 850
  what->size += child->size;
#line 850

#line 850
  if (child->fi_code != FI_CONSTANT)
#line 850
    constargs = 0;
#line 850

#line 850
}
#line 850 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 850
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 850
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 881 "filter/f-inst.c"
what->type = T_NET;

#line 884 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 884
    if (!constargs)
#line 884
      return what;
#line 884

#line 884
    /* Try to pre-calculate the result */
#line 884
    #line 849 "filter/f-inst.c"
 { 	/* Get dst prefix */
    
#line 850 "filter/f-inst.c"
 
#line 850 "filter/f-inst.c"
 
#line 850 "filter/f-inst.c"
;

    net_addr_union *net = (void *) v1.val.net;
    net_addr *dst = falloc(sizeof(net_addr_ip6));
    const byte *part;

    switch(v1.val.net->type) {
    case NET_FLOW4:
      part = flow4_get_part(&net->flow4, FLOW_TYPE_DST_PREFIX);
      if (part)
	net_fill_ip4(dst, flow_read_ip4_part(part), flow_read_pxlen(part));
      else
	net_fill_ip4(dst, IP4_NONE, 0);
      break;

    case NET_FLOW6:
      part = flow6_get_part(&net->flow6, FLOW_TYPE_DST_PREFIX);
      if (part)
	net_fill_ip6(dst, flow_read_ip6_part(part), flow_read_pxlen(part));
      else
	net_fill_ip6(dst, IP6_NONE, 0);
      break;

    case NET_IP6_SADR:
      net_fill_ip6(dst, net->ip6_sadr.dst_prefix, net->ip6_sadr.dst_pxlen);
      break;

    default:
      runtime( "Flow or SADR expected" );
    }

     
#line 881 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_NET, .val.net = dst } );
  }

  
  #undef whati
#line 884 "filter/f-inst.c"
  }
#line 884

#line 884

#line 894 "filter/f-inst.c"
 /* Constructor for FI_ROA_MAXLEN */
#line 894
struct f_inst *f_new_inst_FI_ROA_MAXLEN(enum f_instruction_code fi_code
#line 885 "filter/f-inst.c"
  , struct f_inst * f1
#line 894 "filter/f-inst.c"
)
#line 894
  {
#line 894
    /* Allocate the structure */
#line 894
    struct f_inst *what = fi_new(fi_code);
#line 894
    uint constargs = 1;
#line 894

#line 894
    /* Initialize all the members */
#line 894
  #define whati (&(what->i_FI_ROA_MAXLEN))
#line 894
  #line 885 "filter/f-inst.c"
whati->f1 = f1;
#line 885
for (const struct f_inst *child = f1; child; child = child->next) {
#line 885
  what->size += child->size;
#line 885

#line 885
  if (child->fi_code != FI_CONSTANT)
#line 885
    constargs = 0;
#line 885

#line 885
}
#line 885 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 885
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 885
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 889 "filter/f-inst.c"
what->type = T_INT;

#line 894 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 894
    if (!constargs)
#line 894
      return what;
#line 894

#line 894
    /* Try to pre-calculate the result */
#line 894
    #line 884 "filter/f-inst.c"
 { 	/* Get ROA max prefix length */
    
#line 885 "filter/f-inst.c"
 
#line 885 "filter/f-inst.c"
 
#line 885 "filter/f-inst.c"
;
    if (!net_is_roa(v1.val.net))
      runtime( "ROA expected" );

     
#line 889 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = (v1.val.net->type == NET_ROA4) ?
#line 889
      ((net_addr_roa4 *) v1.val.net)->max_pxlen :
#line 889
      ((net_addr_roa6 *) v1.val.net)->max_pxlen } );
#line 892
  }

  
  #undef whati
#line 894 "filter/f-inst.c"
  }
#line 894

#line 894

#line 904 "filter/f-inst.c"
 /* Constructor for FI_ROA_ASN */
#line 904
struct f_inst *f_new_inst_FI_ROA_ASN(enum f_instruction_code fi_code
#line 895 "filter/f-inst.c"
  , struct f_inst * f1
#line 904 "filter/f-inst.c"
)
#line 904
  {
#line 904
    /* Allocate the structure */
#line 904
    struct f_inst *what = fi_new(fi_code);
#line 904
    uint constargs = 1;
#line 904

#line 904
    /* Initialize all the members */
#line 904
  #define whati (&(what->i_FI_ROA_ASN))
#line 904
  #line 895 "filter/f-inst.c"
whati->f1 = f1;
#line 895
for (const struct f_inst *child = f1; child; child = child->next) {
#line 895
  what->size += child->size;
#line 895

#line 895
  if (child->fi_code != FI_CONSTANT)
#line 895
    constargs = 0;
#line 895

#line 895
}
#line 895 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 895
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 895
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 899 "filter/f-inst.c"
what->type = T_INT;

#line 904 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 904
    if (!constargs)
#line 904
      return what;
#line 904

#line 904
    /* Try to pre-calculate the result */
#line 904
    #line 894 "filter/f-inst.c"
 { 	/* Get ROA ASN */
    
#line 895 "filter/f-inst.c"
 
#line 895 "filter/f-inst.c"
 
#line 895 "filter/f-inst.c"
;
    if (!net_is_roa(v1.val.net))
      runtime( "ROA expected" );

     
#line 899 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = (v1.val.net->type == NET_ROA4) ?
#line 899
      ((net_addr_roa4 *) v1.val.net)->asn :
#line 899
      ((net_addr_roa6 *) v1.val.net)->asn } );
#line 902
  }

  
  #undef whati
#line 904 "filter/f-inst.c"
  }
#line 904

#line 904

#line 909 "filter/f-inst.c"
 /* Constructor for FI_IP */
#line 909
struct f_inst *f_new_inst_FI_IP(enum f_instruction_code fi_code
#line 905 "filter/f-inst.c"
  , struct f_inst * f1
#line 909 "filter/f-inst.c"
)
#line 909
  {
#line 909
    /* Allocate the structure */
#line 909
    struct f_inst *what = fi_new(fi_code);
#line 909
    uint constargs = 1;
#line 909

#line 909
    /* Initialize all the members */
#line 909
  #define whati (&(what->i_FI_IP))
#line 909
  #line 905 "filter/f-inst.c"
whati->f1 = f1;
#line 905
for (const struct f_inst *child = f1; child; child = child->next) {
#line 905
  what->size += child->size;
#line 905

#line 905
  if (child->fi_code != FI_CONSTANT)
#line 905
    constargs = 0;
#line 905

#line 905
}
#line 905 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 905
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 905
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 906 "filter/f-inst.c"
what->type = T_IP;

#line 909 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 909
    if (!constargs)
#line 909
      return what;
#line 909

#line 909
    /* Try to pre-calculate the result */
#line 909
    #line 904 "filter/f-inst.c"
 {	/* Convert prefix to ... */
    
#line 905 "filter/f-inst.c"
 
#line 905 "filter/f-inst.c"
 
#line 905 "filter/f-inst.c"
;
     
#line 906 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_IP, .val.ip = net_prefix(v1.val.net) } );
  }

  
  #undef whati
#line 909 "filter/f-inst.c"
  }
#line 909

#line 909

#line 916 "filter/f-inst.c"
 /* Constructor for FI_ROUTE_DISTINGUISHER */
#line 916
struct f_inst *f_new_inst_FI_ROUTE_DISTINGUISHER(enum f_instruction_code fi_code
#line 910 "filter/f-inst.c"
  , struct f_inst * f1
#line 916 "filter/f-inst.c"
)
#line 916
  {
#line 916
    /* Allocate the structure */
#line 916
    struct f_inst *what = fi_new(fi_code);
#line 916
    uint constargs = 1;
#line 916

#line 916
    /* Initialize all the members */
#line 916
  #define whati (&(what->i_FI_ROUTE_DISTINGUISHER))
#line 916
  #line 910 "filter/f-inst.c"
whati->f1 = f1;
#line 910
for (const struct f_inst *child = f1; child; child = child->next) {
#line 910
  what->size += child->size;
#line 910

#line 910
  if (child->fi_code != FI_CONSTANT)
#line 910
    constargs = 0;
#line 910

#line 910
}
#line 910 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 910
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 910
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 913 "filter/f-inst.c"
what->type = T_RD;

#line 916 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 916
    if (!constargs)
#line 916
      return what;
#line 916

#line 916
    /* Try to pre-calculate the result */
#line 916
    #line 909 "filter/f-inst.c"
 {
    
#line 910 "filter/f-inst.c"
 
#line 910 "filter/f-inst.c"
 
#line 910 "filter/f-inst.c"
;
    if (!net_is_vpn(v1.val.net))
      runtime( "VPN address expected" );
     
#line 913 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_RD, .val.ec = net_rd(v1.val.net) } );
  }

  
  #undef whati
#line 916 "filter/f-inst.c"
  }
#line 916

#line 916

#line 923 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_FIRST */
#line 923
struct f_inst *f_new_inst_FI_AS_PATH_FIRST(enum f_instruction_code fi_code
#line 917 "filter/f-inst.c"
  , struct f_inst * f1
#line 923 "filter/f-inst.c"
)
#line 923
  {
#line 923
    /* Allocate the structure */
#line 923
    struct f_inst *what = fi_new(fi_code);
#line 923
    uint constargs = 1;
#line 923

#line 923
    /* Initialize all the members */
#line 923
  #define whati (&(what->i_FI_AS_PATH_FIRST))
#line 923
  #line 917 "filter/f-inst.c"
whati->f1 = f1;
#line 917
for (const struct f_inst *child = f1; child; child = child->next) {
#line 917
  what->size += child->size;
#line 917

#line 917
  if (child->fi_code != FI_CONSTANT)
#line 917
    constargs = 0;
#line 917

#line 917
}
#line 917 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PATH)) && !f_const_promotion(f1, (T_PATH)))
#line 917
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 917
	   f_instruction_name(what->fi_code), f_type_name(T_PATH), f_type_name(f1->type));
#line 920 "filter/f-inst.c"
what->type = T_INT;

#line 923 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 923
    if (!constargs)
#line 923
      return what;
#line 923

#line 923
    /* Try to pre-calculate the result */
#line 923
    #line 916 "filter/f-inst.c"
 {	/* Get first ASN from AS PATH */
    
#line 917 "filter/f-inst.c"
 
#line 917 "filter/f-inst.c"
 
#line 917 "filter/f-inst.c"
;
    u32 as = 0;
    as_path_get_first(v1.val.ad, &as);
     
#line 920 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as } );
  }

  
  #undef whati
#line 923 "filter/f-inst.c"
  }
#line 923

#line 923

#line 930 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_LAST */
#line 930
struct f_inst *f_new_inst_FI_AS_PATH_LAST(enum f_instruction_code fi_code
#line 924 "filter/f-inst.c"
  , struct f_inst * f1
#line 930 "filter/f-inst.c"
)
#line 930
  {
#line 930
    /* Allocate the structure */
#line 930
    struct f_inst *what = fi_new(fi_code);
#line 930
    uint constargs = 1;
#line 930

#line 930
    /* Initialize all the members */
#line 930
  #define whati (&(what->i_FI_AS_PATH_LAST))
#line 930
  #line 924 "filter/f-inst.c"
whati->f1 = f1;
#line 924
for (const struct f_inst *child = f1; child; child = child->next) {
#line 924
  what->size += child->size;
#line 924

#line 924
  if (child->fi_code != FI_CONSTANT)
#line 924
    constargs = 0;
#line 924

#line 924
}
#line 924 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PATH)) && !f_const_promotion(f1, (T_PATH)))
#line 924
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 924
	   f_instruction_name(what->fi_code), f_type_name(T_PATH), f_type_name(f1->type));
#line 927 "filter/f-inst.c"
what->type = T_INT;

#line 930 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 930
    if (!constargs)
#line 930
      return what;
#line 930

#line 930
    /* Try to pre-calculate the result */
#line 930
    #line 923 "filter/f-inst.c"
 {		/* Get last ASN from AS PATH */
    
#line 924 "filter/f-inst.c"
 
#line 924 "filter/f-inst.c"
 
#line 924 "filter/f-inst.c"
;
    u32 as = 0;
    as_path_get_last(v1.val.ad, &as);
     
#line 927 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as } );
  }

  
  #undef whati
#line 930 "filter/f-inst.c"
  }
#line 930

#line 930

#line 935 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_LAST_NAG */
#line 935
struct f_inst *f_new_inst_FI_AS_PATH_LAST_NAG(enum f_instruction_code fi_code
#line 931 "filter/f-inst.c"
  , struct f_inst * f1
#line 935 "filter/f-inst.c"
)
#line 935
  {
#line 935
    /* Allocate the structure */
#line 935
    struct f_inst *what = fi_new(fi_code);
#line 935
    uint constargs = 1;
#line 935

#line 935
    /* Initialize all the members */
#line 935
  #define whati (&(what->i_FI_AS_PATH_LAST_NAG))
#line 935
  #line 931 "filter/f-inst.c"
whati->f1 = f1;
#line 931
for (const struct f_inst *child = f1; child; child = child->next) {
#line 931
  what->size += child->size;
#line 931

#line 931
  if (child->fi_code != FI_CONSTANT)
#line 931
    constargs = 0;
#line 931

#line 931
}
#line 931 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PATH)) && !f_const_promotion(f1, (T_PATH)))
#line 931
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 931
	   f_instruction_name(what->fi_code), f_type_name(T_PATH), f_type_name(f1->type));
#line 932 "filter/f-inst.c"
what->type = T_INT;

#line 935 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 935
    if (!constargs)
#line 935
      return what;
#line 935

#line 935
    /* Try to pre-calculate the result */
#line 935
    #line 930 "filter/f-inst.c"
 {	/* Get last ASN from non-aggregated part of AS PATH */
    
#line 931 "filter/f-inst.c"
 
#line 931 "filter/f-inst.c"
 
#line 931 "filter/f-inst.c"
;
     
#line 932 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as_path_get_last_nonaggregated(v1.val.ad) } );
  }

  
  #undef whati
#line 935 "filter/f-inst.c"
  }
#line 935

#line 935

#line 961 "filter/f-inst.c"
 /* Constructor for FI_RETURN */
#line 961
struct f_inst *f_new_inst_FI_RETURN(enum f_instruction_code fi_code
#line 938 "filter/f-inst.c"
  , struct f_inst * f1
#line 961 "filter/f-inst.c"
)
#line 961
  {
#line 961
    /* Allocate the structure */
#line 961
    struct f_inst *what = fi_new(fi_code);
#line 961
    
#line 961

#line 961
    /* Initialize all the members */
#line 961
  #define whati (&(what->i_FI_RETURN))
#line 961
  #line 938 "filter/f-inst.c"
whati->f1 = f1;
#line 938
for (const struct f_inst *child = f1; child; child = child->next) {
#line 938
  what->size += child->size;
#line 938

#line 938
}

#line 961 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 961
    
#line 961
      return what;
#line 961

#line 961
    /* Try to pre-calculate the result */
#line 961
      #undef whati
#line 961
  }
#line 961

#line 961

#line 991 "filter/f-inst.c"
 /* Constructor for FI_CALL */
#line 991
struct f_inst *f_new_inst_FI_CALL(enum f_instruction_code fi_code
#line 963 "filter/f-inst.c"
  , struct symbol * sym
#line 991 "filter/f-inst.c"
)
#line 991
  {
#line 991
    /* Allocate the structure */
#line 991
    struct f_inst *what = fi_new(fi_code);
#line 991
    
#line 991

#line 991
    /* Initialize all the members */
#line 991
  #define whati (&(what->i_FI_CALL))
#line 991
  #line 963 "filter/f-inst.c"
whati->sym = sym;

#line 991 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 991
    
#line 991
      return what;
#line 991

#line 991
    /* Try to pre-calculate the result */
#line 991
      #undef whati
#line 991
  }
#line 991

#line 991

#line 996 "filter/f-inst.c"
 /* Constructor for FI_DROP_RESULT */
#line 996
struct f_inst *f_new_inst_FI_DROP_RESULT(enum f_instruction_code fi_code
#line 993 "filter/f-inst.c"
  , struct f_inst * f1
#line 996 "filter/f-inst.c"
)
#line 996
  {
#line 996
    /* Allocate the structure */
#line 996
    struct f_inst *what = fi_new(fi_code);
#line 996
    
#line 996

#line 996
    /* Initialize all the members */
#line 996
  #define whati (&(what->i_FI_DROP_RESULT))
#line 996
  #line 993 "filter/f-inst.c"
whati->f1 = f1;
#line 993
for (const struct f_inst *child = f1; child; child = child->next) {
#line 993
  what->size += child->size;
#line 993

#line 993
}

#line 996 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 996
    
#line 996
      return what;
#line 996

#line 996
    /* Try to pre-calculate the result */
#line 996
      #undef whati
#line 996
  }
#line 996

#line 996

#line 1019 "filter/f-inst.c"
 /* Constructor for FI_SWITCH */
#line 1019
struct f_inst *f_new_inst_FI_SWITCH(enum f_instruction_code fi_code
#line 997 "filter/f-inst.c"
  , struct f_inst * f1
#line 999 "filter/f-inst.c"
  , struct f_tree * tree
#line 1019 "filter/f-inst.c"
)
#line 1019
  {
#line 1019
    /* Allocate the structure */
#line 1019
    struct f_inst *what = fi_new(fi_code);
#line 1019
    uint constargs = 1;
#line 1019

#line 1019
    /* Initialize all the members */
#line 1019
  #define whati (&(what->i_FI_SWITCH))
#line 1019
  #line 997 "filter/f-inst.c"
whati->f1 = f1;
#line 997
for (const struct f_inst *child = f1; child; child = child->next) {
#line 997
  what->size += child->size;
#line 997

#line 997
  if (child->fi_code != FI_CONSTANT)
#line 997
    constargs = 0;
#line 997

#line 997
}
#line 999 "filter/f-inst.c"
whati->tree = tree;

#line 1019 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1019
    if (!constargs)
#line 1019
      return what;
#line 1019

#line 1019
    /* Try to pre-calculate the result */
#line 1019
    #line 996 "filter/f-inst.c"
 {
    
#line 997 "filter/f-inst.c"
;

    #line 999 "filter/f-inst.c"
;

    
#line 1005 "filter/f-inst.c"
    const struct f_tree *t = find_tree(tree, &v1);
    if (!t) {
      v1.type = T_VOID;
      t = find_tree(tree, &v1);
      if (!t) {
	debug( "No else statement?\n");
	return NULL;
      }
    }
    /* It is actually possible to have t->data NULL */

    return t->data ;
#line 1017 "filter/f-inst.c"
  }

  
  #undef whati
#line 1019 "filter/f-inst.c"
  }
#line 1019

#line 1019

#line 1027 "filter/f-inst.c"
 /* Constructor for FI_IP_MASK */
#line 1027
struct f_inst *f_new_inst_FI_IP_MASK(enum f_instruction_code fi_code
#line 1020 "filter/f-inst.c"
  , struct f_inst * f1
#line 1021 "filter/f-inst.c"
  , struct f_inst * f2
#line 1027 "filter/f-inst.c"
)
#line 1027
  {
#line 1027
    /* Allocate the structure */
#line 1027
    struct f_inst *what = fi_new(fi_code);
#line 1027
    uint constargs = 1;
#line 1027

#line 1027
    /* Initialize all the members */
#line 1027
  #define whati (&(what->i_FI_IP_MASK))
#line 1027
  #line 1020 "filter/f-inst.c"
whati->f1 = f1;
#line 1020
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1020
  what->size += child->size;
#line 1020

#line 1020
  if (child->fi_code != FI_CONSTANT)
#line 1020
    constargs = 0;
#line 1020

#line 1020
}
#line 1020 "filter/f-inst.c"
if (f1->type && (f1->type != (T_IP)) && !f_const_promotion(f1, (T_IP)))
#line 1020
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 1020
	   f_instruction_name(what->fi_code), f_type_name(T_IP), f_type_name(f1->type));
#line 1021 "filter/f-inst.c"
whati->f2 = f2;
#line 1021
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1021
  what->size += child->size;
#line 1021

#line 1021
  if (child->fi_code != FI_CONSTANT)
#line 1021
    constargs = 0;
#line 1021

#line 1021
}
#line 1021 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 1021
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 1021
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 1022 "filter/f-inst.c"
what->type = T_IP;

#line 1027 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1027
    if (!constargs)
#line 1027
      return what;
#line 1027

#line 1027
    /* Try to pre-calculate the result */
#line 1027
    #line 1019 "filter/f-inst.c"
 { /* IP.MASK(val) */
    
#line 1020 "filter/f-inst.c"
 
#line 1020 "filter/f-inst.c"
 
#line 1020 "filter/f-inst.c"
;
    
#line 1021 "filter/f-inst.c"
 
#line 1021 "filter/f-inst.c"
 
#line 1021 "filter/f-inst.c"
;
     
#line 1022 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_IP, .val.ip =  ipa_is_ip4(v1.val.ip) ?
#line 1022
      ipa_from_ip4(ip4_and(ipa_to_ip4(v1.val.ip), ip4_mkmask(v2.val.i))) :
#line 1022
      ipa_from_ip6(ip6_and(ipa_to_ip6(v1.val.ip), ip6_mkmask(v2.val.i)))  } );
#line 1025
  }

  
  #undef whati
#line 1027 "filter/f-inst.c"
  }
#line 1027

#line 1027

#line 1033 "filter/f-inst.c"
 /* Constructor for FI_PATH_PREPEND */
#line 1033
struct f_inst *f_new_inst_FI_PATH_PREPEND(enum f_instruction_code fi_code
#line 1028 "filter/f-inst.c"
  , struct f_inst * f1
#line 1029 "filter/f-inst.c"
  , struct f_inst * f2
#line 1033 "filter/f-inst.c"
)
#line 1033
  {
#line 1033
    /* Allocate the structure */
#line 1033
    struct f_inst *what = fi_new(fi_code);
#line 1033
    uint constargs = 1;
#line 1033

#line 1033
    /* Initialize all the members */
#line 1033
  #define whati (&(what->i_FI_PATH_PREPEND))
#line 1033
  #line 1028 "filter/f-inst.c"
whati->f1 = f1;
#line 1028
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1028
  what->size += child->size;
#line 1028

#line 1028
  if (child->fi_code != FI_CONSTANT)
#line 1028
    constargs = 0;
#line 1028

#line 1028
}
#line 1028 "filter/f-inst.c"
if (f1->type && (f1->type != (T_PATH)) && !f_const_promotion(f1, (T_PATH)))
#line 1028
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 1028
	   f_instruction_name(what->fi_code), f_type_name(T_PATH), f_type_name(f1->type));
#line 1029 "filter/f-inst.c"
whati->f2 = f2;
#line 1029
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1029
  what->size += child->size;
#line 1029

#line 1029
  if (child->fi_code != FI_CONSTANT)
#line 1029
    constargs = 0;
#line 1029

#line 1029
}
#line 1029 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 1029
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 1029
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 1030 "filter/f-inst.c"
what->type = T_PATH;

#line 1033 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1033
    if (!constargs)
#line 1033
      return what;
#line 1033

#line 1033
    /* Try to pre-calculate the result */
#line 1033
    #line 1027 "filter/f-inst.c"
 {	/* Path prepend */
    
#line 1028 "filter/f-inst.c"
 
#line 1028 "filter/f-inst.c"
 
#line 1028 "filter/f-inst.c"
;
    
#line 1029 "filter/f-inst.c"
 
#line 1029 "filter/f-inst.c"
 
#line 1029 "filter/f-inst.c"
;
     
#line 1030 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_prepend(fpool, v1.val.ad, v2.val.i)  } );
  }

  
  #undef whati
#line 1033 "filter/f-inst.c"
  }
#line 1033

#line 1033

#line 1090 "filter/f-inst.c"
 /* Constructor for FI_CLIST_ADD */
#line 1090
struct f_inst *f_new_inst_FI_CLIST_ADD(enum f_instruction_code fi_code
#line 1034 "filter/f-inst.c"
  , struct f_inst * f1
#line 1035 "filter/f-inst.c"
  , struct f_inst * f2
#line 1090 "filter/f-inst.c"
)
#line 1090
  {
#line 1090
    /* Allocate the structure */
#line 1090
    struct f_inst *what = fi_new(fi_code);
#line 1090
    uint constargs = 1;
#line 1090

#line 1090
    /* Initialize all the members */
#line 1090
  #define whati (&(what->i_FI_CLIST_ADD))
#line 1090
  #line 1034 "filter/f-inst.c"
whati->f1 = f1;
#line 1034
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1034
  what->size += child->size;
#line 1034

#line 1034
  if (child->fi_code != FI_CONSTANT)
#line 1034
    constargs = 0;
#line 1034

#line 1034
}
#line 1035 "filter/f-inst.c"
whati->f2 = f2;
#line 1035
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1035
  what->size += child->size;
#line 1035

#line 1035
  if (child->fi_code != FI_CONSTANT)
#line 1035
    constargs = 0;
#line 1035

#line 1035
}
#line 1036 "filter/f-inst.c"
what->type = f1->type;

#line 1090 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1090
    if (!constargs)
#line 1090
      return what;
#line 1090

#line 1090
    /* Try to pre-calculate the result */
#line 1090
    #line 1033 "filter/f-inst.c"
 {	/* (Extended) Community list add */
    
#line 1034 "filter/f-inst.c"
;
    
#line 1035 "filter/f-inst.c"
;
     
#line 1036 "filter/f-inst.c"
;

    if (v1.type == T_PATH)
      runtime("Can't add to path");

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_PAIR) || (v2.type == T_QUAD))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_add(fpool, v1.val.ad, v2.val.i)  } );
      /* IP->Quad implicit conversion */
      else if (val_is_ip4(&v2))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_add(fpool, v1.val.ad, ipa_to_u32(v2.val.ip))  } );
      else if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy))
	runtime("Can't add set");
      else if (v2.type == T_CLIST)
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else
	runtime("Can't add non-pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t))
	runtime("Can't add set");
      else if (v2.type == T_ECLIST)
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else if (v2.type != T_EC)
	runtime("Can't add non-ec");
      else
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_add(fpool, v1.val.ad, v2.val.ec)  } );
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t))
	runtime("Can't add set");
      else if (v2.type == T_LCLIST)
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else if (v2.type != T_LC)
	runtime("Can't add non-lc");
      else
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_add(fpool, v1.val.ad, v2.val.lc)  } );

    }

    else
      runtime("Can't add to non-[e|l]clist");
  }

  
  #undef whati
#line 1090 "filter/f-inst.c"
  }
#line 1090

#line 1090

#line 1152 "filter/f-inst.c"
 /* Constructor for FI_CLIST_DEL */
#line 1152
struct f_inst *f_new_inst_FI_CLIST_DEL(enum f_instruction_code fi_code
#line 1091 "filter/f-inst.c"
  , struct f_inst * f1
#line 1092 "filter/f-inst.c"
  , struct f_inst * f2
#line 1152 "filter/f-inst.c"
)
#line 1152
  {
#line 1152
    /* Allocate the structure */
#line 1152
    struct f_inst *what = fi_new(fi_code);
#line 1152
    uint constargs = 1;
#line 1152

#line 1152
    /* Initialize all the members */
#line 1152
  #define whati (&(what->i_FI_CLIST_DEL))
#line 1152
  #line 1091 "filter/f-inst.c"
whati->f1 = f1;
#line 1091
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1091
  what->size += child->size;
#line 1091

#line 1091
  if (child->fi_code != FI_CONSTANT)
#line 1091
    constargs = 0;
#line 1091

#line 1091
}
#line 1092 "filter/f-inst.c"
whati->f2 = f2;
#line 1092
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1092
  what->size += child->size;
#line 1092

#line 1092
  if (child->fi_code != FI_CONSTANT)
#line 1092
    constargs = 0;
#line 1092

#line 1092
}
#line 1093 "filter/f-inst.c"
what->type = f1->type;

#line 1152 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1152
    if (!constargs)
#line 1152
      return what;
#line 1152

#line 1152
    /* Try to pre-calculate the result */
#line 1152
    #line 1090 "filter/f-inst.c"
 {	/* (Extended) Community list add or delete */
    
#line 1091 "filter/f-inst.c"
;
    
#line 1092 "filter/f-inst.c"
;
     
#line 1093 "filter/f-inst.c"
;

    if (v1.type == T_PATH)
    {
      const struct f_tree *set = NULL;
      u32 key = 0;

      if (v2.type == T_INT)
	key = v2.val.i;
      else if ((v2.type == T_SET) && (v2.val.t->from.type == T_INT))
	set = v2.val.t;
      else
	runtime("Can't delete non-integer (set)");

      return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_filter(fpool, v1.val.ad, set, key, 0)  } );
    }

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_PAIR) || (v2.type == T_QUAD))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_del(fpool, v1.val.ad, v2.val.i)  } );
      /* IP->Quad implicit conversion */
      else if (val_is_ip4(&v2))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_del(fpool, v1.val.ad, ipa_to_u32(v2.val.ip))  } );
      else if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy) || (v2.type == T_CLIST))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  clist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else
	runtime("Can't delete non-pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t) || (v2.type == T_ECLIST))
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  eclist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else if (v2.type != T_EC)
	runtime("Can't delete non-ec");
      else
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_del(fpool, v1.val.ad, v2.val.ec)  } );
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t) || (v2.type == T_LCLIST))
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lclist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else if (v2.type != T_LC)
	runtime("Can't delete non-lc");
      else
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_del(fpool, v1.val.ad, v2.val.lc)  } );
    }

    else
      runtime("Can't delete in non-[e|l]clist");
  }

  
  #undef whati
#line 1152 "filter/f-inst.c"
  }
#line 1152

#line 1152

#line 1200 "filter/f-inst.c"
 /* Constructor for FI_CLIST_FILTER */
#line 1200
struct f_inst *f_new_inst_FI_CLIST_FILTER(enum f_instruction_code fi_code
#line 1153 "filter/f-inst.c"
  , struct f_inst * f1
#line 1154 "filter/f-inst.c"
  , struct f_inst * f2
#line 1200 "filter/f-inst.c"
)
#line 1200
  {
#line 1200
    /* Allocate the structure */
#line 1200
    struct f_inst *what = fi_new(fi_code);
#line 1200
    uint constargs = 1;
#line 1200

#line 1200
    /* Initialize all the members */
#line 1200
  #define whati (&(what->i_FI_CLIST_FILTER))
#line 1200
  #line 1153 "filter/f-inst.c"
whati->f1 = f1;
#line 1153
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1153
  what->size += child->size;
#line 1153

#line 1153
  if (child->fi_code != FI_CONSTANT)
#line 1153
    constargs = 0;
#line 1153

#line 1153
}
#line 1154 "filter/f-inst.c"
whati->f2 = f2;
#line 1154
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1154
  what->size += child->size;
#line 1154

#line 1154
  if (child->fi_code != FI_CONSTANT)
#line 1154
    constargs = 0;
#line 1154

#line 1154
}
#line 1155 "filter/f-inst.c"
what->type = f1->type;

#line 1200 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1200
    if (!constargs)
#line 1200
      return what;
#line 1200

#line 1200
    /* Try to pre-calculate the result */
#line 1200
    #line 1152 "filter/f-inst.c"
 {	/* (Extended) Community list add or delete */
    
#line 1153 "filter/f-inst.c"
;
    
#line 1154 "filter/f-inst.c"
;
     
#line 1155 "filter/f-inst.c"
;

    if (v1.type == T_PATH)
    {
      u32 key = 0;

      if ((v2.type == T_SET) && (v2.val.t->from.type == T_INT))
	return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_filter(fpool, v1.val.ad, v2.val.t, key, 1)  } );
      else
	runtime("Can't filter integer");
    }

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy) || (v2.type == T_CLIST))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  clist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t) || (v2.type == T_ECLIST))
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  eclist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter ec");
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t) || (v2.type == T_LCLIST))
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lclist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter lc");
    }

    else
      runtime("Can't filter non-[e|l]clist");
  }

  
  #undef whati
#line 1200 "filter/f-inst.c"
  }
#line 1200

#line 1200

#line 1230 "filter/f-inst.c"
 /* Constructor for FI_ROA_CHECK_IMPLICIT */
#line 1230
struct f_inst *f_new_inst_FI_ROA_CHECK_IMPLICIT(enum f_instruction_code fi_code
#line 1202 "filter/f-inst.c"
  , struct rtable_config * rtc
#line 1230 "filter/f-inst.c"
)
#line 1230
  {
#line 1230
    /* Allocate the structure */
#line 1230
    struct f_inst *what = fi_new(fi_code);
#line 1230
    
#line 1230

#line 1230
    /* Initialize all the members */
#line 1230
  #define whati (&(what->i_FI_ROA_CHECK_IMPLICIT))
#line 1230
  #line 1202 "filter/f-inst.c"
whati->rtc = rtc;
#line 1225 "filter/f-inst.c"
what->type = T_ENUM_ROA;

#line 1230 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1230
    
#line 1230
      return what;
#line 1230

#line 1230
    /* Try to pre-calculate the result */
#line 1230
      #undef whati
#line 1230
  }
#line 1230

#line 1230

#line 1252 "filter/f-inst.c"
 /* Constructor for FI_ROA_CHECK_EXPLICIT */
#line 1252
struct f_inst *f_new_inst_FI_ROA_CHECK_EXPLICIT(enum f_instruction_code fi_code
#line 1232 "filter/f-inst.c"
  , struct f_inst * f1
#line 1233 "filter/f-inst.c"
  , struct f_inst * f2
#line 1234 "filter/f-inst.c"
  , struct rtable_config * rtc
#line 1252 "filter/f-inst.c"
)
#line 1252
  {
#line 1252
    /* Allocate the structure */
#line 1252
    struct f_inst *what = fi_new(fi_code);
#line 1252
    
#line 1252

#line 1252
    /* Initialize all the members */
#line 1252
  #define whati (&(what->i_FI_ROA_CHECK_EXPLICIT))
#line 1252
  #line 1232 "filter/f-inst.c"
whati->f1 = f1;
#line 1232
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1232
  what->size += child->size;
#line 1232

#line 1232
}
#line 1232 "filter/f-inst.c"
if (f1->type && (f1->type != (T_NET)) && !f_const_promotion(f1, (T_NET)))
#line 1232
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 1232
	   f_instruction_name(what->fi_code), f_type_name(T_NET), f_type_name(f1->type));
#line 1233 "filter/f-inst.c"
whati->f2 = f2;
#line 1233
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1233
  what->size += child->size;
#line 1233

#line 1233
}
#line 1233 "filter/f-inst.c"
if (f2->type && (f2->type != (T_INT)) && !f_const_promotion(f2, (T_INT)))
#line 1233
  cf_error("Argument 2 of %s must be of type %s, got type %s",
#line 1233
	   f_instruction_name(what->fi_code), f_type_name(T_INT), f_type_name(f2->type));
#line 1234 "filter/f-inst.c"
whati->rtc = rtc;
#line 1246 "filter/f-inst.c"
what->type = T_ENUM_ROA;

#line 1252 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1252
    
#line 1252
      return what;
#line 1252

#line 1252
    /* Try to pre-calculate the result */
#line 1252
      #undef whati
#line 1252
  }
#line 1252

#line 1252

#line 1257 "filter/f-inst.c"
 /* Constructor for FI_FORMAT */
#line 1257
struct f_inst *f_new_inst_FI_FORMAT(enum f_instruction_code fi_code
#line 1253 "filter/f-inst.c"
  , struct f_inst * f1
#line 1257 "filter/f-inst.c"
)
#line 1257
  {
#line 1257
    /* Allocate the structure */
#line 1257
    struct f_inst *what = fi_new(fi_code);
#line 1257
    uint constargs = 1;
#line 1257

#line 1257
    /* Initialize all the members */
#line 1257
  #define whati (&(what->i_FI_FORMAT))
#line 1257
  #line 1253 "filter/f-inst.c"
whati->f1 = f1;
#line 1253
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1253
  what->size += child->size;
#line 1253

#line 1253
  if (child->fi_code != FI_CONSTANT)
#line 1253
    constargs = 0;
#line 1253

#line 1253
}
#line 1254 "filter/f-inst.c"
what->type = T_STRING;

#line 1257 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1257
    if (!constargs)
#line 1257
      return what;
#line 1257

#line 1257
    /* Try to pre-calculate the result */
#line 1257
    #line 1252 "filter/f-inst.c"
 {	/* Format */
    
#line 1253 "filter/f-inst.c"
;
     
#line 1254 "filter/f-inst.c"
 return fi_constant(what,  (struct f_val) { .type = T_STRING, .val.s = val_format_str(fpool, &v1) } );
  }

  
  #undef whati
#line 1257 "filter/f-inst.c"
  }
#line 1257

#line 1257

#line 668 "filter/decl.m4"
 /* Constructor for FI_ASSERT */
#line 668
struct f_inst *f_new_inst_FI_ASSERT(enum f_instruction_code fi_code
#line 1259 "filter/f-inst.c"
  , struct f_inst * f1
#line 1261 "filter/f-inst.c"
  , char * s
#line 668 "filter/decl.m4"
)
#line 668
  {
#line 668
    /* Allocate the structure */
#line 668
    struct f_inst *what = fi_new(fi_code);
#line 668
    
#line 668

#line 668
    /* Initialize all the members */
#line 668
  #define whati (&(what->i_FI_ASSERT))
#line 668
  #line 1259 "filter/f-inst.c"
whati->f1 = f1;
#line 1259
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1259
  what->size += child->size;
#line 1259

#line 1259
}
#line 1259 "filter/f-inst.c"
if (f1->type && (f1->type != (T_BOOL)) && !f_const_promotion(f1, (T_BOOL)))
#line 1259
  cf_error("Argument 1 of %s must be of type %s, got type %s",
#line 1259
	   f_instruction_name(what->fi_code), f_type_name(T_BOOL), f_type_name(f1->type));
#line 1261 "filter/f-inst.c"
whati->s = s;

#line 668 "filter/decl.m4"
    /* If not constant, return the instruction itself */
#line 668
    
#line 668
      return what;
#line 668

#line 668
    /* Try to pre-calculate the result */
#line 668
      #undef whati
#line 668
  }
#line 668

#line 668

#line 509 "filter/decl.m4"

#undef v1
#undef v2
#undef v3
#undef vv

/* Line dumpers */
#define INDENT (((const char *) f_dump_line_indent_str) + sizeof(f_dump_line_indent_str) - (indent) - 1)
static const char f_dump_line_indent_str[] = "                                ";

#line 227 "filter/f-inst.c"
 /* Dump line for FI_ADD */
#line 227
static inline void f_dump_line_item_FI_ADD(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 227

#line 227
{
#line 227
#define item (&(item_->i_FI_ADD))
#line 227
#undef item
#line 227
}
#line 227

#line 232 "filter/f-inst.c"
 /* Dump line for FI_SUBTRACT */
#line 232
static inline void f_dump_line_item_FI_SUBTRACT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 232

#line 232
{
#line 232
#define item (&(item_->i_FI_SUBTRACT))
#line 232
#undef item
#line 232
}
#line 232

#line 237 "filter/f-inst.c"
 /* Dump line for FI_MULTIPLY */
#line 237
static inline void f_dump_line_item_FI_MULTIPLY(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 237

#line 237
{
#line 237
#define item (&(item_->i_FI_MULTIPLY))
#line 237
#undef item
#line 237
}
#line 237

#line 243 "filter/f-inst.c"
 /* Dump line for FI_DIVIDE */
#line 243
static inline void f_dump_line_item_FI_DIVIDE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 243

#line 243
{
#line 243
#define item (&(item_->i_FI_DIVIDE))
#line 243
#undef item
#line 243
}
#line 243

#line 253 "filter/f-inst.c"
 /* Dump line for FI_AND */
#line 253
static inline void f_dump_line_item_FI_AND(const struct f_line_item *item_, const int indent)
#line 253

#line 253
{
#line 253
#define item (&(item_->i_FI_AND))
#line 249 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 253 "filter/f-inst.c"
#undef item
#line 253
}
#line 253

#line 264 "filter/f-inst.c"
 /* Dump line for FI_OR */
#line 264
static inline void f_dump_line_item_FI_OR(const struct f_line_item *item_, const int indent)
#line 264

#line 264
{
#line 264
#define item (&(item_->i_FI_OR))
#line 259 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 264 "filter/f-inst.c"
#undef item
#line 264
}
#line 264

#line 274 "filter/f-inst.c"
 /* Dump line for FI_PAIR_CONSTRUCT */
#line 274
static inline void f_dump_line_item_FI_PAIR_CONSTRUCT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 274

#line 274
{
#line 274
#define item (&(item_->i_FI_PAIR_CONSTRUCT))
#line 274
#undef item
#line 274
}
#line 274

#line 314 "filter/f-inst.c"
 /* Dump line for FI_EC_CONSTRUCT */
#line 314
static inline void f_dump_line_item_FI_EC_CONSTRUCT(const struct f_line_item *item_, const int indent)
#line 314

#line 314
{
#line 314
#define item (&(item_->i_FI_EC_CONSTRUCT))
#line 278 "filter/f-inst.c"
debug("%s" "ec subtype %s" "\n", INDENT, ec_subtype_str(item->ecs));
#line 278

#line 314 "filter/f-inst.c"
#undef item
#line 314
}
#line 314

#line 321 "filter/f-inst.c"
 /* Dump line for FI_LC_CONSTRUCT */
#line 321
static inline void f_dump_line_item_FI_LC_CONSTRUCT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 321

#line 321
{
#line 321
#define item (&(item_->i_FI_LC_CONSTRUCT))
#line 321
#undef item
#line 321
}
#line 321

#line 371 "filter/f-inst.c"
 /* Dump line for FI_PATHMASK_CONSTRUCT */
#line 371
static inline void f_dump_line_item_FI_PATHMASK_CONSTRUCT(const struct f_line_item *item_, const int indent)
#line 371

#line 371
{
#line 371
#define item (&(item_->i_FI_PATHMASK_CONSTRUCT))
#line 322 "filter/f-inst.c"
  debug("%snumber of varargs %u\n", INDENT, item->varcount);
#line 371 "filter/f-inst.c"
#undef item
#line 371
}
#line 371

#line 377 "filter/f-inst.c"
 /* Dump line for FI_NEQ */
#line 377
static inline void f_dump_line_item_FI_NEQ(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 377

#line 377
{
#line 377
#define item (&(item_->i_FI_NEQ))
#line 377
#undef item
#line 377
}
#line 377

#line 383 "filter/f-inst.c"
 /* Dump line for FI_EQ */
#line 383
static inline void f_dump_line_item_FI_EQ(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 383

#line 383
{
#line 383
#define item (&(item_->i_FI_EQ))
#line 383
#undef item
#line 383
}
#line 383

#line 394 "filter/f-inst.c"
 /* Dump line for FI_LT */
#line 394
static inline void f_dump_line_item_FI_LT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 394

#line 394
{
#line 394
#define item (&(item_->i_FI_LT))
#line 394
#undef item
#line 394
}
#line 394

#line 405 "filter/f-inst.c"
 /* Dump line for FI_LTE */
#line 405
static inline void f_dump_line_item_FI_LTE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 405

#line 405
{
#line 405
#define item (&(item_->i_FI_LTE))
#line 405
#undef item
#line 405
}
#line 405

#line 410 "filter/f-inst.c"
 /* Dump line for FI_NOT */
#line 410
static inline void f_dump_line_item_FI_NOT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 410

#line 410
{
#line 410
#define item (&(item_->i_FI_NOT))
#line 410
#undef item
#line 410
}
#line 410

#line 419 "filter/f-inst.c"
 /* Dump line for FI_MATCH */
#line 419
static inline void f_dump_line_item_FI_MATCH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 419

#line 419
{
#line 419
#define item (&(item_->i_FI_MATCH))
#line 419
#undef item
#line 419
}
#line 419

#line 428 "filter/f-inst.c"
 /* Dump line for FI_NOT_MATCH */
#line 428
static inline void f_dump_line_item_FI_NOT_MATCH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 428

#line 428
{
#line 428
#define item (&(item_->i_FI_NOT_MATCH))
#line 428
#undef item
#line 428
}
#line 428

#line 433 "filter/f-inst.c"
 /* Dump line for FI_DEFINED */
#line 433
static inline void f_dump_line_item_FI_DEFINED(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 433

#line 433
{
#line 433
#define item (&(item_->i_FI_DEFINED))
#line 433
#undef item
#line 433
}
#line 433

#line 445 "filter/f-inst.c"
 /* Dump line for FI_TYPE */
#line 445
static inline void f_dump_line_item_FI_TYPE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 445

#line 445
{
#line 445
#define item (&(item_->i_FI_TYPE))
#line 445
#undef item
#line 445
}
#line 445

#line 451 "filter/f-inst.c"
 /* Dump line for FI_IS_V4 */
#line 451
static inline void f_dump_line_item_FI_IS_V4(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 451

#line 451
{
#line 451
#define item (&(item_->i_FI_IS_V4))
#line 451
#undef item
#line 451
}
#line 451

#line 460 "filter/f-inst.c"
 /* Dump line for FI_VAR_SET */
#line 460
static inline void f_dump_line_item_FI_VAR_SET(const struct f_line_item *item_, const int indent)
#line 460

#line 460
{
#line 460
#define item (&(item_->i_FI_VAR_SET))
#line 454 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 454

#line 460 "filter/f-inst.c"
#undef item
#line 460
}
#line 460

#line 467 "filter/f-inst.c"
 /* Dump line for FI_VAR_GET */
#line 467
static inline void f_dump_line_item_FI_VAR_GET(const struct f_line_item *item_, const int indent)
#line 467

#line 467
{
#line 467
#define item (&(item_->i_FI_VAR_GET))
#line 461 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 461

#line 467 "filter/f-inst.c"
#undef item
#line 467
}
#line 467

#line 480 "filter/f-inst.c"
 /* Dump line for FI_CONSTANT */
#line 480
static inline void f_dump_line_item_FI_CONSTANT(const struct f_line_item *item_, const int indent)
#line 480

#line 480
{
#line 480
#define item (&(item_->i_FI_CONSTANT))
#line 468 "filter/f-inst.c"
debug("%s" "value %s" "\n", INDENT, val_dump(&(item->val))
#line 468
    );
#line 468

#line 480 "filter/f-inst.c"
#undef item
#line 480
}
#line 480

#line 488 "filter/f-inst.c"
 /* Dump line for FI_CONDITION */
#line 488
static inline void f_dump_line_item_FI_CONDITION(const struct f_line_item *item_, const int indent)
#line 488

#line 488
{
#line 488
#define item (&(item_->i_FI_CONDITION))
#line 483 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 485 "filter/f-inst.c"
f_dump_line(item->fl3, indent + 1);
#line 488 "filter/f-inst.c"
#undef item
#line 488
}
#line 488

#line 497 "filter/f-inst.c"
 /* Dump line for FI_PRINT */
#line 497
static inline void f_dump_line_item_FI_PRINT(const struct f_line_item *item_, const int indent)
#line 497

#line 497
{
#line 497
#define item (&(item_->i_FI_PRINT))
#line 490 "filter/f-inst.c"
  debug("%snumber of varargs %u\n", INDENT, item->varcount);
#line 497 "filter/f-inst.c"
#undef item
#line 497
}
#line 497

#line 504 "filter/f-inst.c"
 /* Dump line for FI_FLUSH */
#line 504
static inline void f_dump_line_item_FI_FLUSH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 504

#line 504
{
#line 504
#define item (&(item_->i_FI_FLUSH))
#line 504
#undef item
#line 504
}
#line 504

#line 518 "filter/f-inst.c"
 /* Dump line for FI_DIE */
#line 518
static inline void f_dump_line_item_FI_DIE(const struct f_line_item *item_, const int indent)
#line 518

#line 518
{
#line 518
#define item (&(item_->i_FI_DIE))
#line 506 "filter/f-inst.c"
debug("%s" "%s" "\n", INDENT, filter_return_str(item->fret));
#line 506

#line 518 "filter/f-inst.c"
#undef item
#line 518
}
#line 518

#line 543 "filter/f-inst.c"
 /* Dump line for FI_RTA_GET */
#line 543
static inline void f_dump_line_item_FI_RTA_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 543

#line 543
{
#line 543
#define item (&(item_->i_FI_RTA_GET))
#line 543
#undef item
#line 543
}
#line 543

#line 627 "filter/f-inst.c"
 /* Dump line for FI_RTA_SET */
#line 627
static inline void f_dump_line_item_FI_RTA_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 627

#line 627
{
#line 627
#define item (&(item_->i_FI_RTA_SET))
#line 627
#undef item
#line 627
}
#line 627

#line 702 "filter/f-inst.c"
 /* Dump line for FI_EA_GET */
#line 702
static inline void f_dump_line_item_FI_EA_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 702

#line 702
{
#line 702
#define item (&(item_->i_FI_EA_GET))
#line 702
#undef item
#line 702
}
#line 702

#line 766 "filter/f-inst.c"
 /* Dump line for FI_EA_SET */
#line 766
static inline void f_dump_line_item_FI_EA_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 766

#line 766
{
#line 766
#define item (&(item_->i_FI_EA_SET))
#line 766
#undef item
#line 766
}
#line 766

#line 788 "filter/f-inst.c"
 /* Dump line for FI_EA_UNSET */
#line 788
static inline void f_dump_line_item_FI_EA_UNSET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 788

#line 788
{
#line 788
#define item (&(item_->i_FI_EA_UNSET))
#line 788
#undef item
#line 788
}
#line 788

#line 793 "filter/f-inst.c"
 /* Dump line for FI_PREF_GET */
#line 793
static inline void f_dump_line_item_FI_PREF_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 793

#line 793
{
#line 793
#define item (&(item_->i_FI_PREF_GET))
#line 793
#undef item
#line 793
}
#line 793

#line 802 "filter/f-inst.c"
 /* Dump line for FI_PREF_SET */
#line 802
static inline void f_dump_line_item_FI_PREF_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 802

#line 802
{
#line 802
#define item (&(item_->i_FI_PREF_SET))
#line 802
#undef item
#line 802
}
#line 802

#line 814 "filter/f-inst.c"
 /* Dump line for FI_LENGTH */
#line 814
static inline void f_dump_line_item_FI_LENGTH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 814

#line 814
{
#line 814
#define item (&(item_->i_FI_LENGTH))
#line 814
#undef item
#line 814
}
#line 814

#line 849 "filter/f-inst.c"
 /* Dump line for FI_NET_SRC */
#line 849
static inline void f_dump_line_item_FI_NET_SRC(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 849

#line 849
{
#line 849
#define item (&(item_->i_FI_NET_SRC))
#line 849
#undef item
#line 849
}
#line 849

#line 884 "filter/f-inst.c"
 /* Dump line for FI_NET_DST */
#line 884
static inline void f_dump_line_item_FI_NET_DST(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 884

#line 884
{
#line 884
#define item (&(item_->i_FI_NET_DST))
#line 884
#undef item
#line 884
}
#line 884

#line 894 "filter/f-inst.c"
 /* Dump line for FI_ROA_MAXLEN */
#line 894
static inline void f_dump_line_item_FI_ROA_MAXLEN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 894

#line 894
{
#line 894
#define item (&(item_->i_FI_ROA_MAXLEN))
#line 894
#undef item
#line 894
}
#line 894

#line 904 "filter/f-inst.c"
 /* Dump line for FI_ROA_ASN */
#line 904
static inline void f_dump_line_item_FI_ROA_ASN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 904

#line 904
{
#line 904
#define item (&(item_->i_FI_ROA_ASN))
#line 904
#undef item
#line 904
}
#line 904

#line 909 "filter/f-inst.c"
 /* Dump line for FI_IP */
#line 909
static inline void f_dump_line_item_FI_IP(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 909

#line 909
{
#line 909
#define item (&(item_->i_FI_IP))
#line 909
#undef item
#line 909
}
#line 909

#line 916 "filter/f-inst.c"
 /* Dump line for FI_ROUTE_DISTINGUISHER */
#line 916
static inline void f_dump_line_item_FI_ROUTE_DISTINGUISHER(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 916

#line 916
{
#line 916
#define item (&(item_->i_FI_ROUTE_DISTINGUISHER))
#line 916
#undef item
#line 916
}
#line 916

#line 923 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_FIRST */
#line 923
static inline void f_dump_line_item_FI_AS_PATH_FIRST(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 923

#line 923
{
#line 923
#define item (&(item_->i_FI_AS_PATH_FIRST))
#line 923
#undef item
#line 923
}
#line 923

#line 930 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_LAST */
#line 930
static inline void f_dump_line_item_FI_AS_PATH_LAST(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 930

#line 930
{
#line 930
#define item (&(item_->i_FI_AS_PATH_LAST))
#line 930
#undef item
#line 930
}
#line 930

#line 935 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_LAST_NAG */
#line 935
static inline void f_dump_line_item_FI_AS_PATH_LAST_NAG(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 935

#line 935
{
#line 935
#define item (&(item_->i_FI_AS_PATH_LAST_NAG))
#line 935
#undef item
#line 935
}
#line 935

#line 961 "filter/f-inst.c"
 /* Dump line for FI_RETURN */
#line 961
static inline void f_dump_line_item_FI_RETURN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 961

#line 961
{
#line 961
#define item (&(item_->i_FI_RETURN))
#line 961
#undef item
#line 961
}
#line 961

#line 991 "filter/f-inst.c"
 /* Dump line for FI_CALL */
#line 991
static inline void f_dump_line_item_FI_CALL(const struct f_line_item *item_, const int indent)
#line 991

#line 991
{
#line 991
#define item (&(item_->i_FI_CALL))
#line 963 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 963

#line 991 "filter/f-inst.c"
#undef item
#line 991
}
#line 991

#line 996 "filter/f-inst.c"
 /* Dump line for FI_DROP_RESULT */
#line 996
static inline void f_dump_line_item_FI_DROP_RESULT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 996

#line 996
{
#line 996
#define item (&(item_->i_FI_DROP_RESULT))
#line 996
#undef item
#line 996
}
#line 996

#line 1019 "filter/f-inst.c"
 /* Dump line for FI_SWITCH */
#line 1019
static inline void f_dump_line_item_FI_SWITCH(const struct f_line_item *item_, const int indent)
#line 1019

#line 1019
{
#line 1019
#define item (&(item_->i_FI_SWITCH))
#line 999 "filter/f-inst.c"
debug("%s" "tree %p" "\n", INDENT, item->tree);
#line 999

#line 1019 "filter/f-inst.c"
#undef item
#line 1019
}
#line 1019

#line 1027 "filter/f-inst.c"
 /* Dump line for FI_IP_MASK */
#line 1027
static inline void f_dump_line_item_FI_IP_MASK(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1027

#line 1027
{
#line 1027
#define item (&(item_->i_FI_IP_MASK))
#line 1027
#undef item
#line 1027
}
#line 1027

#line 1033 "filter/f-inst.c"
 /* Dump line for FI_PATH_PREPEND */
#line 1033
static inline void f_dump_line_item_FI_PATH_PREPEND(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1033

#line 1033
{
#line 1033
#define item (&(item_->i_FI_PATH_PREPEND))
#line 1033
#undef item
#line 1033
}
#line 1033

#line 1090 "filter/f-inst.c"
 /* Dump line for FI_CLIST_ADD */
#line 1090
static inline void f_dump_line_item_FI_CLIST_ADD(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1090

#line 1090
{
#line 1090
#define item (&(item_->i_FI_CLIST_ADD))
#line 1090
#undef item
#line 1090
}
#line 1090

#line 1152 "filter/f-inst.c"
 /* Dump line for FI_CLIST_DEL */
#line 1152
static inline void f_dump_line_item_FI_CLIST_DEL(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1152

#line 1152
{
#line 1152
#define item (&(item_->i_FI_CLIST_DEL))
#line 1152
#undef item
#line 1152
}
#line 1152

#line 1200 "filter/f-inst.c"
 /* Dump line for FI_CLIST_FILTER */
#line 1200
static inline void f_dump_line_item_FI_CLIST_FILTER(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1200

#line 1200
{
#line 1200
#define item (&(item_->i_FI_CLIST_FILTER))
#line 1200
#undef item
#line 1200
}
#line 1200

#line 1230 "filter/f-inst.c"
 /* Dump line for FI_ROA_CHECK_IMPLICIT */
#line 1230
static inline void f_dump_line_item_FI_ROA_CHECK_IMPLICIT(const struct f_line_item *item_, const int indent)
#line 1230

#line 1230
{
#line 1230
#define item (&(item_->i_FI_ROA_CHECK_IMPLICIT))
#line 1202 "filter/f-inst.c"
debug("%s" "route table %s" "\n", INDENT, item->rtc->name);
#line 1202

#line 1230 "filter/f-inst.c"
#undef item
#line 1230
}
#line 1230

#line 1252 "filter/f-inst.c"
 /* Dump line for FI_ROA_CHECK_EXPLICIT */
#line 1252
static inline void f_dump_line_item_FI_ROA_CHECK_EXPLICIT(const struct f_line_item *item_, const int indent)
#line 1252

#line 1252
{
#line 1252
#define item (&(item_->i_FI_ROA_CHECK_EXPLICIT))
#line 1234 "filter/f-inst.c"
debug("%s" "route table %s" "\n", INDENT, item->rtc->name);
#line 1234

#line 1252 "filter/f-inst.c"
#undef item
#line 1252
}
#line 1252

#line 1257 "filter/f-inst.c"
 /* Dump line for FI_FORMAT */
#line 1257
static inline void f_dump_line_item_FI_FORMAT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1257

#line 1257
{
#line 1257
#define item (&(item_->i_FI_FORMAT))
#line 1257
#undef item
#line 1257
}
#line 1257

#line 668 "filter/decl.m4"
 /* Dump line for FI_ASSERT */
#line 668
static inline void f_dump_line_item_FI_ASSERT(const struct f_line_item *item_, const int indent)
#line 668

#line 668
{
#line 668
#define item (&(item_->i_FI_ASSERT))
#line 1261 "filter/f-inst.c"
debug("%s" "string %s" "\n", INDENT, item->s);
#line 1261

#line 668 "filter/decl.m4"
#undef item
#line 668
}
#line 668

#line 519 "filter/decl.m4"


void f_dump_line(const struct f_line *dest, uint indent)
{
  if (!dest) {
    debug("%sNo filter line (NULL)\n", INDENT);
    return;
  }
  debug("%sFilter line %p (len=%u)\n", INDENT, dest, dest->len);
  for (uint i=0; i<dest->len; i++) {
    const struct f_line_item *item = &dest->items[i];
    debug("%sInstruction %s at line %u\n", INDENT, f_instruction_name_(item->fi_code), item->lineno);
    switch (item->fi_code) {
#line 227 "filter/f-inst.c"
 /* Dump line caller for FI_ADD */
#line 227
case FI_ADD: f_dump_line_item_FI_ADD(item, indent + 1); break;
#line 227

#line 232 "filter/f-inst.c"
 /* Dump line caller for FI_SUBTRACT */
#line 232
case FI_SUBTRACT: f_dump_line_item_FI_SUBTRACT(item, indent + 1); break;
#line 232

#line 237 "filter/f-inst.c"
 /* Dump line caller for FI_MULTIPLY */
#line 237
case FI_MULTIPLY: f_dump_line_item_FI_MULTIPLY(item, indent + 1); break;
#line 237

#line 243 "filter/f-inst.c"
 /* Dump line caller for FI_DIVIDE */
#line 243
case FI_DIVIDE: f_dump_line_item_FI_DIVIDE(item, indent + 1); break;
#line 243

#line 253 "filter/f-inst.c"
 /* Dump line caller for FI_AND */
#line 253
case FI_AND: f_dump_line_item_FI_AND(item, indent + 1); break;
#line 253

#line 264 "filter/f-inst.c"
 /* Dump line caller for FI_OR */
#line 264
case FI_OR: f_dump_line_item_FI_OR(item, indent + 1); break;
#line 264

#line 274 "filter/f-inst.c"
 /* Dump line caller for FI_PAIR_CONSTRUCT */
#line 274
case FI_PAIR_CONSTRUCT: f_dump_line_item_FI_PAIR_CONSTRUCT(item, indent + 1); break;
#line 274

#line 314 "filter/f-inst.c"
 /* Dump line caller for FI_EC_CONSTRUCT */
#line 314
case FI_EC_CONSTRUCT: f_dump_line_item_FI_EC_CONSTRUCT(item, indent + 1); break;
#line 314

#line 321 "filter/f-inst.c"
 /* Dump line caller for FI_LC_CONSTRUCT */
#line 321
case FI_LC_CONSTRUCT: f_dump_line_item_FI_LC_CONSTRUCT(item, indent + 1); break;
#line 321

#line 371 "filter/f-inst.c"
 /* Dump line caller for FI_PATHMASK_CONSTRUCT */
#line 371
case FI_PATHMASK_CONSTRUCT: f_dump_line_item_FI_PATHMASK_CONSTRUCT(item, indent + 1); break;
#line 371

#line 377 "filter/f-inst.c"
 /* Dump line caller for FI_NEQ */
#line 377
case FI_NEQ: f_dump_line_item_FI_NEQ(item, indent + 1); break;
#line 377

#line 383 "filter/f-inst.c"
 /* Dump line caller for FI_EQ */
#line 383
case FI_EQ: f_dump_line_item_FI_EQ(item, indent + 1); break;
#line 383

#line 394 "filter/f-inst.c"
 /* Dump line caller for FI_LT */
#line 394
case FI_LT: f_dump_line_item_FI_LT(item, indent + 1); break;
#line 394

#line 405 "filter/f-inst.c"
 /* Dump line caller for FI_LTE */
#line 405
case FI_LTE: f_dump_line_item_FI_LTE(item, indent + 1); break;
#line 405

#line 410 "filter/f-inst.c"
 /* Dump line caller for FI_NOT */
#line 410
case FI_NOT: f_dump_line_item_FI_NOT(item, indent + 1); break;
#line 410

#line 419 "filter/f-inst.c"
 /* Dump line caller for FI_MATCH */
#line 419
case FI_MATCH: f_dump_line_item_FI_MATCH(item, indent + 1); break;
#line 419

#line 428 "filter/f-inst.c"
 /* Dump line caller for FI_NOT_MATCH */
#line 428
case FI_NOT_MATCH: f_dump_line_item_FI_NOT_MATCH(item, indent + 1); break;
#line 428

#line 433 "filter/f-inst.c"
 /* Dump line caller for FI_DEFINED */
#line 433
case FI_DEFINED: f_dump_line_item_FI_DEFINED(item, indent + 1); break;
#line 433

#line 445 "filter/f-inst.c"
 /* Dump line caller for FI_TYPE */
#line 445
case FI_TYPE: f_dump_line_item_FI_TYPE(item, indent + 1); break;
#line 445

#line 451 "filter/f-inst.c"
 /* Dump line caller for FI_IS_V4 */
#line 451
case FI_IS_V4: f_dump_line_item_FI_IS_V4(item, indent + 1); break;
#line 451

#line 460 "filter/f-inst.c"
 /* Dump line caller for FI_VAR_SET */
#line 460
case FI_VAR_SET: f_dump_line_item_FI_VAR_SET(item, indent + 1); break;
#line 460

#line 467 "filter/f-inst.c"
 /* Dump line caller for FI_VAR_GET */
#line 467
case FI_VAR_GET: f_dump_line_item_FI_VAR_GET(item, indent + 1); break;
#line 467

#line 480 "filter/f-inst.c"
 /* Dump line caller for FI_CONSTANT */
#line 480
case FI_CONSTANT: f_dump_line_item_FI_CONSTANT(item, indent + 1); break;
#line 480

#line 488 "filter/f-inst.c"
 /* Dump line caller for FI_CONDITION */
#line 488
case FI_CONDITION: f_dump_line_item_FI_CONDITION(item, indent + 1); break;
#line 488

#line 497 "filter/f-inst.c"
 /* Dump line caller for FI_PRINT */
#line 497
case FI_PRINT: f_dump_line_item_FI_PRINT(item, indent + 1); break;
#line 497

#line 504 "filter/f-inst.c"
 /* Dump line caller for FI_FLUSH */
#line 504
case FI_FLUSH: f_dump_line_item_FI_FLUSH(item, indent + 1); break;
#line 504

#line 518 "filter/f-inst.c"
 /* Dump line caller for FI_DIE */
#line 518
case FI_DIE: f_dump_line_item_FI_DIE(item, indent + 1); break;
#line 518

#line 543 "filter/f-inst.c"
 /* Dump line caller for FI_RTA_GET */
#line 543
case FI_RTA_GET: f_dump_line_item_FI_RTA_GET(item, indent + 1); break;
#line 543

#line 627 "filter/f-inst.c"
 /* Dump line caller for FI_RTA_SET */
#line 627
case FI_RTA_SET: f_dump_line_item_FI_RTA_SET(item, indent + 1); break;
#line 627

#line 702 "filter/f-inst.c"
 /* Dump line caller for FI_EA_GET */
#line 702
case FI_EA_GET: f_dump_line_item_FI_EA_GET(item, indent + 1); break;
#line 702

#line 766 "filter/f-inst.c"
 /* Dump line caller for FI_EA_SET */
#line 766
case FI_EA_SET: f_dump_line_item_FI_EA_SET(item, indent + 1); break;
#line 766

#line 788 "filter/f-inst.c"
 /* Dump line caller for FI_EA_UNSET */
#line 788
case FI_EA_UNSET: f_dump_line_item_FI_EA_UNSET(item, indent + 1); break;
#line 788

#line 793 "filter/f-inst.c"
 /* Dump line caller for FI_PREF_GET */
#line 793
case FI_PREF_GET: f_dump_line_item_FI_PREF_GET(item, indent + 1); break;
#line 793

#line 802 "filter/f-inst.c"
 /* Dump line caller for FI_PREF_SET */
#line 802
case FI_PREF_SET: f_dump_line_item_FI_PREF_SET(item, indent + 1); break;
#line 802

#line 814 "filter/f-inst.c"
 /* Dump line caller for FI_LENGTH */
#line 814
case FI_LENGTH: f_dump_line_item_FI_LENGTH(item, indent + 1); break;
#line 814

#line 849 "filter/f-inst.c"
 /* Dump line caller for FI_NET_SRC */
#line 849
case FI_NET_SRC: f_dump_line_item_FI_NET_SRC(item, indent + 1); break;
#line 849

#line 884 "filter/f-inst.c"
 /* Dump line caller for FI_NET_DST */
#line 884
case FI_NET_DST: f_dump_line_item_FI_NET_DST(item, indent + 1); break;
#line 884

#line 894 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_MAXLEN */
#line 894
case FI_ROA_MAXLEN: f_dump_line_item_FI_ROA_MAXLEN(item, indent + 1); break;
#line 894

#line 904 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_ASN */
#line 904
case FI_ROA_ASN: f_dump_line_item_FI_ROA_ASN(item, indent + 1); break;
#line 904

#line 909 "filter/f-inst.c"
 /* Dump line caller for FI_IP */
#line 909
case FI_IP: f_dump_line_item_FI_IP(item, indent + 1); break;
#line 909

#line 916 "filter/f-inst.c"
 /* Dump line caller for FI_ROUTE_DISTINGUISHER */
#line 916
case FI_ROUTE_DISTINGUISHER: f_dump_line_item_FI_ROUTE_DISTINGUISHER(item, indent + 1); break;
#line 916

#line 923 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_FIRST */
#line 923
case FI_AS_PATH_FIRST: f_dump_line_item_FI_AS_PATH_FIRST(item, indent + 1); break;
#line 923

#line 930 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_LAST */
#line 930
case FI_AS_PATH_LAST: f_dump_line_item_FI_AS_PATH_LAST(item, indent + 1); break;
#line 930

#line 935 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_LAST_NAG */
#line 935
case FI_AS_PATH_LAST_NAG: f_dump_line_item_FI_AS_PATH_LAST_NAG(item, indent + 1); break;
#line 935

#line 961 "filter/f-inst.c"
 /* Dump line caller for FI_RETURN */
#line 961
case FI_RETURN: f_dump_line_item_FI_RETURN(item, indent + 1); break;
#line 961

#line 991 "filter/f-inst.c"
 /* Dump line caller for FI_CALL */
#line 991
case FI_CALL: f_dump_line_item_FI_CALL(item, indent + 1); break;
#line 991

#line 996 "filter/f-inst.c"
 /* Dump line caller for FI_DROP_RESULT */
#line 996
case FI_DROP_RESULT: f_dump_line_item_FI_DROP_RESULT(item, indent + 1); break;
#line 996

#line 1019 "filter/f-inst.c"
 /* Dump line caller for FI_SWITCH */
#line 1019
case FI_SWITCH: f_dump_line_item_FI_SWITCH(item, indent + 1); break;
#line 1019

#line 1027 "filter/f-inst.c"
 /* Dump line caller for FI_IP_MASK */
#line 1027
case FI_IP_MASK: f_dump_line_item_FI_IP_MASK(item, indent + 1); break;
#line 1027

#line 1033 "filter/f-inst.c"
 /* Dump line caller for FI_PATH_PREPEND */
#line 1033
case FI_PATH_PREPEND: f_dump_line_item_FI_PATH_PREPEND(item, indent + 1); break;
#line 1033

#line 1090 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_ADD */
#line 1090
case FI_CLIST_ADD: f_dump_line_item_FI_CLIST_ADD(item, indent + 1); break;
#line 1090

#line 1152 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_DEL */
#line 1152
case FI_CLIST_DEL: f_dump_line_item_FI_CLIST_DEL(item, indent + 1); break;
#line 1152

#line 1200 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_FILTER */
#line 1200
case FI_CLIST_FILTER: f_dump_line_item_FI_CLIST_FILTER(item, indent + 1); break;
#line 1200

#line 1230 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_CHECK_IMPLICIT */
#line 1230
case FI_ROA_CHECK_IMPLICIT: f_dump_line_item_FI_ROA_CHECK_IMPLICIT(item, indent + 1); break;
#line 1230

#line 1252 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_CHECK_EXPLICIT */
#line 1252
case FI_ROA_CHECK_EXPLICIT: f_dump_line_item_FI_ROA_CHECK_EXPLICIT(item, indent + 1); break;
#line 1252

#line 1257 "filter/f-inst.c"
 /* Dump line caller for FI_FORMAT */
#line 1257
case FI_FORMAT: f_dump_line_item_FI_FORMAT(item, indent + 1); break;
#line 1257

#line 668 "filter/decl.m4"
 /* Dump line caller for FI_ASSERT */
#line 668
case FI_ASSERT: f_dump_line_item_FI_ASSERT(item, indent + 1); break;
#line 668

#line 532 "filter/decl.m4"

      default: bug("Unknown instruction %x in f_dump_line", item->fi_code);
    }
  }
  debug("%sFilter line %p dump done\n", INDENT, dest);
}

/* Linearize */
static uint
linearize(struct f_line *dest, const struct f_inst *what, uint pos)
{
  for ( ; what; what = what->next) {
    switch (what->fi_code) {
#line 227 "filter/f-inst.c"
 /* Linearize for FI_ADD */
#line 227
case FI_ADD: {
#line 227
#define whati (&(what->i_FI_ADD))
#line 227
#define item (&(dest->items[pos].i_FI_ADD))
#line 227
  #line 223 "filter/f-inst.c"

#line 223
pos = linearize(dest, whati->f1, pos);
#line 224 "filter/f-inst.c"

#line 224
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 227 "filter/f-inst.c"
#undef item
#line 227
  dest->items[pos].fi_code = what->fi_code;
#line 227
  dest->items[pos].lineno = what->lineno;
#line 227
  break;
#line 227
}
#line 227

#line 232 "filter/f-inst.c"
 /* Linearize for FI_SUBTRACT */
#line 232
case FI_SUBTRACT: {
#line 232
#define whati (&(what->i_FI_SUBTRACT))
#line 232
#define item (&(dest->items[pos].i_FI_SUBTRACT))
#line 232
  #line 228 "filter/f-inst.c"

#line 228
pos = linearize(dest, whati->f1, pos);
#line 229 "filter/f-inst.c"

#line 229
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 232 "filter/f-inst.c"
#undef item
#line 232
  dest->items[pos].fi_code = what->fi_code;
#line 232
  dest->items[pos].lineno = what->lineno;
#line 232
  break;
#line 232
}
#line 232

#line 237 "filter/f-inst.c"
 /* Linearize for FI_MULTIPLY */
#line 237
case FI_MULTIPLY: {
#line 237
#define whati (&(what->i_FI_MULTIPLY))
#line 237
#define item (&(dest->items[pos].i_FI_MULTIPLY))
#line 237
  #line 233 "filter/f-inst.c"

#line 233
pos = linearize(dest, whati->f1, pos);
#line 234 "filter/f-inst.c"

#line 234
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 237 "filter/f-inst.c"
#undef item
#line 237
  dest->items[pos].fi_code = what->fi_code;
#line 237
  dest->items[pos].lineno = what->lineno;
#line 237
  break;
#line 237
}
#line 237

#line 243 "filter/f-inst.c"
 /* Linearize for FI_DIVIDE */
#line 243
case FI_DIVIDE: {
#line 243
#define whati (&(what->i_FI_DIVIDE))
#line 243
#define item (&(dest->items[pos].i_FI_DIVIDE))
#line 243
  #line 238 "filter/f-inst.c"

#line 238
pos = linearize(dest, whati->f1, pos);
#line 239 "filter/f-inst.c"

#line 239
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 243 "filter/f-inst.c"
#undef item
#line 243
  dest->items[pos].fi_code = what->fi_code;
#line 243
  dest->items[pos].lineno = what->lineno;
#line 243
  break;
#line 243
}
#line 243

#line 253 "filter/f-inst.c"
 /* Linearize for FI_AND */
#line 253
case FI_AND: {
#line 253
#define whati (&(what->i_FI_AND))
#line 253
#define item (&(dest->items[pos].i_FI_AND))
#line 253
  #line 244 "filter/f-inst.c"

#line 244
pos = linearize(dest, whati->f1, pos);
#line 249 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#undef whati
#line 253 "filter/f-inst.c"
#undef item
#line 253
  dest->items[pos].fi_code = what->fi_code;
#line 253
  dest->items[pos].lineno = what->lineno;
#line 253
  break;
#line 253
}
#line 253

#line 264 "filter/f-inst.c"
 /* Linearize for FI_OR */
#line 264
case FI_OR: {
#line 264
#define whati (&(what->i_FI_OR))
#line 264
#define item (&(dest->items[pos].i_FI_OR))
#line 264
  #line 254 "filter/f-inst.c"

#line 254
pos = linearize(dest, whati->f1, pos);
#line 259 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#undef whati
#line 264 "filter/f-inst.c"
#undef item
#line 264
  dest->items[pos].fi_code = what->fi_code;
#line 264
  dest->items[pos].lineno = what->lineno;
#line 264
  break;
#line 264
}
#line 264

#line 274 "filter/f-inst.c"
 /* Linearize for FI_PAIR_CONSTRUCT */
#line 274
case FI_PAIR_CONSTRUCT: {
#line 274
#define whati (&(what->i_FI_PAIR_CONSTRUCT))
#line 274
#define item (&(dest->items[pos].i_FI_PAIR_CONSTRUCT))
#line 274
  #line 265 "filter/f-inst.c"

#line 265
pos = linearize(dest, whati->f1, pos);
#line 266 "filter/f-inst.c"

#line 266
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 274 "filter/f-inst.c"
#undef item
#line 274
  dest->items[pos].fi_code = what->fi_code;
#line 274
  dest->items[pos].lineno = what->lineno;
#line 274
  break;
#line 274
}
#line 274

#line 314 "filter/f-inst.c"
 /* Linearize for FI_EC_CONSTRUCT */
#line 314
case FI_EC_CONSTRUCT: {
#line 314
#define whati (&(what->i_FI_EC_CONSTRUCT))
#line 314
#define item (&(dest->items[pos].i_FI_EC_CONSTRUCT))
#line 314
  #line 275 "filter/f-inst.c"

#line 275
pos = linearize(dest, whati->f1, pos);
#line 276 "filter/f-inst.c"

#line 276
pos = linearize(dest, whati->f2, pos);
#line 278 "filter/f-inst.c"
item->ecs = whati->ecs;
#line 278

#undef whati
#line 314 "filter/f-inst.c"
#undef item
#line 314
  dest->items[pos].fi_code = what->fi_code;
#line 314
  dest->items[pos].lineno = what->lineno;
#line 314
  break;
#line 314
}
#line 314

#line 321 "filter/f-inst.c"
 /* Linearize for FI_LC_CONSTRUCT */
#line 321
case FI_LC_CONSTRUCT: {
#line 321
#define whati (&(what->i_FI_LC_CONSTRUCT))
#line 321
#define item (&(dest->items[pos].i_FI_LC_CONSTRUCT))
#line 321
  #line 315 "filter/f-inst.c"

#line 315
pos = linearize(dest, whati->f1, pos);
#line 316 "filter/f-inst.c"

#line 316
pos = linearize(dest, whati->f2, pos);
#line 317 "filter/f-inst.c"

#line 317
pos = linearize(dest, whati->f3, pos);
#undef whati
#line 321 "filter/f-inst.c"
#undef item
#line 321
  dest->items[pos].fi_code = what->fi_code;
#line 321
  dest->items[pos].lineno = what->lineno;
#line 321
  break;
#line 321
}
#line 321

#line 371 "filter/f-inst.c"
 /* Linearize for FI_PATHMASK_CONSTRUCT */
#line 371
case FI_PATHMASK_CONSTRUCT: {
#line 371
#define whati (&(what->i_FI_PATHMASK_CONSTRUCT))
#line 371
#define item (&(dest->items[pos].i_FI_PATHMASK_CONSTRUCT))
#line 371
  #line 322 "filter/f-inst.c"
  pos = linearize(dest, whati->fvar, pos);
#line 322
  item->varcount = whati->varcount;
#undef whati
#line 371 "filter/f-inst.c"
#undef item
#line 371
  dest->items[pos].fi_code = what->fi_code;
#line 371
  dest->items[pos].lineno = what->lineno;
#line 371
  break;
#line 371
}
#line 371

#line 377 "filter/f-inst.c"
 /* Linearize for FI_NEQ */
#line 377
case FI_NEQ: {
#line 377
#define whati (&(what->i_FI_NEQ))
#line 377
#define item (&(dest->items[pos].i_FI_NEQ))
#line 377
  #line 372 "filter/f-inst.c"

#line 372
pos = linearize(dest, whati->f1, pos);
#line 373 "filter/f-inst.c"

#line 373
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 377 "filter/f-inst.c"
#undef item
#line 377
  dest->items[pos].fi_code = what->fi_code;
#line 377
  dest->items[pos].lineno = what->lineno;
#line 377
  break;
#line 377
}
#line 377

#line 383 "filter/f-inst.c"
 /* Linearize for FI_EQ */
#line 383
case FI_EQ: {
#line 383
#define whati (&(what->i_FI_EQ))
#line 383
#define item (&(dest->items[pos].i_FI_EQ))
#line 383
  #line 378 "filter/f-inst.c"

#line 378
pos = linearize(dest, whati->f1, pos);
#line 379 "filter/f-inst.c"

#line 379
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 383 "filter/f-inst.c"
#undef item
#line 383
  dest->items[pos].fi_code = what->fi_code;
#line 383
  dest->items[pos].lineno = what->lineno;
#line 383
  break;
#line 383
}
#line 383

#line 394 "filter/f-inst.c"
 /* Linearize for FI_LT */
#line 394
case FI_LT: {
#line 394
#define whati (&(what->i_FI_LT))
#line 394
#define item (&(dest->items[pos].i_FI_LT))
#line 394
  #line 384 "filter/f-inst.c"

#line 384
pos = linearize(dest, whati->f1, pos);
#line 385 "filter/f-inst.c"

#line 385
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 394 "filter/f-inst.c"
#undef item
#line 394
  dest->items[pos].fi_code = what->fi_code;
#line 394
  dest->items[pos].lineno = what->lineno;
#line 394
  break;
#line 394
}
#line 394

#line 405 "filter/f-inst.c"
 /* Linearize for FI_LTE */
#line 405
case FI_LTE: {
#line 405
#define whati (&(what->i_FI_LTE))
#line 405
#define item (&(dest->items[pos].i_FI_LTE))
#line 405
  #line 395 "filter/f-inst.c"

#line 395
pos = linearize(dest, whati->f1, pos);
#line 396 "filter/f-inst.c"

#line 396
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 405 "filter/f-inst.c"
#undef item
#line 405
  dest->items[pos].fi_code = what->fi_code;
#line 405
  dest->items[pos].lineno = what->lineno;
#line 405
  break;
#line 405
}
#line 405

#line 410 "filter/f-inst.c"
 /* Linearize for FI_NOT */
#line 410
case FI_NOT: {
#line 410
#define whati (&(what->i_FI_NOT))
#line 410
#define item (&(dest->items[pos].i_FI_NOT))
#line 410
  #line 406 "filter/f-inst.c"

#line 406
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 410 "filter/f-inst.c"
#undef item
#line 410
  dest->items[pos].fi_code = what->fi_code;
#line 410
  dest->items[pos].lineno = what->lineno;
#line 410
  break;
#line 410
}
#line 410

#line 419 "filter/f-inst.c"
 /* Linearize for FI_MATCH */
#line 419
case FI_MATCH: {
#line 419
#define whati (&(what->i_FI_MATCH))
#line 419
#define item (&(dest->items[pos].i_FI_MATCH))
#line 419
  #line 411 "filter/f-inst.c"

#line 411
pos = linearize(dest, whati->f1, pos);
#line 412 "filter/f-inst.c"

#line 412
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 419 "filter/f-inst.c"
#undef item
#line 419
  dest->items[pos].fi_code = what->fi_code;
#line 419
  dest->items[pos].lineno = what->lineno;
#line 419
  break;
#line 419
}
#line 419

#line 428 "filter/f-inst.c"
 /* Linearize for FI_NOT_MATCH */
#line 428
case FI_NOT_MATCH: {
#line 428
#define whati (&(what->i_FI_NOT_MATCH))
#line 428
#define item (&(dest->items[pos].i_FI_NOT_MATCH))
#line 428
  #line 420 "filter/f-inst.c"

#line 420
pos = linearize(dest, whati->f1, pos);
#line 421 "filter/f-inst.c"

#line 421
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 428 "filter/f-inst.c"
#undef item
#line 428
  dest->items[pos].fi_code = what->fi_code;
#line 428
  dest->items[pos].lineno = what->lineno;
#line 428
  break;
#line 428
}
#line 428

#line 433 "filter/f-inst.c"
 /* Linearize for FI_DEFINED */
#line 433
case FI_DEFINED: {
#line 433
#define whati (&(what->i_FI_DEFINED))
#line 433
#define item (&(dest->items[pos].i_FI_DEFINED))
#line 433
  #line 429 "filter/f-inst.c"

#line 429
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 433 "filter/f-inst.c"
#undef item
#line 433
  dest->items[pos].fi_code = what->fi_code;
#line 433
  dest->items[pos].lineno = what->lineno;
#line 433
  break;
#line 433
}
#line 433

#line 445 "filter/f-inst.c"
 /* Linearize for FI_TYPE */
#line 445
case FI_TYPE: {
#line 445
#define whati (&(what->i_FI_TYPE))
#line 445
#define item (&(dest->items[pos].i_FI_TYPE))
#line 445
  #line 434 "filter/f-inst.c"

#line 434
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 445 "filter/f-inst.c"
#undef item
#line 445
  dest->items[pos].fi_code = what->fi_code;
#line 445
  dest->items[pos].lineno = what->lineno;
#line 445
  break;
#line 445
}
#line 445

#line 451 "filter/f-inst.c"
 /* Linearize for FI_IS_V4 */
#line 451
case FI_IS_V4: {
#line 451
#define whati (&(what->i_FI_IS_V4))
#line 451
#define item (&(dest->items[pos].i_FI_IS_V4))
#line 451
  #line 446 "filter/f-inst.c"

#line 446
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 451 "filter/f-inst.c"
#undef item
#line 451
  dest->items[pos].fi_code = what->fi_code;
#line 451
  dest->items[pos].lineno = what->lineno;
#line 451
  break;
#line 451
}
#line 451

#line 460 "filter/f-inst.c"
 /* Linearize for FI_VAR_SET */
#line 460
case FI_VAR_SET: {
#line 460
#define whati (&(what->i_FI_VAR_SET))
#line 460
#define item (&(dest->items[pos].i_FI_VAR_SET))
#line 460
  #line 453 "filter/f-inst.c"

#line 453
pos = linearize(dest, whati->f1, pos);
#line 454 "filter/f-inst.c"
item->sym = whati->sym;
#line 454

#undef whati
#line 460 "filter/f-inst.c"
#undef item
#line 460
  dest->items[pos].fi_code = what->fi_code;
#line 460
  dest->items[pos].lineno = what->lineno;
#line 460
  break;
#line 460
}
#line 460

#line 467 "filter/f-inst.c"
 /* Linearize for FI_VAR_GET */
#line 467
case FI_VAR_GET: {
#line 467
#define whati (&(what->i_FI_VAR_GET))
#line 467
#define item (&(dest->items[pos].i_FI_VAR_GET))
#line 467
  #line 461 "filter/f-inst.c"
item->sym = whati->sym;
#line 461

#undef whati
#line 467 "filter/f-inst.c"
#undef item
#line 467
  dest->items[pos].fi_code = what->fi_code;
#line 467
  dest->items[pos].lineno = what->lineno;
#line 467
  break;
#line 467
}
#line 467

#line 480 "filter/f-inst.c"
 /* Linearize for FI_CONSTANT */
#line 480
case FI_CONSTANT: {
#line 480
#define whati (&(what->i_FI_CONSTANT))
#line 480
#define item (&(dest->items[pos].i_FI_CONSTANT))
#line 480
  #line 468 "filter/f-inst.c"
item->val = whati->val;
#line 468

#undef whati
#line 480 "filter/f-inst.c"
#undef item
#line 480
  dest->items[pos].fi_code = what->fi_code;
#line 480
  dest->items[pos].lineno = what->lineno;
#line 480
  break;
#line 480
}
#line 480

#line 488 "filter/f-inst.c"
 /* Linearize for FI_CONDITION */
#line 488
case FI_CONDITION: {
#line 488
#define whati (&(what->i_FI_CONDITION))
#line 488
#define item (&(dest->items[pos].i_FI_CONDITION))
#line 488
  #line 481 "filter/f-inst.c"

#line 481
pos = linearize(dest, whati->f1, pos);
#line 483 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#line 485 "filter/f-inst.c"
item->fl3 = f_linearize(whati->f3);
#undef whati
#line 488 "filter/f-inst.c"
#undef item
#line 488
  dest->items[pos].fi_code = what->fi_code;
#line 488
  dest->items[pos].lineno = what->lineno;
#line 488
  break;
#line 488
}
#line 488

#line 497 "filter/f-inst.c"
 /* Linearize for FI_PRINT */
#line 497
case FI_PRINT: {
#line 497
#define whati (&(what->i_FI_PRINT))
#line 497
#define item (&(dest->items[pos].i_FI_PRINT))
#line 497
  #line 490 "filter/f-inst.c"
  pos = linearize(dest, whati->fvar, pos);
#line 490
  item->varcount = whati->varcount;
#undef whati
#line 497 "filter/f-inst.c"
#undef item
#line 497
  dest->items[pos].fi_code = what->fi_code;
#line 497
  dest->items[pos].lineno = what->lineno;
#line 497
  break;
#line 497
}
#line 497

#line 504 "filter/f-inst.c"
 /* Linearize for FI_FLUSH */
#line 504
case FI_FLUSH: {
#line 504
#define whati (&(what->i_FI_FLUSH))
#line 504
#define item (&(dest->items[pos].i_FI_FLUSH))
#line 504
  #undef whati
#line 504
#undef item
#line 504
  dest->items[pos].fi_code = what->fi_code;
#line 504
  dest->items[pos].lineno = what->lineno;
#line 504
  break;
#line 504
}
#line 504

#line 518 "filter/f-inst.c"
 /* Linearize for FI_DIE */
#line 518
case FI_DIE: {
#line 518
#define whati (&(what->i_FI_DIE))
#line 518
#define item (&(dest->items[pos].i_FI_DIE))
#line 518
  #line 506 "filter/f-inst.c"
item->fret = whati->fret;
#line 506

#undef whati
#line 518 "filter/f-inst.c"
#undef item
#line 518
  dest->items[pos].fi_code = what->fi_code;
#line 518
  dest->items[pos].lineno = what->lineno;
#line 518
  break;
#line 518
}
#line 518

#line 543 "filter/f-inst.c"
 /* Linearize for FI_RTA_GET */
#line 543
case FI_RTA_GET: {
#line 543
#define whati (&(what->i_FI_RTA_GET))
#line 543
#define item (&(dest->items[pos].i_FI_RTA_GET))
#line 543
  #line 520 "filter/f-inst.c"
item->sa = whati->sa;
#line 520

#undef whati
#line 543 "filter/f-inst.c"
#undef item
#line 543
  dest->items[pos].fi_code = what->fi_code;
#line 543
  dest->items[pos].lineno = what->lineno;
#line 543
  break;
#line 543
}
#line 543

#line 627 "filter/f-inst.c"
 /* Linearize for FI_RTA_SET */
#line 627
case FI_RTA_SET: {
#line 627
#define whati (&(what->i_FI_RTA_SET))
#line 627
#define item (&(dest->items[pos].i_FI_RTA_SET))
#line 627
  #line 545 "filter/f-inst.c"

#line 545
pos = linearize(dest, whati->f1, pos);
#line 546 "filter/f-inst.c"
item->sa = whati->sa;
#line 546

#undef whati
#line 627 "filter/f-inst.c"
#undef item
#line 627
  dest->items[pos].fi_code = what->fi_code;
#line 627
  dest->items[pos].lineno = what->lineno;
#line 627
  break;
#line 627
}
#line 627

#line 702 "filter/f-inst.c"
 /* Linearize for FI_EA_GET */
#line 702
case FI_EA_GET: {
#line 702
#define whati (&(what->i_FI_EA_GET))
#line 702
#define item (&(dest->items[pos].i_FI_EA_GET))
#line 702
  #line 628 "filter/f-inst.c"
item->da = whati->da;
#line 628

#undef whati
#line 702 "filter/f-inst.c"
#undef item
#line 702
  dest->items[pos].fi_code = what->fi_code;
#line 702
  dest->items[pos].lineno = what->lineno;
#line 702
  break;
#line 702
}
#line 702

#line 766 "filter/f-inst.c"
 /* Linearize for FI_EA_SET */
#line 766
case FI_EA_SET: {
#line 766
#define whati (&(what->i_FI_EA_SET))
#line 766
#define item (&(dest->items[pos].i_FI_EA_SET))
#line 766
  #line 705 "filter/f-inst.c"

#line 705
pos = linearize(dest, whati->f1, pos);
#line 706 "filter/f-inst.c"
item->da = whati->da;
#line 706

#undef whati
#line 766 "filter/f-inst.c"
#undef item
#line 766
  dest->items[pos].fi_code = what->fi_code;
#line 766
  dest->items[pos].lineno = what->lineno;
#line 766
  break;
#line 766
}
#line 766

#line 788 "filter/f-inst.c"
 /* Linearize for FI_EA_UNSET */
#line 788
case FI_EA_UNSET: {
#line 788
#define whati (&(what->i_FI_EA_UNSET))
#line 788
#define item (&(dest->items[pos].i_FI_EA_UNSET))
#line 788
  #line 767 "filter/f-inst.c"
item->da = whati->da;
#line 767

#undef whati
#line 788 "filter/f-inst.c"
#undef item
#line 788
  dest->items[pos].fi_code = what->fi_code;
#line 788
  dest->items[pos].lineno = what->lineno;
#line 788
  break;
#line 788
}
#line 788

#line 793 "filter/f-inst.c"
 /* Linearize for FI_PREF_GET */
#line 793
case FI_PREF_GET: {
#line 793
#define whati (&(what->i_FI_PREF_GET))
#line 793
#define item (&(dest->items[pos].i_FI_PREF_GET))
#line 793
  #undef whati
#line 793
#undef item
#line 793
  dest->items[pos].fi_code = what->fi_code;
#line 793
  dest->items[pos].lineno = what->lineno;
#line 793
  break;
#line 793
}
#line 793

#line 802 "filter/f-inst.c"
 /* Linearize for FI_PREF_SET */
#line 802
case FI_PREF_SET: {
#line 802
#define whati (&(what->i_FI_PREF_SET))
#line 802
#define item (&(dest->items[pos].i_FI_PREF_SET))
#line 802
  #line 795 "filter/f-inst.c"

#line 795
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 802 "filter/f-inst.c"
#undef item
#line 802
  dest->items[pos].fi_code = what->fi_code;
#line 802
  dest->items[pos].lineno = what->lineno;
#line 802
  break;
#line 802
}
#line 802

#line 814 "filter/f-inst.c"
 /* Linearize for FI_LENGTH */
#line 814
case FI_LENGTH: {
#line 814
#define whati (&(what->i_FI_LENGTH))
#line 814
#define item (&(dest->items[pos].i_FI_LENGTH))
#line 814
  #line 803 "filter/f-inst.c"

#line 803
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 814 "filter/f-inst.c"
#undef item
#line 814
  dest->items[pos].fi_code = what->fi_code;
#line 814
  dest->items[pos].lineno = what->lineno;
#line 814
  break;
#line 814
}
#line 814

#line 849 "filter/f-inst.c"
 /* Linearize for FI_NET_SRC */
#line 849
case FI_NET_SRC: {
#line 849
#define whati (&(what->i_FI_NET_SRC))
#line 849
#define item (&(dest->items[pos].i_FI_NET_SRC))
#line 849
  #line 815 "filter/f-inst.c"

#line 815
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 849 "filter/f-inst.c"
#undef item
#line 849
  dest->items[pos].fi_code = what->fi_code;
#line 849
  dest->items[pos].lineno = what->lineno;
#line 849
  break;
#line 849
}
#line 849

#line 884 "filter/f-inst.c"
 /* Linearize for FI_NET_DST */
#line 884
case FI_NET_DST: {
#line 884
#define whati (&(what->i_FI_NET_DST))
#line 884
#define item (&(dest->items[pos].i_FI_NET_DST))
#line 884
  #line 850 "filter/f-inst.c"

#line 850
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 884 "filter/f-inst.c"
#undef item
#line 884
  dest->items[pos].fi_code = what->fi_code;
#line 884
  dest->items[pos].lineno = what->lineno;
#line 884
  break;
#line 884
}
#line 884

#line 894 "filter/f-inst.c"
 /* Linearize for FI_ROA_MAXLEN */
#line 894
case FI_ROA_MAXLEN: {
#line 894
#define whati (&(what->i_FI_ROA_MAXLEN))
#line 894
#define item (&(dest->items[pos].i_FI_ROA_MAXLEN))
#line 894
  #line 885 "filter/f-inst.c"

#line 885
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 894 "filter/f-inst.c"
#undef item
#line 894
  dest->items[pos].fi_code = what->fi_code;
#line 894
  dest->items[pos].lineno = what->lineno;
#line 894
  break;
#line 894
}
#line 894

#line 904 "filter/f-inst.c"
 /* Linearize for FI_ROA_ASN */
#line 904
case FI_ROA_ASN: {
#line 904
#define whati (&(what->i_FI_ROA_ASN))
#line 904
#define item (&(dest->items[pos].i_FI_ROA_ASN))
#line 904
  #line 895 "filter/f-inst.c"

#line 895
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 904 "filter/f-inst.c"
#undef item
#line 904
  dest->items[pos].fi_code = what->fi_code;
#line 904
  dest->items[pos].lineno = what->lineno;
#line 904
  break;
#line 904
}
#line 904

#line 909 "filter/f-inst.c"
 /* Linearize for FI_IP */
#line 909
case FI_IP: {
#line 909
#define whati (&(what->i_FI_IP))
#line 909
#define item (&(dest->items[pos].i_FI_IP))
#line 909
  #line 905 "filter/f-inst.c"

#line 905
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 909 "filter/f-inst.c"
#undef item
#line 909
  dest->items[pos].fi_code = what->fi_code;
#line 909
  dest->items[pos].lineno = what->lineno;
#line 909
  break;
#line 909
}
#line 909

#line 916 "filter/f-inst.c"
 /* Linearize for FI_ROUTE_DISTINGUISHER */
#line 916
case FI_ROUTE_DISTINGUISHER: {
#line 916
#define whati (&(what->i_FI_ROUTE_DISTINGUISHER))
#line 916
#define item (&(dest->items[pos].i_FI_ROUTE_DISTINGUISHER))
#line 916
  #line 910 "filter/f-inst.c"

#line 910
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 916 "filter/f-inst.c"
#undef item
#line 916
  dest->items[pos].fi_code = what->fi_code;
#line 916
  dest->items[pos].lineno = what->lineno;
#line 916
  break;
#line 916
}
#line 916

#line 923 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_FIRST */
#line 923
case FI_AS_PATH_FIRST: {
#line 923
#define whati (&(what->i_FI_AS_PATH_FIRST))
#line 923
#define item (&(dest->items[pos].i_FI_AS_PATH_FIRST))
#line 923
  #line 917 "filter/f-inst.c"

#line 917
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 923 "filter/f-inst.c"
#undef item
#line 923
  dest->items[pos].fi_code = what->fi_code;
#line 923
  dest->items[pos].lineno = what->lineno;
#line 923
  break;
#line 923
}
#line 923

#line 930 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_LAST */
#line 930
case FI_AS_PATH_LAST: {
#line 930
#define whati (&(what->i_FI_AS_PATH_LAST))
#line 930
#define item (&(dest->items[pos].i_FI_AS_PATH_LAST))
#line 930
  #line 924 "filter/f-inst.c"

#line 924
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 930 "filter/f-inst.c"
#undef item
#line 930
  dest->items[pos].fi_code = what->fi_code;
#line 930
  dest->items[pos].lineno = what->lineno;
#line 930
  break;
#line 930
}
#line 930

#line 935 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_LAST_NAG */
#line 935
case FI_AS_PATH_LAST_NAG: {
#line 935
#define whati (&(what->i_FI_AS_PATH_LAST_NAG))
#line 935
#define item (&(dest->items[pos].i_FI_AS_PATH_LAST_NAG))
#line 935
  #line 931 "filter/f-inst.c"

#line 931
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 935 "filter/f-inst.c"
#undef item
#line 935
  dest->items[pos].fi_code = what->fi_code;
#line 935
  dest->items[pos].lineno = what->lineno;
#line 935
  break;
#line 935
}
#line 935

#line 961 "filter/f-inst.c"
 /* Linearize for FI_RETURN */
#line 961
case FI_RETURN: {
#line 961
#define whati (&(what->i_FI_RETURN))
#line 961
#define item (&(dest->items[pos].i_FI_RETURN))
#line 961
  #line 938 "filter/f-inst.c"

#line 938
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 961 "filter/f-inst.c"
#undef item
#line 961
  dest->items[pos].fi_code = what->fi_code;
#line 961
  dest->items[pos].lineno = what->lineno;
#line 961
  break;
#line 961
}
#line 961

#line 991 "filter/f-inst.c"
 /* Linearize for FI_CALL */
#line 991
case FI_CALL: {
#line 991
#define whati (&(what->i_FI_CALL))
#line 991
#define item (&(dest->items[pos].i_FI_CALL))
#line 991
  #line 963 "filter/f-inst.c"
item->sym = whati->sym;
#line 963

#undef whati
#line 991 "filter/f-inst.c"
#undef item
#line 991
  dest->items[pos].fi_code = what->fi_code;
#line 991
  dest->items[pos].lineno = what->lineno;
#line 991
  break;
#line 991
}
#line 991

#line 996 "filter/f-inst.c"
 /* Linearize for FI_DROP_RESULT */
#line 996
case FI_DROP_RESULT: {
#line 996
#define whati (&(what->i_FI_DROP_RESULT))
#line 996
#define item (&(dest->items[pos].i_FI_DROP_RESULT))
#line 996
  #line 993 "filter/f-inst.c"

#line 993
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 996 "filter/f-inst.c"
#undef item
#line 996
  dest->items[pos].fi_code = what->fi_code;
#line 996
  dest->items[pos].lineno = what->lineno;
#line 996
  break;
#line 996
}
#line 996

#line 1019 "filter/f-inst.c"
 /* Linearize for FI_SWITCH */
#line 1019
case FI_SWITCH: {
#line 1019
#define whati (&(what->i_FI_SWITCH))
#line 1019
#define item (&(dest->items[pos].i_FI_SWITCH))
#line 1019
  #line 997 "filter/f-inst.c"

#line 997
pos = linearize(dest, whati->f1, pos);
#line 999 "filter/f-inst.c"
item->tree = whati->tree;
#line 999

#undef whati
#line 1019 "filter/f-inst.c"
#undef item
#line 1019
  dest->items[pos].fi_code = what->fi_code;
#line 1019
  dest->items[pos].lineno = what->lineno;
#line 1019
  break;
#line 1019
}
#line 1019

#line 1027 "filter/f-inst.c"
 /* Linearize for FI_IP_MASK */
#line 1027
case FI_IP_MASK: {
#line 1027
#define whati (&(what->i_FI_IP_MASK))
#line 1027
#define item (&(dest->items[pos].i_FI_IP_MASK))
#line 1027
  #line 1020 "filter/f-inst.c"

#line 1020
pos = linearize(dest, whati->f1, pos);
#line 1021 "filter/f-inst.c"

#line 1021
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1027 "filter/f-inst.c"
#undef item
#line 1027
  dest->items[pos].fi_code = what->fi_code;
#line 1027
  dest->items[pos].lineno = what->lineno;
#line 1027
  break;
#line 1027
}
#line 1027

#line 1033 "filter/f-inst.c"
 /* Linearize for FI_PATH_PREPEND */
#line 1033
case FI_PATH_PREPEND: {
#line 1033
#define whati (&(what->i_FI_PATH_PREPEND))
#line 1033
#define item (&(dest->items[pos].i_FI_PATH_PREPEND))
#line 1033
  #line 1028 "filter/f-inst.c"

#line 1028
pos = linearize(dest, whati->f1, pos);
#line 1029 "filter/f-inst.c"

#line 1029
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1033 "filter/f-inst.c"
#undef item
#line 1033
  dest->items[pos].fi_code = what->fi_code;
#line 1033
  dest->items[pos].lineno = what->lineno;
#line 1033
  break;
#line 1033
}
#line 1033

#line 1090 "filter/f-inst.c"
 /* Linearize for FI_CLIST_ADD */
#line 1090
case FI_CLIST_ADD: {
#line 1090
#define whati (&(what->i_FI_CLIST_ADD))
#line 1090
#define item (&(dest->items[pos].i_FI_CLIST_ADD))
#line 1090
  #line 1034 "filter/f-inst.c"

#line 1034
pos = linearize(dest, whati->f1, pos);
#line 1035 "filter/f-inst.c"

#line 1035
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1090 "filter/f-inst.c"
#undef item
#line 1090
  dest->items[pos].fi_code = what->fi_code;
#line 1090
  dest->items[pos].lineno = what->lineno;
#line 1090
  break;
#line 1090
}
#line 1090

#line 1152 "filter/f-inst.c"
 /* Linearize for FI_CLIST_DEL */
#line 1152
case FI_CLIST_DEL: {
#line 1152
#define whati (&(what->i_FI_CLIST_DEL))
#line 1152
#define item (&(dest->items[pos].i_FI_CLIST_DEL))
#line 1152
  #line 1091 "filter/f-inst.c"

#line 1091
pos = linearize(dest, whati->f1, pos);
#line 1092 "filter/f-inst.c"

#line 1092
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1152 "filter/f-inst.c"
#undef item
#line 1152
  dest->items[pos].fi_code = what->fi_code;
#line 1152
  dest->items[pos].lineno = what->lineno;
#line 1152
  break;
#line 1152
}
#line 1152

#line 1200 "filter/f-inst.c"
 /* Linearize for FI_CLIST_FILTER */
#line 1200
case FI_CLIST_FILTER: {
#line 1200
#define whati (&(what->i_FI_CLIST_FILTER))
#line 1200
#define item (&(dest->items[pos].i_FI_CLIST_FILTER))
#line 1200
  #line 1153 "filter/f-inst.c"

#line 1153
pos = linearize(dest, whati->f1, pos);
#line 1154 "filter/f-inst.c"

#line 1154
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1200 "filter/f-inst.c"
#undef item
#line 1200
  dest->items[pos].fi_code = what->fi_code;
#line 1200
  dest->items[pos].lineno = what->lineno;
#line 1200
  break;
#line 1200
}
#line 1200

#line 1230 "filter/f-inst.c"
 /* Linearize for FI_ROA_CHECK_IMPLICIT */
#line 1230
case FI_ROA_CHECK_IMPLICIT: {
#line 1230
#define whati (&(what->i_FI_ROA_CHECK_IMPLICIT))
#line 1230
#define item (&(dest->items[pos].i_FI_ROA_CHECK_IMPLICIT))
#line 1230
  #line 1202 "filter/f-inst.c"
item->rtc = whati->rtc;
#line 1202

#undef whati
#line 1230 "filter/f-inst.c"
#undef item
#line 1230
  dest->items[pos].fi_code = what->fi_code;
#line 1230
  dest->items[pos].lineno = what->lineno;
#line 1230
  break;
#line 1230
}
#line 1230

#line 1252 "filter/f-inst.c"
 /* Linearize for FI_ROA_CHECK_EXPLICIT */
#line 1252
case FI_ROA_CHECK_EXPLICIT: {
#line 1252
#define whati (&(what->i_FI_ROA_CHECK_EXPLICIT))
#line 1252
#define item (&(dest->items[pos].i_FI_ROA_CHECK_EXPLICIT))
#line 1252
  #line 1232 "filter/f-inst.c"

#line 1232
pos = linearize(dest, whati->f1, pos);
#line 1233 "filter/f-inst.c"

#line 1233
pos = linearize(dest, whati->f2, pos);
#line 1234 "filter/f-inst.c"
item->rtc = whati->rtc;
#line 1234

#undef whati
#line 1252 "filter/f-inst.c"
#undef item
#line 1252
  dest->items[pos].fi_code = what->fi_code;
#line 1252
  dest->items[pos].lineno = what->lineno;
#line 1252
  break;
#line 1252
}
#line 1252

#line 1257 "filter/f-inst.c"
 /* Linearize for FI_FORMAT */
#line 1257
case FI_FORMAT: {
#line 1257
#define whati (&(what->i_FI_FORMAT))
#line 1257
#define item (&(dest->items[pos].i_FI_FORMAT))
#line 1257
  #line 1253 "filter/f-inst.c"

#line 1253
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 1257 "filter/f-inst.c"
#undef item
#line 1257
  dest->items[pos].fi_code = what->fi_code;
#line 1257
  dest->items[pos].lineno = what->lineno;
#line 1257
  break;
#line 1257
}
#line 1257

#line 668 "filter/decl.m4"
 /* Linearize for FI_ASSERT */
#line 668
case FI_ASSERT: {
#line 668
#define whati (&(what->i_FI_ASSERT))
#line 668
#define item (&(dest->items[pos].i_FI_ASSERT))
#line 668
  #line 1259 "filter/f-inst.c"

#line 1259
pos = linearize(dest, whati->f1, pos);
#line 1261 "filter/f-inst.c"
item->s = whati->s;
#line 1261

#undef whati
#line 668 "filter/decl.m4"
#undef item
#line 668
  dest->items[pos].fi_code = what->fi_code;
#line 668
  dest->items[pos].lineno = what->lineno;
#line 668
  break;
#line 668
}
#line 668

#line 545 "filter/decl.m4"

    }
    pos++;
  }
  return pos;
}

struct f_line *
f_linearize_concat(const struct f_inst * const inst[], uint count)
{
  uint len = 0;
  for (uint i=0; i<count; i++)
    for (const struct f_inst *what = inst[i]; what; what = what->next)
      len += what->size;

  struct f_line *out = cfg_allocz(sizeof(struct f_line) + sizeof(struct f_line_item)*len);

  for (uint i=0; i<count; i++)
    out->len = linearize(out, inst[i], out->len);

#ifdef LOCAL_DEBUG
  f_dump_line(out, 0);
#endif
  return out;
}

/* Filter line comparison */
int
f_same(const struct f_line *fl1, const struct f_line *fl2)
{
  if ((!fl1) && (!fl2))
    return 1;
  if ((!fl1) || (!fl2))
    return 0;
  if (fl1->len != fl2->len)
    return 0;
  for (uint i=0; i<fl1->len; i++) {
#define f1_ (&(fl1->items[i]))
#define f2_ (&(fl2->items[i]))
    if (f1_->fi_code != f2_->fi_code)
      return 0;
    if (f1_->flags != f2_->flags)
      return 0;

    switch(f1_->fi_code) {
#line 227 "filter/f-inst.c"
 /* Comparison for FI_ADD */
#line 227
case FI_ADD:
#line 227
#define f1 (&(f1_->i_FI_ADD))
#line 227
#define f2 (&(f2_->i_FI_ADD))
#line 227
#undef f1
#line 227
#undef f2
#line 227
break;
#line 227

#line 232 "filter/f-inst.c"
 /* Comparison for FI_SUBTRACT */
#line 232
case FI_SUBTRACT:
#line 232
#define f1 (&(f1_->i_FI_SUBTRACT))
#line 232
#define f2 (&(f2_->i_FI_SUBTRACT))
#line 232
#undef f1
#line 232
#undef f2
#line 232
break;
#line 232

#line 237 "filter/f-inst.c"
 /* Comparison for FI_MULTIPLY */
#line 237
case FI_MULTIPLY:
#line 237
#define f1 (&(f1_->i_FI_MULTIPLY))
#line 237
#define f2 (&(f2_->i_FI_MULTIPLY))
#line 237
#undef f1
#line 237
#undef f2
#line 237
break;
#line 237

#line 243 "filter/f-inst.c"
 /* Comparison for FI_DIVIDE */
#line 243
case FI_DIVIDE:
#line 243
#define f1 (&(f1_->i_FI_DIVIDE))
#line 243
#define f2 (&(f2_->i_FI_DIVIDE))
#line 243
#undef f1
#line 243
#undef f2
#line 243
break;
#line 243

#line 253 "filter/f-inst.c"
 /* Comparison for FI_AND */
#line 253
case FI_AND:
#line 253
#define f1 (&(f1_->i_FI_AND))
#line 253
#define f2 (&(f2_->i_FI_AND))
#line 249 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 253 "filter/f-inst.c"
#undef f1
#line 253
#undef f2
#line 253
break;
#line 253

#line 264 "filter/f-inst.c"
 /* Comparison for FI_OR */
#line 264
case FI_OR:
#line 264
#define f1 (&(f1_->i_FI_OR))
#line 264
#define f2 (&(f2_->i_FI_OR))
#line 259 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 264 "filter/f-inst.c"
#undef f1
#line 264
#undef f2
#line 264
break;
#line 264

#line 274 "filter/f-inst.c"
 /* Comparison for FI_PAIR_CONSTRUCT */
#line 274
case FI_PAIR_CONSTRUCT:
#line 274
#define f1 (&(f1_->i_FI_PAIR_CONSTRUCT))
#line 274
#define f2 (&(f2_->i_FI_PAIR_CONSTRUCT))
#line 274
#undef f1
#line 274
#undef f2
#line 274
break;
#line 274

#line 314 "filter/f-inst.c"
 /* Comparison for FI_EC_CONSTRUCT */
#line 314
case FI_EC_CONSTRUCT:
#line 314
#define f1 (&(f1_->i_FI_EC_CONSTRUCT))
#line 314
#define f2 (&(f2_->i_FI_EC_CONSTRUCT))
#line 278 "filter/f-inst.c"
if (f1->ecs != f2->ecs) return 0;
#line 278

#line 278

#line 314 "filter/f-inst.c"
#undef f1
#line 314
#undef f2
#line 314
break;
#line 314

#line 321 "filter/f-inst.c"
 /* Comparison for FI_LC_CONSTRUCT */
#line 321
case FI_LC_CONSTRUCT:
#line 321
#define f1 (&(f1_->i_FI_LC_CONSTRUCT))
#line 321
#define f2 (&(f2_->i_FI_LC_CONSTRUCT))
#line 321
#undef f1
#line 321
#undef f2
#line 321
break;
#line 321

#line 371 "filter/f-inst.c"
 /* Comparison for FI_PATHMASK_CONSTRUCT */
#line 371
case FI_PATHMASK_CONSTRUCT:
#line 371
#define f1 (&(f1_->i_FI_PATHMASK_CONSTRUCT))
#line 371
#define f2 (&(f2_->i_FI_PATHMASK_CONSTRUCT))
#line 322 "filter/f-inst.c"
  if (f1->varcount != f2->varcount) return 0;
#line 371 "filter/f-inst.c"
#undef f1
#line 371
#undef f2
#line 371
break;
#line 371

#line 377 "filter/f-inst.c"
 /* Comparison for FI_NEQ */
#line 377
case FI_NEQ:
#line 377
#define f1 (&(f1_->i_FI_NEQ))
#line 377
#define f2 (&(f2_->i_FI_NEQ))
#line 377
#undef f1
#line 377
#undef f2
#line 377
break;
#line 377

#line 383 "filter/f-inst.c"
 /* Comparison for FI_EQ */
#line 383
case FI_EQ:
#line 383
#define f1 (&(f1_->i_FI_EQ))
#line 383
#define f2 (&(f2_->i_FI_EQ))
#line 383
#undef f1
#line 383
#undef f2
#line 383
break;
#line 383

#line 394 "filter/f-inst.c"
 /* Comparison for FI_LT */
#line 394
case FI_LT:
#line 394
#define f1 (&(f1_->i_FI_LT))
#line 394
#define f2 (&(f2_->i_FI_LT))
#line 394
#undef f1
#line 394
#undef f2
#line 394
break;
#line 394

#line 405 "filter/f-inst.c"
 /* Comparison for FI_LTE */
#line 405
case FI_LTE:
#line 405
#define f1 (&(f1_->i_FI_LTE))
#line 405
#define f2 (&(f2_->i_FI_LTE))
#line 405
#undef f1
#line 405
#undef f2
#line 405
break;
#line 405

#line 410 "filter/f-inst.c"
 /* Comparison for FI_NOT */
#line 410
case FI_NOT:
#line 410
#define f1 (&(f1_->i_FI_NOT))
#line 410
#define f2 (&(f2_->i_FI_NOT))
#line 410
#undef f1
#line 410
#undef f2
#line 410
break;
#line 410

#line 419 "filter/f-inst.c"
 /* Comparison for FI_MATCH */
#line 419
case FI_MATCH:
#line 419
#define f1 (&(f1_->i_FI_MATCH))
#line 419
#define f2 (&(f2_->i_FI_MATCH))
#line 419
#undef f1
#line 419
#undef f2
#line 419
break;
#line 419

#line 428 "filter/f-inst.c"
 /* Comparison for FI_NOT_MATCH */
#line 428
case FI_NOT_MATCH:
#line 428
#define f1 (&(f1_->i_FI_NOT_MATCH))
#line 428
#define f2 (&(f2_->i_FI_NOT_MATCH))
#line 428
#undef f1
#line 428
#undef f2
#line 428
break;
#line 428

#line 433 "filter/f-inst.c"
 /* Comparison for FI_DEFINED */
#line 433
case FI_DEFINED:
#line 433
#define f1 (&(f1_->i_FI_DEFINED))
#line 433
#define f2 (&(f2_->i_FI_DEFINED))
#line 433
#undef f1
#line 433
#undef f2
#line 433
break;
#line 433

#line 445 "filter/f-inst.c"
 /* Comparison for FI_TYPE */
#line 445
case FI_TYPE:
#line 445
#define f1 (&(f1_->i_FI_TYPE))
#line 445
#define f2 (&(f2_->i_FI_TYPE))
#line 445
#undef f1
#line 445
#undef f2
#line 445
break;
#line 445

#line 451 "filter/f-inst.c"
 /* Comparison for FI_IS_V4 */
#line 451
case FI_IS_V4:
#line 451
#define f1 (&(f1_->i_FI_IS_V4))
#line 451
#define f2 (&(f2_->i_FI_IS_V4))
#line 451
#undef f1
#line 451
#undef f2
#line 451
break;
#line 451

#line 460 "filter/f-inst.c"
 /* Comparison for FI_VAR_SET */
#line 460
case FI_VAR_SET:
#line 460
#define f1 (&(f1_->i_FI_VAR_SET))
#line 460
#define f2 (&(f2_->i_FI_VAR_SET))
#line 454 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 454

#line 454

#line 460 "filter/f-inst.c"
#undef f1
#line 460
#undef f2
#line 460
break;
#line 460

#line 467 "filter/f-inst.c"
 /* Comparison for FI_VAR_GET */
#line 467
case FI_VAR_GET:
#line 467
#define f1 (&(f1_->i_FI_VAR_GET))
#line 467
#define f2 (&(f2_->i_FI_VAR_GET))
#line 461 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 461

#line 461

#line 467 "filter/f-inst.c"
#undef f1
#line 467
#undef f2
#line 467
break;
#line 467

#line 480 "filter/f-inst.c"
 /* Comparison for FI_CONSTANT */
#line 480
case FI_CONSTANT:
#line 480
#define f1 (&(f1_->i_FI_CONSTANT))
#line 480
#define f2 (&(f2_->i_FI_CONSTANT))
#line 468 "filter/f-inst.c"
if ( !val_same(&(f1->val), &(f2->val)) ) return 0;
#line 468

#line 468

#line 480 "filter/f-inst.c"
#undef f1
#line 480
#undef f2
#line 480
break;
#line 480

#line 488 "filter/f-inst.c"
 /* Comparison for FI_CONDITION */
#line 488
case FI_CONDITION:
#line 488
#define f1 (&(f1_->i_FI_CONDITION))
#line 488
#define f2 (&(f2_->i_FI_CONDITION))
#line 483 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 485 "filter/f-inst.c"
if (!f_same(f1->fl3, f2->fl3)) return 0;
#line 488 "filter/f-inst.c"
#undef f1
#line 488
#undef f2
#line 488
break;
#line 488

#line 497 "filter/f-inst.c"
 /* Comparison for FI_PRINT */
#line 497
case FI_PRINT:
#line 497
#define f1 (&(f1_->i_FI_PRINT))
#line 497
#define f2 (&(f2_->i_FI_PRINT))
#line 490 "filter/f-inst.c"
  if (f1->varcount != f2->varcount) return 0;
#line 497 "filter/f-inst.c"
#undef f1
#line 497
#undef f2
#line 497
break;
#line 497

#line 504 "filter/f-inst.c"
 /* Comparison for FI_FLUSH */
#line 504
case FI_FLUSH:
#line 504
#define f1 (&(f1_->i_FI_FLUSH))
#line 504
#define f2 (&(f2_->i_FI_FLUSH))
#line 504
#undef f1
#line 504
#undef f2
#line 504
break;
#line 504

#line 518 "filter/f-inst.c"
 /* Comparison for FI_DIE */
#line 518
case FI_DIE:
#line 518
#define f1 (&(f1_->i_FI_DIE))
#line 518
#define f2 (&(f2_->i_FI_DIE))
#line 506 "filter/f-inst.c"
if (f1->fret != f2->fret) return 0;
#line 506

#line 506

#line 518 "filter/f-inst.c"
#undef f1
#line 518
#undef f2
#line 518
break;
#line 518

#line 543 "filter/f-inst.c"
 /* Comparison for FI_RTA_GET */
#line 543
case FI_RTA_GET:
#line 543
#define f1 (&(f1_->i_FI_RTA_GET))
#line 543
#define f2 (&(f2_->i_FI_RTA_GET))
#line 520 "filter/f-inst.c"
if (f1->sa.sa_code != f2->sa.sa_code) return 0;
#line 520

#line 520

#line 543 "filter/f-inst.c"
#undef f1
#line 543
#undef f2
#line 543
break;
#line 543

#line 627 "filter/f-inst.c"
 /* Comparison for FI_RTA_SET */
#line 627
case FI_RTA_SET:
#line 627
#define f1 (&(f1_->i_FI_RTA_SET))
#line 627
#define f2 (&(f2_->i_FI_RTA_SET))
#line 546 "filter/f-inst.c"
if (f1->sa.sa_code != f2->sa.sa_code) return 0;
#line 546

#line 546

#line 627 "filter/f-inst.c"
#undef f1
#line 627
#undef f2
#line 627
break;
#line 627

#line 702 "filter/f-inst.c"
 /* Comparison for FI_EA_GET */
#line 702
case FI_EA_GET:
#line 702
#define f1 (&(f1_->i_FI_EA_GET))
#line 702
#define f2 (&(f2_->i_FI_EA_GET))
#line 628 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 628

#line 628

#line 702 "filter/f-inst.c"
#undef f1
#line 702
#undef f2
#line 702
break;
#line 702

#line 766 "filter/f-inst.c"
 /* Comparison for FI_EA_SET */
#line 766
case FI_EA_SET:
#line 766
#define f1 (&(f1_->i_FI_EA_SET))
#line 766
#define f2 (&(f2_->i_FI_EA_SET))
#line 706 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 706

#line 706

#line 766 "filter/f-inst.c"
#undef f1
#line 766
#undef f2
#line 766
break;
#line 766

#line 788 "filter/f-inst.c"
 /* Comparison for FI_EA_UNSET */
#line 788
case FI_EA_UNSET:
#line 788
#define f1 (&(f1_->i_FI_EA_UNSET))
#line 788
#define f2 (&(f2_->i_FI_EA_UNSET))
#line 767 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 767

#line 767

#line 788 "filter/f-inst.c"
#undef f1
#line 788
#undef f2
#line 788
break;
#line 788

#line 793 "filter/f-inst.c"
 /* Comparison for FI_PREF_GET */
#line 793
case FI_PREF_GET:
#line 793
#define f1 (&(f1_->i_FI_PREF_GET))
#line 793
#define f2 (&(f2_->i_FI_PREF_GET))
#line 793
#undef f1
#line 793
#undef f2
#line 793
break;
#line 793

#line 802 "filter/f-inst.c"
 /* Comparison for FI_PREF_SET */
#line 802
case FI_PREF_SET:
#line 802
#define f1 (&(f1_->i_FI_PREF_SET))
#line 802
#define f2 (&(f2_->i_FI_PREF_SET))
#line 802
#undef f1
#line 802
#undef f2
#line 802
break;
#line 802

#line 814 "filter/f-inst.c"
 /* Comparison for FI_LENGTH */
#line 814
case FI_LENGTH:
#line 814
#define f1 (&(f1_->i_FI_LENGTH))
#line 814
#define f2 (&(f2_->i_FI_LENGTH))
#line 814
#undef f1
#line 814
#undef f2
#line 814
break;
#line 814

#line 849 "filter/f-inst.c"
 /* Comparison for FI_NET_SRC */
#line 849
case FI_NET_SRC:
#line 849
#define f1 (&(f1_->i_FI_NET_SRC))
#line 849
#define f2 (&(f2_->i_FI_NET_SRC))
#line 849
#undef f1
#line 849
#undef f2
#line 849
break;
#line 849

#line 884 "filter/f-inst.c"
 /* Comparison for FI_NET_DST */
#line 884
case FI_NET_DST:
#line 884
#define f1 (&(f1_->i_FI_NET_DST))
#line 884
#define f2 (&(f2_->i_FI_NET_DST))
#line 884
#undef f1
#line 884
#undef f2
#line 884
break;
#line 884

#line 894 "filter/f-inst.c"
 /* Comparison for FI_ROA_MAXLEN */
#line 894
case FI_ROA_MAXLEN:
#line 894
#define f1 (&(f1_->i_FI_ROA_MAXLEN))
#line 894
#define f2 (&(f2_->i_FI_ROA_MAXLEN))
#line 894
#undef f1
#line 894
#undef f2
#line 894
break;
#line 894

#line 904 "filter/f-inst.c"
 /* Comparison for FI_ROA_ASN */
#line 904
case FI_ROA_ASN:
#line 904
#define f1 (&(f1_->i_FI_ROA_ASN))
#line 904
#define f2 (&(f2_->i_FI_ROA_ASN))
#line 904
#undef f1
#line 904
#undef f2
#line 904
break;
#line 904

#line 909 "filter/f-inst.c"
 /* Comparison for FI_IP */
#line 909
case FI_IP:
#line 909
#define f1 (&(f1_->i_FI_IP))
#line 909
#define f2 (&(f2_->i_FI_IP))
#line 909
#undef f1
#line 909
#undef f2
#line 909
break;
#line 909

#line 916 "filter/f-inst.c"
 /* Comparison for FI_ROUTE_DISTINGUISHER */
#line 916
case FI_ROUTE_DISTINGUISHER:
#line 916
#define f1 (&(f1_->i_FI_ROUTE_DISTINGUISHER))
#line 916
#define f2 (&(f2_->i_FI_ROUTE_DISTINGUISHER))
#line 916
#undef f1
#line 916
#undef f2
#line 916
break;
#line 916

#line 923 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_FIRST */
#line 923
case FI_AS_PATH_FIRST:
#line 923
#define f1 (&(f1_->i_FI_AS_PATH_FIRST))
#line 923
#define f2 (&(f2_->i_FI_AS_PATH_FIRST))
#line 923
#undef f1
#line 923
#undef f2
#line 923
break;
#line 923

#line 930 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_LAST */
#line 930
case FI_AS_PATH_LAST:
#line 930
#define f1 (&(f1_->i_FI_AS_PATH_LAST))
#line 930
#define f2 (&(f2_->i_FI_AS_PATH_LAST))
#line 930
#undef f1
#line 930
#undef f2
#line 930
break;
#line 930

#line 935 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_LAST_NAG */
#line 935
case FI_AS_PATH_LAST_NAG:
#line 935
#define f1 (&(f1_->i_FI_AS_PATH_LAST_NAG))
#line 935
#define f2 (&(f2_->i_FI_AS_PATH_LAST_NAG))
#line 935
#undef f1
#line 935
#undef f2
#line 935
break;
#line 935

#line 961 "filter/f-inst.c"
 /* Comparison for FI_RETURN */
#line 961
case FI_RETURN:
#line 961
#define f1 (&(f1_->i_FI_RETURN))
#line 961
#define f2 (&(f2_->i_FI_RETURN))
#line 961
#undef f1
#line 961
#undef f2
#line 961
break;
#line 961

#line 991 "filter/f-inst.c"
 /* Comparison for FI_CALL */
#line 991
case FI_CALL:
#line 991
#define f1 (&(f1_->i_FI_CALL))
#line 991
#define f2 (&(f2_->i_FI_CALL))
#line 963 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 963

#line 963


#line 966 "filter/f-inst.c"
      if (!(f1->sym->flags & SYM_FLAG_SAME))
	return 0;

    #line 991 "filter/f-inst.c"
#undef f1
#line 991
#undef f2
#line 991
break;
#line 991

#line 996 "filter/f-inst.c"
 /* Comparison for FI_DROP_RESULT */
#line 996
case FI_DROP_RESULT:
#line 996
#define f1 (&(f1_->i_FI_DROP_RESULT))
#line 996
#define f2 (&(f2_->i_FI_DROP_RESULT))
#line 996
#undef f1
#line 996
#undef f2
#line 996
break;
#line 996

#line 1019 "filter/f-inst.c"
 /* Comparison for FI_SWITCH */
#line 1019
case FI_SWITCH:
#line 1019
#define f1 (&(f1_->i_FI_SWITCH))
#line 1019
#define f2 (&(f2_->i_FI_SWITCH))
#line 999 "filter/f-inst.c"
if (!same_tree(f1->tree, f2->tree)) return 0;
#line 999

#line 999

#line 1019 "filter/f-inst.c"
#undef f1
#line 1019
#undef f2
#line 1019
break;
#line 1019

#line 1027 "filter/f-inst.c"
 /* Comparison for FI_IP_MASK */
#line 1027
case FI_IP_MASK:
#line 1027
#define f1 (&(f1_->i_FI_IP_MASK))
#line 1027
#define f2 (&(f2_->i_FI_IP_MASK))
#line 1027
#undef f1
#line 1027
#undef f2
#line 1027
break;
#line 1027

#line 1033 "filter/f-inst.c"
 /* Comparison for FI_PATH_PREPEND */
#line 1033
case FI_PATH_PREPEND:
#line 1033
#define f1 (&(f1_->i_FI_PATH_PREPEND))
#line 1033
#define f2 (&(f2_->i_FI_PATH_PREPEND))
#line 1033
#undef f1
#line 1033
#undef f2
#line 1033
break;
#line 1033

#line 1090 "filter/f-inst.c"
 /* Comparison for FI_CLIST_ADD */
#line 1090
case FI_CLIST_ADD:
#line 1090
#define f1 (&(f1_->i_FI_CLIST_ADD))
#line 1090
#define f2 (&(f2_->i_FI_CLIST_ADD))
#line 1090
#undef f1
#line 1090
#undef f2
#line 1090
break;
#line 1090

#line 1152 "filter/f-inst.c"
 /* Comparison for FI_CLIST_DEL */
#line 1152
case FI_CLIST_DEL:
#line 1152
#define f1 (&(f1_->i_FI_CLIST_DEL))
#line 1152
#define f2 (&(f2_->i_FI_CLIST_DEL))
#line 1152
#undef f1
#line 1152
#undef f2
#line 1152
break;
#line 1152

#line 1200 "filter/f-inst.c"
 /* Comparison for FI_CLIST_FILTER */
#line 1200
case FI_CLIST_FILTER:
#line 1200
#define f1 (&(f1_->i_FI_CLIST_FILTER))
#line 1200
#define f2 (&(f2_->i_FI_CLIST_FILTER))
#line 1200
#undef f1
#line 1200
#undef f2
#line 1200
break;
#line 1200

#line 1230 "filter/f-inst.c"
 /* Comparison for FI_ROA_CHECK_IMPLICIT */
#line 1230
case FI_ROA_CHECK_IMPLICIT:
#line 1230
#define f1 (&(f1_->i_FI_ROA_CHECK_IMPLICIT))
#line 1230
#define f2 (&(f2_->i_FI_ROA_CHECK_IMPLICIT))
#line 1202 "filter/f-inst.c"
if (strcmp(f1->rtc->name, f2->rtc->name)) return 0;
#line 1202

#line 1202

#line 1230 "filter/f-inst.c"
#undef f1
#line 1230
#undef f2
#line 1230
break;
#line 1230

#line 1252 "filter/f-inst.c"
 /* Comparison for FI_ROA_CHECK_EXPLICIT */
#line 1252
case FI_ROA_CHECK_EXPLICIT:
#line 1252
#define f1 (&(f1_->i_FI_ROA_CHECK_EXPLICIT))
#line 1252
#define f2 (&(f2_->i_FI_ROA_CHECK_EXPLICIT))
#line 1234 "filter/f-inst.c"
if (strcmp(f1->rtc->name, f2->rtc->name)) return 0;
#line 1234

#line 1234

#line 1252 "filter/f-inst.c"
#undef f1
#line 1252
#undef f2
#line 1252
break;
#line 1252

#line 1257 "filter/f-inst.c"
 /* Comparison for FI_FORMAT */
#line 1257
case FI_FORMAT:
#line 1257
#define f1 (&(f1_->i_FI_FORMAT))
#line 1257
#define f2 (&(f2_->i_FI_FORMAT))
#line 1257
#undef f1
#line 1257
#undef f2
#line 1257
break;
#line 1257

#line 668 "filter/decl.m4"
 /* Comparison for FI_ASSERT */
#line 668
case FI_ASSERT:
#line 668
#define f1 (&(f1_->i_FI_ASSERT))
#line 668
#define f2 (&(f2_->i_FI_ASSERT))
#line 1261 "filter/f-inst.c"
if (strcmp(f1->s, f2->s)) return 0;
#line 1261

#line 1261

#line 668 "filter/decl.m4"
#undef f1
#line 668
#undef f2
#line 668
break;
#line 668

#line 590 "filter/decl.m4"

    }
  }
#undef f1_
#undef f2_
  return 1;
}


/* Part of FI_SWITCH filter iterator */
static void
f_add_tree_lines(const struct f_tree *t, void *fit_)
{
  struct filter_iterator * fit = fit_;

  if (t->data)
    BUFFER_PUSH(fit->lines) = t->data;
}

/* Filter line iterator */
void
f_add_lines(const struct f_line_item *what, struct filter_iterator *fit)
{
  switch(what->fi_code) {
#line 227 "filter/f-inst.c"
 /* Iteration for FI_ADD */
#line 227
case FI_ADD:
#line 227
#define whati (&(what->i_FI_ADD))
#line 227
#undef whati
#line 227
break;
#line 227

#line 232 "filter/f-inst.c"
 /* Iteration for FI_SUBTRACT */
#line 232
case FI_SUBTRACT:
#line 232
#define whati (&(what->i_FI_SUBTRACT))
#line 232
#undef whati
#line 232
break;
#line 232

#line 237 "filter/f-inst.c"
 /* Iteration for FI_MULTIPLY */
#line 237
case FI_MULTIPLY:
#line 237
#define whati (&(what->i_FI_MULTIPLY))
#line 237
#undef whati
#line 237
break;
#line 237

#line 243 "filter/f-inst.c"
 /* Iteration for FI_DIVIDE */
#line 243
case FI_DIVIDE:
#line 243
#define whati (&(what->i_FI_DIVIDE))
#line 243
#undef whati
#line 243
break;
#line 243

#line 253 "filter/f-inst.c"
 /* Iteration for FI_AND */
#line 253
case FI_AND:
#line 253
#define whati (&(what->i_FI_AND))
#line 249 "filter/f-inst.c"
if (whati->fl2) BUFFER_PUSH(fit->lines) = whati->fl2;
#line 253 "filter/f-inst.c"
#undef whati
#line 253
break;
#line 253

#line 264 "filter/f-inst.c"
 /* Iteration for FI_OR */
#line 264
case FI_OR:
#line 264
#define whati (&(what->i_FI_OR))
#line 259 "filter/f-inst.c"
if (whati->fl2) BUFFER_PUSH(fit->lines) = whati->fl2;
#line 264 "filter/f-inst.c"
#undef whati
#line 264
break;
#line 264

#line 274 "filter/f-inst.c"
 /* Iteration for FI_PAIR_CONSTRUCT */
#line 274
case FI_PAIR_CONSTRUCT:
#line 274
#define whati (&(what->i_FI_PAIR_CONSTRUCT))
#line 274
#undef whati
#line 274
break;
#line 274

#line 314 "filter/f-inst.c"
 /* Iteration for FI_EC_CONSTRUCT */
#line 314
case FI_EC_CONSTRUCT:
#line 314
#define whati (&(what->i_FI_EC_CONSTRUCT))
#line 314
#undef whati
#line 314
break;
#line 314

#line 321 "filter/f-inst.c"
 /* Iteration for FI_LC_CONSTRUCT */
#line 321
case FI_LC_CONSTRUCT:
#line 321
#define whati (&(what->i_FI_LC_CONSTRUCT))
#line 321
#undef whati
#line 321
break;
#line 321

#line 371 "filter/f-inst.c"
 /* Iteration for FI_PATHMASK_CONSTRUCT */
#line 371
case FI_PATHMASK_CONSTRUCT:
#line 371
#define whati (&(what->i_FI_PATHMASK_CONSTRUCT))
#line 371
#undef whati
#line 371
break;
#line 371

#line 377 "filter/f-inst.c"
 /* Iteration for FI_NEQ */
#line 377
case FI_NEQ:
#line 377
#define whati (&(what->i_FI_NEQ))
#line 377
#undef whati
#line 377
break;
#line 377

#line 383 "filter/f-inst.c"
 /* Iteration for FI_EQ */
#line 383
case FI_EQ:
#line 383
#define whati (&(what->i_FI_EQ))
#line 383
#undef whati
#line 383
break;
#line 383

#line 394 "filter/f-inst.c"
 /* Iteration for FI_LT */
#line 394
case FI_LT:
#line 394
#define whati (&(what->i_FI_LT))
#line 394
#undef whati
#line 394
break;
#line 394

#line 405 "filter/f-inst.c"
 /* Iteration for FI_LTE */
#line 405
case FI_LTE:
#line 405
#define whati (&(what->i_FI_LTE))
#line 405
#undef whati
#line 405
break;
#line 405

#line 410 "filter/f-inst.c"
 /* Iteration for FI_NOT */
#line 410
case FI_NOT:
#line 410
#define whati (&(what->i_FI_NOT))
#line 410
#undef whati
#line 410
break;
#line 410

#line 419 "filter/f-inst.c"
 /* Iteration for FI_MATCH */
#line 419
case FI_MATCH:
#line 419
#define whati (&(what->i_FI_MATCH))
#line 419
#undef whati
#line 419
break;
#line 419

#line 428 "filter/f-inst.c"
 /* Iteration for FI_NOT_MATCH */
#line 428
case FI_NOT_MATCH:
#line 428
#define whati (&(what->i_FI_NOT_MATCH))
#line 428
#undef whati
#line 428
break;
#line 428

#line 433 "filter/f-inst.c"
 /* Iteration for FI_DEFINED */
#line 433
case FI_DEFINED:
#line 433
#define whati (&(what->i_FI_DEFINED))
#line 433
#undef whati
#line 433
break;
#line 433

#line 445 "filter/f-inst.c"
 /* Iteration for FI_TYPE */
#line 445
case FI_TYPE:
#line 445
#define whati (&(what->i_FI_TYPE))
#line 445
#undef whati
#line 445
break;
#line 445

#line 451 "filter/f-inst.c"
 /* Iteration for FI_IS_V4 */
#line 451
case FI_IS_V4:
#line 451
#define whati (&(what->i_FI_IS_V4))
#line 451
#undef whati
#line 451
break;
#line 451

#line 460 "filter/f-inst.c"
 /* Iteration for FI_VAR_SET */
#line 460
case FI_VAR_SET:
#line 460
#define whati (&(what->i_FI_VAR_SET))
#line 460
#undef whati
#line 460
break;
#line 460

#line 467 "filter/f-inst.c"
 /* Iteration for FI_VAR_GET */
#line 467
case FI_VAR_GET:
#line 467
#define whati (&(what->i_FI_VAR_GET))
#line 467
#undef whati
#line 467
break;
#line 467

#line 480 "filter/f-inst.c"
 /* Iteration for FI_CONSTANT */
#line 480
case FI_CONSTANT:
#line 480
#define whati (&(what->i_FI_CONSTANT))
#line 480
#undef whati
#line 480
break;
#line 480

#line 488 "filter/f-inst.c"
 /* Iteration for FI_CONDITION */
#line 488
case FI_CONDITION:
#line 488
#define whati (&(what->i_FI_CONDITION))
#line 483 "filter/f-inst.c"
if (whati->fl2) BUFFER_PUSH(fit->lines) = whati->fl2;
#line 485 "filter/f-inst.c"
if (whati->fl3) BUFFER_PUSH(fit->lines) = whati->fl3;
#line 488 "filter/f-inst.c"
#undef whati
#line 488
break;
#line 488

#line 497 "filter/f-inst.c"
 /* Iteration for FI_PRINT */
#line 497
case FI_PRINT:
#line 497
#define whati (&(what->i_FI_PRINT))
#line 497
#undef whati
#line 497
break;
#line 497

#line 504 "filter/f-inst.c"
 /* Iteration for FI_FLUSH */
#line 504
case FI_FLUSH:
#line 504
#define whati (&(what->i_FI_FLUSH))
#line 504
#undef whati
#line 504
break;
#line 504

#line 518 "filter/f-inst.c"
 /* Iteration for FI_DIE */
#line 518
case FI_DIE:
#line 518
#define whati (&(what->i_FI_DIE))
#line 518
#undef whati
#line 518
break;
#line 518

#line 543 "filter/f-inst.c"
 /* Iteration for FI_RTA_GET */
#line 543
case FI_RTA_GET:
#line 543
#define whati (&(what->i_FI_RTA_GET))
#line 543
#undef whati
#line 543
break;
#line 543

#line 627 "filter/f-inst.c"
 /* Iteration for FI_RTA_SET */
#line 627
case FI_RTA_SET:
#line 627
#define whati (&(what->i_FI_RTA_SET))
#line 627
#undef whati
#line 627
break;
#line 627

#line 702 "filter/f-inst.c"
 /* Iteration for FI_EA_GET */
#line 702
case FI_EA_GET:
#line 702
#define whati (&(what->i_FI_EA_GET))
#line 702
#undef whati
#line 702
break;
#line 702

#line 766 "filter/f-inst.c"
 /* Iteration for FI_EA_SET */
#line 766
case FI_EA_SET:
#line 766
#define whati (&(what->i_FI_EA_SET))
#line 766
#undef whati
#line 766
break;
#line 766

#line 788 "filter/f-inst.c"
 /* Iteration for FI_EA_UNSET */
#line 788
case FI_EA_UNSET:
#line 788
#define whati (&(what->i_FI_EA_UNSET))
#line 788
#undef whati
#line 788
break;
#line 788

#line 793 "filter/f-inst.c"
 /* Iteration for FI_PREF_GET */
#line 793
case FI_PREF_GET:
#line 793
#define whati (&(what->i_FI_PREF_GET))
#line 793
#undef whati
#line 793
break;
#line 793

#line 802 "filter/f-inst.c"
 /* Iteration for FI_PREF_SET */
#line 802
case FI_PREF_SET:
#line 802
#define whati (&(what->i_FI_PREF_SET))
#line 802
#undef whati
#line 802
break;
#line 802

#line 814 "filter/f-inst.c"
 /* Iteration for FI_LENGTH */
#line 814
case FI_LENGTH:
#line 814
#define whati (&(what->i_FI_LENGTH))
#line 814
#undef whati
#line 814
break;
#line 814

#line 849 "filter/f-inst.c"
 /* Iteration for FI_NET_SRC */
#line 849
case FI_NET_SRC:
#line 849
#define whati (&(what->i_FI_NET_SRC))
#line 849
#undef whati
#line 849
break;
#line 849

#line 884 "filter/f-inst.c"
 /* Iteration for FI_NET_DST */
#line 884
case FI_NET_DST:
#line 884
#define whati (&(what->i_FI_NET_DST))
#line 884
#undef whati
#line 884
break;
#line 884

#line 894 "filter/f-inst.c"
 /* Iteration for FI_ROA_MAXLEN */
#line 894
case FI_ROA_MAXLEN:
#line 894
#define whati (&(what->i_FI_ROA_MAXLEN))
#line 894
#undef whati
#line 894
break;
#line 894

#line 904 "filter/f-inst.c"
 /* Iteration for FI_ROA_ASN */
#line 904
case FI_ROA_ASN:
#line 904
#define whati (&(what->i_FI_ROA_ASN))
#line 904
#undef whati
#line 904
break;
#line 904

#line 909 "filter/f-inst.c"
 /* Iteration for FI_IP */
#line 909
case FI_IP:
#line 909
#define whati (&(what->i_FI_IP))
#line 909
#undef whati
#line 909
break;
#line 909

#line 916 "filter/f-inst.c"
 /* Iteration for FI_ROUTE_DISTINGUISHER */
#line 916
case FI_ROUTE_DISTINGUISHER:
#line 916
#define whati (&(what->i_FI_ROUTE_DISTINGUISHER))
#line 916
#undef whati
#line 916
break;
#line 916

#line 923 "filter/f-inst.c"
 /* Iteration for FI_AS_PATH_FIRST */
#line 923
case FI_AS_PATH_FIRST:
#line 923
#define whati (&(what->i_FI_AS_PATH_FIRST))
#line 923
#undef whati
#line 923
break;
#line 923

#line 930 "filter/f-inst.c"
 /* Iteration for FI_AS_PATH_LAST */
#line 930
case FI_AS_PATH_LAST:
#line 930
#define whati (&(what->i_FI_AS_PATH_LAST))
#line 930
#undef whati
#line 930
break;
#line 930

#line 935 "filter/f-inst.c"
 /* Iteration for FI_AS_PATH_LAST_NAG */
#line 935
case FI_AS_PATH_LAST_NAG:
#line 935
#define whati (&(what->i_FI_AS_PATH_LAST_NAG))
#line 935
#undef whati
#line 935
break;
#line 935

#line 961 "filter/f-inst.c"
 /* Iteration for FI_RETURN */
#line 961
case FI_RETURN:
#line 961
#define whati (&(what->i_FI_RETURN))
#line 961
#undef whati
#line 961
break;
#line 961

#line 991 "filter/f-inst.c"
 /* Iteration for FI_CALL */
#line 991
case FI_CALL:
#line 991
#define whati (&(what->i_FI_CALL))

#line 970 "filter/f-inst.c"
      BUFFER_PUSH(fit->lines) = whati->sym->function;

    #line 991 "filter/f-inst.c"
#undef whati
#line 991
break;
#line 991

#line 996 "filter/f-inst.c"
 /* Iteration for FI_DROP_RESULT */
#line 996
case FI_DROP_RESULT:
#line 996
#define whati (&(what->i_FI_DROP_RESULT))
#line 996
#undef whati
#line 996
break;
#line 996

#line 1019 "filter/f-inst.c"
 /* Iteration for FI_SWITCH */
#line 1019
case FI_SWITCH:
#line 1019
#define whati (&(what->i_FI_SWITCH))

#line 1002 "filter/f-inst.c"
      tree_walk(whati->tree, f_add_tree_lines, fit);

    #line 1019 "filter/f-inst.c"
#undef whati
#line 1019
break;
#line 1019

#line 1027 "filter/f-inst.c"
 /* Iteration for FI_IP_MASK */
#line 1027
case FI_IP_MASK:
#line 1027
#define whati (&(what->i_FI_IP_MASK))
#line 1027
#undef whati
#line 1027
break;
#line 1027

#line 1033 "filter/f-inst.c"
 /* Iteration for FI_PATH_PREPEND */
#line 1033
case FI_PATH_PREPEND:
#line 1033
#define whati (&(what->i_FI_PATH_PREPEND))
#line 1033
#undef whati
#line 1033
break;
#line 1033

#line 1090 "filter/f-inst.c"
 /* Iteration for FI_CLIST_ADD */
#line 1090
case FI_CLIST_ADD:
#line 1090
#define whati (&(what->i_FI_CLIST_ADD))
#line 1090
#undef whati
#line 1090
break;
#line 1090

#line 1152 "filter/f-inst.c"
 /* Iteration for FI_CLIST_DEL */
#line 1152
case FI_CLIST_DEL:
#line 1152
#define whati (&(what->i_FI_CLIST_DEL))
#line 1152
#undef whati
#line 1152
break;
#line 1152

#line 1200 "filter/f-inst.c"
 /* Iteration for FI_CLIST_FILTER */
#line 1200
case FI_CLIST_FILTER:
#line 1200
#define whati (&(what->i_FI_CLIST_FILTER))
#line 1200
#undef whati
#line 1200
break;
#line 1200

#line 1230 "filter/f-inst.c"
 /* Iteration for FI_ROA_CHECK_IMPLICIT */
#line 1230
case FI_ROA_CHECK_IMPLICIT:
#line 1230
#define whati (&(what->i_FI_ROA_CHECK_IMPLICIT))
#line 1230
#undef whati
#line 1230
break;
#line 1230

#line 1252 "filter/f-inst.c"
 /* Iteration for FI_ROA_CHECK_EXPLICIT */
#line 1252
case FI_ROA_CHECK_EXPLICIT:
#line 1252
#define whati (&(what->i_FI_ROA_CHECK_EXPLICIT))
#line 1252
#undef whati
#line 1252
break;
#line 1252

#line 1257 "filter/f-inst.c"
 /* Iteration for FI_FORMAT */
#line 1257
case FI_FORMAT:
#line 1257
#define whati (&(what->i_FI_FORMAT))
#line 1257
#undef whati
#line 1257
break;
#line 1257

#line 668 "filter/decl.m4"
 /* Iteration for FI_ASSERT */
#line 668
case FI_ASSERT:
#line 668
#define whati (&(what->i_FI_ASSERT))
#line 668
#undef whati
#line 668
break;
#line 668

#line 614 "filter/decl.m4"

  }
}


#if defined(__GNUC__) && __GNUC__ >= 6
#pragma GCC diagnostic pop
#endif

